/* MonitorManager.c generated by valac 0.56.18, the Vala compiler
 * generated from MonitorManager.vala, do not modify */

/*-
 * Copyright (c) 2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "display.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DISPLAY_MONITOR_MANAGER_0_PROPERTY,
	DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITORS_PROPERTY,
	DISPLAY_MONITOR_MANAGER_MONITORS_PROPERTY,
	DISPLAY_MONITOR_MANAGER_GLOBAL_SCALE_REQUIRED_PROPERTY,
	DISPLAY_MONITOR_MANAGER_MIRRORING_SUPPORTED_PROPERTY,
	DISPLAY_MONITOR_MANAGER_MAX_WIDTH_PROPERTY,
	DISPLAY_MONITOR_MANAGER_MAX_HEIGHT_PROPERTY,
	DISPLAY_MONITOR_MANAGER_MONITOR_NUMBER_PROPERTY,
	DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITOR_NUMBER_PROPERTY,
	DISPLAY_MONITOR_MANAGER_IS_MIRRORED_PROPERTY,
	DISPLAY_MONITOR_MANAGER_NUM_PROPERTIES
};
static GParamSpec* display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DisplayMonitorManagerPrivate {
	GeeLinkedList* _virtual_monitors;
	GeeLinkedList* _monitors;
	gboolean _global_scale_required;
	gboolean _mirroring_supported;
	gint _max_width;
	gint _max_height;
	MutterDisplayConfigInterface* iface;
	guint current_serial;
};

static gint DisplayMonitorManager_private_offset;
static gpointer display_monitor_manager_parent_class = NULL;
static DisplayMonitorManager* display_monitor_manager_monitor_manager;
static DisplayMonitorManager* display_monitor_manager_monitor_manager = NULL;

static DisplayMonitorManager* display_monitor_manager_new (void);
static DisplayMonitorManager* display_monitor_manager_construct (GType object_type);
static void _vala_MutterReadMonitor_array_free (MutterReadMonitor * array,
                                         gssize array_length);
static void _vala_MutterReadLogicalMonitor_array_free (MutterReadLogicalMonitor * array,
                                                gssize array_length);
static void display_monitor_manager_set_mirroring_supported (DisplayMonitorManager* self,
                                                      gboolean value);
static void display_monitor_manager_set_global_scale_required (DisplayMonitorManager* self,
                                                        gboolean value);
static void display_monitor_manager_set_max_width (DisplayMonitorManager* self,
                                            gint value);
static void display_monitor_manager_set_max_height (DisplayMonitorManager* self,
                                             gint value);
static DisplayMonitor* display_monitor_manager_get_monitor_by_hash (DisplayMonitorManager* self,
                                                             guint hash);
static gdouble* _vala_array_dup10 (gdouble* self,
                            gssize length);
static DisplayVirtualMonitor* display_monitor_manager_get_virtual_monitor_by_id (DisplayMonitorManager* self,
                                                                          const gchar* id);
static void display_monitor_manager_add_virtual_monitor (DisplayMonitorManager* self,
                                                  DisplayVirtualMonitor* virtual_monitor);
static gboolean display_monitor_manager_compare_monitor_with_mutter_info (DisplayMonitor* monitor,
                                                                   MutterReadMonitorInfo* mutter_info);
static void _vala_array_add1 (MutterWriteLogicalMonitor* * array,
                       gint* length,
                       gint* size,
                       const MutterWriteLogicalMonitor* value);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
static void _vala_MutterWriteLogicalMonitor_array_free (MutterWriteLogicalMonitor * array,
                                                 gssize array_length);
static void _vala_array_add2 (MutterWriteMonitor* * array,
                       gint* length,
                       gint* size,
                       const MutterWriteMonitor* value);
static MutterWriteMonitor* _vala_array_dup11 (MutterWriteMonitor* self,
                                       gssize length);
static void _vala_MutterWriteMonitor_array_free (MutterWriteMonitor * array,
                                          gssize array_length);
static gboolean _vala_double_array_contains (gdouble * stack,
                                      gssize stack_length,
                                      const gdouble needle);
static GObject * display_monitor_manager_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _display_monitor_manager_get_monitor_config_mutter_display_config_interface_monitors_changed (MutterDisplayConfigInterface* _sender,
                                                                                                   gpointer self);
static void display_monitor_manager_finalize (GObject * obj);
static GType display_monitor_manager_get_type_once (void);
static void _vala_display_monitor_manager_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_display_monitor_manager_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
display_monitor_manager_get_instance_private (DisplayMonitorManager* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayMonitorManager_private_offset);
}

DisplayMonitorManager*
display_monitor_manager_get_default (void)
{
	DisplayMonitorManager* _tmp0_;
	DisplayMonitorManager* _tmp2_;
	DisplayMonitorManager* result;
#line 53 "../src/Objects/MonitorManager.vala"
	_tmp0_ = display_monitor_manager_monitor_manager;
#line 53 "../src/Objects/MonitorManager.vala"
	if (_tmp0_ == NULL) {
#line 158 "MonitorManager.c"
		DisplayMonitorManager* _tmp1_;
#line 54 "../src/Objects/MonitorManager.vala"
		_tmp1_ = display_monitor_manager_new ();
#line 54 "../src/Objects/MonitorManager.vala"
		_g_object_unref0 (display_monitor_manager_monitor_manager);
#line 54 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_monitor_manager = _tmp1_;
#line 166 "MonitorManager.c"
	}
#line 57 "../src/Objects/MonitorManager.vala"
	_tmp2_ = display_monitor_manager_monitor_manager;
#line 57 "../src/Objects/MonitorManager.vala"
	result = _tmp2_;
#line 57 "../src/Objects/MonitorManager.vala"
	return result;
#line 174 "MonitorManager.c"
}

static DisplayMonitorManager*
display_monitor_manager_construct (GType object_type)
{
	DisplayMonitorManager * self = NULL;
#line 60 "../src/Objects/MonitorManager.vala"
	self = (DisplayMonitorManager*) g_object_new (object_type, NULL);
#line 61 "../src/Objects/MonitorManager.vala"
	display_monitor_manager_get_monitor_config (self);
#line 60 "../src/Objects/MonitorManager.vala"
	return self;
#line 187 "MonitorManager.c"
}

static DisplayMonitorManager*
display_monitor_manager_new (void)
{
#line 60 "../src/Objects/MonitorManager.vala"
	return display_monitor_manager_construct (DISPLAY_TYPE_MONITOR_MANAGER);
#line 195 "MonitorManager.c"
}

static void
_vala_MutterReadMonitor_array_free (MutterReadMonitor * array,
                                    gssize array_length)
{
#line 80 "../src/Objects/MonitorManager.vala"
	if (array != NULL) {
#line 204 "MonitorManager.c"
		gssize i;
#line 80 "../src/Objects/MonitorManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 80 "../src/Objects/MonitorManager.vala"
			mutter_read_monitor_destroy (&array[i]);
#line 210 "MonitorManager.c"
		}
	}
#line 80 "../src/Objects/MonitorManager.vala"
	g_free (array);
#line 215 "MonitorManager.c"
}

static void
_vala_MutterReadLogicalMonitor_array_free (MutterReadLogicalMonitor * array,
                                           gssize array_length)
{
#line 80 "../src/Objects/MonitorManager.vala"
	if (array != NULL) {
#line 224 "MonitorManager.c"
		gssize i;
#line 80 "../src/Objects/MonitorManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 80 "../src/Objects/MonitorManager.vala"
			mutter_read_logical_monitor_destroy (&array[i]);
#line 230 "MonitorManager.c"
		}
	}
#line 80 "../src/Objects/MonitorManager.vala"
	g_free (array);
#line 235 "MonitorManager.c"
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 86 "../src/Objects/MonitorManager.vala"
	return self ? g_variant_ref (self) : NULL;
#line 243 "MonitorManager.c"
}

static gdouble*
_vala_array_dup10 (gdouble* self,
                   gssize length)
{
#line 161 "../src/Objects/MonitorManager.vala"
	if (length > 0) {
#line 161 "../src/Objects/MonitorManager.vala"
		return _vala_memdup2 (self, length * sizeof (gdouble));
#line 254 "MonitorManager.c"
	}
#line 161 "../src/Objects/MonitorManager.vala"
	return NULL;
#line 258 "MonitorManager.c"
}

void
display_monitor_manager_get_monitor_config (DisplayMonitorManager* self)
{
	MutterReadMonitor* mutter_monitors = NULL;
	gint mutter_monitors_length1 = 0;
	gint _mutter_monitors_size_ = 0;
	MutterReadLogicalMonitor* mutter_logical_monitors = NULL;
	gint mutter_logical_monitors_length1 = 0;
	gint _mutter_logical_monitors_size_ = 0;
	GHashTable* properties = NULL;
	GVariant* supports_mirroring_variant = NULL;
	gconstpointer _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	GVariant* global_scale_required_variant = NULL;
	gconstpointer _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	GVariant* max_screen_size_variant = NULL;
	gconstpointer _tmp17_;
	GVariant* _tmp18_;
	GVariant* _tmp19_;
	GeeLinkedList* monitors_with_changed_modes = NULL;
	GeeLinkedList* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 75 "../src/Objects/MonitorManager.vala"
	g_return_if_fail (self != NULL);
#line 288 "MonitorManager.c"
	{
		MutterDisplayConfigInterface* _tmp0_;
		guint _tmp1_ = 0U;
		MutterReadMonitor* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		MutterReadLogicalMonitor* _tmp4_ = NULL;
		gint _tmp5_ = 0;
		GHashTable* _tmp6_ = NULL;
#line 80 "../src/Objects/MonitorManager.vala"
		_tmp0_ = self->priv->iface;
#line 80 "../src/Objects/MonitorManager.vala"
		mutter_display_config_interface_get_current_state (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_, &_inner_error0_);
#line 80 "../src/Objects/MonitorManager.vala"
		self->priv->current_serial = _tmp1_;
#line 80 "../src/Objects/MonitorManager.vala"
		mutter_monitors = (_vala_MutterReadMonitor_array_free (mutter_monitors, mutter_monitors_length1), NULL);
#line 80 "../src/Objects/MonitorManager.vala"
		mutter_monitors = _tmp2_;
#line 80 "../src/Objects/MonitorManager.vala"
		mutter_monitors_length1 = _tmp3_;
#line 80 "../src/Objects/MonitorManager.vala"
		_mutter_monitors_size_ = mutter_monitors_length1;
#line 80 "../src/Objects/MonitorManager.vala"
		mutter_logical_monitors = (_vala_MutterReadLogicalMonitor_array_free (mutter_logical_monitors, mutter_logical_monitors_length1), NULL);
#line 80 "../src/Objects/MonitorManager.vala"
		mutter_logical_monitors = _tmp4_;
#line 80 "../src/Objects/MonitorManager.vala"
		mutter_logical_monitors_length1 = _tmp5_;
#line 80 "../src/Objects/MonitorManager.vala"
		_mutter_logical_monitors_size_ = mutter_logical_monitors_length1;
#line 80 "../src/Objects/MonitorManager.vala"
		_g_hash_table_unref0 (properties);
#line 80 "../src/Objects/MonitorManager.vala"
		properties = _tmp6_;
#line 80 "../src/Objects/MonitorManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 325 "MonitorManager.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 79 "../src/Objects/MonitorManager.vala"
		e = _inner_error0_;
#line 79 "../src/Objects/MonitorManager.vala"
		_inner_error0_ = NULL;
#line 82 "../src/Objects/MonitorManager.vala"
		_tmp7_ = e;
#line 82 "../src/Objects/MonitorManager.vala"
		_tmp8_ = _tmp7_->message;
#line 82 "../src/Objects/MonitorManager.vala"
		g_critical ("MonitorManager.vala:82: %s", _tmp8_);
#line 79 "../src/Objects/MonitorManager.vala"
		_g_error_free0 (e);
#line 347 "MonitorManager.c"
	}
	__finally0:
#line 79 "../src/Objects/MonitorManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../src/Objects/MonitorManager.vala"
		_g_hash_table_unref0 (properties);
#line 79 "../src/Objects/MonitorManager.vala"
		mutter_logical_monitors = (_vala_MutterReadLogicalMonitor_array_free (mutter_logical_monitors, mutter_logical_monitors_length1), NULL);
#line 79 "../src/Objects/MonitorManager.vala"
		mutter_monitors = (_vala_MutterReadMonitor_array_free (mutter_monitors, mutter_monitors_length1), NULL);
#line 79 "../src/Objects/MonitorManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 79 "../src/Objects/MonitorManager.vala"
		g_clear_error (&_inner_error0_);
#line 79 "../src/Objects/MonitorManager.vala"
		return;
#line 364 "MonitorManager.c"
	}
#line 86 "../src/Objects/MonitorManager.vala"
	_tmp9_ = g_hash_table_lookup (properties, "supports-mirroring");
#line 86 "../src/Objects/MonitorManager.vala"
	_tmp10_ = _g_variant_ref0 ((GVariant*) _tmp9_);
#line 86 "../src/Objects/MonitorManager.vala"
	supports_mirroring_variant = _tmp10_;
#line 87 "../src/Objects/MonitorManager.vala"
	_tmp11_ = supports_mirroring_variant;
#line 87 "../src/Objects/MonitorManager.vala"
	if (_tmp11_ != NULL) {
#line 376 "MonitorManager.c"
		GVariant* _tmp12_;
#line 88 "../src/Objects/MonitorManager.vala"
		_tmp12_ = supports_mirroring_variant;
#line 88 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_set_mirroring_supported (self, g_variant_get_boolean (_tmp12_));
#line 382 "MonitorManager.c"
	} else {
#line 93 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_set_mirroring_supported (self, TRUE);
#line 386 "MonitorManager.c"
	}
#line 96 "../src/Objects/MonitorManager.vala"
	_tmp13_ = g_hash_table_lookup (properties, "global-scale-required");
#line 96 "../src/Objects/MonitorManager.vala"
	_tmp14_ = _g_variant_ref0 ((GVariant*) _tmp13_);
#line 96 "../src/Objects/MonitorManager.vala"
	global_scale_required_variant = _tmp14_;
#line 97 "../src/Objects/MonitorManager.vala"
	_tmp15_ = global_scale_required_variant;
#line 97 "../src/Objects/MonitorManager.vala"
	if (_tmp15_ != NULL) {
#line 398 "MonitorManager.c"
		GVariant* _tmp16_;
#line 98 "../src/Objects/MonitorManager.vala"
		_tmp16_ = global_scale_required_variant;
#line 98 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_set_global_scale_required (self, g_variant_get_boolean (_tmp16_));
#line 404 "MonitorManager.c"
	} else {
#line 103 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_set_global_scale_required (self, FALSE);
#line 408 "MonitorManager.c"
	}
#line 106 "../src/Objects/MonitorManager.vala"
	_tmp17_ = g_hash_table_lookup (properties, "max-screen-size");
#line 106 "../src/Objects/MonitorManager.vala"
	_tmp18_ = _g_variant_ref0 ((GVariant*) _tmp17_);
#line 106 "../src/Objects/MonitorManager.vala"
	max_screen_size_variant = _tmp18_;
#line 107 "../src/Objects/MonitorManager.vala"
	_tmp19_ = max_screen_size_variant;
#line 107 "../src/Objects/MonitorManager.vala"
	if (_tmp19_ != NULL) {
#line 420 "MonitorManager.c"
		GVariant* _tmp20_;
		GVariant* _tmp21_;
		GVariant* _tmp22_;
		GVariant* _tmp23_;
		GVariant* _tmp24_;
		GVariant* _tmp25_;
#line 108 "../src/Objects/MonitorManager.vala"
		_tmp20_ = max_screen_size_variant;
#line 108 "../src/Objects/MonitorManager.vala"
		_tmp21_ = g_variant_get_child_value (_tmp20_, (gsize) 0);
#line 108 "../src/Objects/MonitorManager.vala"
		_tmp22_ = _tmp21_;
#line 108 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_set_max_width (self, (gint) g_variant_get_int32 (_tmp22_));
#line 108 "../src/Objects/MonitorManager.vala"
		_g_variant_unref0 (_tmp22_);
#line 109 "../src/Objects/MonitorManager.vala"
		_tmp23_ = max_screen_size_variant;
#line 109 "../src/Objects/MonitorManager.vala"
		_tmp24_ = g_variant_get_child_value (_tmp23_, (gsize) 1);
#line 109 "../src/Objects/MonitorManager.vala"
		_tmp25_ = _tmp24_;
#line 109 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_set_max_height (self, (gint) g_variant_get_int32 (_tmp25_));
#line 109 "../src/Objects/MonitorManager.vala"
		_g_variant_unref0 (_tmp25_);
#line 447 "MonitorManager.c"
	} else {
#line 114 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_set_max_width (self, G_MAXINT);
#line 115 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_set_max_height (self, G_MAXINT);
#line 453 "MonitorManager.c"
	}
#line 118 "../src/Objects/MonitorManager.vala"
	_tmp26_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 118 "../src/Objects/MonitorManager.vala"
	monitors_with_changed_modes = _tmp26_;
#line 459 "MonitorManager.c"
	{
		MutterReadMonitor* mutter_monitor_collection = NULL;
		gint mutter_monitor_collection_length1 = 0;
		gint _mutter_monitor_collection_size_ = 0;
		gint mutter_monitor_it = 0;
#line 119 "../src/Objects/MonitorManager.vala"
		mutter_monitor_collection = mutter_monitors;
#line 119 "../src/Objects/MonitorManager.vala"
		mutter_monitor_collection_length1 = mutter_monitors_length1;
#line 119 "../src/Objects/MonitorManager.vala"
		for (mutter_monitor_it = 0; mutter_monitor_it < mutter_monitor_collection_length1; mutter_monitor_it = mutter_monitor_it + 1) {
#line 471 "MonitorManager.c"
			MutterReadMonitor _tmp27_;
			MutterReadMonitor _tmp28_ = {0};
			MutterReadMonitor mutter_monitor = {0};
#line 119 "../src/Objects/MonitorManager.vala"
			_tmp27_ = mutter_monitor_collection[mutter_monitor_it];
#line 119 "../src/Objects/MonitorManager.vala"
			mutter_read_monitor_copy (&_tmp27_, &_tmp28_);
#line 119 "../src/Objects/MonitorManager.vala"
			mutter_monitor = _tmp28_;
#line 481 "MonitorManager.c"
			{
				DisplayMonitor* monitor = NULL;
				MutterReadMonitor _tmp29_;
				MutterReadMonitorInfo _tmp30_;
				guint _tmp31_;
				guint _tmp32_;
				DisplayMonitor* _tmp33_;
				DisplayMonitor* _tmp34_;
				DisplayMonitor* _tmp40_;
				MutterReadMonitor _tmp41_;
				MutterReadMonitorInfo _tmp42_;
				const gchar* _tmp43_;
				DisplayMonitor* _tmp44_;
				MutterReadMonitor _tmp45_;
				MutterReadMonitorInfo _tmp46_;
				const gchar* _tmp47_;
				DisplayMonitor* _tmp48_;
				MutterReadMonitor _tmp49_;
				MutterReadMonitorInfo _tmp50_;
				const gchar* _tmp51_;
				DisplayMonitor* _tmp52_;
				MutterReadMonitor _tmp53_;
				MutterReadMonitorInfo _tmp54_;
				const gchar* _tmp55_;
				GVariant* display_name_variant = NULL;
				MutterReadMonitor _tmp56_;
				GHashTable* _tmp57_;
				gconstpointer _tmp58_;
				GVariant* _tmp59_;
				GVariant* _tmp60_;
				GVariant* is_builtin_variant = NULL;
				MutterReadMonitor _tmp68_;
				GHashTable* _tmp69_;
				gconstpointer _tmp70_;
				GVariant* _tmp71_;
				GVariant* _tmp72_;
				MutterReadMonitor _tmp76_;
				MutterReadMonitorMode* _tmp77_;
				gint _tmp77__length1;
#line 120 "../src/Objects/MonitorManager.vala"
				_tmp29_ = mutter_monitor;
#line 120 "../src/Objects/MonitorManager.vala"
				_tmp30_ = _tmp29_.monitor;
#line 120 "../src/Objects/MonitorManager.vala"
				_tmp31_ = mutter_read_monitor_info_get_hash (&_tmp30_);
#line 120 "../src/Objects/MonitorManager.vala"
				_tmp32_ = _tmp31_;
#line 120 "../src/Objects/MonitorManager.vala"
				_tmp33_ = display_monitor_manager_get_monitor_by_hash (self, _tmp32_);
#line 120 "../src/Objects/MonitorManager.vala"
				monitor = _tmp33_;
#line 121 "../src/Objects/MonitorManager.vala"
				_tmp34_ = monitor;
#line 121 "../src/Objects/MonitorManager.vala"
				if (_tmp34_ == NULL) {
#line 537 "MonitorManager.c"
					DisplayMonitor* _tmp35_;
					GeeLinkedList* _tmp36_;
					DisplayMonitor* _tmp37_;
#line 122 "../src/Objects/MonitorManager.vala"
					_tmp35_ = display_monitor_new ();
#line 122 "../src/Objects/MonitorManager.vala"
					_g_object_unref0 (monitor);
#line 122 "../src/Objects/MonitorManager.vala"
					monitor = _tmp35_;
#line 123 "../src/Objects/MonitorManager.vala"
					_tmp36_ = self->priv->_monitors;
#line 123 "../src/Objects/MonitorManager.vala"
					_tmp37_ = monitor;
#line 123 "../src/Objects/MonitorManager.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, _tmp37_);
#line 553 "MonitorManager.c"
				} else {
					GeeLinkedList* _tmp38_;
					DisplayMonitor* _tmp39_;
#line 125 "../src/Objects/MonitorManager.vala"
					_tmp38_ = monitors_with_changed_modes;
#line 125 "../src/Objects/MonitorManager.vala"
					_tmp39_ = monitor;
#line 125 "../src/Objects/MonitorManager.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, _tmp39_);
#line 563 "MonitorManager.c"
				}
#line 128 "../src/Objects/MonitorManager.vala"
				_tmp40_ = monitor;
#line 128 "../src/Objects/MonitorManager.vala"
				_tmp41_ = mutter_monitor;
#line 128 "../src/Objects/MonitorManager.vala"
				_tmp42_ = _tmp41_.monitor;
#line 128 "../src/Objects/MonitorManager.vala"
				_tmp43_ = _tmp42_.connector;
#line 128 "../src/Objects/MonitorManager.vala"
				display_monitor_set_connector (_tmp40_, _tmp43_);
#line 129 "../src/Objects/MonitorManager.vala"
				_tmp44_ = monitor;
#line 129 "../src/Objects/MonitorManager.vala"
				_tmp45_ = mutter_monitor;
#line 129 "../src/Objects/MonitorManager.vala"
				_tmp46_ = _tmp45_.monitor;
#line 129 "../src/Objects/MonitorManager.vala"
				_tmp47_ = _tmp46_.vendor;
#line 129 "../src/Objects/MonitorManager.vala"
				display_monitor_set_vendor (_tmp44_, _tmp47_);
#line 130 "../src/Objects/MonitorManager.vala"
				_tmp48_ = monitor;
#line 130 "../src/Objects/MonitorManager.vala"
				_tmp49_ = mutter_monitor;
#line 130 "../src/Objects/MonitorManager.vala"
				_tmp50_ = _tmp49_.monitor;
#line 130 "../src/Objects/MonitorManager.vala"
				_tmp51_ = _tmp50_.product;
#line 130 "../src/Objects/MonitorManager.vala"
				display_monitor_set_product (_tmp48_, _tmp51_);
#line 131 "../src/Objects/MonitorManager.vala"
				_tmp52_ = monitor;
#line 131 "../src/Objects/MonitorManager.vala"
				_tmp53_ = mutter_monitor;
#line 131 "../src/Objects/MonitorManager.vala"
				_tmp54_ = _tmp53_.monitor;
#line 131 "../src/Objects/MonitorManager.vala"
				_tmp55_ = _tmp54_.serial;
#line 131 "../src/Objects/MonitorManager.vala"
				display_monitor_set_serial (_tmp52_, _tmp55_);
#line 132 "../src/Objects/MonitorManager.vala"
				_tmp56_ = mutter_monitor;
#line 132 "../src/Objects/MonitorManager.vala"
				_tmp57_ = _tmp56_.properties;
#line 132 "../src/Objects/MonitorManager.vala"
				_tmp58_ = g_hash_table_lookup (_tmp57_, "display-name");
#line 132 "../src/Objects/MonitorManager.vala"
				_tmp59_ = _g_variant_ref0 ((GVariant*) _tmp58_);
#line 132 "../src/Objects/MonitorManager.vala"
				display_name_variant = _tmp59_;
#line 133 "../src/Objects/MonitorManager.vala"
				_tmp60_ = display_name_variant;
#line 133 "../src/Objects/MonitorManager.vala"
				if (_tmp60_ != NULL) {
#line 619 "MonitorManager.c"
					DisplayMonitor* _tmp61_;
					GVariant* _tmp62_;
					const gchar* _tmp63_;
#line 134 "../src/Objects/MonitorManager.vala"
					_tmp61_ = monitor;
#line 134 "../src/Objects/MonitorManager.vala"
					_tmp62_ = display_name_variant;
#line 134 "../src/Objects/MonitorManager.vala"
					_tmp63_ = g_variant_get_string (_tmp62_, NULL);
#line 134 "../src/Objects/MonitorManager.vala"
					display_monitor_set_display_name (_tmp61_, _tmp63_);
#line 631 "MonitorManager.c"
				} else {
					DisplayMonitor* _tmp64_;
					DisplayMonitor* _tmp65_;
					const gchar* _tmp66_;
					const gchar* _tmp67_;
#line 136 "../src/Objects/MonitorManager.vala"
					_tmp64_ = monitor;
#line 136 "../src/Objects/MonitorManager.vala"
					_tmp65_ = monitor;
#line 136 "../src/Objects/MonitorManager.vala"
					_tmp66_ = display_monitor_get_connector (_tmp65_);
#line 136 "../src/Objects/MonitorManager.vala"
					_tmp67_ = _tmp66_;
#line 136 "../src/Objects/MonitorManager.vala"
					display_monitor_set_display_name (_tmp64_, _tmp67_);
#line 647 "MonitorManager.c"
				}
#line 139 "../src/Objects/MonitorManager.vala"
				_tmp68_ = mutter_monitor;
#line 139 "../src/Objects/MonitorManager.vala"
				_tmp69_ = _tmp68_.properties;
#line 139 "../src/Objects/MonitorManager.vala"
				_tmp70_ = g_hash_table_lookup (_tmp69_, "is-builtin");
#line 139 "../src/Objects/MonitorManager.vala"
				_tmp71_ = _g_variant_ref0 ((GVariant*) _tmp70_);
#line 139 "../src/Objects/MonitorManager.vala"
				is_builtin_variant = _tmp71_;
#line 140 "../src/Objects/MonitorManager.vala"
				_tmp72_ = is_builtin_variant;
#line 140 "../src/Objects/MonitorManager.vala"
				if (_tmp72_ != NULL) {
#line 663 "MonitorManager.c"
					DisplayMonitor* _tmp73_;
					GVariant* _tmp74_;
#line 141 "../src/Objects/MonitorManager.vala"
					_tmp73_ = monitor;
#line 141 "../src/Objects/MonitorManager.vala"
					_tmp74_ = is_builtin_variant;
#line 141 "../src/Objects/MonitorManager.vala"
					display_monitor_set_is_builtin (_tmp73_, g_variant_get_boolean (_tmp74_));
#line 672 "MonitorManager.c"
				} else {
					DisplayMonitor* _tmp75_;
#line 146 "../src/Objects/MonitorManager.vala"
					_tmp75_ = monitor;
#line 146 "../src/Objects/MonitorManager.vala"
					display_monitor_set_is_builtin (_tmp75_, FALSE);
#line 679 "MonitorManager.c"
				}
#line 149 "../src/Objects/MonitorManager.vala"
				_tmp76_ = mutter_monitor;
#line 149 "../src/Objects/MonitorManager.vala"
				_tmp77_ = _tmp76_.modes;
#line 149 "../src/Objects/MonitorManager.vala"
				_tmp77__length1 = _tmp76_.modes_length1;
#line 687 "MonitorManager.c"
				{
					MutterReadMonitorMode* mutter_mode_collection = NULL;
					gint mutter_mode_collection_length1 = 0;
					gint _mutter_mode_collection_size_ = 0;
					gint mutter_mode_it = 0;
#line 149 "../src/Objects/MonitorManager.vala"
					mutter_mode_collection = _tmp77_;
#line 149 "../src/Objects/MonitorManager.vala"
					mutter_mode_collection_length1 = _tmp77__length1;
#line 149 "../src/Objects/MonitorManager.vala"
					for (mutter_mode_it = 0; mutter_mode_it < mutter_mode_collection_length1; mutter_mode_it = mutter_mode_it + 1) {
#line 699 "MonitorManager.c"
						MutterReadMonitorMode _tmp78_;
						MutterReadMonitorMode _tmp79_ = {0};
						MutterReadMonitorMode mutter_mode = {0};
#line 149 "../src/Objects/MonitorManager.vala"
						_tmp78_ = mutter_mode_collection[mutter_mode_it];
#line 149 "../src/Objects/MonitorManager.vala"
						mutter_read_monitor_mode_copy (&_tmp78_, &_tmp79_);
#line 149 "../src/Objects/MonitorManager.vala"
						mutter_mode = _tmp79_;
#line 709 "MonitorManager.c"
						{
							DisplayMonitorMode* mode = NULL;
							DisplayMonitor* _tmp80_;
							MutterReadMonitorMode _tmp81_;
							const gchar* _tmp82_;
							DisplayMonitorMode* _tmp83_;
							DisplayMonitorMode* _tmp84_;
							DisplayMonitorMode* _tmp90_;
							MutterReadMonitorMode _tmp91_;
							const gchar* _tmp92_;
							DisplayMonitorMode* _tmp93_;
							MutterReadMonitorMode _tmp94_;
							DisplayMonitorMode* _tmp95_;
							MutterReadMonitorMode _tmp96_;
							DisplayMonitorMode* _tmp97_;
							MutterReadMonitorMode _tmp98_;
							DisplayMonitorMode* _tmp99_;
							MutterReadMonitorMode _tmp100_;
							DisplayMonitorMode* _tmp101_;
							MutterReadMonitorMode _tmp102_;
							gdouble* _tmp103_;
							gint _tmp103__length1;
							gdouble* _tmp104_;
							gint _tmp104__length1;
							GVariant* is_preferred_variant = NULL;
							MutterReadMonitorMode _tmp105_;
							GHashTable* _tmp106_;
							gconstpointer _tmp107_;
							GVariant* _tmp108_;
							GVariant* _tmp109_;
							GVariant* is_current_variant = NULL;
							MutterReadMonitorMode _tmp113_;
							GHashTable* _tmp114_;
							gconstpointer _tmp115_;
							GVariant* _tmp116_;
							GVariant* _tmp117_;
#line 150 "../src/Objects/MonitorManager.vala"
							_tmp80_ = monitor;
#line 150 "../src/Objects/MonitorManager.vala"
							_tmp81_ = mutter_mode;
#line 150 "../src/Objects/MonitorManager.vala"
							_tmp82_ = _tmp81_.id;
#line 150 "../src/Objects/MonitorManager.vala"
							_tmp83_ = display_monitor_get_mode_by_id (_tmp80_, _tmp82_);
#line 150 "../src/Objects/MonitorManager.vala"
							mode = _tmp83_;
#line 151 "../src/Objects/MonitorManager.vala"
							_tmp84_ = mode;
#line 151 "../src/Objects/MonitorManager.vala"
							if (_tmp84_ == NULL) {
#line 760 "MonitorManager.c"
								DisplayMonitorMode* _tmp85_;
								DisplayMonitor* _tmp86_;
								GeeLinkedList* _tmp87_;
								GeeLinkedList* _tmp88_;
								DisplayMonitorMode* _tmp89_;
#line 152 "../src/Objects/MonitorManager.vala"
								_tmp85_ = display_monitor_mode_new ();
#line 152 "../src/Objects/MonitorManager.vala"
								_g_object_unref0 (mode);
#line 152 "../src/Objects/MonitorManager.vala"
								mode = _tmp85_;
#line 153 "../src/Objects/MonitorManager.vala"
								_tmp86_ = monitor;
#line 153 "../src/Objects/MonitorManager.vala"
								_tmp87_ = display_monitor_get_modes (_tmp86_);
#line 153 "../src/Objects/MonitorManager.vala"
								_tmp88_ = _tmp87_;
#line 153 "../src/Objects/MonitorManager.vala"
								_tmp89_ = mode;
#line 153 "../src/Objects/MonitorManager.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp88_, _tmp89_);
#line 782 "MonitorManager.c"
							}
#line 156 "../src/Objects/MonitorManager.vala"
							_tmp90_ = mode;
#line 156 "../src/Objects/MonitorManager.vala"
							_tmp91_ = mutter_mode;
#line 156 "../src/Objects/MonitorManager.vala"
							_tmp92_ = _tmp91_.id;
#line 156 "../src/Objects/MonitorManager.vala"
							display_monitor_mode_set_id (_tmp90_, _tmp92_);
#line 157 "../src/Objects/MonitorManager.vala"
							_tmp93_ = mode;
#line 157 "../src/Objects/MonitorManager.vala"
							_tmp94_ = mutter_mode;
#line 157 "../src/Objects/MonitorManager.vala"
							display_monitor_mode_set_width (_tmp93_, _tmp94_.width);
#line 158 "../src/Objects/MonitorManager.vala"
							_tmp95_ = mode;
#line 158 "../src/Objects/MonitorManager.vala"
							_tmp96_ = mutter_mode;
#line 158 "../src/Objects/MonitorManager.vala"
							display_monitor_mode_set_height (_tmp95_, _tmp96_.height);
#line 159 "../src/Objects/MonitorManager.vala"
							_tmp97_ = mode;
#line 159 "../src/Objects/MonitorManager.vala"
							_tmp98_ = mutter_mode;
#line 159 "../src/Objects/MonitorManager.vala"
							display_monitor_mode_set_frequency (_tmp97_, _tmp98_.frequency);
#line 160 "../src/Objects/MonitorManager.vala"
							_tmp99_ = mode;
#line 160 "../src/Objects/MonitorManager.vala"
							_tmp100_ = mutter_mode;
#line 160 "../src/Objects/MonitorManager.vala"
							display_monitor_mode_set_preferred_scale (_tmp99_, _tmp100_.preferred_scale);
#line 161 "../src/Objects/MonitorManager.vala"
							_tmp101_ = mode;
#line 161 "../src/Objects/MonitorManager.vala"
							_tmp102_ = mutter_mode;
#line 161 "../src/Objects/MonitorManager.vala"
							_tmp103_ = _tmp102_.supported_scales;
#line 161 "../src/Objects/MonitorManager.vala"
							_tmp103__length1 = _tmp102_.supported_scales_length1;
#line 161 "../src/Objects/MonitorManager.vala"
							_tmp104_ = (_tmp103_ != NULL) ? _vala_array_dup10 (_tmp103_, _tmp103__length1) : _tmp103_;
#line 161 "../src/Objects/MonitorManager.vala"
							_tmp104__length1 = _tmp103__length1;
#line 161 "../src/Objects/MonitorManager.vala"
							_tmp101_->supported_scales = (g_free (_tmp101_->supported_scales), NULL);
#line 161 "../src/Objects/MonitorManager.vala"
							_tmp101_->supported_scales = _tmp104_;
#line 161 "../src/Objects/MonitorManager.vala"
							_tmp101_->supported_scales_length1 = _tmp104__length1;
#line 162 "../src/Objects/MonitorManager.vala"
							_tmp105_ = mutter_mode;
#line 162 "../src/Objects/MonitorManager.vala"
							_tmp106_ = _tmp105_.properties;
#line 162 "../src/Objects/MonitorManager.vala"
							_tmp107_ = g_hash_table_lookup (_tmp106_, "is-preferred");
#line 162 "../src/Objects/MonitorManager.vala"
							_tmp108_ = _g_variant_ref0 ((GVariant*) _tmp107_);
#line 162 "../src/Objects/MonitorManager.vala"
							is_preferred_variant = _tmp108_;
#line 163 "../src/Objects/MonitorManager.vala"
							_tmp109_ = is_preferred_variant;
#line 163 "../src/Objects/MonitorManager.vala"
							if (_tmp109_ != NULL) {
#line 848 "MonitorManager.c"
								DisplayMonitorMode* _tmp110_;
								GVariant* _tmp111_;
#line 164 "../src/Objects/MonitorManager.vala"
								_tmp110_ = mode;
#line 164 "../src/Objects/MonitorManager.vala"
								_tmp111_ = is_preferred_variant;
#line 164 "../src/Objects/MonitorManager.vala"
								display_monitor_mode_set_is_preferred (_tmp110_, g_variant_get_boolean (_tmp111_));
#line 857 "MonitorManager.c"
							} else {
								DisplayMonitorMode* _tmp112_;
#line 166 "../src/Objects/MonitorManager.vala"
								_tmp112_ = mode;
#line 166 "../src/Objects/MonitorManager.vala"
								display_monitor_mode_set_is_preferred (_tmp112_, FALSE);
#line 864 "MonitorManager.c"
							}
#line 169 "../src/Objects/MonitorManager.vala"
							_tmp113_ = mutter_mode;
#line 169 "../src/Objects/MonitorManager.vala"
							_tmp114_ = _tmp113_.properties;
#line 169 "../src/Objects/MonitorManager.vala"
							_tmp115_ = g_hash_table_lookup (_tmp114_, "is-current");
#line 169 "../src/Objects/MonitorManager.vala"
							_tmp116_ = _g_variant_ref0 ((GVariant*) _tmp115_);
#line 169 "../src/Objects/MonitorManager.vala"
							is_current_variant = _tmp116_;
#line 170 "../src/Objects/MonitorManager.vala"
							_tmp117_ = is_current_variant;
#line 170 "../src/Objects/MonitorManager.vala"
							if (_tmp117_ != NULL) {
#line 880 "MonitorManager.c"
								DisplayMonitorMode* _tmp118_;
								GVariant* _tmp119_;
#line 171 "../src/Objects/MonitorManager.vala"
								_tmp118_ = mode;
#line 171 "../src/Objects/MonitorManager.vala"
								_tmp119_ = is_current_variant;
#line 171 "../src/Objects/MonitorManager.vala"
								display_monitor_mode_set_is_current (_tmp118_, g_variant_get_boolean (_tmp119_));
#line 889 "MonitorManager.c"
							} else {
								DisplayMonitorMode* _tmp120_;
#line 173 "../src/Objects/MonitorManager.vala"
								_tmp120_ = mode;
#line 173 "../src/Objects/MonitorManager.vala"
								display_monitor_mode_set_is_current (_tmp120_, FALSE);
#line 896 "MonitorManager.c"
							}
#line 149 "../src/Objects/MonitorManager.vala"
							_g_variant_unref0 (is_current_variant);
#line 149 "../src/Objects/MonitorManager.vala"
							_g_variant_unref0 (is_preferred_variant);
#line 149 "../src/Objects/MonitorManager.vala"
							_g_object_unref0 (mode);
#line 149 "../src/Objects/MonitorManager.vala"
							mutter_read_monitor_mode_destroy (&mutter_mode);
#line 906 "MonitorManager.c"
						}
					}
				}
#line 119 "../src/Objects/MonitorManager.vala"
				_g_variant_unref0 (is_builtin_variant);
#line 119 "../src/Objects/MonitorManager.vala"
				_g_variant_unref0 (display_name_variant);
#line 119 "../src/Objects/MonitorManager.vala"
				_g_object_unref0 (monitor);
#line 119 "../src/Objects/MonitorManager.vala"
				mutter_read_monitor_destroy (&mutter_monitor);
#line 918 "MonitorManager.c"
			}
		}
	}
	{
		MutterReadLogicalMonitor* mutter_logical_monitor_collection = NULL;
		gint mutter_logical_monitor_collection_length1 = 0;
		gint _mutter_logical_monitor_collection_size_ = 0;
		gint mutter_logical_monitor_it = 0;
#line 178 "../src/Objects/MonitorManager.vala"
		mutter_logical_monitor_collection = mutter_logical_monitors;
#line 178 "../src/Objects/MonitorManager.vala"
		mutter_logical_monitor_collection_length1 = mutter_logical_monitors_length1;
#line 178 "../src/Objects/MonitorManager.vala"
		for (mutter_logical_monitor_it = 0; mutter_logical_monitor_it < mutter_logical_monitor_collection_length1; mutter_logical_monitor_it = mutter_logical_monitor_it + 1) {
#line 933 "MonitorManager.c"
			MutterReadLogicalMonitor _tmp121_;
			MutterReadLogicalMonitor _tmp122_ = {0};
			MutterReadLogicalMonitor mutter_logical_monitor = {0};
#line 178 "../src/Objects/MonitorManager.vala"
			_tmp121_ = mutter_logical_monitor_collection[mutter_logical_monitor_it];
#line 178 "../src/Objects/MonitorManager.vala"
			mutter_read_logical_monitor_copy (&_tmp121_, &_tmp122_);
#line 178 "../src/Objects/MonitorManager.vala"
			mutter_logical_monitor = _tmp122_;
#line 943 "MonitorManager.c"
			{
				gchar* monitors_id = NULL;
				MutterReadLogicalMonitor _tmp123_;
				MutterReadMonitorInfo* _tmp124_;
				gint _tmp124__length1;
				gchar* _tmp125_;
				DisplayVirtualMonitor* virtual_monitor = NULL;
				const gchar* _tmp126_;
				DisplayVirtualMonitor* _tmp127_;
				DisplayVirtualMonitor* _tmp128_;
				DisplayVirtualMonitor* _tmp131_;
				MutterReadLogicalMonitor _tmp132_;
				DisplayVirtualMonitor* _tmp133_;
				MutterReadLogicalMonitor _tmp134_;
				DisplayVirtualMonitor* _tmp135_;
				MutterReadLogicalMonitor _tmp136_;
				DisplayVirtualMonitor* _tmp137_;
				MutterReadLogicalMonitor _tmp138_;
				DisplayVirtualMonitor* _tmp139_;
				MutterReadLogicalMonitor _tmp140_;
				DisplayVirtualMonitor* _tmp141_;
				MutterReadLogicalMonitor _tmp142_;
				DisplayVirtualMonitor* _tmp143_;
				MutterReadLogicalMonitor _tmp144_;
				MutterReadLogicalMonitor _tmp145_;
				MutterReadMonitorInfo* _tmp146_;
				gint _tmp146__length1;
#line 179 "../src/Objects/MonitorManager.vala"
				_tmp123_ = mutter_logical_monitor;
#line 179 "../src/Objects/MonitorManager.vala"
				_tmp124_ = _tmp123_.monitors;
#line 179 "../src/Objects/MonitorManager.vala"
				_tmp124__length1 = _tmp123_.monitors_length1;
#line 179 "../src/Objects/MonitorManager.vala"
				_tmp125_ = display_virtual_monitor_generate_id_from_monitors (_tmp124_, (gint) _tmp124__length1);
#line 179 "../src/Objects/MonitorManager.vala"
				monitors_id = _tmp125_;
#line 180 "../src/Objects/MonitorManager.vala"
				_tmp126_ = monitors_id;
#line 180 "../src/Objects/MonitorManager.vala"
				_tmp127_ = display_monitor_manager_get_virtual_monitor_by_id (self, _tmp126_);
#line 180 "../src/Objects/MonitorManager.vala"
				virtual_monitor = _tmp127_;
#line 181 "../src/Objects/MonitorManager.vala"
				_tmp128_ = virtual_monitor;
#line 181 "../src/Objects/MonitorManager.vala"
				if (_tmp128_ == NULL) {
#line 991 "MonitorManager.c"
					DisplayVirtualMonitor* _tmp129_;
					DisplayVirtualMonitor* _tmp130_;
#line 182 "../src/Objects/MonitorManager.vala"
					_tmp129_ = display_virtual_monitor_new ();
#line 182 "../src/Objects/MonitorManager.vala"
					_g_object_unref0 (virtual_monitor);
#line 182 "../src/Objects/MonitorManager.vala"
					virtual_monitor = _tmp129_;
#line 183 "../src/Objects/MonitorManager.vala"
					_tmp130_ = virtual_monitor;
#line 183 "../src/Objects/MonitorManager.vala"
					display_monitor_manager_add_virtual_monitor (self, _tmp130_);
#line 1004 "MonitorManager.c"
				}
#line 186 "../src/Objects/MonitorManager.vala"
				_tmp131_ = virtual_monitor;
#line 186 "../src/Objects/MonitorManager.vala"
				_tmp132_ = mutter_logical_monitor;
#line 186 "../src/Objects/MonitorManager.vala"
				display_virtual_monitor_set_x (_tmp131_, _tmp132_.x);
#line 187 "../src/Objects/MonitorManager.vala"
				_tmp133_ = virtual_monitor;
#line 187 "../src/Objects/MonitorManager.vala"
				_tmp134_ = mutter_logical_monitor;
#line 187 "../src/Objects/MonitorManager.vala"
				display_virtual_monitor_set_y (_tmp133_, _tmp134_.y);
#line 188 "../src/Objects/MonitorManager.vala"
				_tmp135_ = virtual_monitor;
#line 188 "../src/Objects/MonitorManager.vala"
				_tmp136_ = mutter_logical_monitor;
#line 188 "../src/Objects/MonitorManager.vala"
				display_virtual_monitor_set_current_x (_tmp135_, _tmp136_.x);
#line 189 "../src/Objects/MonitorManager.vala"
				_tmp137_ = virtual_monitor;
#line 189 "../src/Objects/MonitorManager.vala"
				_tmp138_ = mutter_logical_monitor;
#line 189 "../src/Objects/MonitorManager.vala"
				display_virtual_monitor_set_current_y (_tmp137_, _tmp138_.y);
#line 190 "../src/Objects/MonitorManager.vala"
				_tmp139_ = virtual_monitor;
#line 190 "../src/Objects/MonitorManager.vala"
				_tmp140_ = mutter_logical_monitor;
#line 190 "../src/Objects/MonitorManager.vala"
				display_virtual_monitor_set_scale (_tmp139_, _tmp140_.scale);
#line 191 "../src/Objects/MonitorManager.vala"
				_tmp141_ = virtual_monitor;
#line 191 "../src/Objects/MonitorManager.vala"
				_tmp142_ = mutter_logical_monitor;
#line 191 "../src/Objects/MonitorManager.vala"
				display_virtual_monitor_set_transform (_tmp141_, _tmp142_.transform);
#line 192 "../src/Objects/MonitorManager.vala"
				_tmp143_ = virtual_monitor;
#line 192 "../src/Objects/MonitorManager.vala"
				_tmp144_ = mutter_logical_monitor;
#line 192 "../src/Objects/MonitorManager.vala"
				display_virtual_monitor_set_primary (_tmp143_, _tmp144_.primary);
#line 193 "../src/Objects/MonitorManager.vala"
				_tmp145_ = mutter_logical_monitor;
#line 193 "../src/Objects/MonitorManager.vala"
				_tmp146_ = _tmp145_.monitors;
#line 193 "../src/Objects/MonitorManager.vala"
				_tmp146__length1 = _tmp145_.monitors_length1;
#line 1054 "MonitorManager.c"
				{
					MutterReadMonitorInfo* mutter_info_collection = NULL;
					gint mutter_info_collection_length1 = 0;
					gint _mutter_info_collection_size_ = 0;
					gint mutter_info_it = 0;
#line 193 "../src/Objects/MonitorManager.vala"
					mutter_info_collection = _tmp146_;
#line 193 "../src/Objects/MonitorManager.vala"
					mutter_info_collection_length1 = _tmp146__length1;
#line 193 "../src/Objects/MonitorManager.vala"
					for (mutter_info_it = 0; mutter_info_it < mutter_info_collection_length1; mutter_info_it = mutter_info_it + 1) {
#line 1066 "MonitorManager.c"
						MutterReadMonitorInfo _tmp147_;
						MutterReadMonitorInfo _tmp148_ = {0};
						MutterReadMonitorInfo mutter_info = {0};
#line 193 "../src/Objects/MonitorManager.vala"
						_tmp147_ = mutter_info_collection[mutter_info_it];
#line 193 "../src/Objects/MonitorManager.vala"
						mutter_read_monitor_info_copy (&_tmp147_, &_tmp148_);
#line 193 "../src/Objects/MonitorManager.vala"
						mutter_info = _tmp148_;
#line 1076 "MonitorManager.c"
						{
							{
								GeeLinkedList* _monitor_list = NULL;
								GeeLinkedList* _tmp149_;
								gint _monitor_size = 0;
								GeeLinkedList* _tmp150_;
								gint _tmp151_;
								gint _tmp152_;
								gint _monitor_index = 0;
#line 194 "../src/Objects/MonitorManager.vala"
								_tmp149_ = self->priv->_monitors;
#line 194 "../src/Objects/MonitorManager.vala"
								_monitor_list = _tmp149_;
#line 194 "../src/Objects/MonitorManager.vala"
								_tmp150_ = _monitor_list;
#line 194 "../src/Objects/MonitorManager.vala"
								_tmp151_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp150_);
#line 194 "../src/Objects/MonitorManager.vala"
								_tmp152_ = _tmp151_;
#line 194 "../src/Objects/MonitorManager.vala"
								_monitor_size = _tmp152_;
#line 194 "../src/Objects/MonitorManager.vala"
								_monitor_index = -1;
#line 194 "../src/Objects/MonitorManager.vala"
								while (TRUE) {
#line 1102 "MonitorManager.c"
									gint _tmp153_;
									gint _tmp154_;
									DisplayMonitor* monitor = NULL;
									GeeLinkedList* _tmp155_;
									gpointer _tmp156_;
									gboolean _tmp157_ = FALSE;
									DisplayMonitor* _tmp158_;
									MutterReadMonitorInfo _tmp159_;
#line 194 "../src/Objects/MonitorManager.vala"
									_monitor_index = _monitor_index + 1;
#line 194 "../src/Objects/MonitorManager.vala"
									_tmp153_ = _monitor_index;
#line 194 "../src/Objects/MonitorManager.vala"
									_tmp154_ = _monitor_size;
#line 194 "../src/Objects/MonitorManager.vala"
									if (!(_tmp153_ < _tmp154_)) {
#line 194 "../src/Objects/MonitorManager.vala"
										break;
#line 1121 "MonitorManager.c"
									}
#line 194 "../src/Objects/MonitorManager.vala"
									_tmp155_ = _monitor_list;
#line 194 "../src/Objects/MonitorManager.vala"
									_tmp156_ = gee_abstract_list_get ((GeeAbstractList*) _tmp155_, _monitor_index);
#line 194 "../src/Objects/MonitorManager.vala"
									monitor = (DisplayMonitor*) _tmp156_;
#line 195 "../src/Objects/MonitorManager.vala"
									_tmp158_ = monitor;
#line 195 "../src/Objects/MonitorManager.vala"
									_tmp159_ = mutter_info;
#line 195 "../src/Objects/MonitorManager.vala"
									if (display_monitor_manager_compare_monitor_with_mutter_info (_tmp158_, &_tmp159_)) {
#line 1135 "MonitorManager.c"
										DisplayVirtualMonitor* _tmp160_;
										GeeLinkedList* _tmp161_;
										GeeLinkedList* _tmp162_;
										DisplayMonitor* _tmp163_;
#line 195 "../src/Objects/MonitorManager.vala"
										_tmp160_ = virtual_monitor;
#line 195 "../src/Objects/MonitorManager.vala"
										_tmp161_ = display_virtual_monitor_get_monitors (_tmp160_);
#line 195 "../src/Objects/MonitorManager.vala"
										_tmp162_ = _tmp161_;
#line 195 "../src/Objects/MonitorManager.vala"
										_tmp163_ = monitor;
#line 195 "../src/Objects/MonitorManager.vala"
										_tmp157_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp162_, _tmp163_);
#line 1150 "MonitorManager.c"
									} else {
#line 195 "../src/Objects/MonitorManager.vala"
										_tmp157_ = FALSE;
#line 1154 "MonitorManager.c"
									}
#line 195 "../src/Objects/MonitorManager.vala"
									if (_tmp157_) {
#line 1158 "MonitorManager.c"
										DisplayVirtualMonitor* _tmp164_;
										GeeLinkedList* _tmp165_;
										GeeLinkedList* _tmp166_;
										DisplayMonitor* _tmp167_;
										GeeLinkedList* _tmp168_;
										DisplayMonitor* _tmp169_;
#line 196 "../src/Objects/MonitorManager.vala"
										_tmp164_ = virtual_monitor;
#line 196 "../src/Objects/MonitorManager.vala"
										_tmp165_ = display_virtual_monitor_get_monitors (_tmp164_);
#line 196 "../src/Objects/MonitorManager.vala"
										_tmp166_ = _tmp165_;
#line 196 "../src/Objects/MonitorManager.vala"
										_tmp167_ = monitor;
#line 196 "../src/Objects/MonitorManager.vala"
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp166_, _tmp167_);
#line 197 "../src/Objects/MonitorManager.vala"
										_tmp168_ = monitors_with_changed_modes;
#line 197 "../src/Objects/MonitorManager.vala"
										_tmp169_ = monitor;
#line 197 "../src/Objects/MonitorManager.vala"
										if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp168_, _tmp169_)) {
#line 1181 "MonitorManager.c"
											DisplayVirtualMonitor* _tmp170_;
#line 198 "../src/Objects/MonitorManager.vala"
											_tmp170_ = virtual_monitor;
#line 198 "../src/Objects/MonitorManager.vala"
											g_signal_emit_by_name (_tmp170_, "modes-changed");
#line 1187 "MonitorManager.c"
										}
#line 201 "../src/Objects/MonitorManager.vala"
										_g_object_unref0 (monitor);
#line 201 "../src/Objects/MonitorManager.vala"
										break;
#line 1193 "MonitorManager.c"
									}
#line 194 "../src/Objects/MonitorManager.vala"
									_g_object_unref0 (monitor);
#line 1197 "MonitorManager.c"
								}
							}
#line 193 "../src/Objects/MonitorManager.vala"
							mutter_read_monitor_info_destroy (&mutter_info);
#line 1202 "MonitorManager.c"
						}
					}
				}
#line 178 "../src/Objects/MonitorManager.vala"
				_g_object_unref0 (virtual_monitor);
#line 178 "../src/Objects/MonitorManager.vala"
				_g_free0 (monitors_id);
#line 178 "../src/Objects/MonitorManager.vala"
				mutter_read_logical_monitor_destroy (&mutter_logical_monitor);
#line 1212 "MonitorManager.c"
			}
		}
	}
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp171_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp172_;
		gint _tmp173_;
		gint _tmp174_;
		gint _monitor_index = 0;
#line 209 "../src/Objects/MonitorManager.vala"
		_tmp171_ = self->priv->_monitors;
#line 209 "../src/Objects/MonitorManager.vala"
		_monitor_list = _tmp171_;
#line 209 "../src/Objects/MonitorManager.vala"
		_tmp172_ = _monitor_list;
#line 209 "../src/Objects/MonitorManager.vala"
		_tmp173_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp172_);
#line 209 "../src/Objects/MonitorManager.vala"
		_tmp174_ = _tmp173_;
#line 209 "../src/Objects/MonitorManager.vala"
		_monitor_size = _tmp174_;
#line 209 "../src/Objects/MonitorManager.vala"
		_monitor_index = -1;
#line 209 "../src/Objects/MonitorManager.vala"
		while (TRUE) {
#line 1240 "MonitorManager.c"
			gint _tmp175_;
			gint _tmp176_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp177_;
			gpointer _tmp178_;
			gboolean found = FALSE;
#line 209 "../src/Objects/MonitorManager.vala"
			_monitor_index = _monitor_index + 1;
#line 209 "../src/Objects/MonitorManager.vala"
			_tmp175_ = _monitor_index;
#line 209 "../src/Objects/MonitorManager.vala"
			_tmp176_ = _monitor_size;
#line 209 "../src/Objects/MonitorManager.vala"
			if (!(_tmp175_ < _tmp176_)) {
#line 209 "../src/Objects/MonitorManager.vala"
				break;
#line 1257 "MonitorManager.c"
			}
#line 209 "../src/Objects/MonitorManager.vala"
			_tmp177_ = _monitor_list;
#line 209 "../src/Objects/MonitorManager.vala"
			_tmp178_ = gee_abstract_list_get ((GeeAbstractList*) _tmp177_, _monitor_index);
#line 209 "../src/Objects/MonitorManager.vala"
			monitor = (DisplayMonitor*) _tmp178_;
#line 210 "../src/Objects/MonitorManager.vala"
			found = FALSE;
#line 1267 "MonitorManager.c"
			{
				GeeLinkedList* _virtual_monitor_list = NULL;
				GeeLinkedList* _tmp179_;
				gint _virtual_monitor_size = 0;
				GeeLinkedList* _tmp180_;
				gint _tmp181_;
				gint _tmp182_;
				gint _virtual_monitor_index = 0;
#line 211 "../src/Objects/MonitorManager.vala"
				_tmp179_ = self->priv->_virtual_monitors;
#line 211 "../src/Objects/MonitorManager.vala"
				_virtual_monitor_list = _tmp179_;
#line 211 "../src/Objects/MonitorManager.vala"
				_tmp180_ = _virtual_monitor_list;
#line 211 "../src/Objects/MonitorManager.vala"
				_tmp181_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp180_);
#line 211 "../src/Objects/MonitorManager.vala"
				_tmp182_ = _tmp181_;
#line 211 "../src/Objects/MonitorManager.vala"
				_virtual_monitor_size = _tmp182_;
#line 211 "../src/Objects/MonitorManager.vala"
				_virtual_monitor_index = -1;
#line 211 "../src/Objects/MonitorManager.vala"
				while (TRUE) {
#line 1292 "MonitorManager.c"
					gint _tmp183_;
					gint _tmp184_;
					DisplayVirtualMonitor* virtual_monitor = NULL;
					GeeLinkedList* _tmp185_;
					gpointer _tmp186_;
					DisplayVirtualMonitor* _tmp187_;
					GeeLinkedList* _tmp188_;
					GeeLinkedList* _tmp189_;
					DisplayMonitor* _tmp190_;
#line 211 "../src/Objects/MonitorManager.vala"
					_virtual_monitor_index = _virtual_monitor_index + 1;
#line 211 "../src/Objects/MonitorManager.vala"
					_tmp183_ = _virtual_monitor_index;
#line 211 "../src/Objects/MonitorManager.vala"
					_tmp184_ = _virtual_monitor_size;
#line 211 "../src/Objects/MonitorManager.vala"
					if (!(_tmp183_ < _tmp184_)) {
#line 211 "../src/Objects/MonitorManager.vala"
						break;
#line 1312 "MonitorManager.c"
					}
#line 211 "../src/Objects/MonitorManager.vala"
					_tmp185_ = _virtual_monitor_list;
#line 211 "../src/Objects/MonitorManager.vala"
					_tmp186_ = gee_abstract_list_get ((GeeAbstractList*) _tmp185_, _virtual_monitor_index);
#line 211 "../src/Objects/MonitorManager.vala"
					virtual_monitor = (DisplayVirtualMonitor*) _tmp186_;
#line 212 "../src/Objects/MonitorManager.vala"
					_tmp187_ = virtual_monitor;
#line 212 "../src/Objects/MonitorManager.vala"
					_tmp188_ = display_virtual_monitor_get_monitors (_tmp187_);
#line 212 "../src/Objects/MonitorManager.vala"
					_tmp189_ = _tmp188_;
#line 212 "../src/Objects/MonitorManager.vala"
					_tmp190_ = monitor;
#line 212 "../src/Objects/MonitorManager.vala"
					if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp189_, _tmp190_)) {
#line 213 "../src/Objects/MonitorManager.vala"
						found = TRUE;
#line 214 "../src/Objects/MonitorManager.vala"
						_g_object_unref0 (virtual_monitor);
#line 214 "../src/Objects/MonitorManager.vala"
						break;
#line 1336 "MonitorManager.c"
					}
#line 211 "../src/Objects/MonitorManager.vala"
					_g_object_unref0 (virtual_monitor);
#line 1340 "MonitorManager.c"
				}
			}
#line 218 "../src/Objects/MonitorManager.vala"
			if (!found) {
#line 1345 "MonitorManager.c"
				DisplayVirtualMonitor* virtual_monitor = NULL;
				DisplayVirtualMonitor* _tmp191_;
				DisplayVirtualMonitor* _tmp192_;
				DisplayVirtualMonitor* _tmp193_;
				DisplayVirtualMonitor* _tmp194_;
				DisplayVirtualMonitor* _tmp195_;
				GeeLinkedList* _tmp196_;
				gpointer _tmp197_;
				DisplayVirtualMonitor* _tmp198_;
				gdouble _tmp199_;
				gdouble _tmp200_;
				DisplayVirtualMonitor* _tmp201_;
				GeeLinkedList* _tmp202_;
				GeeLinkedList* _tmp203_;
				DisplayMonitor* _tmp204_;
#line 219 "../src/Objects/MonitorManager.vala"
				_tmp191_ = display_virtual_monitor_new ();
#line 219 "../src/Objects/MonitorManager.vala"
				virtual_monitor = _tmp191_;
#line 220 "../src/Objects/MonitorManager.vala"
				_tmp192_ = virtual_monitor;
#line 220 "../src/Objects/MonitorManager.vala"
				display_monitor_manager_add_virtual_monitor (self, _tmp192_);
#line 221 "../src/Objects/MonitorManager.vala"
				_tmp193_ = virtual_monitor;
#line 221 "../src/Objects/MonitorManager.vala"
				display_virtual_monitor_set_is_active (_tmp193_, FALSE);
#line 222 "../src/Objects/MonitorManager.vala"
				_tmp194_ = virtual_monitor;
#line 222 "../src/Objects/MonitorManager.vala"
				display_virtual_monitor_set_primary (_tmp194_, FALSE);
#line 223 "../src/Objects/MonitorManager.vala"
				_tmp195_ = virtual_monitor;
#line 223 "../src/Objects/MonitorManager.vala"
				_tmp196_ = self->priv->_virtual_monitors;
#line 223 "../src/Objects/MonitorManager.vala"
				_tmp197_ = gee_abstract_list_get ((GeeAbstractList*) _tmp196_, 0);
#line 223 "../src/Objects/MonitorManager.vala"
				_tmp198_ = (DisplayVirtualMonitor*) _tmp197_;
#line 223 "../src/Objects/MonitorManager.vala"
				_tmp199_ = display_virtual_monitor_get_scale (_tmp198_);
#line 223 "../src/Objects/MonitorManager.vala"
				_tmp200_ = _tmp199_;
#line 223 "../src/Objects/MonitorManager.vala"
				display_virtual_monitor_set_scale (_tmp195_, _tmp200_);
#line 223 "../src/Objects/MonitorManager.vala"
				_g_object_unref0 (_tmp198_);
#line 224 "../src/Objects/MonitorManager.vala"
				_tmp201_ = virtual_monitor;
#line 224 "../src/Objects/MonitorManager.vala"
				_tmp202_ = display_virtual_monitor_get_monitors (_tmp201_);
#line 224 "../src/Objects/MonitorManager.vala"
				_tmp203_ = _tmp202_;
#line 224 "../src/Objects/MonitorManager.vala"
				_tmp204_ = monitor;
#line 224 "../src/Objects/MonitorManager.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp203_, _tmp204_);
#line 218 "../src/Objects/MonitorManager.vala"
				_g_object_unref0 (virtual_monitor);
#line 1405 "MonitorManager.c"
			}
#line 209 "../src/Objects/MonitorManager.vala"
			_g_object_unref0 (monitor);
#line 1409 "MonitorManager.c"
		}
	}
#line 75 "../src/Objects/MonitorManager.vala"
	_g_object_unref0 (monitors_with_changed_modes);
#line 75 "../src/Objects/MonitorManager.vala"
	_g_variant_unref0 (max_screen_size_variant);
#line 75 "../src/Objects/MonitorManager.vala"
	_g_variant_unref0 (global_scale_required_variant);
#line 75 "../src/Objects/MonitorManager.vala"
	_g_variant_unref0 (supports_mirroring_variant);
#line 75 "../src/Objects/MonitorManager.vala"
	_g_hash_table_unref0 (properties);
#line 75 "../src/Objects/MonitorManager.vala"
	mutter_logical_monitors = (_vala_MutterReadLogicalMonitor_array_free (mutter_logical_monitors, mutter_logical_monitors_length1), NULL);
#line 75 "../src/Objects/MonitorManager.vala"
	mutter_monitors = (_vala_MutterReadMonitor_array_free (mutter_monitors, mutter_monitors_length1), NULL);
#line 1426 "MonitorManager.c"
}

static void
_vala_array_add1 (MutterWriteLogicalMonitor* * array,
                  gint* length,
                  gint* size,
                  const MutterWriteLogicalMonitor* value)
{
#line 233 "../src/Objects/MonitorManager.vala"
	if ((*length) == (*size)) {
#line 233 "../src/Objects/MonitorManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 233 "../src/Objects/MonitorManager.vala"
		*array = g_renew (MutterWriteLogicalMonitor, *array, *size);
#line 1441 "MonitorManager.c"
	}
#line 233 "../src/Objects/MonitorManager.vala"
	(*array)[(*length)++] = *value;
#line 1445 "MonitorManager.c"
}

static void
_g_free0_ (gpointer var)
{
#line 255 "../src/Objects/MonitorManager.vala"
	var = (g_free (var), NULL);
#line 1453 "MonitorManager.c"
}

static void
_g_variant_unref0_ (gpointer var)
{
#line 255 "../src/Objects/MonitorManager.vala"
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
#line 1461 "MonitorManager.c"
}

static void
_vala_MutterWriteLogicalMonitor_array_free (MutterWriteLogicalMonitor * array,
                                            gssize array_length)
{
#line 256 "../src/Objects/MonitorManager.vala"
	if (array != NULL) {
#line 1470 "MonitorManager.c"
		gssize i;
#line 256 "../src/Objects/MonitorManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 256 "../src/Objects/MonitorManager.vala"
			mutter_write_logical_monitor_destroy (&array[i]);
#line 1476 "MonitorManager.c"
		}
	}
#line 256 "../src/Objects/MonitorManager.vala"
	g_free (array);
#line 1481 "MonitorManager.c"
}

void
display_monitor_manager_set_monitor_config (DisplayMonitorManager* self)
{
	MutterWriteLogicalMonitor* logical_monitors = NULL;
	MutterWriteLogicalMonitor* _tmp0_;
	gint logical_monitors_length1;
	gint _logical_monitors_size_;
	gint min_x = 0;
	gint min_y = 0;
	MutterWriteLogicalMonitor* _tmp14_;
	gint _tmp14__length1;
	gboolean _tmp17_ = FALSE;
	GHashTable* properties = NULL;
	GHashFunc _tmp25_;
	GEqualFunc _tmp26_;
	GHashTable* _tmp27_;
	GError* _inner_error0_ = NULL;
#line 229 "../src/Objects/MonitorManager.vala"
	g_return_if_fail (self != NULL);
#line 230 "../src/Objects/MonitorManager.vala"
	_tmp0_ = g_new0 (MutterWriteLogicalMonitor, 0);
#line 230 "../src/Objects/MonitorManager.vala"
	logical_monitors = _tmp0_;
#line 230 "../src/Objects/MonitorManager.vala"
	logical_monitors_length1 = 0;
#line 230 "../src/Objects/MonitorManager.vala"
	_logical_monitors_size_ = logical_monitors_length1;
#line 1511 "MonitorManager.c"
	{
		GeeLinkedList* _virtual_monitor_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _virtual_monitor_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _virtual_monitor_index = 0;
#line 231 "../src/Objects/MonitorManager.vala"
		_tmp1_ = self->priv->_virtual_monitors;
#line 231 "../src/Objects/MonitorManager.vala"
		_virtual_monitor_list = _tmp1_;
#line 231 "../src/Objects/MonitorManager.vala"
		_tmp2_ = _virtual_monitor_list;
#line 231 "../src/Objects/MonitorManager.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 231 "../src/Objects/MonitorManager.vala"
		_tmp4_ = _tmp3_;
#line 231 "../src/Objects/MonitorManager.vala"
		_virtual_monitor_size = _tmp4_;
#line 231 "../src/Objects/MonitorManager.vala"
		_virtual_monitor_index = -1;
#line 231 "../src/Objects/MonitorManager.vala"
		while (TRUE) {
#line 1536 "MonitorManager.c"
			gint _tmp5_;
			gint _tmp6_;
			DisplayVirtualMonitor* virtual_monitor = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			DisplayVirtualMonitor* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
#line 231 "../src/Objects/MonitorManager.vala"
			_virtual_monitor_index = _virtual_monitor_index + 1;
#line 231 "../src/Objects/MonitorManager.vala"
			_tmp5_ = _virtual_monitor_index;
#line 231 "../src/Objects/MonitorManager.vala"
			_tmp6_ = _virtual_monitor_size;
#line 231 "../src/Objects/MonitorManager.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 231 "../src/Objects/MonitorManager.vala"
				break;
#line 1555 "MonitorManager.c"
			}
#line 231 "../src/Objects/MonitorManager.vala"
			_tmp7_ = _virtual_monitor_list;
#line 231 "../src/Objects/MonitorManager.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _virtual_monitor_index);
#line 231 "../src/Objects/MonitorManager.vala"
			virtual_monitor = (DisplayVirtualMonitor*) _tmp8_;
#line 232 "../src/Objects/MonitorManager.vala"
			_tmp9_ = virtual_monitor;
#line 232 "../src/Objects/MonitorManager.vala"
			_tmp10_ = display_virtual_monitor_get_is_active (_tmp9_);
#line 232 "../src/Objects/MonitorManager.vala"
			_tmp11_ = _tmp10_;
#line 232 "../src/Objects/MonitorManager.vala"
			if (_tmp11_) {
#line 1571 "MonitorManager.c"
				DisplayVirtualMonitor* _tmp12_;
				MutterWriteLogicalMonitor _tmp13_ = {0};
#line 233 "../src/Objects/MonitorManager.vala"
				_tmp12_ = virtual_monitor;
#line 233 "../src/Objects/MonitorManager.vala"
				display_monitor_manager_get_mutter_logical_monitor (_tmp12_, &_tmp13_);
#line 233 "../src/Objects/MonitorManager.vala"
				_vala_array_add1 (&logical_monitors, &logical_monitors_length1, &_logical_monitors_size_, &_tmp13_);
#line 1580 "MonitorManager.c"
			}
#line 231 "../src/Objects/MonitorManager.vala"
			_g_object_unref0 (virtual_monitor);
#line 1584 "MonitorManager.c"
		}
	}
#line 237 "../src/Objects/MonitorManager.vala"
	min_x = G_MAXINT;
#line 238 "../src/Objects/MonitorManager.vala"
	min_y = G_MAXINT;
#line 242 "../src/Objects/MonitorManager.vala"
	_tmp14_ = logical_monitors;
#line 242 "../src/Objects/MonitorManager.vala"
	_tmp14__length1 = logical_monitors_length1;
#line 1595 "MonitorManager.c"
	{
		MutterWriteLogicalMonitor* logical_monitor_collection = NULL;
		gint logical_monitor_collection_length1 = 0;
		gint _logical_monitor_collection_size_ = 0;
		gint logical_monitor_it = 0;
#line 242 "../src/Objects/MonitorManager.vala"
		logical_monitor_collection = _tmp14_;
#line 242 "../src/Objects/MonitorManager.vala"
		logical_monitor_collection_length1 = _tmp14__length1;
#line 242 "../src/Objects/MonitorManager.vala"
		for (logical_monitor_it = 0; logical_monitor_it < logical_monitor_collection_length1; logical_monitor_it = logical_monitor_it + 1) {
#line 1607 "MonitorManager.c"
			MutterWriteLogicalMonitor logical_monitor = {0};
#line 242 "../src/Objects/MonitorManager.vala"
			logical_monitor = logical_monitor_collection[logical_monitor_it];
#line 1611 "MonitorManager.c"
			{
				MutterWriteLogicalMonitor _tmp15_;
				MutterWriteLogicalMonitor _tmp16_;
#line 243 "../src/Objects/MonitorManager.vala"
				_tmp15_ = logical_monitor;
#line 243 "../src/Objects/MonitorManager.vala"
				min_x = MIN (min_x, _tmp15_.x);
#line 244 "../src/Objects/MonitorManager.vala"
				_tmp16_ = logical_monitor;
#line 244 "../src/Objects/MonitorManager.vala"
				min_y = MIN (min_y, _tmp16_.y);
#line 1623 "MonitorManager.c"
			}
		}
	}
#line 247 "../src/Objects/MonitorManager.vala"
	if (min_x != 0) {
#line 247 "../src/Objects/MonitorManager.vala"
		_tmp17_ = TRUE;
#line 1631 "MonitorManager.c"
	} else {
#line 247 "../src/Objects/MonitorManager.vala"
		_tmp17_ = min_y != 0;
#line 1635 "MonitorManager.c"
	}
#line 247 "../src/Objects/MonitorManager.vala"
	if (_tmp17_) {
#line 1639 "MonitorManager.c"
		{
			gint i = 0;
#line 249 "../src/Objects/MonitorManager.vala"
			i = 0;
#line 1644 "MonitorManager.c"
			{
				gboolean _tmp18_ = FALSE;
#line 249 "../src/Objects/MonitorManager.vala"
				_tmp18_ = TRUE;
#line 249 "../src/Objects/MonitorManager.vala"
				while (TRUE) {
#line 1651 "MonitorManager.c"
					MutterWriteLogicalMonitor* _tmp20_;
					gint _tmp20__length1;
					MutterWriteLogicalMonitor* _tmp21_;
					gint _tmp21__length1;
					MutterWriteLogicalMonitor* _tmp22_;
					gint _tmp22__length1;
					MutterWriteLogicalMonitor* _tmp23_;
					gint _tmp23__length1;
					MutterWriteLogicalMonitor* _tmp24_;
					gint _tmp24__length1;
#line 249 "../src/Objects/MonitorManager.vala"
					if (!_tmp18_) {
#line 1664 "MonitorManager.c"
						gint _tmp19_;
#line 249 "../src/Objects/MonitorManager.vala"
						_tmp19_ = i;
#line 249 "../src/Objects/MonitorManager.vala"
						i = _tmp19_ + 1;
#line 1670 "MonitorManager.c"
					}
#line 249 "../src/Objects/MonitorManager.vala"
					_tmp18_ = FALSE;
#line 249 "../src/Objects/MonitorManager.vala"
					_tmp20_ = logical_monitors;
#line 249 "../src/Objects/MonitorManager.vala"
					_tmp20__length1 = logical_monitors_length1;
#line 249 "../src/Objects/MonitorManager.vala"
					if (!(i < _tmp20__length1)) {
#line 249 "../src/Objects/MonitorManager.vala"
						break;
#line 1682 "MonitorManager.c"
					}
#line 250 "../src/Objects/MonitorManager.vala"
					_tmp21_ = logical_monitors;
#line 250 "../src/Objects/MonitorManager.vala"
					_tmp21__length1 = logical_monitors_length1;
#line 250 "../src/Objects/MonitorManager.vala"
					_tmp22_ = logical_monitors;
#line 250 "../src/Objects/MonitorManager.vala"
					_tmp22__length1 = logical_monitors_length1;
#line 250 "../src/Objects/MonitorManager.vala"
					_tmp22_[i].x = _tmp22_[i].x - min_x;
#line 251 "../src/Objects/MonitorManager.vala"
					_tmp23_ = logical_monitors;
#line 251 "../src/Objects/MonitorManager.vala"
					_tmp23__length1 = logical_monitors_length1;
#line 251 "../src/Objects/MonitorManager.vala"
					_tmp24_ = logical_monitors;
#line 251 "../src/Objects/MonitorManager.vala"
					_tmp24__length1 = logical_monitors_length1;
#line 251 "../src/Objects/MonitorManager.vala"
					_tmp24_[i].y = _tmp24_[i].y - min_y;
#line 1704 "MonitorManager.c"
				}
			}
		}
	}
#line 255 "../src/Objects/MonitorManager.vala"
	_tmp25_ = g_str_hash;
#line 255 "../src/Objects/MonitorManager.vala"
	_tmp26_ = g_str_equal;
#line 255 "../src/Objects/MonitorManager.vala"
	_tmp27_ = g_hash_table_new_full (_tmp25_, _tmp26_, _g_free0_, _g_variant_unref0_);
#line 255 "../src/Objects/MonitorManager.vala"
	properties = _tmp27_;
#line 1717 "MonitorManager.c"
	{
		MutterDisplayConfigInterface* _tmp28_;
		MutterWriteLogicalMonitor* _tmp29_;
		gint _tmp29__length1;
#line 257 "../src/Objects/MonitorManager.vala"
		_tmp28_ = self->priv->iface;
#line 257 "../src/Objects/MonitorManager.vala"
		_tmp29_ = logical_monitors;
#line 257 "../src/Objects/MonitorManager.vala"
		_tmp29__length1 = logical_monitors_length1;
#line 257 "../src/Objects/MonitorManager.vala"
		mutter_display_config_interface_apply_monitors_config (_tmp28_, self->priv->current_serial, MUTTER_APPLY_METHOD_PERSISTENT, _tmp29_, (gint) _tmp29__length1, properties, &_inner_error0_);
#line 257 "../src/Objects/MonitorManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1732 "MonitorManager.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
#line 256 "../src/Objects/MonitorManager.vala"
		e = _inner_error0_;
#line 256 "../src/Objects/MonitorManager.vala"
		_inner_error0_ = NULL;
#line 259 "../src/Objects/MonitorManager.vala"
		_tmp30_ = e;
#line 259 "../src/Objects/MonitorManager.vala"
		_tmp31_ = _tmp30_->message;
#line 259 "../src/Objects/MonitorManager.vala"
		g_critical ("MonitorManager.vala:259: %s", _tmp31_);
#line 256 "../src/Objects/MonitorManager.vala"
		_g_error_free0 (e);
#line 1754 "MonitorManager.c"
	}
	__finally0:
#line 256 "../src/Objects/MonitorManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 256 "../src/Objects/MonitorManager.vala"
		_g_hash_table_unref0 (properties);
#line 256 "../src/Objects/MonitorManager.vala"
		logical_monitors = (_vala_MutterWriteLogicalMonitor_array_free (logical_monitors, logical_monitors_length1), NULL);
#line 256 "../src/Objects/MonitorManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 256 "../src/Objects/MonitorManager.vala"
		g_clear_error (&_inner_error0_);
#line 256 "../src/Objects/MonitorManager.vala"
		return;
#line 1769 "MonitorManager.c"
	}
#line 229 "../src/Objects/MonitorManager.vala"
	_g_hash_table_unref0 (properties);
#line 229 "../src/Objects/MonitorManager.vala"
	logical_monitors = (_vala_MutterWriteLogicalMonitor_array_free (logical_monitors, logical_monitors_length1), NULL);
#line 1775 "MonitorManager.c"
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
#line 275 "../src/Objects/MonitorManager.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 1783 "MonitorManager.c"
}

static void
_vala_array_add2 (MutterWriteMonitor* * array,
                  gint* length,
                  gint* size,
                  const MutterWriteMonitor* value)
{
#line 281 "../src/Objects/MonitorManager.vala"
	if ((*length) == (*size)) {
#line 281 "../src/Objects/MonitorManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 281 "../src/Objects/MonitorManager.vala"
		*array = g_renew (MutterWriteMonitor, *array, *size);
#line 1798 "MonitorManager.c"
	}
#line 281 "../src/Objects/MonitorManager.vala"
	(*array)[(*length)++] = *value;
#line 1802 "MonitorManager.c"
}

static MutterWriteMonitor*
_vala_array_dup11 (MutterWriteMonitor* self,
                   gssize length)
{
#line 284 "../src/Objects/MonitorManager.vala"
	if (length > 0) {
#line 1811 "MonitorManager.c"
		MutterWriteMonitor* result;
		gssize i;
#line 284 "../src/Objects/MonitorManager.vala"
		result = g_new0 (MutterWriteMonitor, length);
#line 284 "../src/Objects/MonitorManager.vala"
		for (i = 0; i < length; i++) {
#line 1818 "MonitorManager.c"
			MutterWriteMonitor _tmp0_;
			MutterWriteMonitor _tmp1_ = {0};
#line 284 "../src/Objects/MonitorManager.vala"
			_tmp0_ = self[i];
#line 284 "../src/Objects/MonitorManager.vala"
			mutter_write_monitor_copy (&_tmp0_, &_tmp1_);
#line 284 "../src/Objects/MonitorManager.vala"
			result[i] = _tmp1_;
#line 1827 "MonitorManager.c"
		}
#line 284 "../src/Objects/MonitorManager.vala"
		return result;
#line 1831 "MonitorManager.c"
	}
#line 284 "../src/Objects/MonitorManager.vala"
	return NULL;
#line 1835 "MonitorManager.c"
}

static void
_vala_MutterWriteMonitor_array_free (MutterWriteMonitor * array,
                                     gssize array_length)
{
#line 284 "../src/Objects/MonitorManager.vala"
	if (array != NULL) {
#line 1844 "MonitorManager.c"
		gssize i;
#line 284 "../src/Objects/MonitorManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 284 "../src/Objects/MonitorManager.vala"
			mutter_write_monitor_destroy (&array[i]);
#line 1850 "MonitorManager.c"
		}
	}
#line 284 "../src/Objects/MonitorManager.vala"
	g_free (array);
#line 1855 "MonitorManager.c"
}

void
display_monitor_manager_get_mutter_logical_monitor (DisplayVirtualMonitor* virtual_monitor,
                                                    MutterWriteLogicalMonitor* result)
{
	MutterWriteLogicalMonitor logical_monitor = {0};
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	DisplayTransform _tmp6_;
	DisplayTransform _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	MutterWriteLogicalMonitor _tmp10_ = {0};
	MutterWriteMonitor* mutter_monitors = NULL;
	MutterWriteMonitor* _tmp11_;
	gint mutter_monitors_length1;
	gint _mutter_monitors_size_;
	MutterWriteMonitor* _tmp42_;
	gint _tmp42__length1;
	MutterWriteMonitor* _tmp43_;
	gint _tmp43__length1;
#line 263 "../src/Objects/MonitorManager.vala"
	g_return_if_fail (virtual_monitor != NULL);
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp0_ = display_virtual_monitor_get_x (virtual_monitor);
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp1_ = _tmp0_;
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp2_ = display_virtual_monitor_get_y (virtual_monitor);
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp3_ = _tmp2_;
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp4_ = display_virtual_monitor_get_scale (virtual_monitor);
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp5_ = _tmp4_;
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp6_ = display_virtual_monitor_get_transform (virtual_monitor);
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp7_ = _tmp6_;
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp8_ = display_virtual_monitor_get_primary (virtual_monitor);
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp9_ = _tmp8_;
#line 264 "../src/Objects/MonitorManager.vala"
	memset (&_tmp10_, 0, sizeof (MutterWriteLogicalMonitor));
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp10_.x = _tmp1_;
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp10_.y = _tmp3_;
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp10_.scale = _tmp5_;
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp10_.transform = _tmp7_;
#line 264 "../src/Objects/MonitorManager.vala"
	_tmp10_.primary = _tmp9_;
#line 264 "../src/Objects/MonitorManager.vala"
	logical_monitor = _tmp10_;
#line 272 "../src/Objects/MonitorManager.vala"
	_tmp11_ = g_new0 (MutterWriteMonitor, 0);
#line 272 "../src/Objects/MonitorManager.vala"
	mutter_monitors = _tmp11_;
#line 272 "../src/Objects/MonitorManager.vala"
	mutter_monitors_length1 = 0;
#line 272 "../src/Objects/MonitorManager.vala"
	_mutter_monitors_size_ = mutter_monitors_length1;
#line 1926 "MonitorManager.c"
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp12_;
		GeeLinkedList* _tmp13_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gint _monitor_index = 0;
#line 273 "../src/Objects/MonitorManager.vala"
		_tmp12_ = display_virtual_monitor_get_monitors (virtual_monitor);
#line 273 "../src/Objects/MonitorManager.vala"
		_tmp13_ = _tmp12_;
#line 273 "../src/Objects/MonitorManager.vala"
		_monitor_list = _tmp13_;
#line 273 "../src/Objects/MonitorManager.vala"
		_tmp14_ = _monitor_list;
#line 273 "../src/Objects/MonitorManager.vala"
		_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 273 "../src/Objects/MonitorManager.vala"
		_tmp16_ = _tmp15_;
#line 273 "../src/Objects/MonitorManager.vala"
		_monitor_size = _tmp16_;
#line 273 "../src/Objects/MonitorManager.vala"
		_monitor_index = -1;
#line 273 "../src/Objects/MonitorManager.vala"
		while (TRUE) {
#line 1954 "MonitorManager.c"
			gint _tmp17_;
			gint _tmp18_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp19_;
			gpointer _tmp20_;
			GHashTable* properties = NULL;
			GHashFunc _tmp21_;
			GEqualFunc _tmp22_;
			GHashTable* _tmp23_;
			MutterWriteMonitor mutter_monitor = {0};
			DisplayMonitor* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			gchar* _tmp27_;
			DisplayMonitor* _tmp28_;
			DisplayMonitorMode* _tmp29_;
			DisplayMonitorMode* _tmp30_;
			DisplayMonitorMode* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_;
			gchar* _tmp34_;
			GHashTable* _tmp35_;
			GHashTable* _tmp36_;
			MutterWriteMonitor _tmp37_ = {0};
			MutterWriteMonitor _tmp38_;
			MutterWriteMonitor _tmp39_;
			MutterWriteMonitor _tmp40_;
			MutterWriteMonitor _tmp41_ = {0};
#line 273 "../src/Objects/MonitorManager.vala"
			_monitor_index = _monitor_index + 1;
#line 273 "../src/Objects/MonitorManager.vala"
			_tmp17_ = _monitor_index;
#line 273 "../src/Objects/MonitorManager.vala"
			_tmp18_ = _monitor_size;
#line 273 "../src/Objects/MonitorManager.vala"
			if (!(_tmp17_ < _tmp18_)) {
#line 273 "../src/Objects/MonitorManager.vala"
				break;
#line 1993 "MonitorManager.c"
			}
#line 273 "../src/Objects/MonitorManager.vala"
			_tmp19_ = _monitor_list;
#line 273 "../src/Objects/MonitorManager.vala"
			_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _monitor_index);
#line 273 "../src/Objects/MonitorManager.vala"
			monitor = (DisplayMonitor*) _tmp20_;
#line 274 "../src/Objects/MonitorManager.vala"
			_tmp21_ = g_str_hash;
#line 274 "../src/Objects/MonitorManager.vala"
			_tmp22_ = g_str_equal;
#line 274 "../src/Objects/MonitorManager.vala"
			_tmp23_ = g_hash_table_new_full (_tmp21_, _tmp22_, _g_free0_, _g_variant_unref0_);
#line 274 "../src/Objects/MonitorManager.vala"
			properties = _tmp23_;
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp24_ = monitor;
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp25_ = display_monitor_get_connector (_tmp24_);
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp26_ = _tmp25_;
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp27_ = g_strdup (_tmp26_);
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp28_ = monitor;
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp29_ = display_monitor_get_current_mode (_tmp28_);
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp30_ = _tmp29_;
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp31_ = _tmp30_;
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp32_ = display_monitor_mode_get_id (_tmp31_);
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp33_ = _tmp32_;
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp34_ = g_strdup (_tmp33_);
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp35_ = properties;
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp36_ = _g_hash_table_ref0 (_tmp35_);
#line 275 "../src/Objects/MonitorManager.vala"
			memset (&_tmp37_, 0, sizeof (MutterWriteMonitor));
#line 275 "../src/Objects/MonitorManager.vala"
			_g_free0 (_tmp37_.connector);
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp37_.connector = _tmp27_;
#line 275 "../src/Objects/MonitorManager.vala"
			_g_free0 (_tmp37_.monitor_mode);
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp37_.monitor_mode = _tmp34_;
#line 275 "../src/Objects/MonitorManager.vala"
			_g_hash_table_unref0 (_tmp37_.properties);
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp37_.properties = _tmp36_;
#line 275 "../src/Objects/MonitorManager.vala"
			_tmp38_ = _tmp37_;
#line 275 "../src/Objects/MonitorManager.vala"
			_g_object_unref0 (_tmp31_);
#line 275 "../src/Objects/MonitorManager.vala"
			mutter_monitor = _tmp38_;
#line 281 "../src/Objects/MonitorManager.vala"
			_tmp39_ = mutter_monitor;
#line 281 "../src/Objects/MonitorManager.vala"
			_tmp40_ = _tmp39_;
#line 281 "../src/Objects/MonitorManager.vala"
			mutter_write_monitor_copy (&_tmp40_, &_tmp41_);
#line 281 "../src/Objects/MonitorManager.vala"
			_vala_array_add2 (&mutter_monitors, &mutter_monitors_length1, &_mutter_monitors_size_, &_tmp41_);
#line 273 "../src/Objects/MonitorManager.vala"
			mutter_write_monitor_destroy (&mutter_monitor);
#line 273 "../src/Objects/MonitorManager.vala"
			_g_hash_table_unref0 (properties);
#line 273 "../src/Objects/MonitorManager.vala"
			_g_object_unref0 (monitor);
#line 2069 "MonitorManager.c"
		}
	}
#line 284 "../src/Objects/MonitorManager.vala"
	_tmp42_ = mutter_monitors;
#line 284 "../src/Objects/MonitorManager.vala"
	_tmp42__length1 = mutter_monitors_length1;
#line 284 "../src/Objects/MonitorManager.vala"
	_tmp43_ = (_tmp42_ != NULL) ? _vala_array_dup11 (_tmp42_, _tmp42__length1) : _tmp42_;
#line 284 "../src/Objects/MonitorManager.vala"
	_tmp43__length1 = _tmp42__length1;
#line 284 "../src/Objects/MonitorManager.vala"
	logical_monitor.monitors = (_vala_MutterWriteMonitor_array_free (logical_monitor.monitors, logical_monitor.monitors_length1), NULL);
#line 284 "../src/Objects/MonitorManager.vala"
	logical_monitor.monitors = _tmp43_;
#line 284 "../src/Objects/MonitorManager.vala"
	logical_monitor.monitors_length1 = _tmp43__length1;
#line 285 "../src/Objects/MonitorManager.vala"
	*result = logical_monitor;
#line 285 "../src/Objects/MonitorManager.vala"
	mutter_monitors = (_vala_MutterWriteMonitor_array_free (mutter_monitors, mutter_monitors_length1), NULL);
#line 285 "../src/Objects/MonitorManager.vala"
	return;
#line 2092 "MonitorManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 306 "../src/Objects/MonitorManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 2100 "MonitorManager.c"
}

void
display_monitor_manager_enable_clone_mode (DisplayMonitorManager* self)
{
	DisplayVirtualMonitor* clone_virtual_monitor = NULL;
	DisplayVirtualMonitor* _tmp0_;
	DisplayVirtualMonitor* _tmp1_;
	DisplayVirtualMonitor* _tmp2_;
	GeeLinkedList* _tmp3_;
	DisplayVirtualMonitor* _tmp4_;
	GeeLinkedList* _tmp5_;
	GeeLinkedList* _tmp6_;
	GeeLinkedList* _tmp7_;
	GeeLinkedList* modes = NULL;
	DisplayVirtualMonitor* _tmp8_;
	GeeLinkedList* _tmp9_;
	DisplayMonitorMode* largest_mode_in_use = NULL;
	DisplayMonitorMode* largest_mode = NULL;
	GeeLinkedList* _tmp10_;
	gpointer _tmp11_;
	DisplayMonitorMode* _tmp46_;
	GeeLinkedList* _tmp51_;
	GeeLinkedList* _tmp52_;
	DisplayVirtualMonitor* _tmp53_;
#line 289 "../src/Objects/MonitorManager.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/Objects/MonitorManager.vala"
	_tmp0_ = display_virtual_monitor_new ();
#line 290 "../src/Objects/MonitorManager.vala"
	clone_virtual_monitor = _tmp0_;
#line 291 "../src/Objects/MonitorManager.vala"
	_tmp1_ = clone_virtual_monitor;
#line 291 "../src/Objects/MonitorManager.vala"
	display_virtual_monitor_set_primary (_tmp1_, TRUE);
#line 292 "../src/Objects/MonitorManager.vala"
	_tmp2_ = clone_virtual_monitor;
#line 292 "../src/Objects/MonitorManager.vala"
	_tmp3_ = self->priv->_monitors;
#line 292 "../src/Objects/MonitorManager.vala"
	display_virtual_monitor_set_scale (_tmp2_, display_utils_get_min_compatible_scale (_tmp3_));
#line 293 "../src/Objects/MonitorManager.vala"
	_tmp4_ = clone_virtual_monitor;
#line 293 "../src/Objects/MonitorManager.vala"
	_tmp5_ = display_virtual_monitor_get_monitors (_tmp4_);
#line 293 "../src/Objects/MonitorManager.vala"
	_tmp6_ = _tmp5_;
#line 293 "../src/Objects/MonitorManager.vala"
	_tmp7_ = self->priv->_monitors;
#line 293 "../src/Objects/MonitorManager.vala"
	gee_collection_add_all ((GeeCollection*) _tmp6_, (GeeCollection*) _tmp7_);
#line 294 "../src/Objects/MonitorManager.vala"
	_tmp8_ = clone_virtual_monitor;
#line 294 "../src/Objects/MonitorManager.vala"
	_tmp9_ = display_virtual_monitor_get_available_modes (_tmp8_);
#line 294 "../src/Objects/MonitorManager.vala"
	modes = _tmp9_;
#line 301 "../src/Objects/MonitorManager.vala"
	largest_mode_in_use = NULL;
#line 302 "../src/Objects/MonitorManager.vala"
	_tmp10_ = modes;
#line 302 "../src/Objects/MonitorManager.vala"
	_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, 0);
#line 302 "../src/Objects/MonitorManager.vala"
	largest_mode = (DisplayMonitorMode*) _tmp11_;
#line 2166 "MonitorManager.c"
	{
		GeeLinkedList* _mode_list = NULL;
		GeeLinkedList* _tmp12_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _mode_index = 0;
#line 303 "../src/Objects/MonitorManager.vala"
		_tmp12_ = modes;
#line 303 "../src/Objects/MonitorManager.vala"
		_mode_list = _tmp12_;
#line 303 "../src/Objects/MonitorManager.vala"
		_tmp13_ = _mode_list;
#line 303 "../src/Objects/MonitorManager.vala"
		_tmp14_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp13_);
#line 303 "../src/Objects/MonitorManager.vala"
		_tmp15_ = _tmp14_;
#line 303 "../src/Objects/MonitorManager.vala"
		_mode_size = _tmp15_;
#line 303 "../src/Objects/MonitorManager.vala"
		_mode_index = -1;
#line 303 "../src/Objects/MonitorManager.vala"
		while (TRUE) {
#line 2191 "MonitorManager.c"
			gint _tmp16_;
			gint _tmp17_;
			DisplayMonitorMode* mode = NULL;
			GeeLinkedList* _tmp18_;
			gpointer _tmp19_;
			DisplayMonitorMode* _tmp20_;
			gboolean _tmp21_;
			gboolean _tmp22_;
			DisplayMonitorMode* _tmp34_;
#line 303 "../src/Objects/MonitorManager.vala"
			_mode_index = _mode_index + 1;
#line 303 "../src/Objects/MonitorManager.vala"
			_tmp16_ = _mode_index;
#line 303 "../src/Objects/MonitorManager.vala"
			_tmp17_ = _mode_size;
#line 303 "../src/Objects/MonitorManager.vala"
			if (!(_tmp16_ < _tmp17_)) {
#line 303 "../src/Objects/MonitorManager.vala"
				break;
#line 2211 "MonitorManager.c"
			}
#line 303 "../src/Objects/MonitorManager.vala"
			_tmp18_ = _mode_list;
#line 303 "../src/Objects/MonitorManager.vala"
			_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _mode_index);
#line 303 "../src/Objects/MonitorManager.vala"
			mode = (DisplayMonitorMode*) _tmp19_;
#line 304 "../src/Objects/MonitorManager.vala"
			_tmp20_ = mode;
#line 304 "../src/Objects/MonitorManager.vala"
			_tmp21_ = display_monitor_mode_get_is_current (_tmp20_);
#line 304 "../src/Objects/MonitorManager.vala"
			_tmp22_ = _tmp21_;
#line 304 "../src/Objects/MonitorManager.vala"
			if (_tmp22_) {
#line 2227 "MonitorManager.c"
				DisplayMonitorMode* _tmp23_;
#line 305 "../src/Objects/MonitorManager.vala"
				_tmp23_ = largest_mode_in_use;
#line 305 "../src/Objects/MonitorManager.vala"
				if (_tmp23_ == NULL) {
#line 2233 "MonitorManager.c"
					DisplayMonitorMode* _tmp24_;
					DisplayMonitorMode* _tmp25_;
#line 306 "../src/Objects/MonitorManager.vala"
					_tmp24_ = mode;
#line 306 "../src/Objects/MonitorManager.vala"
					_tmp25_ = _g_object_ref0 (_tmp24_);
#line 306 "../src/Objects/MonitorManager.vala"
					_g_object_unref0 (largest_mode_in_use);
#line 306 "../src/Objects/MonitorManager.vala"
					largest_mode_in_use = _tmp25_;
#line 2244 "MonitorManager.c"
				} else {
					DisplayMonitorMode* _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
					DisplayMonitorMode* _tmp29_;
					gint _tmp30_;
					gint _tmp31_;
#line 307 "../src/Objects/MonitorManager.vala"
					_tmp26_ = largest_mode_in_use;
#line 307 "../src/Objects/MonitorManager.vala"
					_tmp27_ = display_monitor_mode_get_width (_tmp26_);
#line 307 "../src/Objects/MonitorManager.vala"
					_tmp28_ = _tmp27_;
#line 307 "../src/Objects/MonitorManager.vala"
					_tmp29_ = mode;
#line 307 "../src/Objects/MonitorManager.vala"
					_tmp30_ = display_monitor_mode_get_width (_tmp29_);
#line 307 "../src/Objects/MonitorManager.vala"
					_tmp31_ = _tmp30_;
#line 307 "../src/Objects/MonitorManager.vala"
					if (_tmp28_ < _tmp31_) {
#line 2266 "MonitorManager.c"
						DisplayMonitorMode* _tmp32_;
						DisplayMonitorMode* _tmp33_;
#line 308 "../src/Objects/MonitorManager.vala"
						_tmp32_ = mode;
#line 308 "../src/Objects/MonitorManager.vala"
						_tmp33_ = _g_object_ref0 (_tmp32_);
#line 308 "../src/Objects/MonitorManager.vala"
						_g_object_unref0 (largest_mode_in_use);
#line 308 "../src/Objects/MonitorManager.vala"
						largest_mode_in_use = _tmp33_;
#line 2277 "MonitorManager.c"
					}
				}
			}
#line 313 "../src/Objects/MonitorManager.vala"
			_tmp34_ = largest_mode_in_use;
#line 313 "../src/Objects/MonitorManager.vala"
			if (_tmp34_ == NULL) {
#line 2285 "MonitorManager.c"
				DisplayMonitorMode* _tmp35_;
#line 314 "../src/Objects/MonitorManager.vala"
				_tmp35_ = largest_mode;
#line 314 "../src/Objects/MonitorManager.vala"
				if (_tmp35_ == NULL) {
#line 2291 "MonitorManager.c"
					DisplayMonitorMode* _tmp36_;
					DisplayMonitorMode* _tmp37_;
#line 315 "../src/Objects/MonitorManager.vala"
					_tmp36_ = mode;
#line 315 "../src/Objects/MonitorManager.vala"
					_tmp37_ = _g_object_ref0 (_tmp36_);
#line 315 "../src/Objects/MonitorManager.vala"
					_g_object_unref0 (largest_mode);
#line 315 "../src/Objects/MonitorManager.vala"
					largest_mode = _tmp37_;
#line 2302 "MonitorManager.c"
				} else {
					DisplayMonitorMode* _tmp38_;
					gint _tmp39_;
					gint _tmp40_;
					DisplayMonitorMode* _tmp41_;
					gint _tmp42_;
					gint _tmp43_;
#line 316 "../src/Objects/MonitorManager.vala"
					_tmp38_ = largest_mode;
#line 316 "../src/Objects/MonitorManager.vala"
					_tmp39_ = display_monitor_mode_get_width (_tmp38_);
#line 316 "../src/Objects/MonitorManager.vala"
					_tmp40_ = _tmp39_;
#line 316 "../src/Objects/MonitorManager.vala"
					_tmp41_ = mode;
#line 316 "../src/Objects/MonitorManager.vala"
					_tmp42_ = display_monitor_mode_get_width (_tmp41_);
#line 316 "../src/Objects/MonitorManager.vala"
					_tmp43_ = _tmp42_;
#line 316 "../src/Objects/MonitorManager.vala"
					if (_tmp40_ < _tmp43_) {
#line 2324 "MonitorManager.c"
						DisplayMonitorMode* _tmp44_;
						DisplayMonitorMode* _tmp45_;
#line 317 "../src/Objects/MonitorManager.vala"
						_tmp44_ = mode;
#line 317 "../src/Objects/MonitorManager.vala"
						_tmp45_ = _g_object_ref0 (_tmp44_);
#line 317 "../src/Objects/MonitorManager.vala"
						_g_object_unref0 (largest_mode);
#line 317 "../src/Objects/MonitorManager.vala"
						largest_mode = _tmp45_;
#line 2335 "MonitorManager.c"
					}
				}
			}
#line 303 "../src/Objects/MonitorManager.vala"
			_g_object_unref0 (mode);
#line 2341 "MonitorManager.c"
		}
	}
#line 322 "../src/Objects/MonitorManager.vala"
	_tmp46_ = largest_mode_in_use;
#line 322 "../src/Objects/MonitorManager.vala"
	if (_tmp46_ != NULL) {
#line 2348 "MonitorManager.c"
		DisplayVirtualMonitor* _tmp47_;
		DisplayMonitorMode* _tmp48_;
#line 323 "../src/Objects/MonitorManager.vala"
		_tmp47_ = clone_virtual_monitor;
#line 323 "../src/Objects/MonitorManager.vala"
		_tmp48_ = largest_mode_in_use;
#line 323 "../src/Objects/MonitorManager.vala"
		display_virtual_monitor_set_current_mode (_tmp47_, _tmp48_);
#line 2357 "MonitorManager.c"
	} else {
		DisplayVirtualMonitor* _tmp49_;
		DisplayMonitorMode* _tmp50_;
#line 325 "../src/Objects/MonitorManager.vala"
		_tmp49_ = clone_virtual_monitor;
#line 325 "../src/Objects/MonitorManager.vala"
		_tmp50_ = largest_mode;
#line 325 "../src/Objects/MonitorManager.vala"
		display_virtual_monitor_set_current_mode (_tmp49_, _tmp50_);
#line 2367 "MonitorManager.c"
	}
#line 328 "../src/Objects/MonitorManager.vala"
	_tmp51_ = self->priv->_virtual_monitors;
#line 328 "../src/Objects/MonitorManager.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp51_);
#line 329 "../src/Objects/MonitorManager.vala"
	_tmp52_ = self->priv->_virtual_monitors;
#line 329 "../src/Objects/MonitorManager.vala"
	_tmp53_ = clone_virtual_monitor;
#line 329 "../src/Objects/MonitorManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp52_, _tmp53_);
#line 331 "../src/Objects/MonitorManager.vala"
	g_object_notify ((GObject*) self, "virtual-monitor-number");
#line 332 "../src/Objects/MonitorManager.vala"
	g_object_notify ((GObject*) self, "is-mirrored");
#line 289 "../src/Objects/MonitorManager.vala"
	_g_object_unref0 (largest_mode);
#line 289 "../src/Objects/MonitorManager.vala"
	_g_object_unref0 (largest_mode_in_use);
#line 289 "../src/Objects/MonitorManager.vala"
	_g_object_unref0 (modes);
#line 289 "../src/Objects/MonitorManager.vala"
	_g_object_unref0 (clone_virtual_monitor);
#line 2391 "MonitorManager.c"
}

void
display_monitor_manager_set_scale_on_all_monitors (DisplayMonitorManager* self,
                                                   gdouble new_scale)
{
	gdouble max_scale = 0.0;
	GeeLinkedList* _tmp0_;
#line 335 "../src/Objects/MonitorManager.vala"
	g_return_if_fail (self != NULL);
#line 336 "../src/Objects/MonitorManager.vala"
	if (new_scale <= 0.0) {
#line 337 "../src/Objects/MonitorManager.vala"
		return;
#line 2406 "MonitorManager.c"
	}
#line 340 "../src/Objects/MonitorManager.vala"
	_tmp0_ = self->priv->_monitors;
#line 340 "../src/Objects/MonitorManager.vala"
	max_scale = display_utils_get_min_compatible_scale (_tmp0_);
#line 341 "../src/Objects/MonitorManager.vala"
	if (new_scale > max_scale) {
#line 342 "../src/Objects/MonitorManager.vala"
		return;
#line 2416 "MonitorManager.c"
	}
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
#line 345 "../src/Objects/MonitorManager.vala"
		_tmp1_ = self->priv->_virtual_monitors;
#line 345 "../src/Objects/MonitorManager.vala"
		_monitor_list = _tmp1_;
#line 345 "../src/Objects/MonitorManager.vala"
		_tmp2_ = _monitor_list;
#line 345 "../src/Objects/MonitorManager.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 345 "../src/Objects/MonitorManager.vala"
		_tmp4_ = _tmp3_;
#line 345 "../src/Objects/MonitorManager.vala"
		_monitor_size = _tmp4_;
#line 345 "../src/Objects/MonitorManager.vala"
		_monitor_index = -1;
#line 345 "../src/Objects/MonitorManager.vala"
		while (TRUE) {
#line 2442 "MonitorManager.c"
			gint _tmp5_;
			gint _tmp6_;
			DisplayVirtualMonitor* monitor = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			DisplayVirtualMonitor* _tmp9_;
#line 345 "../src/Objects/MonitorManager.vala"
			_monitor_index = _monitor_index + 1;
#line 345 "../src/Objects/MonitorManager.vala"
			_tmp5_ = _monitor_index;
#line 345 "../src/Objects/MonitorManager.vala"
			_tmp6_ = _monitor_size;
#line 345 "../src/Objects/MonitorManager.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 345 "../src/Objects/MonitorManager.vala"
				break;
#line 2459 "MonitorManager.c"
			}
#line 345 "../src/Objects/MonitorManager.vala"
			_tmp7_ = _monitor_list;
#line 345 "../src/Objects/MonitorManager.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _monitor_index);
#line 345 "../src/Objects/MonitorManager.vala"
			monitor = (DisplayVirtualMonitor*) _tmp8_;
#line 346 "../src/Objects/MonitorManager.vala"
			_tmp9_ = monitor;
#line 346 "../src/Objects/MonitorManager.vala"
			display_virtual_monitor_set_scale (_tmp9_, new_scale);
#line 345 "../src/Objects/MonitorManager.vala"
			_g_object_unref0 (monitor);
#line 2473 "MonitorManager.c"
		}
	}
#line 349 "../src/Objects/MonitorManager.vala"
	display_monitor_manager_set_monitor_config (self);
#line 2478 "MonitorManager.c"
}

static gboolean
_vala_double_array_contains (gdouble * stack,
                             gssize stack_length,
                             const gdouble needle)
{
	gssize i;
#line 361 "../src/Objects/MonitorManager.vala"
	for (i = 0; i < stack_length; i++) {
#line 361 "../src/Objects/MonitorManager.vala"
		if (needle == stack[i]) {
#line 361 "../src/Objects/MonitorManager.vala"
			return TRUE;
#line 2493 "MonitorManager.c"
		}
	}
#line 361 "../src/Objects/MonitorManager.vala"
	return FALSE;
#line 2498 "MonitorManager.c"
}

void
display_monitor_manager_disable_clone_mode (DisplayMonitorManager* self)
{
	gdouble max_scale = 0.0;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* new_virtual_monitors = NULL;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp61_;
	gpointer _tmp62_;
	DisplayVirtualMonitor* _tmp63_;
	GeeLinkedList* _tmp64_;
	GeeLinkedList* _tmp65_;
	GeeLinkedList* _tmp66_;
#line 352 "../src/Objects/MonitorManager.vala"
	g_return_if_fail (self != NULL);
#line 353 "../src/Objects/MonitorManager.vala"
	_tmp0_ = self->priv->_monitors;
#line 353 "../src/Objects/MonitorManager.vala"
	max_scale = display_utils_get_min_compatible_scale (_tmp0_);
#line 354 "../src/Objects/MonitorManager.vala"
	_tmp1_ = gee_linked_list_new (DISPLAY_TYPE_VIRTUAL_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 354 "../src/Objects/MonitorManager.vala"
	new_virtual_monitors = _tmp1_;
#line 2524 "MonitorManager.c"
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp2_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _monitor_index = 0;
#line 355 "../src/Objects/MonitorManager.vala"
		_tmp2_ = self->priv->_monitors;
#line 355 "../src/Objects/MonitorManager.vala"
		_monitor_list = _tmp2_;
#line 355 "../src/Objects/MonitorManager.vala"
		_tmp3_ = _monitor_list;
#line 355 "../src/Objects/MonitorManager.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 355 "../src/Objects/MonitorManager.vala"
		_tmp5_ = _tmp4_;
#line 355 "../src/Objects/MonitorManager.vala"
		_monitor_size = _tmp5_;
#line 355 "../src/Objects/MonitorManager.vala"
		_monitor_index = -1;
#line 355 "../src/Objects/MonitorManager.vala"
		while (TRUE) {
#line 2549 "MonitorManager.c"
			gint _tmp6_;
			gint _tmp7_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp8_;
			gpointer _tmp9_;
			DisplayVirtualMonitor* single_virtual_monitor = NULL;
			DisplayVirtualMonitor* _tmp10_;
			DisplayMonitorMode* preferred_mode = NULL;
			DisplayMonitor* _tmp11_;
			DisplayMonitorMode* _tmp12_;
			DisplayMonitorMode* _tmp13_;
			DisplayMonitorMode* current_mode = NULL;
			DisplayMonitor* _tmp14_;
			DisplayMonitorMode* _tmp15_;
			DisplayMonitorMode* _tmp16_;
			gboolean _tmp17_;
			DisplayVirtualMonitor* _tmp55_;
			GeeLinkedList* _tmp56_;
			GeeLinkedList* _tmp57_;
			DisplayMonitor* _tmp58_;
			GeeLinkedList* _tmp59_;
			DisplayVirtualMonitor* _tmp60_;
#line 355 "../src/Objects/MonitorManager.vala"
			_monitor_index = _monitor_index + 1;
#line 355 "../src/Objects/MonitorManager.vala"
			_tmp6_ = _monitor_index;
#line 355 "../src/Objects/MonitorManager.vala"
			_tmp7_ = _monitor_size;
#line 355 "../src/Objects/MonitorManager.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 355 "../src/Objects/MonitorManager.vala"
				break;
#line 2582 "MonitorManager.c"
			}
#line 355 "../src/Objects/MonitorManager.vala"
			_tmp8_ = _monitor_list;
#line 355 "../src/Objects/MonitorManager.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _monitor_index);
#line 355 "../src/Objects/MonitorManager.vala"
			monitor = (DisplayMonitor*) _tmp9_;
#line 356 "../src/Objects/MonitorManager.vala"
			_tmp10_ = display_virtual_monitor_new ();
#line 356 "../src/Objects/MonitorManager.vala"
			single_virtual_monitor = _tmp10_;
#line 357 "../src/Objects/MonitorManager.vala"
			_tmp11_ = monitor;
#line 357 "../src/Objects/MonitorManager.vala"
			_tmp12_ = display_monitor_get_preferred_mode (_tmp11_);
#line 357 "../src/Objects/MonitorManager.vala"
			_tmp13_ = _tmp12_;
#line 357 "../src/Objects/MonitorManager.vala"
			preferred_mode = _tmp13_;
#line 358 "../src/Objects/MonitorManager.vala"
			_tmp14_ = monitor;
#line 358 "../src/Objects/MonitorManager.vala"
			_tmp15_ = display_monitor_get_current_mode (_tmp14_);
#line 358 "../src/Objects/MonitorManager.vala"
			_tmp16_ = _tmp15_;
#line 358 "../src/Objects/MonitorManager.vala"
			current_mode = _tmp16_;
#line 359 "../src/Objects/MonitorManager.vala"
			_tmp17_ = self->priv->_global_scale_required;
#line 359 "../src/Objects/MonitorManager.vala"
			if (_tmp17_) {
#line 2614 "MonitorManager.c"
				DisplayVirtualMonitor* _tmp18_;
				DisplayMonitorMode* _tmp19_;
				gdouble* _tmp20_;
				gint _tmp20__length1;
#line 360 "../src/Objects/MonitorManager.vala"
				_tmp18_ = single_virtual_monitor;
#line 360 "../src/Objects/MonitorManager.vala"
				display_virtual_monitor_set_scale (_tmp18_, max_scale);
#line 361 "../src/Objects/MonitorManager.vala"
				_tmp19_ = preferred_mode;
#line 361 "../src/Objects/MonitorManager.vala"
				_tmp20_ = _tmp19_->supported_scales;
#line 361 "../src/Objects/MonitorManager.vala"
				_tmp20__length1 = _tmp19_->supported_scales_length1;
#line 361 "../src/Objects/MonitorManager.vala"
				if (_vala_double_array_contains (_tmp20_, _tmp20__length1, max_scale)) {
#line 2631 "MonitorManager.c"
					DisplayMonitorMode* _tmp21_;
					DisplayMonitorMode* _tmp22_;
#line 362 "../src/Objects/MonitorManager.vala"
					_tmp21_ = current_mode;
#line 362 "../src/Objects/MonitorManager.vala"
					display_monitor_mode_set_is_current (_tmp21_, FALSE);
#line 363 "../src/Objects/MonitorManager.vala"
					_tmp22_ = preferred_mode;
#line 363 "../src/Objects/MonitorManager.vala"
					display_monitor_mode_set_is_current (_tmp22_, TRUE);
#line 2642 "MonitorManager.c"
				} else {
					DisplayMonitorMode* _tmp23_;
					gdouble* _tmp24_;
					gint _tmp24__length1;
#line 364 "../src/Objects/MonitorManager.vala"
					_tmp23_ = current_mode;
#line 364 "../src/Objects/MonitorManager.vala"
					_tmp24_ = _tmp23_->supported_scales;
#line 364 "../src/Objects/MonitorManager.vala"
					_tmp24__length1 = _tmp23_->supported_scales_length1;
#line 364 "../src/Objects/MonitorManager.vala"
					if (!_vala_double_array_contains (_tmp24_, _tmp24__length1, max_scale)) {
#line 2655 "MonitorManager.c"
						DisplayMonitorMode* largest_mode = NULL;
						DisplayMonitorMode* _tmp47_;
						DisplayMonitorMode* _tmp48_;
#line 365 "../src/Objects/MonitorManager.vala"
						largest_mode = NULL;
#line 2661 "MonitorManager.c"
						{
							GeeLinkedList* _mode_list = NULL;
							DisplayMonitor* _tmp25_;
							GeeLinkedList* _tmp26_;
							GeeLinkedList* _tmp27_;
							gint _mode_size = 0;
							GeeLinkedList* _tmp28_;
							gint _tmp29_;
							gint _tmp30_;
							gint _mode_index = 0;
#line 366 "../src/Objects/MonitorManager.vala"
							_tmp25_ = monitor;
#line 366 "../src/Objects/MonitorManager.vala"
							_tmp26_ = display_monitor_get_modes (_tmp25_);
#line 366 "../src/Objects/MonitorManager.vala"
							_tmp27_ = _tmp26_;
#line 366 "../src/Objects/MonitorManager.vala"
							_mode_list = _tmp27_;
#line 366 "../src/Objects/MonitorManager.vala"
							_tmp28_ = _mode_list;
#line 366 "../src/Objects/MonitorManager.vala"
							_tmp29_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp28_);
#line 366 "../src/Objects/MonitorManager.vala"
							_tmp30_ = _tmp29_;
#line 366 "../src/Objects/MonitorManager.vala"
							_mode_size = _tmp30_;
#line 366 "../src/Objects/MonitorManager.vala"
							_mode_index = -1;
#line 366 "../src/Objects/MonitorManager.vala"
							while (TRUE) {
#line 2692 "MonitorManager.c"
								gint _tmp31_;
								gint _tmp32_;
								DisplayMonitorMode* mode = NULL;
								GeeLinkedList* _tmp33_;
								gpointer _tmp34_;
								DisplayMonitorMode* _tmp35_;
								gdouble* _tmp36_;
								gint _tmp36__length1;
#line 366 "../src/Objects/MonitorManager.vala"
								_mode_index = _mode_index + 1;
#line 366 "../src/Objects/MonitorManager.vala"
								_tmp31_ = _mode_index;
#line 366 "../src/Objects/MonitorManager.vala"
								_tmp32_ = _mode_size;
#line 366 "../src/Objects/MonitorManager.vala"
								if (!(_tmp31_ < _tmp32_)) {
#line 366 "../src/Objects/MonitorManager.vala"
									break;
#line 2711 "MonitorManager.c"
								}
#line 366 "../src/Objects/MonitorManager.vala"
								_tmp33_ = _mode_list;
#line 366 "../src/Objects/MonitorManager.vala"
								_tmp34_ = gee_abstract_list_get ((GeeAbstractList*) _tmp33_, _mode_index);
#line 366 "../src/Objects/MonitorManager.vala"
								mode = (DisplayMonitorMode*) _tmp34_;
#line 367 "../src/Objects/MonitorManager.vala"
								_tmp35_ = mode;
#line 367 "../src/Objects/MonitorManager.vala"
								_tmp36_ = _tmp35_->supported_scales;
#line 367 "../src/Objects/MonitorManager.vala"
								_tmp36__length1 = _tmp35_->supported_scales_length1;
#line 367 "../src/Objects/MonitorManager.vala"
								if (_vala_double_array_contains (_tmp36_, _tmp36__length1, max_scale)) {
#line 2727 "MonitorManager.c"
									gboolean _tmp37_ = FALSE;
									DisplayMonitorMode* _tmp38_;
#line 368 "../src/Objects/MonitorManager.vala"
									_tmp38_ = largest_mode;
#line 368 "../src/Objects/MonitorManager.vala"
									if (_tmp38_ == NULL) {
#line 368 "../src/Objects/MonitorManager.vala"
										_tmp37_ = TRUE;
#line 2736 "MonitorManager.c"
									} else {
										DisplayMonitorMode* _tmp39_;
										gint _tmp40_;
										gint _tmp41_;
										DisplayMonitorMode* _tmp42_;
										gint _tmp43_;
										gint _tmp44_;
#line 368 "../src/Objects/MonitorManager.vala"
										_tmp39_ = mode;
#line 368 "../src/Objects/MonitorManager.vala"
										_tmp40_ = display_monitor_mode_get_width (_tmp39_);
#line 368 "../src/Objects/MonitorManager.vala"
										_tmp41_ = _tmp40_;
#line 368 "../src/Objects/MonitorManager.vala"
										_tmp42_ = largest_mode;
#line 368 "../src/Objects/MonitorManager.vala"
										_tmp43_ = display_monitor_mode_get_width (_tmp42_);
#line 368 "../src/Objects/MonitorManager.vala"
										_tmp44_ = _tmp43_;
#line 368 "../src/Objects/MonitorManager.vala"
										_tmp37_ = _tmp41_ > _tmp44_;
#line 2758 "MonitorManager.c"
									}
#line 368 "../src/Objects/MonitorManager.vala"
									if (_tmp37_) {
#line 2762 "MonitorManager.c"
										DisplayMonitorMode* _tmp45_;
										DisplayMonitorMode* _tmp46_;
#line 369 "../src/Objects/MonitorManager.vala"
										_tmp45_ = mode;
#line 369 "../src/Objects/MonitorManager.vala"
										_tmp46_ = _g_object_ref0 (_tmp45_);
#line 369 "../src/Objects/MonitorManager.vala"
										_g_object_unref0 (largest_mode);
#line 369 "../src/Objects/MonitorManager.vala"
										largest_mode = _tmp46_;
#line 2773 "MonitorManager.c"
									}
								}
#line 366 "../src/Objects/MonitorManager.vala"
								_g_object_unref0 (mode);
#line 2778 "MonitorManager.c"
							}
						}
#line 374 "../src/Objects/MonitorManager.vala"
						_tmp47_ = current_mode;
#line 374 "../src/Objects/MonitorManager.vala"
						display_monitor_mode_set_is_current (_tmp47_, FALSE);
#line 375 "../src/Objects/MonitorManager.vala"
						_tmp48_ = largest_mode;
#line 375 "../src/Objects/MonitorManager.vala"
						display_monitor_mode_set_is_current (_tmp48_, TRUE);
#line 364 "../src/Objects/MonitorManager.vala"
						_g_object_unref0 (largest_mode);
#line 2791 "MonitorManager.c"
					}
				}
			} else {
				DisplayMonitorMode* _tmp49_;
				DisplayMonitorMode* _tmp50_;
				DisplayVirtualMonitor* _tmp51_;
				DisplayMonitorMode* _tmp52_;
				gdouble _tmp53_;
				gdouble _tmp54_;
#line 378 "../src/Objects/MonitorManager.vala"
				_tmp49_ = current_mode;
#line 378 "../src/Objects/MonitorManager.vala"
				display_monitor_mode_set_is_current (_tmp49_, FALSE);
#line 379 "../src/Objects/MonitorManager.vala"
				_tmp50_ = preferred_mode;
#line 379 "../src/Objects/MonitorManager.vala"
				display_monitor_mode_set_is_current (_tmp50_, TRUE);
#line 380 "../src/Objects/MonitorManager.vala"
				_tmp51_ = single_virtual_monitor;
#line 380 "../src/Objects/MonitorManager.vala"
				_tmp52_ = preferred_mode;
#line 380 "../src/Objects/MonitorManager.vala"
				_tmp53_ = display_monitor_mode_get_preferred_scale (_tmp52_);
#line 380 "../src/Objects/MonitorManager.vala"
				_tmp54_ = _tmp53_;
#line 380 "../src/Objects/MonitorManager.vala"
				display_virtual_monitor_set_scale (_tmp51_, _tmp54_);
#line 2819 "MonitorManager.c"
			}
#line 383 "../src/Objects/MonitorManager.vala"
			_tmp55_ = single_virtual_monitor;
#line 383 "../src/Objects/MonitorManager.vala"
			_tmp56_ = display_virtual_monitor_get_monitors (_tmp55_);
#line 383 "../src/Objects/MonitorManager.vala"
			_tmp57_ = _tmp56_;
#line 383 "../src/Objects/MonitorManager.vala"
			_tmp58_ = monitor;
#line 383 "../src/Objects/MonitorManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp57_, _tmp58_);
#line 384 "../src/Objects/MonitorManager.vala"
			_tmp59_ = new_virtual_monitors;
#line 384 "../src/Objects/MonitorManager.vala"
			_tmp60_ = single_virtual_monitor;
#line 384 "../src/Objects/MonitorManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp59_, _tmp60_);
#line 355 "../src/Objects/MonitorManager.vala"
			_g_object_unref0 (current_mode);
#line 355 "../src/Objects/MonitorManager.vala"
			_g_object_unref0 (preferred_mode);
#line 355 "../src/Objects/MonitorManager.vala"
			_g_object_unref0 (single_virtual_monitor);
#line 355 "../src/Objects/MonitorManager.vala"
			_g_object_unref0 (monitor);
#line 2845 "MonitorManager.c"
		}
	}
#line 387 "../src/Objects/MonitorManager.vala"
	_tmp61_ = new_virtual_monitors;
#line 387 "../src/Objects/MonitorManager.vala"
	_tmp62_ = gee_abstract_list_get ((GeeAbstractList*) _tmp61_, 0);
#line 387 "../src/Objects/MonitorManager.vala"
	_tmp63_ = (DisplayVirtualMonitor*) _tmp62_;
#line 387 "../src/Objects/MonitorManager.vala"
	display_virtual_monitor_set_primary (_tmp63_, TRUE);
#line 387 "../src/Objects/MonitorManager.vala"
	_g_object_unref0 (_tmp63_);
#line 388 "../src/Objects/MonitorManager.vala"
	_tmp64_ = self->priv->_virtual_monitors;
#line 388 "../src/Objects/MonitorManager.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp64_);
#line 389 "../src/Objects/MonitorManager.vala"
	_tmp65_ = self->priv->_virtual_monitors;
#line 389 "../src/Objects/MonitorManager.vala"
	_tmp66_ = new_virtual_monitors;
#line 389 "../src/Objects/MonitorManager.vala"
	gee_collection_add_all ((GeeCollection*) _tmp65_, (GeeCollection*) _tmp66_);
#line 391 "../src/Objects/MonitorManager.vala"
	g_object_notify ((GObject*) self, "virtual-monitor-number");
#line 392 "../src/Objects/MonitorManager.vala"
	g_object_notify ((GObject*) self, "is-mirrored");
#line 352 "../src/Objects/MonitorManager.vala"
	_g_object_unref0 (new_virtual_monitors);
#line 2874 "MonitorManager.c"
}

static void
display_monitor_manager_add_virtual_monitor (DisplayMonitorManager* self,
                                             DisplayVirtualMonitor* virtual_monitor)
{
	GeeLinkedList* _tmp0_;
#line 395 "../src/Objects/MonitorManager.vala"
	g_return_if_fail (self != NULL);
#line 395 "../src/Objects/MonitorManager.vala"
	g_return_if_fail (virtual_monitor != NULL);
#line 396 "../src/Objects/MonitorManager.vala"
	_tmp0_ = self->priv->_virtual_monitors;
#line 396 "../src/Objects/MonitorManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, virtual_monitor);
#line 397 "../src/Objects/MonitorManager.vala"
	g_object_notify ((GObject*) self, "virtual-monitor-number");
#line 2892 "MonitorManager.c"
}

static DisplayVirtualMonitor*
display_monitor_manager_get_virtual_monitor_by_id (DisplayMonitorManager* self,
                                                   const gchar* id)
{
	DisplayVirtualMonitor* result;
#line 400 "../src/Objects/MonitorManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 400 "../src/Objects/MonitorManager.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 2904 "MonitorManager.c"
	{
		GeeLinkedList* _vm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _vm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _vm_index = 0;
#line 401 "../src/Objects/MonitorManager.vala"
		_tmp0_ = self->priv->_virtual_monitors;
#line 401 "../src/Objects/MonitorManager.vala"
		_vm_list = _tmp0_;
#line 401 "../src/Objects/MonitorManager.vala"
		_tmp1_ = _vm_list;
#line 401 "../src/Objects/MonitorManager.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 401 "../src/Objects/MonitorManager.vala"
		_tmp3_ = _tmp2_;
#line 401 "../src/Objects/MonitorManager.vala"
		_vm_size = _tmp3_;
#line 401 "../src/Objects/MonitorManager.vala"
		_vm_index = -1;
#line 401 "../src/Objects/MonitorManager.vala"
		while (TRUE) {
#line 2929 "MonitorManager.c"
			gint _tmp4_;
			gint _tmp5_;
			DisplayVirtualMonitor* vm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			DisplayVirtualMonitor* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gboolean _tmp12_;
#line 401 "../src/Objects/MonitorManager.vala"
			_vm_index = _vm_index + 1;
#line 401 "../src/Objects/MonitorManager.vala"
			_tmp4_ = _vm_index;
#line 401 "../src/Objects/MonitorManager.vala"
			_tmp5_ = _vm_size;
#line 401 "../src/Objects/MonitorManager.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 401 "../src/Objects/MonitorManager.vala"
				break;
#line 2950 "MonitorManager.c"
			}
#line 401 "../src/Objects/MonitorManager.vala"
			_tmp6_ = _vm_list;
#line 401 "../src/Objects/MonitorManager.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _vm_index);
#line 401 "../src/Objects/MonitorManager.vala"
			vm = (DisplayVirtualMonitor*) _tmp7_;
#line 402 "../src/Objects/MonitorManager.vala"
			_tmp8_ = vm;
#line 402 "../src/Objects/MonitorManager.vala"
			_tmp9_ = display_virtual_monitor_get_id (_tmp8_);
#line 402 "../src/Objects/MonitorManager.vala"
			_tmp10_ = _tmp9_;
#line 402 "../src/Objects/MonitorManager.vala"
			_tmp11_ = _tmp10_;
#line 402 "../src/Objects/MonitorManager.vala"
			_tmp12_ = g_strcmp0 (_tmp11_, id) == 0;
#line 402 "../src/Objects/MonitorManager.vala"
			_g_free0 (_tmp11_);
#line 402 "../src/Objects/MonitorManager.vala"
			if (_tmp12_) {
#line 403 "../src/Objects/MonitorManager.vala"
				result = vm;
#line 403 "../src/Objects/MonitorManager.vala"
				return result;
#line 2976 "MonitorManager.c"
			}
#line 401 "../src/Objects/MonitorManager.vala"
			_g_object_unref0 (vm);
#line 2980 "MonitorManager.c"
		}
	}
#line 407 "../src/Objects/MonitorManager.vala"
	result = NULL;
#line 407 "../src/Objects/MonitorManager.vala"
	return result;
#line 2987 "MonitorManager.c"
}

static gboolean
display_monitor_manager_compare_monitor_with_mutter_info (DisplayMonitor* monitor,
                                                          MutterReadMonitorInfo* mutter_info)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	MutterReadMonitorInfo _tmp5_;
	const gchar* _tmp6_;
	gboolean result;
#line 410 "../src/Objects/MonitorManager.vala"
	g_return_val_if_fail (monitor != NULL, FALSE);
#line 410 "../src/Objects/MonitorManager.vala"
	g_return_val_if_fail (mutter_info != NULL, FALSE);
#line 411 "../src/Objects/MonitorManager.vala"
	_tmp3_ = display_monitor_get_connector (monitor);
#line 411 "../src/Objects/MonitorManager.vala"
	_tmp4_ = _tmp3_;
#line 411 "../src/Objects/MonitorManager.vala"
	_tmp5_ = *mutter_info;
#line 411 "../src/Objects/MonitorManager.vala"
	_tmp6_ = _tmp5_.connector;
#line 411 "../src/Objects/MonitorManager.vala"
	if (g_strcmp0 (_tmp4_, _tmp6_) == 0) {
#line 3016 "MonitorManager.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		MutterReadMonitorInfo _tmp9_;
		const gchar* _tmp10_;
#line 412 "../src/Objects/MonitorManager.vala"
		_tmp7_ = display_monitor_get_vendor (monitor);
#line 412 "../src/Objects/MonitorManager.vala"
		_tmp8_ = _tmp7_;
#line 412 "../src/Objects/MonitorManager.vala"
		_tmp9_ = *mutter_info;
#line 412 "../src/Objects/MonitorManager.vala"
		_tmp10_ = _tmp9_.vendor;
#line 412 "../src/Objects/MonitorManager.vala"
		_tmp2_ = g_strcmp0 (_tmp8_, _tmp10_) == 0;
#line 3031 "MonitorManager.c"
	} else {
#line 411 "../src/Objects/MonitorManager.vala"
		_tmp2_ = FALSE;
#line 3035 "MonitorManager.c"
	}
#line 411 "../src/Objects/MonitorManager.vala"
	if (_tmp2_) {
#line 3039 "MonitorManager.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		MutterReadMonitorInfo _tmp13_;
		const gchar* _tmp14_;
#line 413 "../src/Objects/MonitorManager.vala"
		_tmp11_ = display_monitor_get_product (monitor);
#line 413 "../src/Objects/MonitorManager.vala"
		_tmp12_ = _tmp11_;
#line 413 "../src/Objects/MonitorManager.vala"
		_tmp13_ = *mutter_info;
#line 413 "../src/Objects/MonitorManager.vala"
		_tmp14_ = _tmp13_.product;
#line 413 "../src/Objects/MonitorManager.vala"
		_tmp1_ = g_strcmp0 (_tmp12_, _tmp14_) == 0;
#line 3054 "MonitorManager.c"
	} else {
#line 411 "../src/Objects/MonitorManager.vala"
		_tmp1_ = FALSE;
#line 3058 "MonitorManager.c"
	}
#line 411 "../src/Objects/MonitorManager.vala"
	if (_tmp1_) {
#line 3062 "MonitorManager.c"
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		MutterReadMonitorInfo _tmp17_;
		const gchar* _tmp18_;
#line 414 "../src/Objects/MonitorManager.vala"
		_tmp15_ = display_monitor_get_serial (monitor);
#line 414 "../src/Objects/MonitorManager.vala"
		_tmp16_ = _tmp15_;
#line 414 "../src/Objects/MonitorManager.vala"
		_tmp17_ = *mutter_info;
#line 414 "../src/Objects/MonitorManager.vala"
		_tmp18_ = _tmp17_.serial;
#line 414 "../src/Objects/MonitorManager.vala"
		_tmp0_ = g_strcmp0 (_tmp16_, _tmp18_) == 0;
#line 3077 "MonitorManager.c"
	} else {
#line 411 "../src/Objects/MonitorManager.vala"
		_tmp0_ = FALSE;
#line 3081 "MonitorManager.c"
	}
#line 411 "../src/Objects/MonitorManager.vala"
	result = _tmp0_;
#line 411 "../src/Objects/MonitorManager.vala"
	return result;
#line 3087 "MonitorManager.c"
}

static DisplayMonitor*
display_monitor_manager_get_monitor_by_hash (DisplayMonitorManager* self,
                                             guint hash)
{
	DisplayMonitor* result;
#line 417 "../src/Objects/MonitorManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3097 "MonitorManager.c"
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
#line 418 "../src/Objects/MonitorManager.vala"
		_tmp0_ = self->priv->_monitors;
#line 418 "../src/Objects/MonitorManager.vala"
		_monitor_list = _tmp0_;
#line 418 "../src/Objects/MonitorManager.vala"
		_tmp1_ = _monitor_list;
#line 418 "../src/Objects/MonitorManager.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 418 "../src/Objects/MonitorManager.vala"
		_tmp3_ = _tmp2_;
#line 418 "../src/Objects/MonitorManager.vala"
		_monitor_size = _tmp3_;
#line 418 "../src/Objects/MonitorManager.vala"
		_monitor_index = -1;
#line 418 "../src/Objects/MonitorManager.vala"
		while (TRUE) {
#line 3122 "MonitorManager.c"
			gint _tmp4_;
			gint _tmp5_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			DisplayMonitor* _tmp8_;
			guint _tmp9_;
			guint _tmp10_;
#line 418 "../src/Objects/MonitorManager.vala"
			_monitor_index = _monitor_index + 1;
#line 418 "../src/Objects/MonitorManager.vala"
			_tmp4_ = _monitor_index;
#line 418 "../src/Objects/MonitorManager.vala"
			_tmp5_ = _monitor_size;
#line 418 "../src/Objects/MonitorManager.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 418 "../src/Objects/MonitorManager.vala"
				break;
#line 3141 "MonitorManager.c"
			}
#line 418 "../src/Objects/MonitorManager.vala"
			_tmp6_ = _monitor_list;
#line 418 "../src/Objects/MonitorManager.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _monitor_index);
#line 418 "../src/Objects/MonitorManager.vala"
			monitor = (DisplayMonitor*) _tmp7_;
#line 419 "../src/Objects/MonitorManager.vala"
			_tmp8_ = monitor;
#line 419 "../src/Objects/MonitorManager.vala"
			_tmp9_ = display_monitor_get_hash (_tmp8_);
#line 419 "../src/Objects/MonitorManager.vala"
			_tmp10_ = _tmp9_;
#line 419 "../src/Objects/MonitorManager.vala"
			if (_tmp10_ == hash) {
#line 420 "../src/Objects/MonitorManager.vala"
				result = monitor;
#line 420 "../src/Objects/MonitorManager.vala"
				return result;
#line 3161 "MonitorManager.c"
			}
#line 418 "../src/Objects/MonitorManager.vala"
			_g_object_unref0 (monitor);
#line 3165 "MonitorManager.c"
		}
	}
#line 424 "../src/Objects/MonitorManager.vala"
	result = NULL;
#line 424 "../src/Objects/MonitorManager.vala"
	return result;
#line 3172 "MonitorManager.c"
}

GeeLinkedList*
display_monitor_manager_get_virtual_monitors (DisplayMonitorManager* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
#line 23 "../src/Objects/MonitorManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Objects/MonitorManager.vala"
	_tmp0_ = self->priv->_virtual_monitors;
#line 23 "../src/Objects/MonitorManager.vala"
	result = _tmp0_;
#line 23 "../src/Objects/MonitorManager.vala"
	return result;
#line 3188 "MonitorManager.c"
}

static void
display_monitor_manager_set_virtual_monitors (DisplayMonitorManager* self,
                                              GeeLinkedList* value)
{
	GeeLinkedList* old_value;
#line 23 "../src/Objects/MonitorManager.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Objects/MonitorManager.vala"
	old_value = display_monitor_manager_get_virtual_monitors (self);
#line 23 "../src/Objects/MonitorManager.vala"
	if (old_value != value) {
#line 3202 "MonitorManager.c"
		GeeLinkedList* _tmp0_;
#line 23 "../src/Objects/MonitorManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/Objects/MonitorManager.vala"
		_g_object_unref0 (self->priv->_virtual_monitors);
#line 23 "../src/Objects/MonitorManager.vala"
		self->priv->_virtual_monitors = _tmp0_;
#line 23 "../src/Objects/MonitorManager.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITORS_PROPERTY]);
#line 3212 "MonitorManager.c"
	}
}

GeeLinkedList*
display_monitor_manager_get_monitors (DisplayMonitorManager* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
#line 24 "../src/Objects/MonitorManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Objects/MonitorManager.vala"
	_tmp0_ = self->priv->_monitors;
#line 24 "../src/Objects/MonitorManager.vala"
	result = _tmp0_;
#line 24 "../src/Objects/MonitorManager.vala"
	return result;
#line 3229 "MonitorManager.c"
}

static void
display_monitor_manager_set_monitors (DisplayMonitorManager* self,
                                      GeeLinkedList* value)
{
	GeeLinkedList* old_value;
#line 24 "../src/Objects/MonitorManager.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Objects/MonitorManager.vala"
	old_value = display_monitor_manager_get_monitors (self);
#line 24 "../src/Objects/MonitorManager.vala"
	if (old_value != value) {
#line 3243 "MonitorManager.c"
		GeeLinkedList* _tmp0_;
#line 24 "../src/Objects/MonitorManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/Objects/MonitorManager.vala"
		_g_object_unref0 (self->priv->_monitors);
#line 24 "../src/Objects/MonitorManager.vala"
		self->priv->_monitors = _tmp0_;
#line 24 "../src/Objects/MonitorManager.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MONITORS_PROPERTY]);
#line 3253 "MonitorManager.c"
	}
}

gboolean
display_monitor_manager_get_global_scale_required (DisplayMonitorManager* self)
{
	gboolean result;
#line 26 "../src/Objects/MonitorManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 26 "../src/Objects/MonitorManager.vala"
	result = self->priv->_global_scale_required;
#line 26 "../src/Objects/MonitorManager.vala"
	return result;
#line 3267 "MonitorManager.c"
}

static void
display_monitor_manager_set_global_scale_required (DisplayMonitorManager* self,
                                                   gboolean value)
{
	gboolean old_value;
#line 26 "../src/Objects/MonitorManager.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Objects/MonitorManager.vala"
	old_value = display_monitor_manager_get_global_scale_required (self);
#line 26 "../src/Objects/MonitorManager.vala"
	if (old_value != value) {
#line 26 "../src/Objects/MonitorManager.vala"
		self->priv->_global_scale_required = value;
#line 26 "../src/Objects/MonitorManager.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_GLOBAL_SCALE_REQUIRED_PROPERTY]);
#line 3285 "MonitorManager.c"
	}
}

gboolean
display_monitor_manager_get_mirroring_supported (DisplayMonitorManager* self)
{
	gboolean result;
#line 27 "../src/Objects/MonitorManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27 "../src/Objects/MonitorManager.vala"
	result = self->priv->_mirroring_supported;
#line 27 "../src/Objects/MonitorManager.vala"
	return result;
#line 3299 "MonitorManager.c"
}

static void
display_monitor_manager_set_mirroring_supported (DisplayMonitorManager* self,
                                                 gboolean value)
{
	gboolean old_value;
#line 27 "../src/Objects/MonitorManager.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Objects/MonitorManager.vala"
	old_value = display_monitor_manager_get_mirroring_supported (self);
#line 27 "../src/Objects/MonitorManager.vala"
	if (old_value != value) {
#line 27 "../src/Objects/MonitorManager.vala"
		self->priv->_mirroring_supported = value;
#line 27 "../src/Objects/MonitorManager.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MIRRORING_SUPPORTED_PROPERTY]);
#line 3317 "MonitorManager.c"
	}
}

gint
display_monitor_manager_get_max_width (DisplayMonitorManager* self)
{
	gint result;
#line 28 "../src/Objects/MonitorManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 28 "../src/Objects/MonitorManager.vala"
	result = self->priv->_max_width;
#line 28 "../src/Objects/MonitorManager.vala"
	return result;
#line 3331 "MonitorManager.c"
}

static void
display_monitor_manager_set_max_width (DisplayMonitorManager* self,
                                       gint value)
{
	gint old_value;
#line 28 "../src/Objects/MonitorManager.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Objects/MonitorManager.vala"
	old_value = display_monitor_manager_get_max_width (self);
#line 28 "../src/Objects/MonitorManager.vala"
	if (old_value != value) {
#line 28 "../src/Objects/MonitorManager.vala"
		self->priv->_max_width = value;
#line 28 "../src/Objects/MonitorManager.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MAX_WIDTH_PROPERTY]);
#line 3349 "MonitorManager.c"
	}
}

gint
display_monitor_manager_get_max_height (DisplayMonitorManager* self)
{
	gint result;
#line 29 "../src/Objects/MonitorManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 29 "../src/Objects/MonitorManager.vala"
	result = self->priv->_max_height;
#line 29 "../src/Objects/MonitorManager.vala"
	return result;
#line 3363 "MonitorManager.c"
}

static void
display_monitor_manager_set_max_height (DisplayMonitorManager* self,
                                        gint value)
{
	gint old_value;
#line 29 "../src/Objects/MonitorManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Objects/MonitorManager.vala"
	old_value = display_monitor_manager_get_max_height (self);
#line 29 "../src/Objects/MonitorManager.vala"
	if (old_value != value) {
#line 29 "../src/Objects/MonitorManager.vala"
		self->priv->_max_height = value;
#line 29 "../src/Objects/MonitorManager.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MAX_HEIGHT_PROPERTY]);
#line 3381 "MonitorManager.c"
	}
}

gint
display_monitor_manager_get_monitor_number (DisplayMonitorManager* self)
{
	gint result;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 31 "../src/Objects/MonitorManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 32 "../src/Objects/MonitorManager.vala"
	_tmp0_ = self->priv->_monitors;
#line 32 "../src/Objects/MonitorManager.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 32 "../src/Objects/MonitorManager.vala"
	_tmp2_ = _tmp1_;
#line 32 "../src/Objects/MonitorManager.vala"
	result = _tmp2_;
#line 32 "../src/Objects/MonitorManager.vala"
	return result;
#line 3404 "MonitorManager.c"
}

gint
display_monitor_manager_get_virtual_monitor_number (DisplayMonitorManager* self)
{
	gint result;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 37 "../src/Objects/MonitorManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../src/Objects/MonitorManager.vala"
	_tmp0_ = self->priv->_virtual_monitors;
#line 38 "../src/Objects/MonitorManager.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 38 "../src/Objects/MonitorManager.vala"
	_tmp2_ = _tmp1_;
#line 38 "../src/Objects/MonitorManager.vala"
	result = _tmp2_;
#line 38 "../src/Objects/MonitorManager.vala"
	return result;
#line 3426 "MonitorManager.c"
}

gboolean
display_monitor_manager_get_is_mirrored (DisplayMonitorManager* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	GeeLinkedList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 43 "../src/Objects/MonitorManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "../src/Objects/MonitorManager.vala"
	_tmp1_ = self->priv->_virtual_monitors;
#line 44 "../src/Objects/MonitorManager.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 44 "../src/Objects/MonitorManager.vala"
	_tmp3_ = _tmp2_;
#line 44 "../src/Objects/MonitorManager.vala"
	if (_tmp3_ == 1) {
#line 3447 "MonitorManager.c"
		GeeLinkedList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 44 "../src/Objects/MonitorManager.vala"
		_tmp4_ = self->priv->_monitors;
#line 44 "../src/Objects/MonitorManager.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 44 "../src/Objects/MonitorManager.vala"
		_tmp6_ = _tmp5_;
#line 44 "../src/Objects/MonitorManager.vala"
		_tmp0_ = _tmp6_ > 1;
#line 3459 "MonitorManager.c"
	} else {
#line 44 "../src/Objects/MonitorManager.vala"
		_tmp0_ = FALSE;
#line 3463 "MonitorManager.c"
	}
#line 44 "../src/Objects/MonitorManager.vala"
	result = _tmp0_;
#line 44 "../src/Objects/MonitorManager.vala"
	return result;
#line 3469 "MonitorManager.c"
}

static void
_display_monitor_manager_get_monitor_config_mutter_display_config_interface_monitors_changed (MutterDisplayConfigInterface* _sender,
                                                                                              gpointer self)
{
#line 69 "../src/Objects/MonitorManager.vala"
	display_monitor_manager_get_monitor_config ((DisplayMonitorManager*) self);
#line 3478 "MonitorManager.c"
}

static GObject *
display_monitor_manager_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayMonitorManager * self;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
	GeeLinkedList* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 64 "../src/Objects/MonitorManager.vala"
	parent_class = G_OBJECT_CLASS (display_monitor_manager_parent_class);
#line 64 "../src/Objects/MonitorManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 64 "../src/Objects/MonitorManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_MONITOR_MANAGER, DisplayMonitorManager);
#line 65 "../src/Objects/MonitorManager.vala"
	_tmp0_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 65 "../src/Objects/MonitorManager.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/Objects/MonitorManager.vala"
	display_monitor_manager_set_monitors (self, _tmp1_);
#line 65 "../src/Objects/MonitorManager.vala"
	_g_object_unref0 (_tmp1_);
#line 66 "../src/Objects/MonitorManager.vala"
	_tmp2_ = gee_linked_list_new (DISPLAY_TYPE_VIRTUAL_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 66 "../src/Objects/MonitorManager.vala"
	_tmp3_ = _tmp2_;
#line 66 "../src/Objects/MonitorManager.vala"
	display_monitor_manager_set_virtual_monitors (self, _tmp3_);
#line 66 "../src/Objects/MonitorManager.vala"
	_g_object_unref0 (_tmp3_);
#line 3516 "MonitorManager.c"
	{
		MutterDisplayConfigInterface* _tmp4_ = NULL;
		MutterDisplayConfigInterface* _tmp5_;
		MutterDisplayConfigInterface* _tmp6_;
		MutterDisplayConfigInterface* _tmp7_;
#line 68 "../src/Objects/MonitorManager.vala"
		_tmp5_ = (MutterDisplayConfigInterface*) g_initable_new (TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.gnome.Mutter.DisplayConfig", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/Mutter/DisplayConfig", "g-interface-name", "org.gnome.Mutter.DisplayConfig", NULL);
#line 68 "../src/Objects/MonitorManager.vala"
		_tmp4_ = (MutterDisplayConfigInterface*) _tmp5_;
#line 68 "../src/Objects/MonitorManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3528 "MonitorManager.c"
			goto __catch0_g_error;
		}
#line 68 "../src/Objects/MonitorManager.vala"
		_tmp6_ = _tmp4_;
#line 68 "../src/Objects/MonitorManager.vala"
		_tmp4_ = NULL;
#line 68 "../src/Objects/MonitorManager.vala"
		_g_object_unref0 (self->priv->iface);
#line 68 "../src/Objects/MonitorManager.vala"
		self->priv->iface = _tmp6_;
#line 69 "../src/Objects/MonitorManager.vala"
		_tmp7_ = self->priv->iface;
#line 69 "../src/Objects/MonitorManager.vala"
		g_signal_connect_object (_tmp7_, "monitors-changed", (GCallback) _display_monitor_manager_get_monitor_config_mutter_display_config_interface_monitors_changed, self, 0);
#line 67 "../src/Objects/MonitorManager.vala"
		_g_object_unref0 (_tmp4_);
#line 3545 "MonitorManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 67 "../src/Objects/MonitorManager.vala"
		e = _inner_error0_;
#line 67 "../src/Objects/MonitorManager.vala"
		_inner_error0_ = NULL;
#line 71 "../src/Objects/MonitorManager.vala"
		_tmp8_ = e;
#line 71 "../src/Objects/MonitorManager.vala"
		_tmp9_ = _tmp8_->message;
#line 71 "../src/Objects/MonitorManager.vala"
		g_critical ("MonitorManager.vala:71: %s", _tmp9_);
#line 67 "../src/Objects/MonitorManager.vala"
		_g_error_free0 (e);
#line 3565 "MonitorManager.c"
	}
	__finally0:
#line 67 "../src/Objects/MonitorManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 67 "../src/Objects/MonitorManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 67 "../src/Objects/MonitorManager.vala"
		g_clear_error (&_inner_error0_);
#line 3574 "MonitorManager.c"
	}
#line 64 "../src/Objects/MonitorManager.vala"
	return obj;
#line 3578 "MonitorManager.c"
}

static void
display_monitor_manager_class_init (DisplayMonitorManagerClass * klass,
                                    gpointer klass_data)
{
#line 22 "../src/Objects/MonitorManager.vala"
	display_monitor_manager_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Objects/MonitorManager.vala"
	g_type_class_adjust_private_offset (klass, &DisplayMonitorManager_private_offset);
#line 22 "../src/Objects/MonitorManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_display_monitor_manager_get_property;
#line 22 "../src/Objects/MonitorManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_display_monitor_manager_set_property;
#line 22 "../src/Objects/MonitorManager.vala"
	G_OBJECT_CLASS (klass)->constructor = display_monitor_manager_constructor;
#line 22 "../src/Objects/MonitorManager.vala"
	G_OBJECT_CLASS (klass)->finalize = display_monitor_manager_finalize;
#line 22 "../src/Objects/MonitorManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITORS_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITORS_PROPERTY] = g_param_spec_object ("virtual-monitors", "virtual-monitors", "virtual-monitors", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Objects/MonitorManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_MONITORS_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MONITORS_PROPERTY] = g_param_spec_object ("monitors", "monitors", "monitors", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Objects/MonitorManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_GLOBAL_SCALE_REQUIRED_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_GLOBAL_SCALE_REQUIRED_PROPERTY] = g_param_spec_boolean ("global-scale-required", "global-scale-required", "global-scale-required", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/MonitorManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_MIRRORING_SUPPORTED_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MIRRORING_SUPPORTED_PROPERTY] = g_param_spec_boolean ("mirroring-supported", "mirroring-supported", "mirroring-supported", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/MonitorManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_MAX_WIDTH_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MAX_WIDTH_PROPERTY] = g_param_spec_int ("max-width", "max-width", "max-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/MonitorManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_MAX_HEIGHT_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MAX_HEIGHT_PROPERTY] = g_param_spec_int ("max-height", "max-height", "max-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/MonitorManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_MONITOR_NUMBER_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_MONITOR_NUMBER_PROPERTY] = g_param_spec_int ("monitor-number", "monitor-number", "monitor-number", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/MonitorManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITOR_NUMBER_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITOR_NUMBER_PROPERTY] = g_param_spec_int ("virtual-monitor-number", "virtual-monitor-number", "virtual-monitor-number", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/MonitorManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MANAGER_IS_MIRRORED_PROPERTY, display_monitor_manager_properties[DISPLAY_MONITOR_MANAGER_IS_MIRRORED_PROPERTY] = g_param_spec_boolean ("is-mirrored", "is-mirrored", "is-mirrored", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3615 "MonitorManager.c"
}

static void
display_monitor_manager_instance_init (DisplayMonitorManager * self,
                                       gpointer klass)
{
#line 22 "../src/Objects/MonitorManager.vala"
	self->priv = display_monitor_manager_get_instance_private (self);
#line 3624 "MonitorManager.c"
}

static void
display_monitor_manager_finalize (GObject * obj)
{
	DisplayMonitorManager * self;
#line 22 "../src/Objects/MonitorManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_MONITOR_MANAGER, DisplayMonitorManager);
#line 23 "../src/Objects/MonitorManager.vala"
	_g_object_unref0 (self->priv->_virtual_monitors);
#line 24 "../src/Objects/MonitorManager.vala"
	_g_object_unref0 (self->priv->_monitors);
#line 48 "../src/Objects/MonitorManager.vala"
	_g_object_unref0 (self->priv->iface);
#line 22 "../src/Objects/MonitorManager.vala"
	G_OBJECT_CLASS (display_monitor_manager_parent_class)->finalize (obj);
#line 3641 "MonitorManager.c"
}

static GType
display_monitor_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayMonitorManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_monitor_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayMonitorManager), 0, (GInstanceInitFunc) display_monitor_manager_instance_init, NULL };
	GType display_monitor_manager_type_id;
	display_monitor_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "DisplayMonitorManager", &g_define_type_info, 0);
	DisplayMonitorManager_private_offset = g_type_add_instance_private (display_monitor_manager_type_id, sizeof (DisplayMonitorManagerPrivate));
	return display_monitor_manager_type_id;
}

GType
display_monitor_manager_get_type (void)
{
	static volatile gsize display_monitor_manager_type_id__once = 0;
	if (g_once_init_enter (&display_monitor_manager_type_id__once)) {
		GType display_monitor_manager_type_id;
		display_monitor_manager_type_id = display_monitor_manager_get_type_once ();
		g_once_init_leave (&display_monitor_manager_type_id__once, display_monitor_manager_type_id);
	}
	return display_monitor_manager_type_id__once;
}

static void
_vala_display_monitor_manager_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	DisplayMonitorManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_MONITOR_MANAGER, DisplayMonitorManager);
#line 22 "../src/Objects/MonitorManager.vala"
	switch (property_id) {
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITORS_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		g_value_set_object (value, display_monitor_manager_get_virtual_monitors (self));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_MONITORS_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		g_value_set_object (value, display_monitor_manager_get_monitors (self));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_GLOBAL_SCALE_REQUIRED_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		g_value_set_boolean (value, display_monitor_manager_get_global_scale_required (self));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_MIRRORING_SUPPORTED_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		g_value_set_boolean (value, display_monitor_manager_get_mirroring_supported (self));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_MAX_WIDTH_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		g_value_set_int (value, display_monitor_manager_get_max_width (self));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_MAX_HEIGHT_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		g_value_set_int (value, display_monitor_manager_get_max_height (self));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_MONITOR_NUMBER_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		g_value_set_int (value, display_monitor_manager_get_monitor_number (self));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITOR_NUMBER_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		g_value_set_int (value, display_monitor_manager_get_virtual_monitor_number (self));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_IS_MIRRORED_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		g_value_set_boolean (value, display_monitor_manager_get_is_mirrored (self));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 3730 "MonitorManager.c"
		default:
#line 22 "../src/Objects/MonitorManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 3736 "MonitorManager.c"
	}
}

static void
_vala_display_monitor_manager_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	DisplayMonitorManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_MONITOR_MANAGER, DisplayMonitorManager);
#line 22 "../src/Objects/MonitorManager.vala"
	switch (property_id) {
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_VIRTUAL_MONITORS_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_set_virtual_monitors (self, g_value_get_object (value));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_MONITORS_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_set_monitors (self, g_value_get_object (value));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_GLOBAL_SCALE_REQUIRED_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_set_global_scale_required (self, g_value_get_boolean (value));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_MIRRORING_SUPPORTED_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_set_mirroring_supported (self, g_value_get_boolean (value));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_MAX_WIDTH_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_set_max_width (self, g_value_get_int (value));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 22 "../src/Objects/MonitorManager.vala"
		case DISPLAY_MONITOR_MANAGER_MAX_HEIGHT_PROPERTY:
#line 22 "../src/Objects/MonitorManager.vala"
		display_monitor_manager_set_max_height (self, g_value_get_int (value));
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 3786 "MonitorManager.c"
		default:
#line 22 "../src/Objects/MonitorManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Objects/MonitorManager.vala"
		break;
#line 3792 "MonitorManager.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

