/* Utils.c generated by valac 0.56.18, the Vala compiler
 * generated from Utils.vala, do not modify */

/*-
 * Copyright (c) 2014-2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "display.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gboolean _vala_double_array_contains (gdouble * stack,
                                      gssize stack_length,
                                      const gdouble needle);

static gboolean
_vala_double_array_contains (gdouble * stack,
                             gssize stack_length,
                             const gdouble needle)
{
	gssize i;
#line 30 "../src/Utils.vala"
	for (i = 0; i < stack_length; i++) {
#line 30 "../src/Utils.vala"
		if (needle == stack[i]) {
#line 30 "../src/Utils.vala"
			return TRUE;
#line 60 "Utils.c"
		}
	}
#line 30 "../src/Utils.vala"
	return FALSE;
#line 65 "Utils.c"
}

GeeLinkedList*
display_utils_get_common_monitor_modes (GeeLinkedList* monitors)
{
	GeeLinkedList* common_modes = NULL;
	GeeLinkedList* _tmp0_;
	gdouble min_scale = 0.0;
	gboolean first_monitor = FALSE;
	GeeLinkedList* result;
#line 23 "../src/Utils.vala"
	g_return_val_if_fail (monitors != NULL, NULL);
#line 24 "../src/Utils.vala"
	_tmp0_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 24 "../src/Utils.vala"
	common_modes = _tmp0_;
#line 25 "../src/Utils.vala"
	min_scale = display_utils_get_min_compatible_scale (monitors);
#line 26 "../src/Utils.vala"
	first_monitor = TRUE;
#line 86 "Utils.c"
	{
		GeeLinkedList* _monitor_list = NULL;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
#line 27 "../src/Utils.vala"
		_monitor_list = monitors;
#line 27 "../src/Utils.vala"
		_tmp1_ = _monitor_list;
#line 27 "../src/Utils.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 27 "../src/Utils.vala"
		_tmp3_ = _tmp2_;
#line 27 "../src/Utils.vala"
		_monitor_size = _tmp3_;
#line 27 "../src/Utils.vala"
		_monitor_index = -1;
#line 27 "../src/Utils.vala"
		while (TRUE) {
#line 108 "Utils.c"
			gint _tmp4_;
			gint _tmp5_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
#line 27 "../src/Utils.vala"
			_monitor_index = _monitor_index + 1;
#line 27 "../src/Utils.vala"
			_tmp4_ = _monitor_index;
#line 27 "../src/Utils.vala"
			_tmp5_ = _monitor_size;
#line 27 "../src/Utils.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 27 "../src/Utils.vala"
				break;
#line 124 "Utils.c"
			}
#line 27 "../src/Utils.vala"
			_tmp6_ = _monitor_list;
#line 27 "../src/Utils.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _monitor_index);
#line 27 "../src/Utils.vala"
			monitor = (DisplayMonitor*) _tmp7_;
#line 28 "../src/Utils.vala"
			if (first_monitor) {
#line 134 "Utils.c"
				{
					GeeLinkedList* _mode_list = NULL;
					DisplayMonitor* _tmp8_;
					GeeLinkedList* _tmp9_;
					GeeLinkedList* _tmp10_;
					gint _mode_size = 0;
					GeeLinkedList* _tmp11_;
					gint _tmp12_;
					gint _tmp13_;
					gint _mode_index = 0;
#line 29 "../src/Utils.vala"
					_tmp8_ = monitor;
#line 29 "../src/Utils.vala"
					_tmp9_ = display_monitor_get_modes (_tmp8_);
#line 29 "../src/Utils.vala"
					_tmp10_ = _tmp9_;
#line 29 "../src/Utils.vala"
					_mode_list = _tmp10_;
#line 29 "../src/Utils.vala"
					_tmp11_ = _mode_list;
#line 29 "../src/Utils.vala"
					_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 29 "../src/Utils.vala"
					_tmp13_ = _tmp12_;
#line 29 "../src/Utils.vala"
					_mode_size = _tmp13_;
#line 29 "../src/Utils.vala"
					_mode_index = -1;
#line 29 "../src/Utils.vala"
					while (TRUE) {
#line 165 "Utils.c"
						gint _tmp14_;
						gint _tmp15_;
						DisplayMonitorMode* mode = NULL;
						GeeLinkedList* _tmp16_;
						gpointer _tmp17_;
						DisplayMonitorMode* _tmp18_;
						gdouble* _tmp19_;
						gint _tmp19__length1;
#line 29 "../src/Utils.vala"
						_mode_index = _mode_index + 1;
#line 29 "../src/Utils.vala"
						_tmp14_ = _mode_index;
#line 29 "../src/Utils.vala"
						_tmp15_ = _mode_size;
#line 29 "../src/Utils.vala"
						if (!(_tmp14_ < _tmp15_)) {
#line 29 "../src/Utils.vala"
							break;
#line 184 "Utils.c"
						}
#line 29 "../src/Utils.vala"
						_tmp16_ = _mode_list;
#line 29 "../src/Utils.vala"
						_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _mode_index);
#line 29 "../src/Utils.vala"
						mode = (DisplayMonitorMode*) _tmp17_;
#line 30 "../src/Utils.vala"
						_tmp18_ = mode;
#line 30 "../src/Utils.vala"
						_tmp19_ = _tmp18_->supported_scales;
#line 30 "../src/Utils.vala"
						_tmp19__length1 = _tmp18_->supported_scales_length1;
#line 30 "../src/Utils.vala"
						if (_vala_double_array_contains (_tmp19_, _tmp19__length1, min_scale)) {
#line 200 "Utils.c"
							GeeLinkedList* _tmp20_;
							DisplayMonitorMode* _tmp21_;
#line 31 "../src/Utils.vala"
							_tmp20_ = common_modes;
#line 31 "../src/Utils.vala"
							_tmp21_ = mode;
#line 31 "../src/Utils.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 209 "Utils.c"
						}
#line 29 "../src/Utils.vala"
						_g_object_unref0 (mode);
#line 213 "Utils.c"
					}
				}
#line 35 "../src/Utils.vala"
				first_monitor = FALSE;
#line 218 "Utils.c"
			} else {
				GeeLinkedList* to_remove = NULL;
				GeeLinkedList* _tmp22_;
				GeeLinkedList* _tmp56_;
				GeeLinkedList* _tmp57_;
#line 37 "../src/Utils.vala"
				_tmp22_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 37 "../src/Utils.vala"
				to_remove = _tmp22_;
#line 228 "Utils.c"
				{
					GeeLinkedList* _mode_to_check_list = NULL;
					GeeLinkedList* _tmp23_;
					gint _mode_to_check_size = 0;
					GeeLinkedList* _tmp24_;
					gint _tmp25_;
					gint _tmp26_;
					gint _mode_to_check_index = 0;
#line 38 "../src/Utils.vala"
					_tmp23_ = common_modes;
#line 38 "../src/Utils.vala"
					_mode_to_check_list = _tmp23_;
#line 38 "../src/Utils.vala"
					_tmp24_ = _mode_to_check_list;
#line 38 "../src/Utils.vala"
					_tmp25_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp24_);
#line 38 "../src/Utils.vala"
					_tmp26_ = _tmp25_;
#line 38 "../src/Utils.vala"
					_mode_to_check_size = _tmp26_;
#line 38 "../src/Utils.vala"
					_mode_to_check_index = -1;
#line 38 "../src/Utils.vala"
					while (TRUE) {
#line 253 "Utils.c"
						gint _tmp27_;
						gint _tmp28_;
						DisplayMonitorMode* mode_to_check = NULL;
						GeeLinkedList* _tmp29_;
						gpointer _tmp30_;
						gboolean mode_found = FALSE;
#line 38 "../src/Utils.vala"
						_mode_to_check_index = _mode_to_check_index + 1;
#line 38 "../src/Utils.vala"
						_tmp27_ = _mode_to_check_index;
#line 38 "../src/Utils.vala"
						_tmp28_ = _mode_to_check_size;
#line 38 "../src/Utils.vala"
						if (!(_tmp27_ < _tmp28_)) {
#line 38 "../src/Utils.vala"
							break;
#line 270 "Utils.c"
						}
#line 38 "../src/Utils.vala"
						_tmp29_ = _mode_to_check_list;
#line 38 "../src/Utils.vala"
						_tmp30_ = gee_abstract_list_get ((GeeAbstractList*) _tmp29_, _mode_to_check_index);
#line 38 "../src/Utils.vala"
						mode_to_check = (DisplayMonitorMode*) _tmp30_;
#line 39 "../src/Utils.vala"
						mode_found = FALSE;
#line 280 "Utils.c"
						{
							GeeLinkedList* _monitor_mode_list = NULL;
							DisplayMonitor* _tmp31_;
							GeeLinkedList* _tmp32_;
							GeeLinkedList* _tmp33_;
							gint _monitor_mode_size = 0;
							GeeLinkedList* _tmp34_;
							gint _tmp35_;
							gint _tmp36_;
							gint _monitor_mode_index = 0;
#line 40 "../src/Utils.vala"
							_tmp31_ = monitor;
#line 40 "../src/Utils.vala"
							_tmp32_ = display_monitor_get_modes (_tmp31_);
#line 40 "../src/Utils.vala"
							_tmp33_ = _tmp32_;
#line 40 "../src/Utils.vala"
							_monitor_mode_list = _tmp33_;
#line 40 "../src/Utils.vala"
							_tmp34_ = _monitor_mode_list;
#line 40 "../src/Utils.vala"
							_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
#line 40 "../src/Utils.vala"
							_tmp36_ = _tmp35_;
#line 40 "../src/Utils.vala"
							_monitor_mode_size = _tmp36_;
#line 40 "../src/Utils.vala"
							_monitor_mode_index = -1;
#line 40 "../src/Utils.vala"
							while (TRUE) {
#line 311 "Utils.c"
								gint _tmp37_;
								gint _tmp38_;
								DisplayMonitorMode* monitor_mode = NULL;
								GeeLinkedList* _tmp39_;
								gpointer _tmp40_;
								gboolean _tmp41_ = FALSE;
								DisplayMonitorMode* _tmp42_;
								gint _tmp43_;
								gint _tmp44_;
								DisplayMonitorMode* _tmp45_;
								gint _tmp46_;
								gint _tmp47_;
#line 40 "../src/Utils.vala"
								_monitor_mode_index = _monitor_mode_index + 1;
#line 40 "../src/Utils.vala"
								_tmp37_ = _monitor_mode_index;
#line 40 "../src/Utils.vala"
								_tmp38_ = _monitor_mode_size;
#line 40 "../src/Utils.vala"
								if (!(_tmp37_ < _tmp38_)) {
#line 40 "../src/Utils.vala"
									break;
#line 334 "Utils.c"
								}
#line 40 "../src/Utils.vala"
								_tmp39_ = _monitor_mode_list;
#line 40 "../src/Utils.vala"
								_tmp40_ = gee_abstract_list_get ((GeeAbstractList*) _tmp39_, _monitor_mode_index);
#line 40 "../src/Utils.vala"
								monitor_mode = (DisplayMonitorMode*) _tmp40_;
#line 41 "../src/Utils.vala"
								_tmp42_ = mode_to_check;
#line 41 "../src/Utils.vala"
								_tmp43_ = display_monitor_mode_get_width (_tmp42_);
#line 41 "../src/Utils.vala"
								_tmp44_ = _tmp43_;
#line 41 "../src/Utils.vala"
								_tmp45_ = monitor_mode;
#line 41 "../src/Utils.vala"
								_tmp46_ = display_monitor_mode_get_width (_tmp45_);
#line 41 "../src/Utils.vala"
								_tmp47_ = _tmp46_;
#line 41 "../src/Utils.vala"
								if (_tmp44_ == _tmp47_) {
#line 356 "Utils.c"
									DisplayMonitorMode* _tmp48_;
									gint _tmp49_;
									gint _tmp50_;
									DisplayMonitorMode* _tmp51_;
									gint _tmp52_;
									gint _tmp53_;
#line 42 "../src/Utils.vala"
									_tmp48_ = mode_to_check;
#line 42 "../src/Utils.vala"
									_tmp49_ = display_monitor_mode_get_height (_tmp48_);
#line 42 "../src/Utils.vala"
									_tmp50_ = _tmp49_;
#line 42 "../src/Utils.vala"
									_tmp51_ = monitor_mode;
#line 42 "../src/Utils.vala"
									_tmp52_ = display_monitor_mode_get_height (_tmp51_);
#line 42 "../src/Utils.vala"
									_tmp53_ = _tmp52_;
#line 42 "../src/Utils.vala"
									_tmp41_ = _tmp50_ == _tmp53_;
#line 377 "Utils.c"
								} else {
#line 41 "../src/Utils.vala"
									_tmp41_ = FALSE;
#line 381 "Utils.c"
								}
#line 41 "../src/Utils.vala"
								if (_tmp41_) {
#line 43 "../src/Utils.vala"
									mode_found = TRUE;
#line 44 "../src/Utils.vala"
									_g_object_unref0 (monitor_mode);
#line 44 "../src/Utils.vala"
									break;
#line 391 "Utils.c"
								}
#line 40 "../src/Utils.vala"
								_g_object_unref0 (monitor_mode);
#line 395 "Utils.c"
							}
						}
#line 48 "../src/Utils.vala"
						if (mode_found == FALSE) {
#line 400 "Utils.c"
							GeeLinkedList* _tmp54_;
							DisplayMonitorMode* _tmp55_;
#line 49 "../src/Utils.vala"
							_tmp54_ = to_remove;
#line 49 "../src/Utils.vala"
							_tmp55_ = mode_to_check;
#line 49 "../src/Utils.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp54_, _tmp55_);
#line 409 "Utils.c"
						}
#line 38 "../src/Utils.vala"
						_g_object_unref0 (mode_to_check);
#line 413 "Utils.c"
					}
				}
#line 53 "../src/Utils.vala"
				_tmp56_ = common_modes;
#line 53 "../src/Utils.vala"
				_tmp57_ = to_remove;
#line 53 "../src/Utils.vala"
				gee_collection_remove_all ((GeeCollection*) _tmp56_, (GeeCollection*) _tmp57_);
#line 28 "../src/Utils.vala"
				_g_object_unref0 (to_remove);
#line 424 "Utils.c"
			}
#line 27 "../src/Utils.vala"
			_g_object_unref0 (monitor);
#line 428 "Utils.c"
		}
	}
#line 57 "../src/Utils.vala"
	result = common_modes;
#line 57 "../src/Utils.vala"
	return result;
#line 435 "Utils.c"
}

gdouble
display_utils_get_min_compatible_scale (GeeLinkedList* monitors)
{
	gdouble min_scale = 0.0;
	gdouble result;
#line 60 "../src/Utils.vala"
	g_return_val_if_fail (monitors != NULL, 0.0);
#line 61 "../src/Utils.vala"
	min_scale = DBL_MAX;
#line 447 "Utils.c"
	{
		GeeLinkedList* _monitor_list = NULL;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _monitor_index = 0;
#line 62 "../src/Utils.vala"
		_monitor_list = monitors;
#line 62 "../src/Utils.vala"
		_tmp0_ = _monitor_list;
#line 62 "../src/Utils.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 62 "../src/Utils.vala"
		_tmp2_ = _tmp1_;
#line 62 "../src/Utils.vala"
		_monitor_size = _tmp2_;
#line 62 "../src/Utils.vala"
		_monitor_index = -1;
#line 62 "../src/Utils.vala"
		while (TRUE) {
#line 469 "Utils.c"
			gint _tmp3_;
			gint _tmp4_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			DisplayMonitor* _tmp7_;
#line 62 "../src/Utils.vala"
			_monitor_index = _monitor_index + 1;
#line 62 "../src/Utils.vala"
			_tmp3_ = _monitor_index;
#line 62 "../src/Utils.vala"
			_tmp4_ = _monitor_size;
#line 62 "../src/Utils.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 62 "../src/Utils.vala"
				break;
#line 486 "Utils.c"
			}
#line 62 "../src/Utils.vala"
			_tmp5_ = _monitor_list;
#line 62 "../src/Utils.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _monitor_index);
#line 62 "../src/Utils.vala"
			monitor = (DisplayMonitor*) _tmp6_;
#line 63 "../src/Utils.vala"
			_tmp7_ = monitor;
#line 63 "../src/Utils.vala"
			min_scale = MIN (min_scale, display_monitor_get_max_scale (_tmp7_));
#line 62 "../src/Utils.vala"
			_g_object_unref0 (monitor);
#line 500 "Utils.c"
		}
	}
#line 66 "../src/Utils.vala"
	result = min_scale;
#line 66 "../src/Utils.vala"
	return result;
#line 507 "Utils.c"
}

