/* DisplayWindow.c generated by valac 0.56.18, the Vala compiler
 * generated from DisplayWindow.vala, do not modify */

/*-
 * Copyright 2014-2021 elementary, Inc.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "display.h"
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

#define DISPLAY_DISPLAY_WINDOW_SPACING 12
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DISPLAY_DISPLAY_WINDOW_0_PROPERTY,
	DISPLAY_DISPLAY_WINDOW_VIRTUAL_MONITOR_PROPERTY,
	DISPLAY_DISPLAY_WINDOW_NUM_PROPERTIES
};
static GParamSpec* display_display_window_properties[DISPLAY_DISPLAY_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DisplayDisplayWindowPrivate {
	DisplayVirtualMonitor* _virtual_monitor;
};

static gint DisplayDisplayWindow_private_offset;
static gpointer display_display_window_parent_class = NULL;

static GObject * display_display_window_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void display_display_window_finalize (GObject * obj);
static GType display_display_window_get_type_once (void);
static void _vala_display_display_window_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_display_display_window_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
display_display_window_get_instance_private (DisplayDisplayWindow* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayDisplayWindow_private_offset);
}

DisplayDisplayWindow*
display_display_window_construct (GType object_type,
                                  DisplayVirtualMonitor* virtual_monitor)
{
	DisplayDisplayWindow * self = NULL;
#line 27 "../src/Widgets/DisplayWindow.vala"
	g_return_val_if_fail (virtual_monitor != NULL, NULL);
#line 28 "../src/Widgets/DisplayWindow.vala"
	self = (DisplayDisplayWindow*) g_object_new (object_type, "virtual-monitor", virtual_monitor, NULL);
#line 27 "../src/Widgets/DisplayWindow.vala"
	return self;
#line 92 "DisplayWindow.c"
}

DisplayDisplayWindow*
display_display_window_new (DisplayVirtualMonitor* virtual_monitor)
{
#line 27 "../src/Widgets/DisplayWindow.vala"
	return display_display_window_construct (DISPLAY_TYPE_DISPLAY_WINDOW, virtual_monitor);
#line 100 "DisplayWindow.c"
}

DisplayVirtualMonitor*
display_display_window_get_virtual_monitor (DisplayDisplayWindow* self)
{
	DisplayVirtualMonitor* result;
	DisplayVirtualMonitor* _tmp0_;
#line 23 "../src/Widgets/DisplayWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/DisplayWindow.vala"
	_tmp0_ = self->priv->_virtual_monitor;
#line 23 "../src/Widgets/DisplayWindow.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/DisplayWindow.vala"
	return result;
#line 116 "DisplayWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 23 "../src/Widgets/DisplayWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 124 "DisplayWindow.c"
}

static void
display_display_window_set_virtual_monitor (DisplayDisplayWindow* self,
                                            DisplayVirtualMonitor* value)
{
	DisplayVirtualMonitor* old_value;
#line 23 "../src/Widgets/DisplayWindow.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/DisplayWindow.vala"
	old_value = display_display_window_get_virtual_monitor (self);
#line 23 "../src/Widgets/DisplayWindow.vala"
	if (old_value != value) {
#line 138 "DisplayWindow.c"
		DisplayVirtualMonitor* _tmp0_;
#line 23 "../src/Widgets/DisplayWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/Widgets/DisplayWindow.vala"
		_g_object_unref0 (self->priv->_virtual_monitor);
#line 23 "../src/Widgets/DisplayWindow.vala"
		self->priv->_virtual_monitor = _tmp0_;
#line 23 "../src/Widgets/DisplayWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, display_display_window_properties[DISPLAY_DISPLAY_WINDOW_VIRTUAL_MONITOR_PROPERTY]);
#line 148 "DisplayWindow.c"
	}
}

static GObject *
display_display_window_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayDisplayWindow * self;
	GtkLabel* label = NULL;
	DisplayVirtualMonitor* _tmp0_;
	const gchar* _tmp1_;
	GtkLabel* _tmp2_ = NULL;
	GtkLabel* _tmp3_;
	gint scale_factor = 0;
	GtkStyleContext* _tmp4_;
	DisplayVirtualMonitor* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	DisplayVirtualMonitor* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
#line 31 "../src/Widgets/DisplayWindow.vala"
	parent_class = G_OBJECT_CLASS (display_display_window_parent_class);
#line 31 "../src/Widgets/DisplayWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 31 "../src/Widgets/DisplayWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAY_WINDOW, DisplayDisplayWindow);
#line 32 "../src/Widgets/DisplayWindow.vala"
	_tmp0_ = self->priv->_virtual_monitor;
#line 32 "../src/Widgets/DisplayWindow.vala"
	_tmp1_ = display_virtual_monitor_get_display_name (_tmp0_);
#line 32 "../src/Widgets/DisplayWindow.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new (_tmp1_);
#line 32 "../src/Widgets/DisplayWindow.vala"
	g_object_set ((GtkWidget*) _tmp2_, "margin", 12, NULL);
#line 32 "../src/Widgets/DisplayWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 32 "../src/Widgets/DisplayWindow.vala"
	label = _tmp2_;
#line 36 "../src/Widgets/DisplayWindow.vala"
	_tmp3_ = label;
#line 36 "../src/Widgets/DisplayWindow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp3_);
#line 38 "../src/Widgets/DisplayWindow.vala"
	gtk_widget_input_shape_combine_region ((GtkWidget*) self, NULL);
#line 39 "../src/Widgets/DisplayWindow.vala"
	gtk_window_set_accept_focus ((GtkWindow*) self, FALSE);
#line 40 "../src/Widgets/DisplayWindow.vala"
	gtk_window_set_decorated ((GtkWindow*) self, FALSE);
#line 41 "../src/Widgets/DisplayWindow.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 42 "../src/Widgets/DisplayWindow.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 43 "../src/Widgets/DisplayWindow.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, FALSE);
#line 44 "../src/Widgets/DisplayWindow.vala"
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, TRUE);
#line 45 "../src/Widgets/DisplayWindow.vala"
	gtk_window_set_skip_pager_hint ((GtkWindow*) self, TRUE);
#line 46 "../src/Widgets/DisplayWindow.vala"
	gtk_window_set_type_hint ((GtkWindow*) self, GDK_WINDOW_TYPE_HINT_TOOLTIP);
#line 47 "../src/Widgets/DisplayWindow.vala"
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
#line 49 "../src/Widgets/DisplayWindow.vala"
	gtk_window_stick ((GtkWindow*) self);
#line 51 "../src/Widgets/DisplayWindow.vala"
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 51 "../src/Widgets/DisplayWindow.vala"
	scale_factor = gtk_style_context_get_scale (_tmp4_);
#line 52 "../src/Widgets/DisplayWindow.vala"
	_tmp5_ = self->priv->_virtual_monitor;
#line 52 "../src/Widgets/DisplayWindow.vala"
	_tmp6_ = display_virtual_monitor_get_current_x (_tmp5_);
#line 52 "../src/Widgets/DisplayWindow.vala"
	_tmp7_ = _tmp6_;
#line 52 "../src/Widgets/DisplayWindow.vala"
	_tmp8_ = self->priv->_virtual_monitor;
#line 52 "../src/Widgets/DisplayWindow.vala"
	_tmp9_ = display_virtual_monitor_get_current_y (_tmp8_);
#line 52 "../src/Widgets/DisplayWindow.vala"
	_tmp10_ = _tmp9_;
#line 52 "../src/Widgets/DisplayWindow.vala"
	gtk_window_move ((GtkWindow*) self, ((gint) (_tmp7_ / scale_factor)) + DISPLAY_DISPLAY_WINDOW_SPACING, ((gint) (_tmp10_ / scale_factor)) + DISPLAY_DISPLAY_WINDOW_SPACING);
#line 31 "../src/Widgets/DisplayWindow.vala"
	_g_object_unref0 (label);
#line 31 "../src/Widgets/DisplayWindow.vala"
	return obj;
#line 239 "DisplayWindow.c"
}

static void
display_display_window_class_init (DisplayDisplayWindowClass * klass,
                                   gpointer klass_data)
{
#line 22 "../src/Widgets/DisplayWindow.vala"
	display_display_window_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/DisplayWindow.vala"
	g_type_class_adjust_private_offset (klass, &DisplayDisplayWindow_private_offset);
#line 22 "../src/Widgets/DisplayWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_display_display_window_get_property;
#line 22 "../src/Widgets/DisplayWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_display_display_window_set_property;
#line 22 "../src/Widgets/DisplayWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = display_display_window_constructor;
#line 22 "../src/Widgets/DisplayWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = display_display_window_finalize;
#line 22 "../src/Widgets/DisplayWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WINDOW_VIRTUAL_MONITOR_PROPERTY, display_display_window_properties[DISPLAY_DISPLAY_WINDOW_VIRTUAL_MONITOR_PROPERTY] = g_param_spec_object ("virtual-monitor", "virtual-monitor", "virtual-monitor", DISPLAY_TYPE_VIRTUAL_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 260 "DisplayWindow.c"
}

static void
display_display_window_instance_init (DisplayDisplayWindow * self,
                                      gpointer klass)
{
#line 22 "../src/Widgets/DisplayWindow.vala"
	self->priv = display_display_window_get_instance_private (self);
#line 269 "DisplayWindow.c"
}

static void
display_display_window_finalize (GObject * obj)
{
	DisplayDisplayWindow * self;
#line 22 "../src/Widgets/DisplayWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAY_WINDOW, DisplayDisplayWindow);
#line 23 "../src/Widgets/DisplayWindow.vala"
	_g_object_unref0 (self->priv->_virtual_monitor);
#line 22 "../src/Widgets/DisplayWindow.vala"
	G_OBJECT_CLASS (display_display_window_parent_class)->finalize (obj);
#line 282 "DisplayWindow.c"
}

static GType
display_display_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayDisplayWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_display_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayDisplayWindow), 0, (GInstanceInitFunc) display_display_window_instance_init, NULL };
	GType display_display_window_type_id;
	display_display_window_type_id = g_type_register_static (hdy_window_get_type (), "DisplayDisplayWindow", &g_define_type_info, 0);
	DisplayDisplayWindow_private_offset = g_type_add_instance_private (display_display_window_type_id, sizeof (DisplayDisplayWindowPrivate));
	return display_display_window_type_id;
}

GType
display_display_window_get_type (void)
{
	static volatile gsize display_display_window_type_id__once = 0;
	if (g_once_init_enter (&display_display_window_type_id__once)) {
		GType display_display_window_type_id;
		display_display_window_type_id = display_display_window_get_type_once ();
		g_once_init_leave (&display_display_window_type_id__once, display_display_window_type_id);
	}
	return display_display_window_type_id__once;
}

static void
_vala_display_display_window_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	DisplayDisplayWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_DISPLAY_WINDOW, DisplayDisplayWindow);
#line 22 "../src/Widgets/DisplayWindow.vala"
	switch (property_id) {
#line 22 "../src/Widgets/DisplayWindow.vala"
		case DISPLAY_DISPLAY_WINDOW_VIRTUAL_MONITOR_PROPERTY:
#line 22 "../src/Widgets/DisplayWindow.vala"
		g_value_set_object (value, display_display_window_get_virtual_monitor (self));
#line 22 "../src/Widgets/DisplayWindow.vala"
		break;
#line 323 "DisplayWindow.c"
		default:
#line 22 "../src/Widgets/DisplayWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/DisplayWindow.vala"
		break;
#line 329 "DisplayWindow.c"
	}
}

static void
_vala_display_display_window_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	DisplayDisplayWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_DISPLAY_WINDOW, DisplayDisplayWindow);
#line 22 "../src/Widgets/DisplayWindow.vala"
	switch (property_id) {
#line 22 "../src/Widgets/DisplayWindow.vala"
		case DISPLAY_DISPLAY_WINDOW_VIRTUAL_MONITOR_PROPERTY:
#line 22 "../src/Widgets/DisplayWindow.vala"
		display_display_window_set_virtual_monitor (self, g_value_get_object (value));
#line 22 "../src/Widgets/DisplayWindow.vala"
		break;
#line 349 "DisplayWindow.c"
		default:
#line 22 "../src/Widgets/DisplayWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/DisplayWindow.vala"
		break;
#line 355 "DisplayWindow.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

