/* DisplaysOverlay.c generated by valac 0.56.18, the Vala compiler
 * generated from DisplaysOverlay.vala, do not modify */

/*-
 * Copyright (c) 2014-2019 elementary, Inc. (https://elementary.io)
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 *              Felix Andreas <fandreas@physik.hu-berlin.de>
 */

#include "display.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gee.h>
#include <cairo-gobject.h>

#define DISPLAY_DISPLAYS_OVERLAY_SNAP_LIMIT (G_MAXINT - 1)
#define DISPLAY_DISPLAYS_OVERLAY_MINIMUM_WIDGET_OFFSET 50
#define DISPLAY_DISPLAYS_OVERLAY_COLORED_STYLE_CSS "\n" \
"        @define-color BG_COLOR %s;\n" \
"        @define-color TEXT_COLOR %s;\n" \
"    "
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DISPLAY_DISPLAYS_OVERLAY_0_PROPERTY,
	DISPLAY_DISPLAYS_OVERLAY_ACTIVE_DISPLAYS_PROPERTY,
	DISPLAY_DISPLAYS_OVERLAY_NUM_PROPERTIES
};
static GParamSpec* display_displays_overlay_properties[DISPLAY_DISPLAYS_OVERLAY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block10Data Block10Data;
typedef struct _Block11Data Block11Data;
typedef struct _Block12Data Block12Data;
enum  {
	DISPLAY_DISPLAYS_OVERLAY_CONFIGURATION_CHANGED_SIGNAL,
	DISPLAY_DISPLAYS_OVERLAY_NUM_SIGNALS
};
static guint display_displays_overlay_signals[DISPLAY_DISPLAYS_OVERLAY_NUM_SIGNALS] = {0};

struct _DisplayDisplaysOverlayPrivate {
	gboolean scanning;
	gdouble current_ratio;
	gint current_allocated_width;
	gint current_allocated_height;
	gint default_x_margin;
	gint default_y_margin;
	DisplayMonitorManager* monitor_manager;
	gint _active_displays;
};

struct _Block8Data {
	int _ref_count_;
	DisplayDisplaysOverlay* self;
	gint added_width;
	gint added_height;
	gint max_width;
	gint max_height;
};

struct _Block9Data {
	int _ref_count_;
	DisplayDisplaysOverlay* self;
	DisplayDisplayWidget* display_widget;
	DisplayVirtualMonitor* virtual_monitor;
};

struct _Block10Data {
	int _ref_count_;
	DisplayDisplaysOverlay* self;
	DisplayVirtualMonitor* new_primary;
};

struct _Block11Data {
	int _ref_count_;
	DisplayDisplaysOverlay* self;
	gint min_x;
	gint min_y;
};

struct _Block12Data {
	int _ref_count_;
	DisplayDisplaysOverlay* self;
	GList* anchors;
	DisplayDisplayWidget* last_moved;
};

static gint DisplayDisplaysOverlay_private_offset;
static gpointer display_displays_overlay_parent_class = NULL;
static GtkCssProvider* display_displays_overlay_display_provider;
static GtkCssProvider* display_displays_overlay_display_provider = NULL;
static gchar** display_displays_overlay_colors;
static gint display_displays_overlay_colors_length1;
static gchar** display_displays_overlay_colors = NULL;
static gint display_displays_overlay_colors_length1 = 0;
static gint _display_displays_overlay_colors_size_ = 0;
static gchar** display_displays_overlay_text_colors;
static gint display_displays_overlay_text_colors_length1;
static gchar** display_displays_overlay_text_colors = NULL;
static gint display_displays_overlay_text_colors_length1 = 0;
static gint _display_displays_overlay_text_colors_size_ = 0;

static void __lambda5_ (DisplayDisplaysOverlay* self);
static void ___lambda5__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static gboolean display_displays_overlay_real_get_child_position (GtkOverlay* base,
                                                           GtkWidget* widget,
                                                           GdkRectangle* allocation);
static void display_displays_overlay_calculate_ratio (DisplayDisplaysOverlay* self);
static void __lambda6_ (DisplayDisplaysOverlay* self,
                 GtkWidget* child);
static void ___lambda6__gfunc (gconstpointer data,
                        gpointer self);
static void display_displays_overlay_add_output (DisplayDisplaysOverlay* self,
                                          DisplayVirtualMonitor* virtual_monitor);
static void display_displays_overlay_change_active_displays_sensitivity (DisplayDisplaysOverlay* self);
static void __lambda25_ (DisplayDisplaysOverlay* self,
                  GtkWidget* child);
static void ___lambda25__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda26_ (DisplayDisplaysOverlay* self,
                  GtkWidget* child);
static void ___lambda26__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda23_ (DisplayDisplaysOverlay* self,
                  GtkWidget* child);
static void ___lambda23__gfunc (gconstpointer data,
                         gpointer self);
static void display_displays_overlay_check_configuration_changed (DisplayDisplaysOverlay* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda21_ (Block8Data* _data8_,
                  GtkWidget* child);
static void ___lambda21__gfunc (gconstpointer data,
                         gpointer self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda15_ (Block9Data* _data9_);
static void display_displays_overlay_set_as_primary (DisplayDisplaysOverlay* self,
                                              DisplayVirtualMonitor* new_primary);
static void ___lambda15__display_display_widget_set_as_primary (DisplayDisplayWidget* _sender,
                                                         gpointer self);
static void __lambda17_ (Block9Data* _data9_);
static void display_displays_overlay_close_gaps (DisplayDisplaysOverlay* self);
static void display_displays_overlay_verify_global_positions (DisplayDisplaysOverlay* self);
static void ___lambda17__display_display_widget_check_position (DisplayDisplayWidget* _sender,
                                                         gpointer self);
static void display_displays_overlay_move_display (DisplayDisplaysOverlay* self,
                                            DisplayDisplayWidget* display_widget,
                                            gdouble diff_x,
                                            gdouble diff_y);
static void _display_displays_overlay_move_display_display_display_widget_move_display (DisplayDisplayWidget* _sender,
                                                                                 gdouble diff_x,
                                                                                 gdouble diff_y,
                                                                                 gpointer self);
static void _display_displays_overlay_check_configuration_changed_display_display_widget_configuration_changed (DisplayDisplayWidget* _sender,
                                                                                                         gpointer self);
static void __lambda22_ (Block9Data* _data9_);
static void ___lambda22__display_display_widget_active_changed (DisplayDisplayWidget* _sender,
                                                         gpointer self);
static void __lambda24_ (Block9Data* _data9_,
                  gint delta_x,
                  gint delta_y);
static void ___lambda24__display_display_widget_end_grab (DisplayDisplayWidget* _sender,
                                                   gint delta_x,
                                                   gint delta_y,
                                                   gpointer self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda16_ (Block10Data* _data10_,
                  GtkWidget* child);
static void ___lambda16__gfunc (gconstpointer data,
                         gpointer self);
static void display_displays_overlay_align_edges (DisplayDisplaysOverlay* self,
                                           DisplayDisplayWidget* display_widget);
static gboolean display_displays_overlay_is_connected (DisplayDisplaysOverlay* self,
                                                DisplayDisplayWidget* display_widget,
                                                GList* other_display_widgets);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void __lambda19_ (Block11Data* _data11_,
                  GtkWidget* child);
static void ___lambda19__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda20_ (Block11Data* _data11_,
                  GtkWidget* child);
static void ___lambda20__gfunc (gconstpointer data,
                         gpointer self);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void __lambda18_ (Block12Data* _data12_,
                  GtkWidget* child);
static void ___lambda18__gfunc (gconstpointer data,
                         gpointer self);
static void display_displays_overlay_snap_widget (DisplayDisplaysOverlay* self,
                                           DisplayDisplayWidget* widget,
                                           GList* anchors);
static void display_displays_overlay_finalize (GObject * obj);
static GType display_displays_overlay_get_type_once (void);
static void _vala_display_displays_overlay_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_display_displays_overlay_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
display_displays_overlay_get_instance_private (DisplayDisplaysOverlay* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayDisplaysOverlay_private_offset);
}

static void
__lambda5_ (DisplayDisplaysOverlay* self)
{
#line 72 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_rescan_displays (self);
#line 255 "DisplaysOverlay.c"
}

static void
___lambda5__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 72 "../src/Widgets/DisplaysOverlay.vala"
	__lambda5_ ((DisplayDisplaysOverlay*) self);
#line 265 "DisplaysOverlay.c"
}

DisplayDisplaysOverlay*
display_displays_overlay_construct (GType object_type)
{
	DisplayDisplaysOverlay * self = NULL;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp0_;
	GtkStyleContext* _tmp1_;
	DisplayMonitorManager* _tmp2_;
	DisplayMonitorManager* _tmp3_;
#line 65 "../src/Widgets/DisplaysOverlay.vala"
	self = (DisplayDisplaysOverlay*) g_object_new (object_type, NULL);
#line 66 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
#line 66 "../src/Widgets/DisplaysOverlay.vala"
	g_object_ref_sink (_tmp0_);
#line 66 "../src/Widgets/DisplaysOverlay.vala"
	grid = _tmp0_;
#line 67 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) grid);
#line 67 "../src/Widgets/DisplaysOverlay.vala"
	gtk_style_context_add_class (_tmp1_, GTK_STYLE_CLASS_VIEW);
#line 68 "../src/Widgets/DisplaysOverlay.vala"
	g_object_set ((GtkWidget*) grid, "expand", TRUE, NULL);
#line 69 "../src/Widgets/DisplaysOverlay.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) grid);
#line 71 "../src/Widgets/DisplaysOverlay.vala"
	_tmp2_ = display_monitor_manager_get_default ();
#line 71 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->monitor_manager = _tmp2_;
#line 72 "../src/Widgets/DisplaysOverlay.vala"
	_tmp3_ = self->priv->monitor_manager;
#line 72 "../src/Widgets/DisplaysOverlay.vala"
	g_signal_connect_object ((GObject*) _tmp3_, "notify::virtual-monitor-number", (GCallback) ___lambda5__g_object_notify, self, 0);
#line 73 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_rescan_displays (self);
#line 65 "../src/Widgets/DisplaysOverlay.vala"
	_g_object_unref0 (grid);
#line 65 "../src/Widgets/DisplaysOverlay.vala"
	return self;
#line 307 "DisplaysOverlay.c"
}

DisplayDisplaysOverlay*
display_displays_overlay_new (void)
{
#line 65 "../src/Widgets/DisplaysOverlay.vala"
	return display_displays_overlay_construct (DISPLAY_TYPE_DISPLAYS_OVERLAY);
#line 315 "DisplaysOverlay.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 88 "../src/Widgets/DisplaysOverlay.vala"
	return self ? g_object_ref (self) : NULL;
#line 323 "DisplaysOverlay.c"
}

static gboolean
display_displays_overlay_real_get_child_position (GtkOverlay* base,
                                                  GtkWidget* widget,
                                                  GdkRectangle* allocation)
{
	DisplayDisplaysOverlay * self;
	GdkRectangle _vala_allocation = {0};
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 81 "../src/Widgets/DisplaysOverlay.vala"
	self = (DisplayDisplaysOverlay*) base;
#line 81 "../src/Widgets/DisplaysOverlay.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 82 "../src/Widgets/DisplaysOverlay.vala"
	memset (&_vala_allocation, 0, sizeof (GdkRectangle));
#line 83 "../src/Widgets/DisplaysOverlay.vala"
	if (self->priv->current_allocated_width != gtk_widget_get_allocated_width ((GtkWidget*) self)) {
#line 83 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = TRUE;
#line 345 "DisplaysOverlay.c"
	} else {
#line 83 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = self->priv->current_allocated_height != gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 349 "DisplaysOverlay.c"
	}
#line 83 "../src/Widgets/DisplaysOverlay.vala"
	if (_tmp0_) {
#line 84 "../src/Widgets/DisplaysOverlay.vala"
		display_displays_overlay_calculate_ratio (self);
#line 355 "DisplaysOverlay.c"
	}
#line 87 "../src/Widgets/DisplaysOverlay.vala"
	if (DISPLAY_IS_DISPLAY_WIDGET (widget)) {
#line 359 "DisplaysOverlay.c"
		DisplayDisplayWidget* display_widget = NULL;
		DisplayDisplayWidget* _tmp1_;
		gint x = 0;
		gint y = 0;
		gint width = 0;
		gint height = 0;
		DisplayDisplayWidget* _tmp2_;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		DisplayDisplayWidget* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		DisplayDisplayWidget* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint x_start = 0;
		gint y_start = 0;
		gint x_end = 0;
		gint y_end = 0;
#line 88 "../src/Widgets/DisplaysOverlay.vala"
		_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
#line 88 "../src/Widgets/DisplaysOverlay.vala"
		display_widget = _tmp1_;
#line 91 "../src/Widgets/DisplaysOverlay.vala"
		_tmp2_ = display_widget;
#line 91 "../src/Widgets/DisplaysOverlay.vala"
		display_display_widget_get_geometry (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 91 "../src/Widgets/DisplaysOverlay.vala"
		x = _tmp3_;
#line 91 "../src/Widgets/DisplaysOverlay.vala"
		y = _tmp4_;
#line 91 "../src/Widgets/DisplaysOverlay.vala"
		width = _tmp5_;
#line 91 "../src/Widgets/DisplaysOverlay.vala"
		height = _tmp6_;
#line 92 "../src/Widgets/DisplaysOverlay.vala"
		_tmp7_ = display_widget;
#line 92 "../src/Widgets/DisplaysOverlay.vala"
		_tmp8_ = display_display_widget_get_delta_x (_tmp7_);
#line 92 "../src/Widgets/DisplaysOverlay.vala"
		_tmp9_ = _tmp8_;
#line 92 "../src/Widgets/DisplaysOverlay.vala"
		x += _tmp9_;
#line 93 "../src/Widgets/DisplaysOverlay.vala"
		_tmp10_ = display_widget;
#line 93 "../src/Widgets/DisplaysOverlay.vala"
		_tmp11_ = display_display_widget_get_delta_y (_tmp10_);
#line 93 "../src/Widgets/DisplaysOverlay.vala"
		_tmp12_ = _tmp11_;
#line 93 "../src/Widgets/DisplaysOverlay.vala"
		y += _tmp12_;
#line 94 "../src/Widgets/DisplaysOverlay.vala"
		x_start = (gint) round (x * self->priv->current_ratio);
#line 95 "../src/Widgets/DisplaysOverlay.vala"
		y_start = (gint) round (y * self->priv->current_ratio);
#line 96 "../src/Widgets/DisplaysOverlay.vala"
		x_end = (gint) round ((x + width) * self->priv->current_ratio);
#line 97 "../src/Widgets/DisplaysOverlay.vala"
		y_end = (gint) round ((y + height) * self->priv->current_ratio);
#line 98 "../src/Widgets/DisplaysOverlay.vala"
		_vala_allocation.x = self->priv->default_x_margin + x_start;
#line 99 "../src/Widgets/DisplaysOverlay.vala"
		_vala_allocation.y = self->priv->default_y_margin + y_start;
#line 100 "../src/Widgets/DisplaysOverlay.vala"
		_vala_allocation.width = x_end - x_start;
#line 101 "../src/Widgets/DisplaysOverlay.vala"
		_vala_allocation.height = y_end - y_start;
#line 102 "../src/Widgets/DisplaysOverlay.vala"
		result = TRUE;
#line 102 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (display_widget);
#line 102 "../src/Widgets/DisplaysOverlay.vala"
		if (allocation) {
#line 102 "../src/Widgets/DisplaysOverlay.vala"
			*allocation = _vala_allocation;
#line 437 "DisplaysOverlay.c"
		}
#line 102 "../src/Widgets/DisplaysOverlay.vala"
		return result;
#line 441 "DisplaysOverlay.c"
	}
#line 105 "../src/Widgets/DisplaysOverlay.vala"
	result = FALSE;
#line 105 "../src/Widgets/DisplaysOverlay.vala"
	if (allocation) {
#line 105 "../src/Widgets/DisplaysOverlay.vala"
		*allocation = _vala_allocation;
#line 449 "DisplaysOverlay.c"
	}
#line 105 "../src/Widgets/DisplaysOverlay.vala"
	return result;
#line 453 "DisplaysOverlay.c"
}

static void
__lambda6_ (DisplayDisplaysOverlay* self,
            GtkWidget* child)
{
#line 110 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (child != NULL);
#line 111 "../src/Widgets/DisplaysOverlay.vala"
	if (DISPLAY_IS_DISPLAY_WIDGET (child)) {
#line 112 "../src/Widgets/DisplaysOverlay.vala"
		gtk_widget_destroy (child);
#line 466 "DisplaysOverlay.c"
	}
}

static void
___lambda6__gfunc (gconstpointer data,
                   gpointer self)
{
#line 110 "../src/Widgets/DisplaysOverlay.vala"
	__lambda6_ ((DisplayDisplaysOverlay*) self, (GtkWidget*) data);
#line 476 "DisplaysOverlay.c"
}

void
display_displays_overlay_rescan_displays (DisplayDisplaysOverlay* self)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 108 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 109 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->scanning = TRUE;
#line 110 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
#line 110 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = _tmp0_;
#line 110 "../src/Widgets/DisplaysOverlay.vala"
	g_list_foreach (_tmp1_, ___lambda6__gfunc, self);
#line 110 "../src/Widgets/DisplaysOverlay.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
#line 116 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_set_active_displays (self, 0);
#line 498 "DisplaysOverlay.c"
	{
		GeeLinkedList* _virtual_monitor_list = NULL;
		DisplayMonitorManager* _tmp2_;
		GeeLinkedList* _tmp3_;
		GeeLinkedList* _tmp4_;
		gint _virtual_monitor_size = 0;
		GeeLinkedList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _virtual_monitor_index = 0;
#line 117 "../src/Widgets/DisplaysOverlay.vala"
		_tmp2_ = self->priv->monitor_manager;
#line 117 "../src/Widgets/DisplaysOverlay.vala"
		_tmp3_ = display_monitor_manager_get_virtual_monitors (_tmp2_);
#line 117 "../src/Widgets/DisplaysOverlay.vala"
		_tmp4_ = _tmp3_;
#line 117 "../src/Widgets/DisplaysOverlay.vala"
		_virtual_monitor_list = _tmp4_;
#line 117 "../src/Widgets/DisplaysOverlay.vala"
		_tmp5_ = _virtual_monitor_list;
#line 117 "../src/Widgets/DisplaysOverlay.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 117 "../src/Widgets/DisplaysOverlay.vala"
		_tmp7_ = _tmp6_;
#line 117 "../src/Widgets/DisplaysOverlay.vala"
		_virtual_monitor_size = _tmp7_;
#line 117 "../src/Widgets/DisplaysOverlay.vala"
		_virtual_monitor_index = -1;
#line 117 "../src/Widgets/DisplaysOverlay.vala"
		while (TRUE) {
#line 529 "DisplaysOverlay.c"
			gint _tmp8_;
			gint _tmp9_;
			DisplayVirtualMonitor* virtual_monitor = NULL;
			GeeLinkedList* _tmp10_;
			gpointer _tmp11_;
			gint _tmp12_ = 0;
			DisplayVirtualMonitor* _tmp13_;
			gboolean _tmp14_;
			gboolean _tmp15_;
			gint _tmp16_;
			DisplayVirtualMonitor* _tmp17_;
#line 117 "../src/Widgets/DisplaysOverlay.vala"
			_virtual_monitor_index = _virtual_monitor_index + 1;
#line 117 "../src/Widgets/DisplaysOverlay.vala"
			_tmp8_ = _virtual_monitor_index;
#line 117 "../src/Widgets/DisplaysOverlay.vala"
			_tmp9_ = _virtual_monitor_size;
#line 117 "../src/Widgets/DisplaysOverlay.vala"
			if (!(_tmp8_ < _tmp9_)) {
#line 117 "../src/Widgets/DisplaysOverlay.vala"
				break;
#line 551 "DisplaysOverlay.c"
			}
#line 117 "../src/Widgets/DisplaysOverlay.vala"
			_tmp10_ = _virtual_monitor_list;
#line 117 "../src/Widgets/DisplaysOverlay.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _virtual_monitor_index);
#line 117 "../src/Widgets/DisplaysOverlay.vala"
			virtual_monitor = (DisplayVirtualMonitor*) _tmp11_;
#line 118 "../src/Widgets/DisplaysOverlay.vala"
			_tmp13_ = virtual_monitor;
#line 118 "../src/Widgets/DisplaysOverlay.vala"
			_tmp14_ = display_virtual_monitor_get_is_active (_tmp13_);
#line 118 "../src/Widgets/DisplaysOverlay.vala"
			_tmp15_ = _tmp14_;
#line 118 "../src/Widgets/DisplaysOverlay.vala"
			if (_tmp15_) {
#line 118 "../src/Widgets/DisplaysOverlay.vala"
				_tmp12_ = 1;
#line 569 "DisplaysOverlay.c"
			} else {
#line 118 "../src/Widgets/DisplaysOverlay.vala"
				_tmp12_ = 0;
#line 573 "DisplaysOverlay.c"
			}
#line 118 "../src/Widgets/DisplaysOverlay.vala"
			_tmp16_ = self->priv->_active_displays;
#line 118 "../src/Widgets/DisplaysOverlay.vala"
			display_displays_overlay_set_active_displays (self, _tmp16_ + _tmp12_);
#line 119 "../src/Widgets/DisplaysOverlay.vala"
			_tmp17_ = virtual_monitor;
#line 119 "../src/Widgets/DisplaysOverlay.vala"
			display_displays_overlay_add_output (self, _tmp17_);
#line 117 "../src/Widgets/DisplaysOverlay.vala"
			_g_object_unref0 (virtual_monitor);
#line 585 "DisplaysOverlay.c"
		}
	}
#line 122 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_change_active_displays_sensitivity (self);
#line 123 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_calculate_ratio (self);
#line 124 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->scanning = FALSE;
#line 594 "DisplaysOverlay.c"
}

static void
__lambda25_ (DisplayDisplaysOverlay* self,
             GtkWidget* child)
{
#line 132 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (child != NULL);
#line 133 "../src/Widgets/DisplaysOverlay.vala"
	if (DISPLAY_IS_DISPLAY_WIDGET (child)) {
#line 605 "DisplaysOverlay.c"
		DisplayVirtualMonitor* _tmp0_;
		DisplayVirtualMonitor* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 134 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = display_display_widget_get_virtual_monitor (G_TYPE_CHECK_INSTANCE_CAST (child, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
#line 134 "../src/Widgets/DisplaysOverlay.vala"
		_tmp1_ = _tmp0_;
#line 134 "../src/Widgets/DisplaysOverlay.vala"
		_tmp2_ = display_virtual_monitor_get_is_active (_tmp1_);
#line 134 "../src/Widgets/DisplaysOverlay.vala"
		_tmp3_ = _tmp2_;
#line 134 "../src/Widgets/DisplaysOverlay.vala"
		if (_tmp3_) {
#line 620 "DisplaysOverlay.c"
			DisplayDisplayWindow* _tmp4_;
			DisplayDisplayWindow* _tmp5_;
#line 135 "../src/Widgets/DisplaysOverlay.vala"
			_tmp4_ = display_display_widget_get_display_window (G_TYPE_CHECK_INSTANCE_CAST (child, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
#line 135 "../src/Widgets/DisplaysOverlay.vala"
			_tmp5_ = _tmp4_;
#line 135 "../src/Widgets/DisplaysOverlay.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp5_);
#line 629 "DisplaysOverlay.c"
		}
	}
}

static void
___lambda25__gfunc (gconstpointer data,
                    gpointer self)
{
#line 132 "../src/Widgets/DisplaysOverlay.vala"
	__lambda25_ ((DisplayDisplaysOverlay*) self, (GtkWidget*) data);
#line 640 "DisplaysOverlay.c"
}

void
display_displays_overlay_show_windows (DisplayDisplaysOverlay* self)
{
	DisplayMonitorManager* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
#line 127 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_ = self->priv->monitor_manager;
#line 128 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = display_monitor_manager_get_is_mirrored (_tmp0_);
#line 128 "../src/Widgets/DisplaysOverlay.vala"
	_tmp2_ = _tmp1_;
#line 128 "../src/Widgets/DisplaysOverlay.vala"
	if (_tmp2_) {
#line 129 "../src/Widgets/DisplaysOverlay.vala"
		return;
#line 663 "DisplaysOverlay.c"
	}
#line 132 "../src/Widgets/DisplaysOverlay.vala"
	_tmp3_ = gtk_container_get_children ((GtkContainer*) self);
#line 132 "../src/Widgets/DisplaysOverlay.vala"
	_tmp4_ = _tmp3_;
#line 132 "../src/Widgets/DisplaysOverlay.vala"
	g_list_foreach (_tmp4_, ___lambda25__gfunc, self);
#line 132 "../src/Widgets/DisplaysOverlay.vala"
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_list_free (_tmp4_), NULL));
#line 673 "DisplaysOverlay.c"
}

static void
__lambda26_ (DisplayDisplaysOverlay* self,
             GtkWidget* child)
{
#line 142 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (child != NULL);
#line 143 "../src/Widgets/DisplaysOverlay.vala"
	if (DISPLAY_IS_DISPLAY_WIDGET (child)) {
#line 684 "DisplaysOverlay.c"
		DisplayDisplayWindow* _tmp0_;
		DisplayDisplayWindow* _tmp1_;
#line 144 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = display_display_widget_get_display_window (G_TYPE_CHECK_INSTANCE_CAST (child, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
#line 144 "../src/Widgets/DisplaysOverlay.vala"
		_tmp1_ = _tmp0_;
#line 144 "../src/Widgets/DisplaysOverlay.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 693 "DisplaysOverlay.c"
	}
}

static void
___lambda26__gfunc (gconstpointer data,
                    gpointer self)
{
#line 142 "../src/Widgets/DisplaysOverlay.vala"
	__lambda26_ ((DisplayDisplaysOverlay*) self, (GtkWidget*) data);
#line 703 "DisplaysOverlay.c"
}

void
display_displays_overlay_hide_windows (DisplayDisplaysOverlay* self)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 141 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
#line 142 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = _tmp0_;
#line 142 "../src/Widgets/DisplaysOverlay.vala"
	g_list_foreach (_tmp1_, ___lambda26__gfunc, self);
#line 142 "../src/Widgets/DisplaysOverlay.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
#line 721 "DisplaysOverlay.c"
}

static void
__lambda23_ (DisplayDisplaysOverlay* self,
             GtkWidget* child)
{
#line 150 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (child != NULL);
#line 151 "../src/Widgets/DisplaysOverlay.vala"
	if (DISPLAY_IS_DISPLAY_WIDGET (child)) {
#line 732 "DisplaysOverlay.c"
		DisplayVirtualMonitor* _tmp0_;
		DisplayVirtualMonitor* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 152 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = display_display_widget_get_virtual_monitor (G_TYPE_CHECK_INSTANCE_CAST (child, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
#line 152 "../src/Widgets/DisplaysOverlay.vala"
		_tmp1_ = _tmp0_;
#line 152 "../src/Widgets/DisplaysOverlay.vala"
		_tmp2_ = display_virtual_monitor_get_is_active (_tmp1_);
#line 152 "../src/Widgets/DisplaysOverlay.vala"
		_tmp3_ = _tmp2_;
#line 152 "../src/Widgets/DisplaysOverlay.vala"
		if (_tmp3_) {
#line 747 "DisplaysOverlay.c"
			gint _tmp4_;
#line 153 "../src/Widgets/DisplaysOverlay.vala"
			_tmp4_ = self->priv->_active_displays;
#line 153 "../src/Widgets/DisplaysOverlay.vala"
			display_display_widget_set_only_display (G_TYPE_CHECK_INSTANCE_CAST (child, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget), _tmp4_ == 1);
#line 753 "DisplaysOverlay.c"
		}
	}
}

static void
___lambda23__gfunc (gconstpointer data,
                    gpointer self)
{
#line 150 "../src/Widgets/DisplaysOverlay.vala"
	__lambda23_ ((DisplayDisplaysOverlay*) self, (GtkWidget*) data);
#line 764 "DisplaysOverlay.c"
}

static void
display_displays_overlay_change_active_displays_sensitivity (DisplayDisplaysOverlay* self)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 149 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
#line 150 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = _tmp0_;
#line 150 "../src/Widgets/DisplaysOverlay.vala"
	g_list_foreach (_tmp1_, ___lambda23__gfunc, self);
#line 150 "../src/Widgets/DisplaysOverlay.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
#line 782 "DisplaysOverlay.c"
}

static void
display_displays_overlay_check_configuration_changed (DisplayDisplaysOverlay* self)
{
#line 159 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 161 "../src/Widgets/DisplaysOverlay.vala"
	g_signal_emit (self, display_displays_overlay_signals[DISPLAY_DISPLAYS_OVERLAY_CONFIGURATION_CHANGED_SIGNAL], 0, TRUE);
#line 792 "DisplaysOverlay.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 164 "../src/Widgets/DisplaysOverlay.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 164 "../src/Widgets/DisplaysOverlay.vala"
	return _data8_;
#line 802 "DisplaysOverlay.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 164 "../src/Widgets/DisplaysOverlay.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 812 "DisplaysOverlay.c"
		DisplayDisplaysOverlay* self;
#line 164 "../src/Widgets/DisplaysOverlay.vala"
		self = _data8_->self;
#line 164 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (self);
#line 164 "../src/Widgets/DisplaysOverlay.vala"
		g_slice_free (Block8Data, _data8_);
#line 820 "DisplaysOverlay.c"
	}
}

static void
__lambda21_ (Block8Data* _data8_,
             GtkWidget* child)
{
	DisplayDisplaysOverlay* self;
#line 170 "../src/Widgets/DisplaysOverlay.vala"
	self = _data8_->self;
#line 170 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (child != NULL);
#line 171 "../src/Widgets/DisplaysOverlay.vala"
	if (DISPLAY_IS_DISPLAY_WIDGET (child)) {
#line 835 "DisplaysOverlay.c"
		DisplayDisplayWidget* display_widget = NULL;
		DisplayDisplayWidget* _tmp0_;
		gint x = 0;
		gint y = 0;
		gint width = 0;
		gint height = 0;
		DisplayDisplayWidget* _tmp1_;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
#line 172 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
#line 172 "../src/Widgets/DisplaysOverlay.vala"
		display_widget = _tmp0_;
#line 174 "../src/Widgets/DisplaysOverlay.vala"
		_tmp1_ = display_widget;
#line 174 "../src/Widgets/DisplaysOverlay.vala"
		display_display_widget_get_geometry (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 174 "../src/Widgets/DisplaysOverlay.vala"
		x = _tmp2_;
#line 174 "../src/Widgets/DisplaysOverlay.vala"
		y = _tmp3_;
#line 174 "../src/Widgets/DisplaysOverlay.vala"
		width = _tmp4_;
#line 174 "../src/Widgets/DisplaysOverlay.vala"
		height = _tmp5_;
#line 176 "../src/Widgets/DisplaysOverlay.vala"
		_data8_->added_width += width;
#line 177 "../src/Widgets/DisplaysOverlay.vala"
		_data8_->added_height += height;
#line 178 "../src/Widgets/DisplaysOverlay.vala"
		_data8_->max_width = MAX (_data8_->max_width, x + width);
#line 179 "../src/Widgets/DisplaysOverlay.vala"
		_data8_->max_height = MAX (_data8_->max_height, y + height);
#line 171 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (display_widget);
#line 873 "DisplaysOverlay.c"
	}
}

static void
___lambda21__gfunc (gconstpointer data,
                    gpointer self)
{
#line 170 "../src/Widgets/DisplaysOverlay.vala"
	__lambda21_ (self, (GtkWidget*) data);
#line 883 "DisplaysOverlay.c"
}

static void
display_displays_overlay_calculate_ratio (DisplayDisplaysOverlay* self)
{
	Block8Data* _data8_;
	GList* _tmp0_;
	GList* _tmp1_;
#line 164 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/Widgets/DisplaysOverlay.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 164 "../src/Widgets/DisplaysOverlay.vala"
	_data8_->_ref_count_ = 1;
#line 164 "../src/Widgets/DisplaysOverlay.vala"
	_data8_->self = g_object_ref (self);
#line 165 "../src/Widgets/DisplaysOverlay.vala"
	_data8_->added_width = 0;
#line 166 "../src/Widgets/DisplaysOverlay.vala"
	_data8_->added_height = 0;
#line 167 "../src/Widgets/DisplaysOverlay.vala"
	_data8_->max_width = G_MININT;
#line 168 "../src/Widgets/DisplaysOverlay.vala"
	_data8_->max_height = G_MININT;
#line 170 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
#line 170 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = _tmp0_;
#line 170 "../src/Widgets/DisplaysOverlay.vala"
	g_list_foreach (_tmp1_, ___lambda21__gfunc, _data8_);
#line 170 "../src/Widgets/DisplaysOverlay.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
#line 183 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->current_allocated_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 184 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->current_allocated_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 185 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->current_ratio = MIN (((gdouble) (gtk_widget_get_allocated_width ((GtkWidget*) self) - 24)) / ((gdouble) _data8_->added_width), ((gdouble) (gtk_widget_get_allocated_height ((GtkWidget*) self) - 24)) / ((gdouble) _data8_->added_height));
#line 189 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->default_x_margin = (gint) ((gtk_widget_get_allocated_width ((GtkWidget*) self) - (_data8_->max_width * self->priv->current_ratio)) / 2);
#line 190 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->default_y_margin = (gint) ((gtk_widget_get_allocated_height ((GtkWidget*) self) - (_data8_->max_height * self->priv->current_ratio)) / 2);
#line 164 "../src/Widgets/DisplaysOverlay.vala"
	block8_data_unref (_data8_);
#line 164 "../src/Widgets/DisplaysOverlay.vala"
	_data8_ = NULL;
#line 930 "DisplaysOverlay.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 193 "../src/Widgets/DisplaysOverlay.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 193 "../src/Widgets/DisplaysOverlay.vala"
	return _data9_;
#line 940 "DisplaysOverlay.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 193 "../src/Widgets/DisplaysOverlay.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 950 "DisplaysOverlay.c"
		DisplayDisplaysOverlay* self;
#line 193 "../src/Widgets/DisplaysOverlay.vala"
		self = _data9_->self;
#line 193 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (_data9_->display_widget);
#line 193 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (_data9_->virtual_monitor);
#line 193 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (self);
#line 193 "../src/Widgets/DisplaysOverlay.vala"
		g_slice_free (Block9Data, _data9_);
#line 962 "DisplaysOverlay.c"
	}
}

static void
__lambda15_ (Block9Data* _data9_)
{
	DisplayDisplaysOverlay* self;
	DisplayVirtualMonitor* _tmp0_;
	DisplayVirtualMonitor* _tmp1_;
#line 229 "../src/Widgets/DisplaysOverlay.vala"
	self = _data9_->self;
#line 229 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_ = display_display_widget_get_virtual_monitor (_data9_->display_widget);
#line 229 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = _tmp0_;
#line 229 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_set_as_primary (self, _tmp1_);
#line 980 "DisplaysOverlay.c"
}

static void
___lambda15__display_display_widget_set_as_primary (DisplayDisplayWidget* _sender,
                                                    gpointer self)
{
#line 229 "../src/Widgets/DisplaysOverlay.vala"
	__lambda15_ (self);
#line 989 "DisplaysOverlay.c"
}

static void
__lambda17_ (Block9Data* _data9_)
{
	DisplayDisplaysOverlay* self;
#line 231 "../src/Widgets/DisplaysOverlay.vala"
	self = _data9_->self;
#line 232 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_check_intersects (self, _data9_->display_widget, 0, 0, 0);
#line 233 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_close_gaps (self);
#line 234 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_verify_global_positions (self);
#line 235 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_calculate_ratio (self);
#line 1006 "DisplaysOverlay.c"
}

static void
___lambda17__display_display_widget_check_position (DisplayDisplayWidget* _sender,
                                                    gpointer self)
{
#line 231 "../src/Widgets/DisplaysOverlay.vala"
	__lambda17_ (self);
#line 1015 "DisplaysOverlay.c"
}

static void
_display_displays_overlay_move_display_display_display_widget_move_display (DisplayDisplayWidget* _sender,
                                                                            gdouble diff_x,
                                                                            gdouble diff_y,
                                                                            gpointer self)
{
#line 238 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_move_display ((DisplayDisplaysOverlay*) self, _sender, diff_x, diff_y);
#line 1026 "DisplaysOverlay.c"
}

static void
_display_displays_overlay_check_configuration_changed_display_display_widget_configuration_changed (DisplayDisplayWidget* _sender,
                                                                                                    gpointer self)
{
#line 239 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_check_configuration_changed ((DisplayDisplaysOverlay*) self);
#line 1035 "DisplaysOverlay.c"
}

static void
__lambda22_ (Block9Data* _data9_)
{
	DisplayDisplaysOverlay* self;
	gint _tmp0_ = 0;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint _tmp3_;
#line 240 "../src/Widgets/DisplaysOverlay.vala"
	self = _data9_->self;
#line 241 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = display_virtual_monitor_get_is_active (_data9_->virtual_monitor);
#line 241 "../src/Widgets/DisplaysOverlay.vala"
	_tmp2_ = _tmp1_;
#line 241 "../src/Widgets/DisplaysOverlay.vala"
	if (_tmp2_) {
#line 241 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = 1;
#line 1056 "DisplaysOverlay.c"
	} else {
#line 241 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = -1;
#line 1060 "DisplaysOverlay.c"
	}
#line 241 "../src/Widgets/DisplaysOverlay.vala"
	_tmp3_ = self->priv->_active_displays;
#line 241 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_set_active_displays (self, _tmp3_ + _tmp0_);
#line 242 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_change_active_displays_sensitivity (self);
#line 243 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_check_configuration_changed (self);
#line 244 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_calculate_ratio (self);
#line 1072 "DisplaysOverlay.c"
}

static void
___lambda22__display_display_widget_active_changed (DisplayDisplayWidget* _sender,
                                                    gpointer self)
{
#line 240 "../src/Widgets/DisplaysOverlay.vala"
	__lambda22_ (self);
#line 1081 "DisplaysOverlay.c"
}

static void
__lambda24_ (Block9Data* _data9_,
             gint delta_x,
             gint delta_y)
{
	DisplayDisplaysOverlay* self;
	gboolean _tmp0_ = FALSE;
	gint x = 0;
	gint y = 0;
	gint width = 0;
	gint height = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
#line 251 "../src/Widgets/DisplaysOverlay.vala"
	self = _data9_->self;
#line 252 "../src/Widgets/DisplaysOverlay.vala"
	if (delta_x == 0) {
#line 252 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = delta_y == 0;
#line 1105 "DisplaysOverlay.c"
	} else {
#line 252 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = FALSE;
#line 1109 "DisplaysOverlay.c"
	}
#line 252 "../src/Widgets/DisplaysOverlay.vala"
	if (_tmp0_) {
#line 253 "../src/Widgets/DisplaysOverlay.vala"
		return;
#line 1115 "DisplaysOverlay.c"
	}
#line 257 "../src/Widgets/DisplaysOverlay.vala"
	display_display_widget_get_geometry (_data9_->display_widget, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 257 "../src/Widgets/DisplaysOverlay.vala"
	x = _tmp1_;
#line 257 "../src/Widgets/DisplaysOverlay.vala"
	y = _tmp2_;
#line 257 "../src/Widgets/DisplaysOverlay.vala"
	width = _tmp3_;
#line 257 "../src/Widgets/DisplaysOverlay.vala"
	height = _tmp4_;
#line 258 "../src/Widgets/DisplaysOverlay.vala"
	display_display_widget_set_geometry (_data9_->display_widget, delta_x + x, delta_y + y, width, height);
#line 259 "../src/Widgets/DisplaysOverlay.vala"
	gtk_widget_queue_resize_no_redraw ((GtkWidget*) _data9_->display_widget);
#line 260 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_check_configuration_changed (self);
#line 261 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_check_intersects (self, _data9_->display_widget, 0, 0, 0);
#line 262 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_snap_edges (self, _data9_->display_widget);
#line 263 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_close_gaps (self);
#line 264 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_verify_global_positions (self);
#line 265 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_calculate_ratio (self);
#line 1143 "DisplaysOverlay.c"
}

static void
___lambda24__display_display_widget_end_grab (DisplayDisplayWidget* _sender,
                                              gint delta_x,
                                              gint delta_y,
                                              gpointer self)
{
#line 251 "../src/Widgets/DisplaysOverlay.vala"
	__lambda24_ (self, delta_x, delta_y);
#line 1154 "DisplaysOverlay.c"
}

static void
display_displays_overlay_add_output (DisplayDisplaysOverlay* self,
                                     DisplayVirtualMonitor* virtual_monitor)
{
	Block9Data* _data9_;
	DisplayVirtualMonitor* _tmp0_;
	DisplayDisplayWidget* _tmp1_;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp2_;
	gboolean _tmp45_ = FALSE;
	DisplayMonitorManager* _tmp46_;
	gboolean _tmp47_;
	gboolean _tmp48_;
	gint old_delta_x = 0;
	gint _tmp53_;
	gint _tmp54_;
	gint old_delta_y = 0;
	gint _tmp55_;
	gint _tmp56_;
	GError* _inner_error0_ = NULL;
#line 193 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (virtual_monitor != NULL);
#line 193 "../src/Widgets/DisplaysOverlay.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 193 "../src/Widgets/DisplaysOverlay.vala"
	_data9_->_ref_count_ = 1;
#line 193 "../src/Widgets/DisplaysOverlay.vala"
	_data9_->self = g_object_ref (self);
#line 193 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_ = _g_object_ref0 (virtual_monitor);
#line 193 "../src/Widgets/DisplaysOverlay.vala"
	_g_object_unref0 (_data9_->virtual_monitor);
#line 193 "../src/Widgets/DisplaysOverlay.vala"
	_data9_->virtual_monitor = _tmp0_;
#line 194 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = display_display_widget_new (_data9_->virtual_monitor);
#line 194 "../src/Widgets/DisplaysOverlay.vala"
	g_object_ref_sink (_tmp1_);
#line 194 "../src/Widgets/DisplaysOverlay.vala"
	_data9_->display_widget = _tmp1_;
#line 195 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->current_allocated_width = 0;
#line 196 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->current_allocated_height = 0;
#line 197 "../src/Widgets/DisplaysOverlay.vala"
	gtk_overlay_add_overlay ((GtkOverlay*) self, (GtkWidget*) _data9_->display_widget);
#line 198 "../src/Widgets/DisplaysOverlay.vala"
	_tmp2_ = gtk_css_provider_new ();
#line 198 "../src/Widgets/DisplaysOverlay.vala"
	provider = _tmp2_;
#line 1209 "DisplaysOverlay.c"
	{
		guint color_number = 0U;
		GList* _tmp3_;
		GList* _tmp4_;
		guint _tmp5_;
		gchar* colored_css = NULL;
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		GtkStyleContext* context = NULL;
		GtkStyleContext* _tmp13_;
		GtkStyleContext* _tmp14_;
		GtkStyleContext* _tmp15_;
		GtkStyleContext* _tmp16_;
		GtkCssProvider* _tmp17_;
		GtkStyleContext* _tmp18_;
		DisplayDisplayWindow* _tmp19_;
		DisplayDisplayWindow* _tmp20_;
		GtkStyleContext* _tmp21_;
		GtkStyleContext* _tmp22_;
		GtkStyleContext* _tmp23_;
		GtkStyleContext* _tmp24_;
		GtkCssProvider* _tmp25_;
		GtkStyleContext* _tmp26_;
		GtkButton* _tmp27_;
		GtkButton* _tmp28_;
		GtkStyleContext* _tmp29_;
		GtkStyleContext* _tmp30_;
		GtkStyleContext* _tmp31_;
		GtkStyleContext* _tmp32_;
		GtkCssProvider* _tmp33_;
		GtkStyleContext* _tmp34_;
		GtkMenuButton* _tmp35_;
		GtkMenuButton* _tmp36_;
		GtkStyleContext* _tmp37_;
		GtkStyleContext* _tmp38_;
		GtkStyleContext* _tmp39_;
		GtkStyleContext* _tmp40_;
		GtkCssProvider* _tmp41_;
		GtkStyleContext* _tmp42_;
#line 200 "../src/Widgets/DisplaysOverlay.vala"
		_tmp3_ = gtk_container_get_children ((GtkContainer*) self);
#line 200 "../src/Widgets/DisplaysOverlay.vala"
		_tmp4_ = _tmp3_;
#line 200 "../src/Widgets/DisplaysOverlay.vala"
		_tmp5_ = (g_list_length (_tmp4_) - 2) % 7;
#line 200 "../src/Widgets/DisplaysOverlay.vala"
		(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_list_free (_tmp4_), NULL));
#line 200 "../src/Widgets/DisplaysOverlay.vala"
		color_number = _tmp5_;
#line 202 "../src/Widgets/DisplaysOverlay.vala"
		_tmp6_ = display_displays_overlay_colors;
#line 202 "../src/Widgets/DisplaysOverlay.vala"
		_tmp6__length1 = display_displays_overlay_colors_length1;
#line 202 "../src/Widgets/DisplaysOverlay.vala"
		_tmp7_ = _tmp6_[color_number];
#line 202 "../src/Widgets/DisplaysOverlay.vala"
		_tmp8_ = display_displays_overlay_text_colors;
#line 202 "../src/Widgets/DisplaysOverlay.vala"
		_tmp8__length1 = display_displays_overlay_text_colors_length1;
#line 202 "../src/Widgets/DisplaysOverlay.vala"
		_tmp9_ = _tmp8_[color_number];
#line 202 "../src/Widgets/DisplaysOverlay.vala"
		_tmp10_ = g_strdup_printf (DISPLAY_DISPLAYS_OVERLAY_COLORED_STYLE_CSS, _tmp7_, _tmp9_);
#line 202 "../src/Widgets/DisplaysOverlay.vala"
		colored_css = _tmp10_;
#line 203 "../src/Widgets/DisplaysOverlay.vala"
		_tmp11_ = strlen (colored_css);
#line 203 "../src/Widgets/DisplaysOverlay.vala"
		_tmp12_ = _tmp11_;
#line 203 "../src/Widgets/DisplaysOverlay.vala"
		gtk_css_provider_load_from_data (provider, colored_css, (gssize) _tmp12_, &_inner_error0_);
#line 203 "../src/Widgets/DisplaysOverlay.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 203 "../src/Widgets/DisplaysOverlay.vala"
			_g_free0 (colored_css);
#line 1292 "DisplaysOverlay.c"
			goto __catch0_g_error;
		}
#line 205 "../src/Widgets/DisplaysOverlay.vala"
		_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _data9_->display_widget);
#line 205 "../src/Widgets/DisplaysOverlay.vala"
		_tmp14_ = _g_object_ref0 (_tmp13_);
#line 205 "../src/Widgets/DisplaysOverlay.vala"
		context = _tmp14_;
#line 206 "../src/Widgets/DisplaysOverlay.vala"
		_tmp15_ = context;
#line 206 "../src/Widgets/DisplaysOverlay.vala"
		gtk_style_context_add_provider (_tmp15_, (GtkStyleProvider*) provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 207 "../src/Widgets/DisplaysOverlay.vala"
		_tmp16_ = context;
#line 207 "../src/Widgets/DisplaysOverlay.vala"
		_tmp17_ = display_displays_overlay_display_provider;
#line 207 "../src/Widgets/DisplaysOverlay.vala"
		gtk_style_context_add_provider (_tmp16_, (GtkStyleProvider*) _tmp17_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 208 "../src/Widgets/DisplaysOverlay.vala"
		_tmp18_ = context;
#line 208 "../src/Widgets/DisplaysOverlay.vala"
		gtk_style_context_add_class (_tmp18_, "colored");
#line 210 "../src/Widgets/DisplaysOverlay.vala"
		_tmp19_ = display_display_widget_get_display_window (_data9_->display_widget);
#line 210 "../src/Widgets/DisplaysOverlay.vala"
		_tmp20_ = _tmp19_;
#line 210 "../src/Widgets/DisplaysOverlay.vala"
		_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) _tmp20_);
#line 210 "../src/Widgets/DisplaysOverlay.vala"
		_tmp22_ = _g_object_ref0 (_tmp21_);
#line 210 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (context);
#line 210 "../src/Widgets/DisplaysOverlay.vala"
		context = _tmp22_;
#line 211 "../src/Widgets/DisplaysOverlay.vala"
		_tmp23_ = context;
#line 211 "../src/Widgets/DisplaysOverlay.vala"
		gtk_style_context_add_provider (_tmp23_, (GtkStyleProvider*) provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 212 "../src/Widgets/DisplaysOverlay.vala"
		_tmp24_ = context;
#line 212 "../src/Widgets/DisplaysOverlay.vala"
		_tmp25_ = display_displays_overlay_display_provider;
#line 212 "../src/Widgets/DisplaysOverlay.vala"
		gtk_style_context_add_provider (_tmp24_, (GtkStyleProvider*) _tmp25_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 213 "../src/Widgets/DisplaysOverlay.vala"
		_tmp26_ = context;
#line 213 "../src/Widgets/DisplaysOverlay.vala"
		gtk_style_context_add_class (_tmp26_, "colored");
#line 215 "../src/Widgets/DisplaysOverlay.vala"
		_tmp27_ = display_display_widget_get_primary_image (_data9_->display_widget);
#line 215 "../src/Widgets/DisplaysOverlay.vala"
		_tmp28_ = _tmp27_;
#line 215 "../src/Widgets/DisplaysOverlay.vala"
		_tmp29_ = gtk_widget_get_style_context ((GtkWidget*) _tmp28_);
#line 215 "../src/Widgets/DisplaysOverlay.vala"
		_tmp30_ = _g_object_ref0 (_tmp29_);
#line 215 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (context);
#line 215 "../src/Widgets/DisplaysOverlay.vala"
		context = _tmp30_;
#line 216 "../src/Widgets/DisplaysOverlay.vala"
		_tmp31_ = context;
#line 216 "../src/Widgets/DisplaysOverlay.vala"
		gtk_style_context_add_provider (_tmp31_, (GtkStyleProvider*) provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 217 "../src/Widgets/DisplaysOverlay.vala"
		_tmp32_ = context;
#line 217 "../src/Widgets/DisplaysOverlay.vala"
		_tmp33_ = display_displays_overlay_display_provider;
#line 217 "../src/Widgets/DisplaysOverlay.vala"
		gtk_style_context_add_provider (_tmp32_, (GtkStyleProvider*) _tmp33_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 218 "../src/Widgets/DisplaysOverlay.vala"
		_tmp34_ = context;
#line 218 "../src/Widgets/DisplaysOverlay.vala"
		gtk_style_context_add_class (_tmp34_, "colored");
#line 220 "../src/Widgets/DisplaysOverlay.vala"
		_tmp35_ = display_display_widget_get_toggle_settings (_data9_->display_widget);
#line 220 "../src/Widgets/DisplaysOverlay.vala"
		_tmp36_ = _tmp35_;
#line 220 "../src/Widgets/DisplaysOverlay.vala"
		_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) _tmp36_);
#line 220 "../src/Widgets/DisplaysOverlay.vala"
		_tmp38_ = _g_object_ref0 (_tmp37_);
#line 220 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (context);
#line 220 "../src/Widgets/DisplaysOverlay.vala"
		context = _tmp38_;
#line 221 "../src/Widgets/DisplaysOverlay.vala"
		_tmp39_ = context;
#line 221 "../src/Widgets/DisplaysOverlay.vala"
		gtk_style_context_add_provider (_tmp39_, (GtkStyleProvider*) provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 222 "../src/Widgets/DisplaysOverlay.vala"
		_tmp40_ = context;
#line 222 "../src/Widgets/DisplaysOverlay.vala"
		_tmp41_ = display_displays_overlay_display_provider;
#line 222 "../src/Widgets/DisplaysOverlay.vala"
		gtk_style_context_add_provider (_tmp40_, (GtkStyleProvider*) _tmp41_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 223 "../src/Widgets/DisplaysOverlay.vala"
		_tmp42_ = context;
#line 223 "../src/Widgets/DisplaysOverlay.vala"
		gtk_style_context_add_class (_tmp42_, "colored");
#line 199 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (context);
#line 199 "../src/Widgets/DisplaysOverlay.vala"
		_g_free0 (colored_css);
#line 1397 "DisplaysOverlay.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp43_;
		const gchar* _tmp44_;
#line 199 "../src/Widgets/DisplaysOverlay.vala"
		e = _inner_error0_;
#line 199 "../src/Widgets/DisplaysOverlay.vala"
		_inner_error0_ = NULL;
#line 225 "../src/Widgets/DisplaysOverlay.vala"
		_tmp43_ = e;
#line 225 "../src/Widgets/DisplaysOverlay.vala"
		_tmp44_ = _tmp43_->message;
#line 225 "../src/Widgets/DisplaysOverlay.vala"
		g_critical ("DisplaysOverlay.vala:225: %s", _tmp44_);
#line 199 "../src/Widgets/DisplaysOverlay.vala"
		_g_error_free0 (e);
#line 1417 "DisplaysOverlay.c"
	}
	__finally0:
#line 199 "../src/Widgets/DisplaysOverlay.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (provider);
#line 199 "../src/Widgets/DisplaysOverlay.vala"
		block9_data_unref (_data9_);
#line 199 "../src/Widgets/DisplaysOverlay.vala"
		_data9_ = NULL;
#line 199 "../src/Widgets/DisplaysOverlay.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 199 "../src/Widgets/DisplaysOverlay.vala"
		g_clear_error (&_inner_error0_);
#line 199 "../src/Widgets/DisplaysOverlay.vala"
		return;
#line 1434 "DisplaysOverlay.c"
	}
#line 228 "../src/Widgets/DisplaysOverlay.vala"
	gtk_widget_show_all ((GtkWidget*) _data9_->display_widget);
#line 229 "../src/Widgets/DisplaysOverlay.vala"
	g_signal_connect_data (_data9_->display_widget, "set-as-primary", (GCallback) ___lambda15__display_display_widget_set_as_primary, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 231 "../src/Widgets/DisplaysOverlay.vala"
	g_signal_connect_data (_data9_->display_widget, "check-position", (GCallback) ___lambda17__display_display_widget_check_position, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 238 "../src/Widgets/DisplaysOverlay.vala"
	g_signal_connect_object (_data9_->display_widget, "move-display", (GCallback) _display_displays_overlay_move_display_display_display_widget_move_display, self, 0);
#line 239 "../src/Widgets/DisplaysOverlay.vala"
	g_signal_connect_object (_data9_->display_widget, "configuration-changed", (GCallback) _display_displays_overlay_check_configuration_changed_display_display_widget_configuration_changed, self, 0);
#line 240 "../src/Widgets/DisplaysOverlay.vala"
	g_signal_connect_data (_data9_->display_widget, "active-changed", (GCallback) ___lambda22__display_display_widget_active_changed, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 247 "../src/Widgets/DisplaysOverlay.vala"
	_tmp46_ = self->priv->monitor_manager;
#line 247 "../src/Widgets/DisplaysOverlay.vala"
	_tmp47_ = display_monitor_manager_get_is_mirrored (_tmp46_);
#line 247 "../src/Widgets/DisplaysOverlay.vala"
	_tmp48_ = _tmp47_;
#line 247 "../src/Widgets/DisplaysOverlay.vala"
	if (!_tmp48_) {
#line 1456 "DisplaysOverlay.c"
		gboolean _tmp49_;
		gboolean _tmp50_;
#line 247 "../src/Widgets/DisplaysOverlay.vala"
		_tmp49_ = display_virtual_monitor_get_is_active (_data9_->virtual_monitor);
#line 247 "../src/Widgets/DisplaysOverlay.vala"
		_tmp50_ = _tmp49_;
#line 247 "../src/Widgets/DisplaysOverlay.vala"
		_tmp45_ = _tmp50_;
#line 1465 "DisplaysOverlay.c"
	} else {
#line 247 "../src/Widgets/DisplaysOverlay.vala"
		_tmp45_ = FALSE;
#line 1469 "DisplaysOverlay.c"
	}
#line 247 "../src/Widgets/DisplaysOverlay.vala"
	if (_tmp45_) {
#line 1473 "DisplaysOverlay.c"
		DisplayDisplayWindow* _tmp51_;
		DisplayDisplayWindow* _tmp52_;
#line 248 "../src/Widgets/DisplaysOverlay.vala"
		_tmp51_ = display_display_widget_get_display_window (_data9_->display_widget);
#line 248 "../src/Widgets/DisplaysOverlay.vala"
		_tmp52_ = _tmp51_;
#line 248 "../src/Widgets/DisplaysOverlay.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp52_);
#line 1482 "DisplaysOverlay.c"
	}
#line 251 "../src/Widgets/DisplaysOverlay.vala"
	g_signal_connect_data (_data9_->display_widget, "end-grab", (GCallback) ___lambda24__display_display_widget_end_grab, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 268 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_check_intersects (self, _data9_->display_widget, 0, 0, 0);
#line 269 "../src/Widgets/DisplaysOverlay.vala"
	_tmp53_ = display_display_widget_get_delta_x (_data9_->display_widget);
#line 269 "../src/Widgets/DisplaysOverlay.vala"
	_tmp54_ = _tmp53_;
#line 269 "../src/Widgets/DisplaysOverlay.vala"
	old_delta_x = _tmp54_;
#line 270 "../src/Widgets/DisplaysOverlay.vala"
	_tmp55_ = display_display_widget_get_delta_y (_data9_->display_widget);
#line 270 "../src/Widgets/DisplaysOverlay.vala"
	_tmp56_ = _tmp55_;
#line 270 "../src/Widgets/DisplaysOverlay.vala"
	old_delta_y = _tmp56_;
#line 271 "../src/Widgets/DisplaysOverlay.vala"
	display_display_widget_set_delta_x (_data9_->display_widget, 0);
#line 272 "../src/Widgets/DisplaysOverlay.vala"
	display_display_widget_set_delta_y (_data9_->display_widget, 0);
#line 273 "../src/Widgets/DisplaysOverlay.vala"
	g_signal_emit_by_name (_data9_->display_widget, "end-grab", old_delta_x, old_delta_y);
#line 193 "../src/Widgets/DisplaysOverlay.vala"
	_g_object_unref0 (provider);
#line 193 "../src/Widgets/DisplaysOverlay.vala"
	block9_data_unref (_data9_);
#line 193 "../src/Widgets/DisplaysOverlay.vala"
	_data9_ = NULL;
#line 1512 "DisplaysOverlay.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 276 "../src/Widgets/DisplaysOverlay.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 276 "../src/Widgets/DisplaysOverlay.vala"
	return _data10_;
#line 1522 "DisplaysOverlay.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 276 "../src/Widgets/DisplaysOverlay.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 1532 "DisplaysOverlay.c"
		DisplayDisplaysOverlay* self;
#line 276 "../src/Widgets/DisplaysOverlay.vala"
		self = _data10_->self;
#line 276 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (_data10_->new_primary);
#line 276 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (self);
#line 276 "../src/Widgets/DisplaysOverlay.vala"
		g_slice_free (Block10Data, _data10_);
#line 1542 "DisplaysOverlay.c"
	}
}

static void
__lambda16_ (Block10Data* _data10_,
             GtkWidget* child)
{
	DisplayDisplaysOverlay* self;
#line 277 "../src/Widgets/DisplaysOverlay.vala"
	self = _data10_->self;
#line 277 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (child != NULL);
#line 278 "../src/Widgets/DisplaysOverlay.vala"
	if (DISPLAY_IS_DISPLAY_WIDGET (child)) {
#line 1557 "DisplaysOverlay.c"
		DisplayDisplayWidget* display_widget = NULL;
		DisplayDisplayWidget* _tmp0_;
		DisplayVirtualMonitor* virtual_monitor = NULL;
		DisplayDisplayWidget* _tmp1_;
		DisplayVirtualMonitor* _tmp2_;
		DisplayVirtualMonitor* _tmp3_;
		DisplayVirtualMonitor* _tmp4_;
		gboolean is_primary = FALSE;
		DisplayVirtualMonitor* _tmp5_;
		DisplayDisplayWidget* _tmp6_;
		DisplayVirtualMonitor* _tmp7_;
#line 279 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = _g_object_ref0 (DISPLAY_IS_DISPLAY_WIDGET (child) ? ((DisplayDisplayWidget*) child) : NULL);
#line 279 "../src/Widgets/DisplaysOverlay.vala"
		display_widget = _tmp0_;
#line 280 "../src/Widgets/DisplaysOverlay.vala"
		_tmp1_ = display_widget;
#line 280 "../src/Widgets/DisplaysOverlay.vala"
		_tmp2_ = display_display_widget_get_virtual_monitor (_tmp1_);
#line 280 "../src/Widgets/DisplaysOverlay.vala"
		_tmp3_ = _tmp2_;
#line 280 "../src/Widgets/DisplaysOverlay.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 280 "../src/Widgets/DisplaysOverlay.vala"
		virtual_monitor = _tmp4_;
#line 281 "../src/Widgets/DisplaysOverlay.vala"
		_tmp5_ = virtual_monitor;
#line 281 "../src/Widgets/DisplaysOverlay.vala"
		is_primary = _tmp5_ == _data10_->new_primary;
#line 282 "../src/Widgets/DisplaysOverlay.vala"
		_tmp6_ = display_widget;
#line 282 "../src/Widgets/DisplaysOverlay.vala"
		display_display_widget_set_primary (_tmp6_, is_primary);
#line 283 "../src/Widgets/DisplaysOverlay.vala"
		_tmp7_ = virtual_monitor;
#line 283 "../src/Widgets/DisplaysOverlay.vala"
		display_virtual_monitor_set_primary (_tmp7_, is_primary);
#line 278 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (virtual_monitor);
#line 278 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (display_widget);
#line 1599 "DisplaysOverlay.c"
	}
}

static void
___lambda16__gfunc (gconstpointer data,
                    gpointer self)
{
#line 277 "../src/Widgets/DisplaysOverlay.vala"
	__lambda16_ (self, (GtkWidget*) data);
#line 1609 "DisplaysOverlay.c"
}

static void
display_displays_overlay_set_as_primary (DisplayDisplaysOverlay* self,
                                         DisplayVirtualMonitor* new_primary)
{
	Block10Data* _data10_;
	DisplayVirtualMonitor* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 276 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 276 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (new_primary != NULL);
#line 276 "../src/Widgets/DisplaysOverlay.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 276 "../src/Widgets/DisplaysOverlay.vala"
	_data10_->_ref_count_ = 1;
#line 276 "../src/Widgets/DisplaysOverlay.vala"
	_data10_->self = g_object_ref (self);
#line 276 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_ = _g_object_ref0 (new_primary);
#line 276 "../src/Widgets/DisplaysOverlay.vala"
	_g_object_unref0 (_data10_->new_primary);
#line 276 "../src/Widgets/DisplaysOverlay.vala"
	_data10_->new_primary = _tmp0_;
#line 277 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) self);
#line 277 "../src/Widgets/DisplaysOverlay.vala"
	_tmp2_ = _tmp1_;
#line 277 "../src/Widgets/DisplaysOverlay.vala"
	g_list_foreach (_tmp2_, ___lambda16__gfunc, _data10_);
#line 277 "../src/Widgets/DisplaysOverlay.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
#line 1644 "DisplaysOverlay.c"
	{
		GeeLinkedList* _virtual_monitor_list = NULL;
		DisplayMonitorManager* _tmp3_;
		GeeLinkedList* _tmp4_;
		GeeLinkedList* _tmp5_;
		gint _virtual_monitor_size = 0;
		GeeLinkedList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _virtual_monitor_index = 0;
#line 286 "../src/Widgets/DisplaysOverlay.vala"
		_tmp3_ = self->priv->monitor_manager;
#line 286 "../src/Widgets/DisplaysOverlay.vala"
		_tmp4_ = display_monitor_manager_get_virtual_monitors (_tmp3_);
#line 286 "../src/Widgets/DisplaysOverlay.vala"
		_tmp5_ = _tmp4_;
#line 286 "../src/Widgets/DisplaysOverlay.vala"
		_virtual_monitor_list = _tmp5_;
#line 286 "../src/Widgets/DisplaysOverlay.vala"
		_tmp6_ = _virtual_monitor_list;
#line 286 "../src/Widgets/DisplaysOverlay.vala"
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 286 "../src/Widgets/DisplaysOverlay.vala"
		_tmp8_ = _tmp7_;
#line 286 "../src/Widgets/DisplaysOverlay.vala"
		_virtual_monitor_size = _tmp8_;
#line 286 "../src/Widgets/DisplaysOverlay.vala"
		_virtual_monitor_index = -1;
#line 286 "../src/Widgets/DisplaysOverlay.vala"
		while (TRUE) {
#line 1675 "DisplaysOverlay.c"
			gint _tmp9_;
			gint _tmp10_;
			DisplayVirtualMonitor* virtual_monitor = NULL;
			GeeLinkedList* _tmp11_;
			gpointer _tmp12_;
			DisplayVirtualMonitor* _tmp13_;
			DisplayVirtualMonitor* _tmp14_;
#line 286 "../src/Widgets/DisplaysOverlay.vala"
			_virtual_monitor_index = _virtual_monitor_index + 1;
#line 286 "../src/Widgets/DisplaysOverlay.vala"
			_tmp9_ = _virtual_monitor_index;
#line 286 "../src/Widgets/DisplaysOverlay.vala"
			_tmp10_ = _virtual_monitor_size;
#line 286 "../src/Widgets/DisplaysOverlay.vala"
			if (!(_tmp9_ < _tmp10_)) {
#line 286 "../src/Widgets/DisplaysOverlay.vala"
				break;
#line 1693 "DisplaysOverlay.c"
			}
#line 286 "../src/Widgets/DisplaysOverlay.vala"
			_tmp11_ = _virtual_monitor_list;
#line 286 "../src/Widgets/DisplaysOverlay.vala"
			_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _virtual_monitor_index);
#line 286 "../src/Widgets/DisplaysOverlay.vala"
			virtual_monitor = (DisplayVirtualMonitor*) _tmp12_;
#line 287 "../src/Widgets/DisplaysOverlay.vala"
			_tmp13_ = virtual_monitor;
#line 287 "../src/Widgets/DisplaysOverlay.vala"
			_tmp14_ = virtual_monitor;
#line 287 "../src/Widgets/DisplaysOverlay.vala"
			display_virtual_monitor_set_primary (_tmp13_, _tmp14_ == _data10_->new_primary);
#line 286 "../src/Widgets/DisplaysOverlay.vala"
			_g_object_unref0 (virtual_monitor);
#line 1709 "DisplaysOverlay.c"
		}
	}
#line 290 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_check_configuration_changed (self);
#line 276 "../src/Widgets/DisplaysOverlay.vala"
	block10_data_unref (_data10_);
#line 276 "../src/Widgets/DisplaysOverlay.vala"
	_data10_ = NULL;
#line 1718 "DisplaysOverlay.c"
}

static void
display_displays_overlay_move_display (DisplayDisplaysOverlay* self,
                                       DisplayDisplayWidget* display_widget,
                                       gdouble diff_x,
                                       gdouble diff_y)
{
	GdkModifierType state = 0U;
	GdkModifierType _tmp0_ = 0U;
#line 293 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 293 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (display_widget != NULL);
#line 294 "../src/Widgets/DisplaysOverlay.vala"
	gtk_overlay_reorder_overlay ((GtkOverlay*) self, (GtkWidget*) display_widget, -1);
#line 295 "../src/Widgets/DisplaysOverlay.vala"
	display_display_widget_set_delta_x (display_widget, (gint) (diff_x / self->priv->current_ratio));
#line 296 "../src/Widgets/DisplaysOverlay.vala"
	display_display_widget_set_delta_y (display_widget, (gint) (diff_y / self->priv->current_ratio));
#line 298 "../src/Widgets/DisplaysOverlay.vala"
	gtk_get_current_event_state (&_tmp0_);
#line 298 "../src/Widgets/DisplaysOverlay.vala"
	state = _tmp0_;
#line 299 "../src/Widgets/DisplaysOverlay.vala"
	if (!((state & GDK_CONTROL_MASK) == GDK_CONTROL_MASK)) {
#line 300 "../src/Widgets/DisplaysOverlay.vala"
		display_displays_overlay_align_edges (self, display_widget);
#line 1747 "DisplaysOverlay.c"
	}
#line 303 "../src/Widgets/DisplaysOverlay.vala"
	gtk_widget_queue_resize_no_redraw ((GtkWidget*) display_widget);
#line 1751 "DisplaysOverlay.c"
}

static void
display_displays_overlay_align_edges (DisplayDisplaysOverlay* self,
                                      DisplayDisplayWidget* display_widget)
{
	gint aligned_delta[2] = {0};
	gint _tmp0_[2] = {0};
	gint current_delta[2] = {0};
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_[2] = {0};
	gint x = 0;
	gint y = 0;
	gint width = 0;
	gint height = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	gint widget_points[6] = {0};
	gint anchor_points[6] = {0};
	GList* _tmp10_;
	gint _tmp33_;
	gint _tmp35_;
#line 306 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 306 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (display_widget != NULL);
#line 307 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_[0] = G_MAXINT;
#line 307 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_[1] = G_MAXINT;
#line 307 "../src/Widgets/DisplaysOverlay.vala"
	memcpy (aligned_delta, _tmp0_, 2 * sizeof (gint));
#line 308 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = display_display_widget_get_delta_x (display_widget);
#line 308 "../src/Widgets/DisplaysOverlay.vala"
	_tmp2_ = _tmp1_;
#line 308 "../src/Widgets/DisplaysOverlay.vala"
	_tmp3_ = display_display_widget_get_delta_y (display_widget);
#line 308 "../src/Widgets/DisplaysOverlay.vala"
	_tmp4_ = _tmp3_;
#line 308 "../src/Widgets/DisplaysOverlay.vala"
	_tmp5_[0] = _tmp2_;
#line 308 "../src/Widgets/DisplaysOverlay.vala"
	_tmp5_[1] = _tmp4_;
#line 308 "../src/Widgets/DisplaysOverlay.vala"
	memcpy (current_delta, _tmp5_, 2 * sizeof (gint));
#line 311 "../src/Widgets/DisplaysOverlay.vala"
	display_display_widget_get_geometry (display_widget, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 311 "../src/Widgets/DisplaysOverlay.vala"
	x = _tmp6_;
#line 311 "../src/Widgets/DisplaysOverlay.vala"
	y = _tmp7_;
#line 311 "../src/Widgets/DisplaysOverlay.vala"
	width = _tmp8_;
#line 311 "../src/Widgets/DisplaysOverlay.vala"
	height = _tmp9_;
#line 314 "../src/Widgets/DisplaysOverlay.vala"
	widget_points[0] = x;
#line 315 "../src/Widgets/DisplaysOverlay.vala"
	widget_points[1] = (x + (width / 2)) - 1;
#line 316 "../src/Widgets/DisplaysOverlay.vala"
	widget_points[2] = (x + width) - 1;
#line 317 "../src/Widgets/DisplaysOverlay.vala"
	widget_points[3] = y;
#line 318 "../src/Widgets/DisplaysOverlay.vala"
	widget_points[4] = (y + (height / 2)) - 1;
#line 319 "../src/Widgets/DisplaysOverlay.vala"
	widget_points[5] = (y + height) - 1;
#line 321 "../src/Widgets/DisplaysOverlay.vala"
	_tmp10_ = gtk_container_get_children ((GtkContainer*) self);
#line 1827 "DisplaysOverlay.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 321 "../src/Widgets/DisplaysOverlay.vala"
		child_collection = _tmp10_;
#line 321 "../src/Widgets/DisplaysOverlay.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 1835 "DisplaysOverlay.c"
			GtkWidget* child = NULL;
#line 321 "../src/Widgets/DisplaysOverlay.vala"
			child = (GtkWidget*) child_it->data;
#line 1839 "DisplaysOverlay.c"
			{
				gboolean _tmp11_ = FALSE;
				GtkWidget* _tmp12_;
				DisplayDisplayWidget* anchor = NULL;
				GtkWidget* _tmp14_;
				DisplayDisplayWidget* _tmp15_;
				DisplayDisplayWidget* _tmp16_;
				gint _tmp17_ = 0;
				gint _tmp18_ = 0;
				gint _tmp19_ = 0;
				gint _tmp20_ = 0;
				gint threshold = 0;
#line 322 "../src/Widgets/DisplaysOverlay.vala"
				_tmp12_ = child;
#line 322 "../src/Widgets/DisplaysOverlay.vala"
				if (!DISPLAY_IS_DISPLAY_WIDGET (_tmp12_)) {
#line 322 "../src/Widgets/DisplaysOverlay.vala"
					_tmp11_ = TRUE;
#line 1858 "DisplaysOverlay.c"
				} else {
					GtkWidget* _tmp13_;
#line 322 "../src/Widgets/DisplaysOverlay.vala"
					_tmp13_ = child;
#line 322 "../src/Widgets/DisplaysOverlay.vala"
					_tmp11_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget) == display_widget;
#line 1865 "DisplaysOverlay.c"
				}
#line 322 "../src/Widgets/DisplaysOverlay.vala"
				if (_tmp11_) {
#line 323 "../src/Widgets/DisplaysOverlay.vala"
					continue;
#line 1871 "DisplaysOverlay.c"
				}
#line 326 "../src/Widgets/DisplaysOverlay.vala"
				_tmp14_ = child;
#line 326 "../src/Widgets/DisplaysOverlay.vala"
				_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
#line 326 "../src/Widgets/DisplaysOverlay.vala"
				anchor = _tmp15_;
#line 327 "../src/Widgets/DisplaysOverlay.vala"
				_tmp16_ = anchor;
#line 327 "../src/Widgets/DisplaysOverlay.vala"
				display_display_widget_get_geometry (_tmp16_, &_tmp17_, &_tmp18_, &_tmp19_, &_tmp20_);
#line 327 "../src/Widgets/DisplaysOverlay.vala"
				x = _tmp17_;
#line 327 "../src/Widgets/DisplaysOverlay.vala"
				y = _tmp18_;
#line 327 "../src/Widgets/DisplaysOverlay.vala"
				width = _tmp19_;
#line 327 "../src/Widgets/DisplaysOverlay.vala"
				height = _tmp20_;
#line 328 "../src/Widgets/DisplaysOverlay.vala"
				anchor_points[0] = x;
#line 329 "../src/Widgets/DisplaysOverlay.vala"
				anchor_points[1] = (x + (width / 2)) - 1;
#line 330 "../src/Widgets/DisplaysOverlay.vala"
				anchor_points[2] = (x + width) - 1;
#line 331 "../src/Widgets/DisplaysOverlay.vala"
				anchor_points[3] = y;
#line 332 "../src/Widgets/DisplaysOverlay.vala"
				anchor_points[4] = (y + (height / 2)) - 1;
#line 333 "../src/Widgets/DisplaysOverlay.vala"
				anchor_points[5] = (y + height) - 1;
#line 335 "../src/Widgets/DisplaysOverlay.vala"
				threshold = MIN (width, height) / 10;
#line 1905 "DisplaysOverlay.c"
				{
					gint u = 0;
#line 336 "../src/Widgets/DisplaysOverlay.vala"
					u = 0;
#line 1910 "DisplaysOverlay.c"
					{
						gboolean _tmp21_ = FALSE;
#line 336 "../src/Widgets/DisplaysOverlay.vala"
						_tmp21_ = TRUE;
#line 336 "../src/Widgets/DisplaysOverlay.vala"
						while (TRUE) {
#line 336 "../src/Widgets/DisplaysOverlay.vala"
							if (!_tmp21_) {
#line 1919 "DisplaysOverlay.c"
								gint _tmp22_;
#line 336 "../src/Widgets/DisplaysOverlay.vala"
								_tmp22_ = u;
#line 336 "../src/Widgets/DisplaysOverlay.vala"
								u = _tmp22_ + 1;
#line 1925 "DisplaysOverlay.c"
							}
#line 336 "../src/Widgets/DisplaysOverlay.vala"
							_tmp21_ = FALSE;
#line 336 "../src/Widgets/DisplaysOverlay.vala"
							if (!(u < 2)) {
#line 336 "../src/Widgets/DisplaysOverlay.vala"
								break;
#line 1933 "DisplaysOverlay.c"
							}
							{
								gint i = 0;
#line 337 "../src/Widgets/DisplaysOverlay.vala"
								i = 0;
#line 1939 "DisplaysOverlay.c"
								{
									gboolean _tmp23_ = FALSE;
#line 337 "../src/Widgets/DisplaysOverlay.vala"
									_tmp23_ = TRUE;
#line 337 "../src/Widgets/DisplaysOverlay.vala"
									while (TRUE) {
#line 337 "../src/Widgets/DisplaysOverlay.vala"
										if (!_tmp23_) {
#line 1948 "DisplaysOverlay.c"
											gint _tmp24_;
#line 337 "../src/Widgets/DisplaysOverlay.vala"
											_tmp24_ = i;
#line 337 "../src/Widgets/DisplaysOverlay.vala"
											i = _tmp24_ + 1;
#line 1954 "DisplaysOverlay.c"
										}
#line 337 "../src/Widgets/DisplaysOverlay.vala"
										_tmp23_ = FALSE;
#line 337 "../src/Widgets/DisplaysOverlay.vala"
										if (!(i < 3)) {
#line 337 "../src/Widgets/DisplaysOverlay.vala"
											break;
#line 1962 "DisplaysOverlay.c"
										}
										{
											gint j = 0;
#line 338 "../src/Widgets/DisplaysOverlay.vala"
											j = 0;
#line 1968 "DisplaysOverlay.c"
											{
												gboolean _tmp25_ = FALSE;
#line 338 "../src/Widgets/DisplaysOverlay.vala"
												_tmp25_ = TRUE;
#line 338 "../src/Widgets/DisplaysOverlay.vala"
												while (TRUE) {
#line 1975 "DisplaysOverlay.c"
													gint test_delta = 0;
													gint _tmp27_;
													gint _tmp28_;
													gint _tmp29_;
#line 338 "../src/Widgets/DisplaysOverlay.vala"
													if (!_tmp25_) {
#line 1982 "DisplaysOverlay.c"
														gint _tmp26_;
#line 338 "../src/Widgets/DisplaysOverlay.vala"
														_tmp26_ = j;
#line 338 "../src/Widgets/DisplaysOverlay.vala"
														j = _tmp26_ + 1;
#line 1988 "DisplaysOverlay.c"
													}
#line 338 "../src/Widgets/DisplaysOverlay.vala"
													_tmp25_ = FALSE;
#line 338 "../src/Widgets/DisplaysOverlay.vala"
													if (!(j < 3)) {
#line 338 "../src/Widgets/DisplaysOverlay.vala"
														break;
#line 1996 "DisplaysOverlay.c"
													}
#line 339 "../src/Widgets/DisplaysOverlay.vala"
													_tmp27_ = anchor_points[i + (3 * u)];
#line 339 "../src/Widgets/DisplaysOverlay.vala"
													_tmp28_ = widget_points[j + (3 * u)];
#line 339 "../src/Widgets/DisplaysOverlay.vala"
													test_delta = _tmp27_ - _tmp28_;
#line 340 "../src/Widgets/DisplaysOverlay.vala"
													_tmp29_ = current_delta[u];
#line 340 "../src/Widgets/DisplaysOverlay.vala"
													if (threshold > abs (test_delta - _tmp29_)) {
#line 2008 "DisplaysOverlay.c"
														gint _tmp30_;
#line 341 "../src/Widgets/DisplaysOverlay.vala"
														_tmp30_ = aligned_delta[u];
#line 341 "../src/Widgets/DisplaysOverlay.vala"
														if (abs (test_delta) < abs (_tmp30_)) {
#line 2014 "DisplaysOverlay.c"
															gboolean _tmp31_ = FALSE;
#line 342 "../src/Widgets/DisplaysOverlay.vala"
															aligned_delta[u] = test_delta;
#line 343 "../src/Widgets/DisplaysOverlay.vala"
															if (i == 0) {
#line 343 "../src/Widgets/DisplaysOverlay.vala"
																_tmp31_ = j != i;
#line 2022 "DisplaysOverlay.c"
															} else {
#line 343 "../src/Widgets/DisplaysOverlay.vala"
																_tmp31_ = FALSE;
#line 2026 "DisplaysOverlay.c"
															}
#line 343 "../src/Widgets/DisplaysOverlay.vala"
															if (_tmp31_) {
#line 344 "../src/Widgets/DisplaysOverlay.vala"
																aligned_delta[u] -= 1;
#line 2032 "DisplaysOverlay.c"
															} else {
																gboolean _tmp32_ = FALSE;
#line 345 "../src/Widgets/DisplaysOverlay.vala"
																if (j == 0) {
#line 345 "../src/Widgets/DisplaysOverlay.vala"
																	_tmp32_ = i != j;
#line 2039 "DisplaysOverlay.c"
																} else {
#line 345 "../src/Widgets/DisplaysOverlay.vala"
																	_tmp32_ = FALSE;
#line 2043 "DisplaysOverlay.c"
																}
#line 345 "../src/Widgets/DisplaysOverlay.vala"
																if (_tmp32_) {
#line 346 "../src/Widgets/DisplaysOverlay.vala"
																	aligned_delta[u] += 1;
#line 2049 "DisplaysOverlay.c"
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
#line 321 "../src/Widgets/DisplaysOverlay.vala"
				_g_object_unref0 (anchor);
#line 2065 "DisplaysOverlay.c"
			}
		}
#line 321 "../src/Widgets/DisplaysOverlay.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 2070 "DisplaysOverlay.c"
	}
#line 355 "../src/Widgets/DisplaysOverlay.vala"
	_tmp33_ = aligned_delta[0];
#line 355 "../src/Widgets/DisplaysOverlay.vala"
	if (_tmp33_ != G_MAXINT) {
#line 2076 "DisplaysOverlay.c"
		gint _tmp34_;
#line 356 "../src/Widgets/DisplaysOverlay.vala"
		_tmp34_ = aligned_delta[0];
#line 356 "../src/Widgets/DisplaysOverlay.vala"
		display_display_widget_set_delta_x (display_widget, _tmp34_);
#line 2082 "DisplaysOverlay.c"
	}
#line 358 "../src/Widgets/DisplaysOverlay.vala"
	_tmp35_ = aligned_delta[1];
#line 358 "../src/Widgets/DisplaysOverlay.vala"
	if (_tmp35_ != G_MAXINT) {
#line 2088 "DisplaysOverlay.c"
		gint _tmp36_;
#line 359 "../src/Widgets/DisplaysOverlay.vala"
		_tmp36_ = aligned_delta[1];
#line 359 "../src/Widgets/DisplaysOverlay.vala"
		display_display_widget_set_delta_y (display_widget, _tmp36_);
#line 2094 "DisplaysOverlay.c"
	}
}

static void
_g_object_unref0_ (gpointer var)
{
#line 363 "../src/Widgets/DisplaysOverlay.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2103 "DisplaysOverlay.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 363 "../src/Widgets/DisplaysOverlay.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2111 "DisplaysOverlay.c"
}

static void
display_displays_overlay_close_gaps (DisplayDisplaysOverlay* self)
{
	GList* display_widgets = NULL;
	GList* _tmp0_;
	GList* _tmp4_;
#line 363 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 364 "../src/Widgets/DisplaysOverlay.vala"
	display_widgets = NULL;
#line 365 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
#line 2126 "DisplaysOverlay.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 365 "../src/Widgets/DisplaysOverlay.vala"
		child_collection = _tmp0_;
#line 365 "../src/Widgets/DisplaysOverlay.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 2134 "DisplaysOverlay.c"
			GtkWidget* child = NULL;
#line 365 "../src/Widgets/DisplaysOverlay.vala"
			child = (GtkWidget*) child_it->data;
#line 2138 "DisplaysOverlay.c"
			{
				GtkWidget* _tmp1_;
#line 366 "../src/Widgets/DisplaysOverlay.vala"
				_tmp1_ = child;
#line 366 "../src/Widgets/DisplaysOverlay.vala"
				if (DISPLAY_IS_DISPLAY_WIDGET (_tmp1_)) {
#line 2145 "DisplaysOverlay.c"
					GtkWidget* _tmp2_;
					DisplayDisplayWidget* _tmp3_;
#line 367 "../src/Widgets/DisplaysOverlay.vala"
					_tmp2_ = child;
#line 367 "../src/Widgets/DisplaysOverlay.vala"
					_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
#line 367 "../src/Widgets/DisplaysOverlay.vala"
					display_widgets = g_list_append (display_widgets, _tmp3_);
#line 2154 "DisplaysOverlay.c"
				}
			}
		}
#line 365 "../src/Widgets/DisplaysOverlay.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 2160 "DisplaysOverlay.c"
	}
#line 371 "../src/Widgets/DisplaysOverlay.vala"
	_tmp4_ = display_widgets;
#line 2164 "DisplaysOverlay.c"
	{
		GList* display_widget_collection = NULL;
		GList* display_widget_it = NULL;
#line 371 "../src/Widgets/DisplaysOverlay.vala"
		display_widget_collection = _tmp4_;
#line 371 "../src/Widgets/DisplaysOverlay.vala"
		for (display_widget_it = display_widget_collection; display_widget_it != NULL; display_widget_it = display_widget_it->next) {
#line 2172 "DisplaysOverlay.c"
			DisplayDisplayWidget* _tmp5_;
			DisplayDisplayWidget* display_widget = NULL;
#line 371 "../src/Widgets/DisplaysOverlay.vala"
			_tmp5_ = _g_object_ref0 ((DisplayDisplayWidget*) display_widget_it->data);
#line 371 "../src/Widgets/DisplaysOverlay.vala"
			display_widget = _tmp5_;
#line 2179 "DisplaysOverlay.c"
			{
				DisplayDisplayWidget* _tmp6_;
				GList* _tmp7_;
#line 372 "../src/Widgets/DisplaysOverlay.vala"
				_tmp6_ = display_widget;
#line 372 "../src/Widgets/DisplaysOverlay.vala"
				_tmp7_ = display_widgets;
#line 372 "../src/Widgets/DisplaysOverlay.vala"
				if (!display_displays_overlay_is_connected (self, _tmp6_, _tmp7_)) {
#line 2189 "DisplaysOverlay.c"
					DisplayDisplayWidget* _tmp8_;
#line 373 "../src/Widgets/DisplaysOverlay.vala"
					_tmp8_ = display_widget;
#line 373 "../src/Widgets/DisplaysOverlay.vala"
					display_displays_overlay_snap_edges (self, _tmp8_);
#line 2195 "DisplaysOverlay.c"
				}
#line 371 "../src/Widgets/DisplaysOverlay.vala"
				_g_object_unref0 (display_widget);
#line 2199 "DisplaysOverlay.c"
			}
		}
	}
#line 363 "../src/Widgets/DisplaysOverlay.vala"
	(display_widgets == NULL) ? NULL : (display_widgets = (_g_list_free__g_object_unref0_ (display_widgets), NULL));
#line 2205 "DisplaysOverlay.c"
}

static gboolean
display_displays_overlay_is_connected (DisplayDisplaysOverlay* self,
                                       DisplayDisplayWidget* display_widget,
                                       GList* other_display_widgets)
{
	gint x = 0;
	gint y = 0;
	gint width = 0;
	gint height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GdkRectangle rect = {0};
	GdkRectangle _tmp4_ = {0};
	gboolean result;
#line 380 "../src/Widgets/DisplaysOverlay.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 380 "../src/Widgets/DisplaysOverlay.vala"
	g_return_val_if_fail (display_widget != NULL, FALSE);
#line 382 "../src/Widgets/DisplaysOverlay.vala"
	display_display_widget_get_geometry (display_widget, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 382 "../src/Widgets/DisplaysOverlay.vala"
	x = _tmp0_;
#line 382 "../src/Widgets/DisplaysOverlay.vala"
	y = _tmp1_;
#line 382 "../src/Widgets/DisplaysOverlay.vala"
	width = _tmp2_;
#line 382 "../src/Widgets/DisplaysOverlay.vala"
	height = _tmp3_;
#line 383 "../src/Widgets/DisplaysOverlay.vala"
	_tmp4_.x = x - 1;
#line 383 "../src/Widgets/DisplaysOverlay.vala"
	_tmp4_.y = y - 1;
#line 383 "../src/Widgets/DisplaysOverlay.vala"
	_tmp4_.width = width + 2;
#line 383 "../src/Widgets/DisplaysOverlay.vala"
	_tmp4_.height = height + 2;
#line 383 "../src/Widgets/DisplaysOverlay.vala"
	rect = _tmp4_;
#line 2248 "DisplaysOverlay.c"
	{
		GList* other_display_widget_collection = NULL;
		GList* other_display_widget_it = NULL;
#line 385 "../src/Widgets/DisplaysOverlay.vala"
		other_display_widget_collection = other_display_widgets;
#line 385 "../src/Widgets/DisplaysOverlay.vala"
		for (other_display_widget_it = other_display_widget_collection; other_display_widget_it != NULL; other_display_widget_it = other_display_widget_it->next) {
#line 2256 "DisplaysOverlay.c"
			DisplayDisplayWidget* _tmp5_;
			DisplayDisplayWidget* other_display_widget = NULL;
#line 385 "../src/Widgets/DisplaysOverlay.vala"
			_tmp5_ = _g_object_ref0 ((DisplayDisplayWidget*) other_display_widget_it->data);
#line 385 "../src/Widgets/DisplaysOverlay.vala"
			other_display_widget = _tmp5_;
#line 2263 "DisplaysOverlay.c"
			{
				DisplayDisplayWidget* _tmp6_;
				gint other_x = 0;
				gint other_y = 0;
				gint other_width = 0;
				gint other_height = 0;
				DisplayDisplayWidget* _tmp7_;
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
				GdkRectangle other_rect = {0};
				GdkRectangle _tmp12_ = {0};
				GdkRectangle intersection = {0};
				gboolean is_connected = FALSE;
				GdkRectangle _tmp13_;
				GdkRectangle _tmp14_ = {0};
				gboolean _tmp15_;
				gboolean _tmp16_ = FALSE;
				GdkRectangle _tmp17_;
				gboolean is_diagonal = FALSE;
				gboolean _tmp19_ = FALSE;
#line 386 "../src/Widgets/DisplaysOverlay.vala"
				_tmp6_ = other_display_widget;
#line 386 "../src/Widgets/DisplaysOverlay.vala"
				if (_tmp6_ == display_widget) {
#line 387 "../src/Widgets/DisplaysOverlay.vala"
					_g_object_unref0 (other_display_widget);
#line 387 "../src/Widgets/DisplaysOverlay.vala"
					continue;
#line 2294 "DisplaysOverlay.c"
				}
#line 391 "../src/Widgets/DisplaysOverlay.vala"
				_tmp7_ = other_display_widget;
#line 391 "../src/Widgets/DisplaysOverlay.vala"
				display_display_widget_get_geometry (_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
#line 391 "../src/Widgets/DisplaysOverlay.vala"
				other_x = _tmp8_;
#line 391 "../src/Widgets/DisplaysOverlay.vala"
				other_y = _tmp9_;
#line 391 "../src/Widgets/DisplaysOverlay.vala"
				other_width = _tmp10_;
#line 391 "../src/Widgets/DisplaysOverlay.vala"
				other_height = _tmp11_;
#line 393 "../src/Widgets/DisplaysOverlay.vala"
				_tmp12_.x = other_x;
#line 393 "../src/Widgets/DisplaysOverlay.vala"
				_tmp12_.y = other_y;
#line 393 "../src/Widgets/DisplaysOverlay.vala"
				_tmp12_.width = other_width;
#line 393 "../src/Widgets/DisplaysOverlay.vala"
				_tmp12_.height = other_height;
#line 393 "../src/Widgets/DisplaysOverlay.vala"
				other_rect = _tmp12_;
#line 395 "../src/Widgets/DisplaysOverlay.vala"
				_tmp13_ = other_rect;
#line 395 "../src/Widgets/DisplaysOverlay.vala"
				_tmp15_ = gdk_rectangle_intersect (&rect, &_tmp13_, &_tmp14_);
#line 395 "../src/Widgets/DisplaysOverlay.vala"
				intersection = _tmp14_;
#line 395 "../src/Widgets/DisplaysOverlay.vala"
				is_connected = _tmp15_;
#line 396 "../src/Widgets/DisplaysOverlay.vala"
				_tmp17_ = intersection;
#line 396 "../src/Widgets/DisplaysOverlay.vala"
				if (_tmp17_.height == 1) {
#line 2330 "DisplaysOverlay.c"
					GdkRectangle _tmp18_;
#line 396 "../src/Widgets/DisplaysOverlay.vala"
					_tmp18_ = intersection;
#line 396 "../src/Widgets/DisplaysOverlay.vala"
					_tmp16_ = _tmp18_.width == 1;
#line 2336 "DisplaysOverlay.c"
				} else {
#line 396 "../src/Widgets/DisplaysOverlay.vala"
					_tmp16_ = FALSE;
#line 2340 "DisplaysOverlay.c"
				}
#line 396 "../src/Widgets/DisplaysOverlay.vala"
				is_diagonal = _tmp16_;
#line 397 "../src/Widgets/DisplaysOverlay.vala"
				if (is_connected) {
#line 397 "../src/Widgets/DisplaysOverlay.vala"
					_tmp19_ = !is_diagonal;
#line 2348 "DisplaysOverlay.c"
				} else {
#line 397 "../src/Widgets/DisplaysOverlay.vala"
					_tmp19_ = FALSE;
#line 2352 "DisplaysOverlay.c"
				}
#line 397 "../src/Widgets/DisplaysOverlay.vala"
				if (_tmp19_) {
#line 398 "../src/Widgets/DisplaysOverlay.vala"
					result = TRUE;
#line 398 "../src/Widgets/DisplaysOverlay.vala"
					_g_object_unref0 (other_display_widget);
#line 398 "../src/Widgets/DisplaysOverlay.vala"
					return result;
#line 2362 "DisplaysOverlay.c"
				}
#line 385 "../src/Widgets/DisplaysOverlay.vala"
				_g_object_unref0 (other_display_widget);
#line 2366 "DisplaysOverlay.c"
			}
		}
	}
#line 402 "../src/Widgets/DisplaysOverlay.vala"
	result = FALSE;
#line 402 "../src/Widgets/DisplaysOverlay.vala"
	return result;
#line 2374 "DisplaysOverlay.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 405 "../src/Widgets/DisplaysOverlay.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 405 "../src/Widgets/DisplaysOverlay.vala"
	return _data11_;
#line 2384 "DisplaysOverlay.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 405 "../src/Widgets/DisplaysOverlay.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 2394 "DisplaysOverlay.c"
		DisplayDisplaysOverlay* self;
#line 405 "../src/Widgets/DisplaysOverlay.vala"
		self = _data11_->self;
#line 405 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (self);
#line 405 "../src/Widgets/DisplaysOverlay.vala"
		g_slice_free (Block11Data, _data11_);
#line 2402 "DisplaysOverlay.c"
	}
}

static void
__lambda19_ (Block11Data* _data11_,
             GtkWidget* child)
{
	DisplayDisplaysOverlay* self;
#line 408 "../src/Widgets/DisplaysOverlay.vala"
	self = _data11_->self;
#line 408 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (child != NULL);
#line 409 "../src/Widgets/DisplaysOverlay.vala"
	if (DISPLAY_IS_DISPLAY_WIDGET (child)) {
#line 2417 "DisplaysOverlay.c"
		DisplayDisplayWidget* display_widget = NULL;
		DisplayDisplayWidget* _tmp0_;
		gint x = 0;
		gint y = 0;
		gint width = 0;
		gint height = 0;
		DisplayDisplayWidget* _tmp1_;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
#line 410 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
#line 410 "../src/Widgets/DisplaysOverlay.vala"
		display_widget = _tmp0_;
#line 412 "../src/Widgets/DisplaysOverlay.vala"
		_tmp1_ = display_widget;
#line 412 "../src/Widgets/DisplaysOverlay.vala"
		display_display_widget_get_geometry (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 412 "../src/Widgets/DisplaysOverlay.vala"
		x = _tmp2_;
#line 412 "../src/Widgets/DisplaysOverlay.vala"
		y = _tmp3_;
#line 412 "../src/Widgets/DisplaysOverlay.vala"
		width = _tmp4_;
#line 412 "../src/Widgets/DisplaysOverlay.vala"
		height = _tmp5_;
#line 413 "../src/Widgets/DisplaysOverlay.vala"
		_data11_->min_x = MIN (_data11_->min_x, x);
#line 414 "../src/Widgets/DisplaysOverlay.vala"
		_data11_->min_y = MIN (_data11_->min_y, y);
#line 409 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (display_widget);
#line 2451 "DisplaysOverlay.c"
	}
}

static void
___lambda19__gfunc (gconstpointer data,
                    gpointer self)
{
#line 408 "../src/Widgets/DisplaysOverlay.vala"
	__lambda19_ (self, (GtkWidget*) data);
#line 2461 "DisplaysOverlay.c"
}

static void
__lambda20_ (Block11Data* _data11_,
             GtkWidget* child)
{
	DisplayDisplaysOverlay* self;
#line 422 "../src/Widgets/DisplaysOverlay.vala"
	self = _data11_->self;
#line 422 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (child != NULL);
#line 423 "../src/Widgets/DisplaysOverlay.vala"
	if (DISPLAY_IS_DISPLAY_WIDGET (child)) {
#line 2475 "DisplaysOverlay.c"
		DisplayDisplayWidget* display_widget = NULL;
		DisplayDisplayWidget* _tmp0_;
		gint x = 0;
		gint y = 0;
		gint width = 0;
		gint height = 0;
		DisplayDisplayWidget* _tmp1_;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		DisplayDisplayWidget* _tmp6_;
#line 424 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
#line 424 "../src/Widgets/DisplaysOverlay.vala"
		display_widget = _tmp0_;
#line 426 "../src/Widgets/DisplaysOverlay.vala"
		_tmp1_ = display_widget;
#line 426 "../src/Widgets/DisplaysOverlay.vala"
		display_display_widget_get_geometry (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 426 "../src/Widgets/DisplaysOverlay.vala"
		x = _tmp2_;
#line 426 "../src/Widgets/DisplaysOverlay.vala"
		y = _tmp3_;
#line 426 "../src/Widgets/DisplaysOverlay.vala"
		width = _tmp4_;
#line 426 "../src/Widgets/DisplaysOverlay.vala"
		height = _tmp5_;
#line 427 "../src/Widgets/DisplaysOverlay.vala"
		_tmp6_ = display_widget;
#line 427 "../src/Widgets/DisplaysOverlay.vala"
		display_display_widget_set_geometry (_tmp6_, x - _data11_->min_x, y - _data11_->min_y, width, height);
#line 423 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (display_widget);
#line 2510 "DisplaysOverlay.c"
	}
}

static void
___lambda20__gfunc (gconstpointer data,
                    gpointer self)
{
#line 422 "../src/Widgets/DisplaysOverlay.vala"
	__lambda20_ (self, (GtkWidget*) data);
#line 2520 "DisplaysOverlay.c"
}

static void
display_displays_overlay_verify_global_positions (DisplayDisplaysOverlay* self)
{
	Block11Data* _data11_;
	GList* _tmp0_;
	GList* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GList* _tmp3_;
	GList* _tmp4_;
#line 405 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 405 "../src/Widgets/DisplaysOverlay.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 405 "../src/Widgets/DisplaysOverlay.vala"
	_data11_->_ref_count_ = 1;
#line 405 "../src/Widgets/DisplaysOverlay.vala"
	_data11_->self = g_object_ref (self);
#line 406 "../src/Widgets/DisplaysOverlay.vala"
	_data11_->min_x = G_MAXINT;
#line 407 "../src/Widgets/DisplaysOverlay.vala"
	_data11_->min_y = G_MAXINT;
#line 408 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
#line 408 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = _tmp0_;
#line 408 "../src/Widgets/DisplaysOverlay.vala"
	g_list_foreach (_tmp1_, ___lambda19__gfunc, _data11_);
#line 408 "../src/Widgets/DisplaysOverlay.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
#line 418 "../src/Widgets/DisplaysOverlay.vala"
	if (_data11_->min_x == 0) {
#line 418 "../src/Widgets/DisplaysOverlay.vala"
		_tmp2_ = _data11_->min_y == 0;
#line 2556 "DisplaysOverlay.c"
	} else {
#line 418 "../src/Widgets/DisplaysOverlay.vala"
		_tmp2_ = FALSE;
#line 2560 "DisplaysOverlay.c"
	}
#line 418 "../src/Widgets/DisplaysOverlay.vala"
	if (_tmp2_) {
#line 419 "../src/Widgets/DisplaysOverlay.vala"
		block11_data_unref (_data11_);
#line 419 "../src/Widgets/DisplaysOverlay.vala"
		_data11_ = NULL;
#line 419 "../src/Widgets/DisplaysOverlay.vala"
		return;
#line 2570 "DisplaysOverlay.c"
	}
#line 422 "../src/Widgets/DisplaysOverlay.vala"
	_tmp3_ = gtk_container_get_children ((GtkContainer*) self);
#line 422 "../src/Widgets/DisplaysOverlay.vala"
	_tmp4_ = _tmp3_;
#line 422 "../src/Widgets/DisplaysOverlay.vala"
	g_list_foreach (_tmp4_, ___lambda20__gfunc, _data11_);
#line 422 "../src/Widgets/DisplaysOverlay.vala"
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_list_free (_tmp4_), NULL));
#line 405 "../src/Widgets/DisplaysOverlay.vala"
	block11_data_unref (_data11_);
#line 405 "../src/Widgets/DisplaysOverlay.vala"
	_data11_ = NULL;
#line 2584 "DisplaysOverlay.c"
}

void
display_displays_overlay_check_intersects (DisplayDisplaysOverlay* self,
                                           DisplayDisplayWidget* source_display_widget,
                                           gint level,
                                           gint distance_x,
                                           gint distance_y)
{
	gint source_x = 0;
	gint source_y = 0;
	gint source_width = 0;
	gint source_height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GdkRectangle src_rect = {0};
	GdkRectangle _tmp4_ = {0};
	GList* _tmp5_;
#line 433 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 433 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (source_display_widget != NULL);
#line 434 "../src/Widgets/DisplaysOverlay.vala"
	if (level > 10) {
#line 435 "../src/Widgets/DisplaysOverlay.vala"
		g_warning ("DisplaysOverlay.vala:435: Maximum level of recursion reached! Could no" \
"t fix intersects!");
#line 436 "../src/Widgets/DisplaysOverlay.vala"
		return;
#line 2615 "DisplaysOverlay.c"
	}
#line 440 "../src/Widgets/DisplaysOverlay.vala"
	display_display_widget_get_geometry (source_display_widget, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 440 "../src/Widgets/DisplaysOverlay.vala"
	source_x = _tmp0_;
#line 440 "../src/Widgets/DisplaysOverlay.vala"
	source_y = _tmp1_;
#line 440 "../src/Widgets/DisplaysOverlay.vala"
	source_width = _tmp2_;
#line 440 "../src/Widgets/DisplaysOverlay.vala"
	source_height = _tmp3_;
#line 441 "../src/Widgets/DisplaysOverlay.vala"
	_tmp4_.x = source_x;
#line 441 "../src/Widgets/DisplaysOverlay.vala"
	_tmp4_.y = source_y;
#line 441 "../src/Widgets/DisplaysOverlay.vala"
	_tmp4_.width = source_width;
#line 441 "../src/Widgets/DisplaysOverlay.vala"
	_tmp4_.height = source_height;
#line 441 "../src/Widgets/DisplaysOverlay.vala"
	src_rect = _tmp4_;
#line 443 "../src/Widgets/DisplaysOverlay.vala"
	_tmp5_ = gtk_container_get_children ((GtkContainer*) self);
#line 2639 "DisplaysOverlay.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 443 "../src/Widgets/DisplaysOverlay.vala"
		child_collection = _tmp5_;
#line 443 "../src/Widgets/DisplaysOverlay.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 2647 "DisplaysOverlay.c"
			GtkWidget* child = NULL;
#line 443 "../src/Widgets/DisplaysOverlay.vala"
			child = (GtkWidget*) child_it->data;
#line 2651 "DisplaysOverlay.c"
			{
				gboolean _tmp6_ = FALSE;
				GtkWidget* _tmp7_;
				DisplayDisplayWidget* other_display_widget = NULL;
				GtkWidget* _tmp9_;
				DisplayDisplayWidget* _tmp10_;
				gint other_x = 0;
				gint other_y = 0;
				gint other_width = 0;
				gint other_height = 0;
				DisplayDisplayWidget* _tmp11_;
				gint _tmp12_ = 0;
				gint _tmp13_ = 0;
				gint _tmp14_ = 0;
				gint _tmp15_ = 0;
				GdkRectangle test_rect = {0};
				GdkRectangle _tmp16_ = {0};
				GdkRectangle _tmp17_;
#line 444 "../src/Widgets/DisplaysOverlay.vala"
				_tmp7_ = child;
#line 444 "../src/Widgets/DisplaysOverlay.vala"
				if (!DISPLAY_IS_DISPLAY_WIDGET (_tmp7_)) {
#line 444 "../src/Widgets/DisplaysOverlay.vala"
					_tmp6_ = TRUE;
#line 2676 "DisplaysOverlay.c"
				} else {
					GtkWidget* _tmp8_;
#line 444 "../src/Widgets/DisplaysOverlay.vala"
					_tmp8_ = child;
#line 444 "../src/Widgets/DisplaysOverlay.vala"
					_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget) == source_display_widget;
#line 2683 "DisplaysOverlay.c"
				}
#line 444 "../src/Widgets/DisplaysOverlay.vala"
				if (_tmp6_) {
#line 445 "../src/Widgets/DisplaysOverlay.vala"
					continue;
#line 2689 "DisplaysOverlay.c"
				}
#line 448 "../src/Widgets/DisplaysOverlay.vala"
				_tmp9_ = child;
#line 448 "../src/Widgets/DisplaysOverlay.vala"
				_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
#line 448 "../src/Widgets/DisplaysOverlay.vala"
				other_display_widget = _tmp10_;
#line 450 "../src/Widgets/DisplaysOverlay.vala"
				_tmp11_ = other_display_widget;
#line 450 "../src/Widgets/DisplaysOverlay.vala"
				display_display_widget_get_geometry (_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
#line 450 "../src/Widgets/DisplaysOverlay.vala"
				other_x = _tmp12_;
#line 450 "../src/Widgets/DisplaysOverlay.vala"
				other_y = _tmp13_;
#line 450 "../src/Widgets/DisplaysOverlay.vala"
				other_width = _tmp14_;
#line 450 "../src/Widgets/DisplaysOverlay.vala"
				other_height = _tmp15_;
#line 451 "../src/Widgets/DisplaysOverlay.vala"
				_tmp16_.x = other_x;
#line 451 "../src/Widgets/DisplaysOverlay.vala"
				_tmp16_.y = other_y;
#line 451 "../src/Widgets/DisplaysOverlay.vala"
				_tmp16_.width = other_width;
#line 451 "../src/Widgets/DisplaysOverlay.vala"
				_tmp16_.height = other_height;
#line 451 "../src/Widgets/DisplaysOverlay.vala"
				test_rect = _tmp16_;
#line 452 "../src/Widgets/DisplaysOverlay.vala"
				_tmp17_ = test_rect;
#line 452 "../src/Widgets/DisplaysOverlay.vala"
				if (gdk_rectangle_intersect (&src_rect, &_tmp17_, NULL)) {
#line 2723 "DisplaysOverlay.c"
					DisplayDisplayWidget* _tmp21_;
					DisplayDisplayWidget* _tmp22_;
					DisplayDisplayWidget* _tmp23_;
#line 453 "../src/Widgets/DisplaysOverlay.vala"
					if (level == 0) {
#line 2729 "DisplaysOverlay.c"
						gint distance_left = 0;
						gint distance_right = 0;
						gint distance_top = 0;
						gint distance_bottom = 0;
						gint _tmp18_ = 0;
						gint test_distance_x = 0;
						gint _tmp19_ = 0;
						gint test_distance_y = 0;
						gboolean _tmp20_ = FALSE;
#line 454 "../src/Widgets/DisplaysOverlay.vala"
						distance_left = (source_x - other_x) - other_width;
#line 455 "../src/Widgets/DisplaysOverlay.vala"
						distance_right = (source_x - other_x) + source_width;
#line 456 "../src/Widgets/DisplaysOverlay.vala"
						distance_top = (source_y - other_y) - other_height;
#line 457 "../src/Widgets/DisplaysOverlay.vala"
						distance_bottom = (source_y - other_y) + source_height;
#line 458 "../src/Widgets/DisplaysOverlay.vala"
						if (distance_right < (-distance_left)) {
#line 458 "../src/Widgets/DisplaysOverlay.vala"
							_tmp18_ = distance_right;
#line 2751 "DisplaysOverlay.c"
						} else {
#line 458 "../src/Widgets/DisplaysOverlay.vala"
							_tmp18_ = distance_left;
#line 2755 "DisplaysOverlay.c"
						}
#line 458 "../src/Widgets/DisplaysOverlay.vala"
						test_distance_x = _tmp18_;
#line 459 "../src/Widgets/DisplaysOverlay.vala"
						if (distance_bottom < (-distance_top)) {
#line 459 "../src/Widgets/DisplaysOverlay.vala"
							_tmp19_ = distance_bottom;
#line 2763 "DisplaysOverlay.c"
						} else {
#line 459 "../src/Widgets/DisplaysOverlay.vala"
							_tmp19_ = distance_top;
#line 2767 "DisplaysOverlay.c"
						}
#line 459 "../src/Widgets/DisplaysOverlay.vala"
						test_distance_y = _tmp19_;
#line 462 "../src/Widgets/DisplaysOverlay.vala"
						if (abs (test_distance_x) <= abs (test_distance_y)) {
#line 462 "../src/Widgets/DisplaysOverlay.vala"
							_tmp20_ = TRUE;
#line 2775 "DisplaysOverlay.c"
						} else {
#line 462 "../src/Widgets/DisplaysOverlay.vala"
							_tmp20_ = distance_top == (-distance_bottom);
#line 2779 "DisplaysOverlay.c"
						}
#line 462 "../src/Widgets/DisplaysOverlay.vala"
						if (_tmp20_) {
#line 463 "../src/Widgets/DisplaysOverlay.vala"
							distance_x = test_distance_x;
#line 2785 "DisplaysOverlay.c"
						} else {
#line 465 "../src/Widgets/DisplaysOverlay.vala"
							distance_y = test_distance_y;
#line 2789 "DisplaysOverlay.c"
						}
					}
#line 469 "../src/Widgets/DisplaysOverlay.vala"
					_tmp21_ = other_display_widget;
#line 469 "../src/Widgets/DisplaysOverlay.vala"
					display_display_widget_set_geometry (_tmp21_, other_x + distance_x, other_y + distance_y, other_width, other_height);
#line 470 "../src/Widgets/DisplaysOverlay.vala"
					_tmp22_ = other_display_widget;
#line 470 "../src/Widgets/DisplaysOverlay.vala"
					gtk_widget_queue_resize_no_redraw ((GtkWidget*) _tmp22_);
#line 471 "../src/Widgets/DisplaysOverlay.vala"
					_tmp23_ = other_display_widget;
#line 471 "../src/Widgets/DisplaysOverlay.vala"
					display_displays_overlay_check_intersects (self, _tmp23_, level + 1, distance_x, distance_y);
#line 2804 "DisplaysOverlay.c"
				}
#line 443 "../src/Widgets/DisplaysOverlay.vala"
				_g_object_unref0 (other_display_widget);
#line 2808 "DisplaysOverlay.c"
			}
		}
#line 443 "../src/Widgets/DisplaysOverlay.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 2813 "DisplaysOverlay.c"
	}
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 476 "../src/Widgets/DisplaysOverlay.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 476 "../src/Widgets/DisplaysOverlay.vala"
	return _data12_;
#line 2824 "DisplaysOverlay.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 476 "../src/Widgets/DisplaysOverlay.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 2834 "DisplaysOverlay.c"
		DisplayDisplaysOverlay* self;
#line 476 "../src/Widgets/DisplaysOverlay.vala"
		self = _data12_->self;
#line 476 "../src/Widgets/DisplaysOverlay.vala"
		(_data12_->anchors == NULL) ? NULL : (_data12_->anchors = (_g_list_free__g_object_unref0_ (_data12_->anchors), NULL));
#line 476 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (_data12_->last_moved);
#line 476 "../src/Widgets/DisplaysOverlay.vala"
		_g_object_unref0 (self);
#line 476 "../src/Widgets/DisplaysOverlay.vala"
		g_slice_free (Block12Data, _data12_);
#line 2846 "DisplaysOverlay.c"
	}
}

static void
__lambda18_ (Block12Data* _data12_,
             GtkWidget* child)
{
	DisplayDisplaysOverlay* self;
	gboolean _tmp0_ = FALSE;
	DisplayDisplayWidget* _tmp1_;
#line 481 "../src/Widgets/DisplaysOverlay.vala"
	self = _data12_->self;
#line 481 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (child != NULL);
#line 482 "../src/Widgets/DisplaysOverlay.vala"
	if (!DISPLAY_IS_DISPLAY_WIDGET (child)) {
#line 482 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = TRUE;
#line 2865 "DisplaysOverlay.c"
	} else {
#line 482 "../src/Widgets/DisplaysOverlay.vala"
		_tmp0_ = display_display_widget_equals (_data12_->last_moved, G_TYPE_CHECK_INSTANCE_CAST (child, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
#line 2869 "DisplaysOverlay.c"
	}
#line 482 "../src/Widgets/DisplaysOverlay.vala"
	if (_tmp0_) {
#line 482 "../src/Widgets/DisplaysOverlay.vala"
		return;
#line 2875 "DisplaysOverlay.c"
	}
#line 483 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
#line 483 "../src/Widgets/DisplaysOverlay.vala"
	_data12_->anchors = g_list_append (_data12_->anchors, _tmp1_);
#line 2881 "DisplaysOverlay.c"
}

static void
___lambda18__gfunc (gconstpointer data,
                    gpointer self)
{
#line 481 "../src/Widgets/DisplaysOverlay.vala"
	__lambda18_ (self, (GtkWidget*) data);
#line 2890 "DisplaysOverlay.c"
}

void
display_displays_overlay_snap_edges (DisplayDisplaysOverlay* self,
                                     DisplayDisplayWidget* last_moved)
{
	Block12Data* _data12_;
	DisplayDisplayWidget* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
#line 476 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 476 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (last_moved != NULL);
#line 476 "../src/Widgets/DisplaysOverlay.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 476 "../src/Widgets/DisplaysOverlay.vala"
	_data12_->_ref_count_ = 1;
#line 476 "../src/Widgets/DisplaysOverlay.vala"
	_data12_->self = g_object_ref (self);
#line 476 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_ = _g_object_ref0 (last_moved);
#line 476 "../src/Widgets/DisplaysOverlay.vala"
	_g_object_unref0 (_data12_->last_moved);
#line 476 "../src/Widgets/DisplaysOverlay.vala"
	_data12_->last_moved = _tmp0_;
#line 477 "../src/Widgets/DisplaysOverlay.vala"
	if (self->priv->scanning) {
#line 477 "../src/Widgets/DisplaysOverlay.vala"
		block12_data_unref (_data12_);
#line 477 "../src/Widgets/DisplaysOverlay.vala"
		_data12_ = NULL;
#line 477 "../src/Widgets/DisplaysOverlay.vala"
		return;
#line 2926 "DisplaysOverlay.c"
	}
#line 479 "../src/Widgets/DisplaysOverlay.vala"
	g_debug ("DisplaysOverlay.vala:479: Snapping displays");
#line 480 "../src/Widgets/DisplaysOverlay.vala"
	_data12_->anchors = NULL;
#line 481 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) self);
#line 481 "../src/Widgets/DisplaysOverlay.vala"
	_tmp2_ = _tmp1_;
#line 481 "../src/Widgets/DisplaysOverlay.vala"
	g_list_foreach (_tmp2_, ___lambda18__gfunc, _data12_);
#line 481 "../src/Widgets/DisplaysOverlay.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
#line 486 "../src/Widgets/DisplaysOverlay.vala"
	_tmp3_ = _data12_->anchors;
#line 486 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_snap_widget (self, _data12_->last_moved, _tmp3_);
#line 476 "../src/Widgets/DisplaysOverlay.vala"
	block12_data_unref (_data12_);
#line 476 "../src/Widgets/DisplaysOverlay.vala"
	_data12_ = NULL;
#line 2948 "DisplaysOverlay.c"
}

/******************************************************************************************
    *   Widget snapping is done by trying to snap a widget to other widgets called Anchors.  *
    *   It first calculates the distance between each anchor and the widget, and afterwards  *
    *   snaps the widget to the closest edge/corner                                          *
    *                                                                                        *
    *   Cases:          W = widget, A = current anchor                                       *
    *                                                                                        *
    *   1.        2.        3.        4.        5.        6.        7.         8.            *
    *     A W       W A        A         W         W          W         A         A          *
    *                          W         A          A        A           W       W           *
    *                                                                                        *
    ******************************************************************************************/
static void
display_displays_overlay_snap_widget (DisplayDisplaysOverlay* self,
                                      DisplayDisplayWidget* widget,
                                      GList* anchors)
{
	gint widget_x = 0;
	gint widget_y = 0;
	gint widget_width = 0;
	gint widget_height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint shortest_distance = 0;
	gint shortest_distance_x = 0;
	gint shortest_distance_y = 0;
#line 511 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 511 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (widget != NULL);
#line 512 "../src/Widgets/DisplaysOverlay.vala"
	if (g_list_length (anchors) == ((guint) 0)) {
#line 513 "../src/Widgets/DisplaysOverlay.vala"
		return;
#line 2991 "DisplaysOverlay.c"
	}
#line 517 "../src/Widgets/DisplaysOverlay.vala"
	display_display_widget_get_geometry (widget, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 517 "../src/Widgets/DisplaysOverlay.vala"
	widget_x = _tmp0_;
#line 517 "../src/Widgets/DisplaysOverlay.vala"
	widget_y = _tmp1_;
#line 517 "../src/Widgets/DisplaysOverlay.vala"
	widget_width = _tmp2_;
#line 517 "../src/Widgets/DisplaysOverlay.vala"
	widget_height = _tmp3_;
#line 518 "../src/Widgets/DisplaysOverlay.vala"
	_tmp4_ = display_display_widget_get_delta_x (widget);
#line 518 "../src/Widgets/DisplaysOverlay.vala"
	_tmp5_ = _tmp4_;
#line 518 "../src/Widgets/DisplaysOverlay.vala"
	widget_x += _tmp5_;
#line 519 "../src/Widgets/DisplaysOverlay.vala"
	_tmp6_ = display_display_widget_get_delta_y (widget);
#line 519 "../src/Widgets/DisplaysOverlay.vala"
	_tmp7_ = _tmp6_;
#line 519 "../src/Widgets/DisplaysOverlay.vala"
	widget_y += _tmp7_;
#line 521 "../src/Widgets/DisplaysOverlay.vala"
	shortest_distance = G_MAXINT;
#line 521 "../src/Widgets/DisplaysOverlay.vala"
	shortest_distance_x = 0;
#line 521 "../src/Widgets/DisplaysOverlay.vala"
	shortest_distance_y = 0;
#line 3021 "DisplaysOverlay.c"
	{
		GList* anchor_collection = NULL;
		GList* anchor_it = NULL;
#line 522 "../src/Widgets/DisplaysOverlay.vala"
		anchor_collection = anchors;
#line 522 "../src/Widgets/DisplaysOverlay.vala"
		for (anchor_it = anchor_collection; anchor_it != NULL; anchor_it = anchor_it->next) {
#line 3029 "DisplaysOverlay.c"
			DisplayDisplayWidget* _tmp8_;
			DisplayDisplayWidget* anchor = NULL;
#line 522 "../src/Widgets/DisplaysOverlay.vala"
			_tmp8_ = _g_object_ref0 ((DisplayDisplayWidget*) anchor_it->data);
#line 522 "../src/Widgets/DisplaysOverlay.vala"
			anchor = _tmp8_;
#line 3036 "DisplaysOverlay.c"
			{
				gint anchor_x = 0;
				gint anchor_y = 0;
				gint anchor_width = 0;
				gint anchor_height = 0;
				DisplayDisplayWidget* _tmp9_;
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
				gint _tmp12_ = 0;
				gint _tmp13_ = 0;
				gint distance_origin_x = 0;
				gint distance_origin_y = 0;
				gint distance_left = 0;
				gint distance_right = 0;
				gint distance_top = 0;
				gint distance_bottom = 0;
				gint _tmp14_ = 0;
				gint distance_widget_anchor_x = 0;
				gint _tmp15_ = 0;
				gint distance_widget_anchor_y = 0;
				gboolean _tmp16_ = FALSE;
				gint shortest_distance_candidate = 0;
#line 524 "../src/Widgets/DisplaysOverlay.vala"
				_tmp9_ = anchor;
#line 524 "../src/Widgets/DisplaysOverlay.vala"
				display_display_widget_get_geometry (_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_);
#line 524 "../src/Widgets/DisplaysOverlay.vala"
				anchor_x = _tmp10_;
#line 524 "../src/Widgets/DisplaysOverlay.vala"
				anchor_y = _tmp11_;
#line 524 "../src/Widgets/DisplaysOverlay.vala"
				anchor_width = _tmp12_;
#line 524 "../src/Widgets/DisplaysOverlay.vala"
				anchor_height = _tmp13_;
#line 526 "../src/Widgets/DisplaysOverlay.vala"
				distance_origin_x = anchor_x - widget_x;
#line 527 "../src/Widgets/DisplaysOverlay.vala"
				distance_origin_y = anchor_y - widget_y;
#line 528 "../src/Widgets/DisplaysOverlay.vala"
				distance_left = distance_origin_x + anchor_width;
#line 529 "../src/Widgets/DisplaysOverlay.vala"
				distance_right = distance_origin_x - widget_width;
#line 530 "../src/Widgets/DisplaysOverlay.vala"
				distance_top = distance_origin_y + anchor_height;
#line 531 "../src/Widgets/DisplaysOverlay.vala"
				distance_bottom = distance_origin_y - widget_height;
#line 532 "../src/Widgets/DisplaysOverlay.vala"
				if (distance_right > (-distance_left)) {
#line 532 "../src/Widgets/DisplaysOverlay.vala"
					_tmp14_ = distance_right;
#line 3087 "DisplaysOverlay.c"
				} else {
#line 532 "../src/Widgets/DisplaysOverlay.vala"
					_tmp14_ = distance_left;
#line 3091 "DisplaysOverlay.c"
				}
#line 532 "../src/Widgets/DisplaysOverlay.vala"
				distance_widget_anchor_x = _tmp14_;
#line 533 "../src/Widgets/DisplaysOverlay.vala"
				if (distance_bottom > (-distance_top)) {
#line 533 "../src/Widgets/DisplaysOverlay.vala"
					_tmp15_ = distance_bottom;
#line 3099 "DisplaysOverlay.c"
				} else {
#line 533 "../src/Widgets/DisplaysOverlay.vala"
					_tmp15_ = distance_top;
#line 3103 "DisplaysOverlay.c"
				}
#line 533 "../src/Widgets/DisplaysOverlay.vala"
				distance_widget_anchor_y = _tmp15_;
#line 536 "../src/Widgets/DisplaysOverlay.vala"
				if (distance_left > 0) {
#line 536 "../src/Widgets/DisplaysOverlay.vala"
					_tmp16_ = distance_right < 0;
#line 3111 "DisplaysOverlay.c"
				} else {
#line 536 "../src/Widgets/DisplaysOverlay.vala"
					_tmp16_ = FALSE;
#line 3115 "DisplaysOverlay.c"
				}
#line 536 "../src/Widgets/DisplaysOverlay.vala"
				if (_tmp16_) {
#line 537 "../src/Widgets/DisplaysOverlay.vala"
					distance_widget_anchor_x = 0;
#line 3121 "DisplaysOverlay.c"
				} else {
					gboolean _tmp17_ = FALSE;
#line 539 "../src/Widgets/DisplaysOverlay.vala"
					if (distance_top > 0) {
#line 539 "../src/Widgets/DisplaysOverlay.vala"
						_tmp17_ = distance_bottom < 0;
#line 3128 "DisplaysOverlay.c"
					} else {
#line 539 "../src/Widgets/DisplaysOverlay.vala"
						_tmp17_ = FALSE;
#line 3132 "DisplaysOverlay.c"
					}
#line 539 "../src/Widgets/DisplaysOverlay.vala"
					if (_tmp17_) {
#line 540 "../src/Widgets/DisplaysOverlay.vala"
						distance_widget_anchor_y = 0;
#line 3138 "DisplaysOverlay.c"
					} else {
#line 543 "../src/Widgets/DisplaysOverlay.vala"
						if (abs (distance_widget_anchor_x) >= abs (distance_widget_anchor_y)) {
#line 3142 "DisplaysOverlay.c"
							gint _tmp18_ = 0;
#line 544 "../src/Widgets/DisplaysOverlay.vala"
							if (distance_origin_x > 0) {
#line 544 "../src/Widgets/DisplaysOverlay.vala"
								_tmp18_ = 1;
#line 3148 "DisplaysOverlay.c"
							} else {
#line 544 "../src/Widgets/DisplaysOverlay.vala"
								_tmp18_ = -1;
#line 3152 "DisplaysOverlay.c"
							}
#line 544 "../src/Widgets/DisplaysOverlay.vala"
							distance_widget_anchor_x += _tmp18_ * DISPLAY_DISPLAYS_OVERLAY_MINIMUM_WIDGET_OFFSET;
#line 3156 "DisplaysOverlay.c"
						} else {
							gint _tmp19_ = 0;
#line 546 "../src/Widgets/DisplaysOverlay.vala"
							if (distance_origin_y > 0) {
#line 546 "../src/Widgets/DisplaysOverlay.vala"
								_tmp19_ = 1;
#line 3163 "DisplaysOverlay.c"
							} else {
#line 546 "../src/Widgets/DisplaysOverlay.vala"
								_tmp19_ = -1;
#line 3167 "DisplaysOverlay.c"
							}
#line 546 "../src/Widgets/DisplaysOverlay.vala"
							distance_widget_anchor_y += _tmp19_ * DISPLAY_DISPLAYS_OVERLAY_MINIMUM_WIDGET_OFFSET;
#line 3171 "DisplaysOverlay.c"
						}
					}
				}
#line 550 "../src/Widgets/DisplaysOverlay.vala"
				shortest_distance_candidate = (distance_widget_anchor_x * distance_widget_anchor_x) + (distance_widget_anchor_y * distance_widget_anchor_y);
#line 552 "../src/Widgets/DisplaysOverlay.vala"
				if (shortest_distance_candidate < shortest_distance) {
#line 553 "../src/Widgets/DisplaysOverlay.vala"
					shortest_distance = shortest_distance_candidate;
#line 554 "../src/Widgets/DisplaysOverlay.vala"
					shortest_distance_x = distance_widget_anchor_x;
#line 555 "../src/Widgets/DisplaysOverlay.vala"
					shortest_distance_y = distance_widget_anchor_y;
#line 3185 "DisplaysOverlay.c"
				}
#line 522 "../src/Widgets/DisplaysOverlay.vala"
				_g_object_unref0 (anchor);
#line 3189 "DisplaysOverlay.c"
			}
		}
	}
#line 559 "../src/Widgets/DisplaysOverlay.vala"
	display_display_widget_set_geometry (widget, widget_x + shortest_distance_x, widget_y + shortest_distance_y, widget_width, widget_height);
#line 3195 "DisplaysOverlay.c"
}

gint
display_displays_overlay_get_active_displays (DisplayDisplaysOverlay* self)
{
	gint result;
#line 37 "../src/Widgets/DisplaysOverlay.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 37 "../src/Widgets/DisplaysOverlay.vala"
	result = self->priv->_active_displays;
#line 37 "../src/Widgets/DisplaysOverlay.vala"
	return result;
#line 3208 "DisplaysOverlay.c"
}

void
display_displays_overlay_set_active_displays (DisplayDisplaysOverlay* self,
                                              gint value)
{
	gint old_value;
#line 37 "../src/Widgets/DisplaysOverlay.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Widgets/DisplaysOverlay.vala"
	old_value = display_displays_overlay_get_active_displays (self);
#line 37 "../src/Widgets/DisplaysOverlay.vala"
	if (old_value != value) {
#line 37 "../src/Widgets/DisplaysOverlay.vala"
		self->priv->_active_displays = value;
#line 37 "../src/Widgets/DisplaysOverlay.vala"
		g_object_notify_by_pspec ((GObject *) self, display_displays_overlay_properties[DISPLAY_DISPLAYS_OVERLAY_ACTIVE_DISPLAYS_PROPERTY]);
#line 3226 "DisplaysOverlay.c"
	}
}

static void
display_displays_overlay_class_init (DisplayDisplaysOverlayClass * klass,
                                     gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar** _tmp15_;
	GtkCssProvider* _tmp16_;
	GtkCssProvider* _tmp17_;
#line 23 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Widgets/DisplaysOverlay.vala"
	g_type_class_adjust_private_offset (klass, &DisplayDisplaysOverlay_private_offset);
#line 23 "../src/Widgets/DisplaysOverlay.vala"
	((GtkOverlayClass *) klass)->get_child_position = (gboolean (*) (GtkOverlay*, GtkWidget*, GdkRectangle*)) display_displays_overlay_real_get_child_position;
#line 23 "../src/Widgets/DisplaysOverlay.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_display_displays_overlay_get_property;
#line 23 "../src/Widgets/DisplaysOverlay.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_display_displays_overlay_set_property;
#line 23 "../src/Widgets/DisplaysOverlay.vala"
	G_OBJECT_CLASS (klass)->finalize = display_displays_overlay_finalize;
#line 23 "../src/Widgets/DisplaysOverlay.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAYS_OVERLAY_ACTIVE_DISPLAYS_PROPERTY, display_displays_overlay_properties[DISPLAY_DISPLAYS_OVERLAY_ACTIVE_DISPLAYS_PROPERTY] = g_param_spec_int ("active-displays", "active-displays", "active-displays", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_signals[DISPLAY_DISPLAYS_OVERLAY_CONFIGURATION_CHANGED_SIGNAL] = g_signal_new ("configuration-changed", DISPLAY_TYPE_DISPLAYS_OVERLAY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp0_ = g_strdup ("@BLUEBERRY_100");
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp1_ = g_strdup ("@STRAWBERRY_100");
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp2_ = g_strdup ("@ORANGE_100");
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp3_ = g_strdup ("@BANANA_100");
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp4_ = g_strdup ("@LIME_100");
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp5_ = g_strdup ("@GRAPE_100");
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp6_ = g_strdup ("@COCOA_100");
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp7_ = g_new0 (gchar*, 7 + 1);
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp7_[0] = _tmp0_;
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp7_[1] = _tmp1_;
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp7_[2] = _tmp2_;
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp7_[3] = _tmp3_;
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp7_[4] = _tmp4_;
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp7_[5] = _tmp5_;
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_tmp7_[6] = _tmp6_;
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_colors = _tmp7_;
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_colors_length1 = 7;
#line 41 "../src/Widgets/DisplaysOverlay.vala"
	_display_displays_overlay_colors_size_ = display_displays_overlay_colors_length1;
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp8_ = g_strdup ("@BLUEBERRY_900");
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp9_ = g_strdup ("@STRAWBERRY_900");
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp10_ = g_strdup ("@ORANGE_900");
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp11_ = g_strdup ("@BANANA_900");
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp12_ = g_strdup ("@LIME_900");
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp13_ = g_strdup ("@GRAPE_900");
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp14_ = g_strdup ("@COCOA_900");
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp15_ = g_new0 (gchar*, 7 + 1);
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp15_[0] = _tmp8_;
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp15_[1] = _tmp9_;
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp15_[2] = _tmp10_;
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp15_[3] = _tmp11_;
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp15_[4] = _tmp12_;
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp15_[5] = _tmp13_;
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_tmp15_[6] = _tmp14_;
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_text_colors = _tmp15_;
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_text_colors_length1 = 7;
#line 50 "../src/Widgets/DisplaysOverlay.vala"
	_display_displays_overlay_text_colors_size_ = display_displays_overlay_text_colors_length1;
#line 77 "../src/Widgets/DisplaysOverlay.vala"
	_tmp16_ = gtk_css_provider_new ();
#line 77 "../src/Widgets/DisplaysOverlay.vala"
	_g_object_unref0 (display_displays_overlay_display_provider);
#line 77 "../src/Widgets/DisplaysOverlay.vala"
	display_displays_overlay_display_provider = _tmp16_;
#line 78 "../src/Widgets/DisplaysOverlay.vala"
	_tmp17_ = display_displays_overlay_display_provider;
#line 78 "../src/Widgets/DisplaysOverlay.vala"
	gtk_css_provider_load_from_resource (_tmp17_, "io/elementary/switchboard/display/Display.css");
#line 3350 "DisplaysOverlay.c"
}

static void
display_displays_overlay_instance_init (DisplayDisplaysOverlay * self,
                                        gpointer klass)
{
#line 23 "../src/Widgets/DisplaysOverlay.vala"
	self->priv = display_displays_overlay_get_instance_private (self);
#line 29 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->scanning = FALSE;
#line 30 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->current_ratio = (gdouble) 1.0f;
#line 31 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->current_allocated_width = 0;
#line 32 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->current_allocated_height = 0;
#line 33 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->default_x_margin = 0;
#line 34 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->default_y_margin = 0;
#line 37 "../src/Widgets/DisplaysOverlay.vala"
	self->priv->_active_displays = 0;
#line 3373 "DisplaysOverlay.c"
}

static void
display_displays_overlay_finalize (GObject * obj)
{
	DisplayDisplaysOverlay * self;
#line 23 "../src/Widgets/DisplaysOverlay.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAYS_OVERLAY, DisplayDisplaysOverlay);
#line 23 "../src/Widgets/DisplaysOverlay.vala"
	G_OBJECT_CLASS (display_displays_overlay_parent_class)->finalize (obj);
#line 3384 "DisplaysOverlay.c"
}

static GType
display_displays_overlay_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayDisplaysOverlayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_displays_overlay_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayDisplaysOverlay), 0, (GInstanceInitFunc) display_displays_overlay_instance_init, NULL };
	GType display_displays_overlay_type_id;
	display_displays_overlay_type_id = g_type_register_static (gtk_overlay_get_type (), "DisplayDisplaysOverlay", &g_define_type_info, 0);
	DisplayDisplaysOverlay_private_offset = g_type_add_instance_private (display_displays_overlay_type_id, sizeof (DisplayDisplaysOverlayPrivate));
	return display_displays_overlay_type_id;
}

GType
display_displays_overlay_get_type (void)
{
	static volatile gsize display_displays_overlay_type_id__once = 0;
	if (g_once_init_enter (&display_displays_overlay_type_id__once)) {
		GType display_displays_overlay_type_id;
		display_displays_overlay_type_id = display_displays_overlay_get_type_once ();
		g_once_init_leave (&display_displays_overlay_type_id__once, display_displays_overlay_type_id);
	}
	return display_displays_overlay_type_id__once;
}

static void
_vala_display_displays_overlay_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	DisplayDisplaysOverlay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_DISPLAYS_OVERLAY, DisplayDisplaysOverlay);
#line 23 "../src/Widgets/DisplaysOverlay.vala"
	switch (property_id) {
#line 23 "../src/Widgets/DisplaysOverlay.vala"
		case DISPLAY_DISPLAYS_OVERLAY_ACTIVE_DISPLAYS_PROPERTY:
#line 23 "../src/Widgets/DisplaysOverlay.vala"
		g_value_set_int (value, display_displays_overlay_get_active_displays (self));
#line 23 "../src/Widgets/DisplaysOverlay.vala"
		break;
#line 3425 "DisplaysOverlay.c"
		default:
#line 23 "../src/Widgets/DisplaysOverlay.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/DisplaysOverlay.vala"
		break;
#line 3431 "DisplaysOverlay.c"
	}
}

static void
_vala_display_displays_overlay_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	DisplayDisplaysOverlay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_DISPLAYS_OVERLAY, DisplayDisplaysOverlay);
#line 23 "../src/Widgets/DisplaysOverlay.vala"
	switch (property_id) {
#line 23 "../src/Widgets/DisplaysOverlay.vala"
		case DISPLAY_DISPLAYS_OVERLAY_ACTIVE_DISPLAYS_PROPERTY:
#line 23 "../src/Widgets/DisplaysOverlay.vala"
		display_displays_overlay_set_active_displays (self, g_value_get_int (value));
#line 23 "../src/Widgets/DisplaysOverlay.vala"
		break;
#line 3451 "DisplaysOverlay.c"
		default:
#line 23 "../src/Widgets/DisplaysOverlay.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/DisplaysOverlay.vala"
		break;
#line 3457 "DisplaysOverlay.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

