/* DisplayWidget.c generated by valac 0.56.18, the Vala compiler
 * generated from DisplayWidget.vala, do not modify */

/*-
 * Copyright 2014–2021 elementary, Inc.
 *           2014–2018 Corentin Noël <corentin@elementary.io>
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "display.h"
#include <glib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DISPLAY_DISPLAY_WIDGET_0_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_VIRTUAL_MONITOR_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_WINDOW_RATIO_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_DISPLAY_WINDOW_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_NUM_PROPERTIES
};
static GParamSpec* display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_NUM_PROPERTIES];
typedef enum  {
	DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME,
	DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH,
	DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT,
	DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_TOTAL
} DisplayDisplayWidgetResolutionColumns;

#define DISPLAY_DISPLAY_WIDGET_TYPE_RESOLUTION_COLUMNS (display_display_widget_resolution_columns_get_type ())
typedef enum  {
	DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME,
	DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE,
	DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_TOTAL
} DisplayDisplayWidgetRotationColumns;

#define DISPLAY_DISPLAY_WIDGET_TYPE_ROTATION_COLUMNS (display_display_widget_rotation_columns_get_type ())
typedef enum  {
	DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_NAME,
	DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_VALUE,
	DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_TOTAL
} DisplayDisplayWidgetRefreshColumns;

#define DISPLAY_DISPLAY_WIDGET_TYPE_REFRESH_COLUMNS (display_display_widget_refresh_columns_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
enum  {
	DISPLAY_DISPLAY_WIDGET_SET_AS_PRIMARY_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_MOVE_DISPLAY_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_END_GRAB_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_ACTIVE_CHANGED_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_NUM_SIGNALS
};
static guint display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_NUM_SIGNALS] = {0};

struct _DisplayDisplayWidgetPrivate {
	DisplayVirtualMonitor* _virtual_monitor;
	gdouble _window_ratio;
	gint _delta_x;
	gint _delta_y;
	gboolean _only_display;
	gdouble start_x;
	gdouble start_y;
	gboolean holding;
	DisplayDisplayWindow* _display_window;
	GtkButton* _primary_image;
	GtkMenuButton* _toggle_settings;
	GtkSwitch* use_switch;
	GtkComboBox* resolution_combobox;
	GtkTreeStore* resolution_tree_store;
	GtkComboBox* rotation_combobox;
	GtkListStore* rotation_list_store;
	GtkComboBox* refresh_combobox;
	GtkListStore* refresh_list_store;
	gint real_width;
	gint real_height;
};

struct _Block4Data {
	int _ref_count_;
	DisplayDisplayWidget* self;
	gboolean _result_;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	DisplayMonitorMode* mode;
};

struct _Block6Data {
	int _ref_count_;
	DisplayDisplayWidget* self;
	DisplayTransform transform;
};

struct _Block7Data {
	int _ref_count_;
	DisplayDisplayWidget* self;
	gchar* virtual_monitor_name;
	GtkLabel* label;
};

static gint DisplayDisplayWidget_private_offset;
static gpointer display_display_widget_parent_class = NULL;

static GType display_display_widget_resolution_columns_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType display_display_widget_rotation_columns_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType display_display_widget_refresh_columns_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void display_display_widget_populate_refresh_rates (DisplayDisplayWidget* self);
static gboolean _vala_double_array_contains (gdouble * stack,
                                      gssize stack_length,
                                      const gdouble needle);
static void _vala_array_add3 (gdouble* * array,
                       gint* length,
                       gint* size,
                       gdouble value);
static void display_display_widget_on_monitor_modes_changed (DisplayDisplayWidget* self);
static gboolean display_display_widget_set_active_resolution_from_current_mode (DisplayDisplayWidget* self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gboolean ____lambda7_ (Block5Data* _data5_,
                       GtkTreeModel* model,
                       GtkTreePath* path,
                       GtkTreeIter* iter);
static gboolean _____lambda7__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                    GtkTreePath* path,
                                                    GtkTreeIter* iter,
                                                    gpointer self);
static void display_display_widget_on_vm_transform_changed (DisplayDisplayWidget* self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean __lambda8_ (Block6Data* _data6_,
                     GtkTreeModel* model,
                     GtkTreePath* path,
                     GtkTreeIter* iter);
static gboolean ___lambda8__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                  GtkTreePath* path,
                                                  GtkTreeIter* iter,
                                                  gpointer self);
static gboolean display_display_widget_real_button_press_event (GtkWidget* base,
                                                         GdkEventButton* event);
static gboolean display_display_widget_real_button_release_event (GtkWidget* base,
                                                           GdkEventButton* event);
static gboolean display_display_widget_real_motion_notify_event (GtkWidget* base,
                                                          GdkEventMotion* event);
static void display_display_widget_real_get_preferred_width (GtkWidget* base,
                                                      gint* minimum_width,
                                                      gint* natural_width);
static void display_display_widget_real_get_preferred_height (GtkWidget* base,
                                                       gint* minimum_height,
                                                       gint* natural_height);
static void display_display_widget_set_window_ratio (DisplayDisplayWidget* self,
                                              gdouble value);
static void display_display_widget_set_display_window (DisplayDisplayWidget* self,
                                                DisplayDisplayWindow* value);
static void display_display_widget_set_primary_image (DisplayDisplayWidget* self,
                                               GtkButton* value);
static void display_display_widget_set_toggle_settings (DisplayDisplayWidget* self,
                                                 GtkMenuButton* value);
static void g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static GObject * display_display_widget_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _display_display_widget___lambda9_ (DisplayDisplayWidget* self);
static void __display_display_widget___lambda9__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static gint _display_monitor_mode_resolution_compare_func_gcompare_data_func (gconstpointer a,
                                                                       gconstpointer b,
                                                                       gpointer self);
static void _vala_array_add4 (DisplayResolution* * array,
                       gint* length,
                       gint* size,
                       const DisplayResolution* value);
static void _vala_array_add5 (DisplayResolution* * array,
                       gint* length,
                       gint* size,
                       const DisplayResolution* value);
static void _vala_array_add6 (DisplayResolution* * array,
                       gint* length,
                       gint* size,
                       const DisplayResolution* value);
static void _display_display_widget___lambda10_ (DisplayDisplayWidget* self);
static void __display_display_widget___lambda10__gtk_widget_destroy (GtkWidget* _sender,
                                                              gpointer self);
static void _display_display_widget___lambda11_ (DisplayDisplayWidget* self);
static void __display_display_widget___lambda11__g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void _display_display_widget___lambda12_ (DisplayDisplayWidget* self);
static void __display_display_widget___lambda12__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self);
static void _display_display_widget___lambda13_ (Block7Data* _data7_);
static void __display_display_widget___lambda13__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self);
static void _display_display_widget___lambda14_ (DisplayDisplayWidget* self);
static void __display_display_widget___lambda14__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self);
static void _display_display_widget_on_monitor_modes_changed_display_virtual_monitor_modes_changed (DisplayVirtualMonitor* _sender,
                                                                                             gpointer self);
static void _display_display_widget_on_vm_transform_changed_g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self);
static void display_display_widget_finalize (GObject * obj);
static GType display_display_widget_get_type_once (void);
static void _vala_display_display_widget_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_display_display_widget_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

DisplayResolution*
display_resolution_dup (const DisplayResolution* self)
{
	DisplayResolution* dup;
#line 21 "../src/Widgets/DisplayWidget.vala"
	dup = g_new0 (DisplayResolution, 1);
#line 21 "../src/Widgets/DisplayWidget.vala"
	memcpy (dup, self, sizeof (DisplayResolution));
#line 21 "../src/Widgets/DisplayWidget.vala"
	return dup;
#line 284 "DisplayWidget.c"
}

void
display_resolution_free (DisplayResolution* self)
{
#line 21 "../src/Widgets/DisplayWidget.vala"
	g_free (self);
#line 292 "DisplayWidget.c"
}

static GType
display_resolution_get_type_once (void)
{
	GType display_resolution_type_id;
	display_resolution_type_id = g_boxed_type_register_static ("DisplayResolution", (GBoxedCopyFunc) display_resolution_dup, (GBoxedFreeFunc) display_resolution_free);
	return display_resolution_type_id;
}

GType
display_resolution_get_type (void)
{
	static volatile gsize display_resolution_type_id__once = 0;
	if (g_once_init_enter (&display_resolution_type_id__once)) {
		GType display_resolution_type_id;
		display_resolution_type_id = display_resolution_get_type_once ();
		g_once_init_leave (&display_resolution_type_id__once, display_resolution_type_id);
	}
	return display_resolution_type_id__once;
}

static inline gpointer
display_display_widget_get_instance_private (DisplayDisplayWidget* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayDisplayWidget_private_offset);
}

static GType
display_display_widget_resolution_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME, "DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME", "name"}, {DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH, "DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH", "width"}, {DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT, "DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT", "height"}, {DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_TOTAL, "DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_TOTAL", "total"}, {0, NULL, NULL}};
	GType display_display_widget_resolution_columns_type_id;
	display_display_widget_resolution_columns_type_id = g_enum_register_static ("DisplayDisplayWidgetResolutionColumns", values);
	return display_display_widget_resolution_columns_type_id;
}

static GType
display_display_widget_resolution_columns_get_type (void)
{
	static volatile gsize display_display_widget_resolution_columns_type_id__once = 0;
	if (g_once_init_enter (&display_display_widget_resolution_columns_type_id__once)) {
		GType display_display_widget_resolution_columns_type_id;
		display_display_widget_resolution_columns_type_id = display_display_widget_resolution_columns_get_type_once ();
		g_once_init_leave (&display_display_widget_resolution_columns_type_id__once, display_display_widget_resolution_columns_type_id);
	}
	return display_display_widget_resolution_columns_type_id__once;
}

static GType
display_display_widget_rotation_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME, "DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME", "name"}, {DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE, "DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE", "value"}, {DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_TOTAL, "DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_TOTAL", "total"}, {0, NULL, NULL}};
	GType display_display_widget_rotation_columns_type_id;
	display_display_widget_rotation_columns_type_id = g_enum_register_static ("DisplayDisplayWidgetRotationColumns", values);
	return display_display_widget_rotation_columns_type_id;
}

static GType
display_display_widget_rotation_columns_get_type (void)
{
	static volatile gsize display_display_widget_rotation_columns_type_id__once = 0;
	if (g_once_init_enter (&display_display_widget_rotation_columns_type_id__once)) {
		GType display_display_widget_rotation_columns_type_id;
		display_display_widget_rotation_columns_type_id = display_display_widget_rotation_columns_get_type_once ();
		g_once_init_leave (&display_display_widget_rotation_columns_type_id__once, display_display_widget_rotation_columns_type_id);
	}
	return display_display_widget_rotation_columns_type_id__once;
}

static GType
display_display_widget_refresh_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_NAME, "DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_NAME", "name"}, {DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_VALUE, "DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_VALUE", "value"}, {DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_TOTAL, "DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_TOTAL", "total"}, {0, NULL, NULL}};
	GType display_display_widget_refresh_columns_type_id;
	display_display_widget_refresh_columns_type_id = g_enum_register_static ("DisplayDisplayWidgetRefreshColumns", values);
	return display_display_widget_refresh_columns_type_id;
}

static GType
display_display_widget_refresh_columns_get_type (void)
{
	static volatile gsize display_display_widget_refresh_columns_type_id__once = 0;
	if (g_once_init_enter (&display_display_widget_refresh_columns_type_id__once)) {
		GType display_display_widget_refresh_columns_type_id;
		display_display_widget_refresh_columns_type_id = display_display_widget_refresh_columns_get_type_once ();
		g_once_init_leave (&display_display_widget_refresh_columns_type_id__once, display_display_widget_refresh_columns_type_id);
	}
	return display_display_widget_refresh_columns_type_id__once;
}

DisplayDisplayWidget*
display_display_widget_construct (GType object_type,
                                  DisplayVirtualMonitor* virtual_monitor)
{
	DisplayDisplayWidget * self = NULL;
#line 85 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (virtual_monitor != NULL, NULL);
#line 86 "../src/Widgets/DisplayWidget.vala"
	self = (DisplayDisplayWidget*) g_object_new (object_type, "virtual-monitor", virtual_monitor, NULL);
#line 85 "../src/Widgets/DisplayWidget.vala"
	return self;
#line 395 "DisplayWidget.c"
}

DisplayDisplayWidget*
display_display_widget_new (DisplayVirtualMonitor* virtual_monitor)
{
#line 85 "../src/Widgets/DisplayWidget.vala"
	return display_display_widget_construct (DISPLAY_TYPE_DISPLAY_WIDGET, virtual_monitor);
#line 403 "DisplayWidget.c"
}

static gboolean
_vala_double_array_contains (gdouble * stack,
                             gssize stack_length,
                             const gdouble needle)
{
	gssize i;
#line 435 "../src/Widgets/DisplayWidget.vala"
	for (i = 0; i < stack_length; i++) {
#line 435 "../src/Widgets/DisplayWidget.vala"
		if (needle == stack[i]) {
#line 435 "../src/Widgets/DisplayWidget.vala"
			return TRUE;
#line 418 "DisplayWidget.c"
		}
	}
#line 435 "../src/Widgets/DisplayWidget.vala"
	return FALSE;
#line 423 "DisplayWidget.c"
}

static void
_vala_array_add3 (gdouble* * array,
                  gint* length,
                  gint* size,
                  gdouble value)
{
#line 451 "../src/Widgets/DisplayWidget.vala"
	if ((*length) == (*size)) {
#line 451 "../src/Widgets/DisplayWidget.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 451 "../src/Widgets/DisplayWidget.vala"
		*array = g_renew (gdouble, *array, *size);
#line 438 "DisplayWidget.c"
	}
#line 451 "../src/Widgets/DisplayWidget.vala"
	(*array)[(*length)++] = value;
#line 442 "DisplayWidget.c"
}

static void
display_display_widget_populate_refresh_rates (DisplayDisplayWidget* self)
{
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
	gint added = 0;
	GtkComboBox* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_;
	GtkComboBox* _tmp56_;
#line 412 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (self != NULL);
#line 413 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->refresh_list_store;
#line 413 "../src/Widgets/DisplayWidget.vala"
	gtk_list_store_clear (_tmp0_);
#line 416 "../src/Widgets/DisplayWidget.vala"
	added = 0;
#line 417 "../src/Widgets/DisplayWidget.vala"
	_tmp1_ = self->priv->resolution_combobox;
#line 417 "../src/Widgets/DisplayWidget.vala"
	_tmp3_ = gtk_combo_box_get_active_iter (_tmp1_, &_tmp2_);
#line 417 "../src/Widgets/DisplayWidget.vala"
	iter = _tmp2_;
#line 417 "../src/Widgets/DisplayWidget.vala"
	if (_tmp3_) {
#line 471 "DisplayWidget.c"
		gint active_width = 0;
		gint active_height = 0;
		GtkComboBox* _tmp4_;
		GtkTreeIter _tmp5_ = {0};
		gboolean _tmp6_;
		gdouble* frequencies = NULL;
		gdouble* _tmp11_;
		gint frequencies_length1;
		gint _frequencies_size_;
		gboolean refresh_set = FALSE;
#line 419 "../src/Widgets/DisplayWidget.vala"
		_tmp4_ = self->priv->resolution_combobox;
#line 419 "../src/Widgets/DisplayWidget.vala"
		_tmp6_ = gtk_combo_box_get_active_iter (_tmp4_, &_tmp5_);
#line 419 "../src/Widgets/DisplayWidget.vala"
		iter = _tmp5_;
#line 419 "../src/Widgets/DisplayWidget.vala"
		if (_tmp6_) {
#line 490 "DisplayWidget.c"
			GtkTreeStore* _tmp7_;
			GtkTreeIter _tmp8_;
			gint _tmp9_ = 0;
			gint _tmp10_ = 0;
#line 420 "../src/Widgets/DisplayWidget.vala"
			_tmp7_ = self->priv->resolution_tree_store;
#line 420 "../src/Widgets/DisplayWidget.vala"
			_tmp8_ = iter;
#line 420 "../src/Widgets/DisplayWidget.vala"
			gtk_tree_model_get ((GtkTreeModel*) _tmp7_, &_tmp8_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH, &_tmp9_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT, &_tmp10_, -1);
#line 420 "../src/Widgets/DisplayWidget.vala"
			active_width = _tmp9_;
#line 420 "../src/Widgets/DisplayWidget.vala"
			active_height = _tmp10_;
#line 505 "DisplayWidget.c"
		} else {
#line 425 "../src/Widgets/DisplayWidget.vala"
			return;
#line 509 "DisplayWidget.c"
		}
#line 428 "../src/Widgets/DisplayWidget.vala"
		_tmp11_ = g_new0 (gdouble, 0);
#line 428 "../src/Widgets/DisplayWidget.vala"
		frequencies = _tmp11_;
#line 428 "../src/Widgets/DisplayWidget.vala"
		frequencies_length1 = 0;
#line 428 "../src/Widgets/DisplayWidget.vala"
		_frequencies_size_ = frequencies_length1;
#line 429 "../src/Widgets/DisplayWidget.vala"
		refresh_set = FALSE;
#line 521 "DisplayWidget.c"
		{
			GeeLinkedList* _mode_list = NULL;
			DisplayVirtualMonitor* _tmp12_;
			GeeLinkedList* _tmp13_;
			gint _mode_size = 0;
			GeeLinkedList* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			gint _mode_index = 0;
#line 430 "../src/Widgets/DisplayWidget.vala"
			_tmp12_ = self->priv->_virtual_monitor;
#line 430 "../src/Widgets/DisplayWidget.vala"
			_tmp13_ = display_virtual_monitor_get_available_modes (_tmp12_);
#line 430 "../src/Widgets/DisplayWidget.vala"
			_mode_list = _tmp13_;
#line 430 "../src/Widgets/DisplayWidget.vala"
			_tmp14_ = _mode_list;
#line 430 "../src/Widgets/DisplayWidget.vala"
			_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 430 "../src/Widgets/DisplayWidget.vala"
			_tmp16_ = _tmp15_;
#line 430 "../src/Widgets/DisplayWidget.vala"
			_mode_size = _tmp16_;
#line 430 "../src/Widgets/DisplayWidget.vala"
			_mode_index = -1;
#line 430 "../src/Widgets/DisplayWidget.vala"
			while (TRUE) {
#line 549 "DisplayWidget.c"
				gint _tmp17_;
				gint _tmp18_;
				DisplayMonitorMode* mode = NULL;
				GeeLinkedList* _tmp19_;
				gpointer _tmp20_;
				gboolean _tmp21_ = FALSE;
				DisplayMonitorMode* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				DisplayMonitorMode* _tmp28_;
				gdouble _tmp29_;
				gdouble _tmp30_;
				gdouble* _tmp31_;
				gint _tmp31__length1;
				gboolean freq_already_added = FALSE;
				gdouble* _tmp32_;
				gint _tmp32__length1;
				DisplayMonitorMode* _tmp36_;
				gdouble _tmp37_;
				gdouble _tmp38_;
				gchar* freq_name = NULL;
				DisplayMonitorMode* _tmp39_;
				gdouble _tmp40_;
				gdouble _tmp41_;
				gchar* _tmp42_;
				GtkListStore* _tmp43_;
				GtkTreeIter _tmp44_ = {0};
				GtkListStore* _tmp45_;
				GtkTreeIter _tmp46_;
				const gchar* _tmp47_;
				DisplayMonitorMode* _tmp48_;
				gint _tmp49_;
				DisplayMonitorMode* _tmp50_;
				gboolean _tmp51_;
				gboolean _tmp52_;
#line 430 "../src/Widgets/DisplayWidget.vala"
				_mode_index = _mode_index + 1;
#line 430 "../src/Widgets/DisplayWidget.vala"
				_tmp17_ = _mode_index;
#line 430 "../src/Widgets/DisplayWidget.vala"
				_tmp18_ = _mode_size;
#line 430 "../src/Widgets/DisplayWidget.vala"
				if (!(_tmp17_ < _tmp18_)) {
#line 430 "../src/Widgets/DisplayWidget.vala"
					break;
#line 595 "DisplayWidget.c"
				}
#line 430 "../src/Widgets/DisplayWidget.vala"
				_tmp19_ = _mode_list;
#line 430 "../src/Widgets/DisplayWidget.vala"
				_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _mode_index);
#line 430 "../src/Widgets/DisplayWidget.vala"
				mode = (DisplayMonitorMode*) _tmp20_;
#line 431 "../src/Widgets/DisplayWidget.vala"
				_tmp22_ = mode;
#line 431 "../src/Widgets/DisplayWidget.vala"
				_tmp23_ = display_monitor_mode_get_width (_tmp22_);
#line 431 "../src/Widgets/DisplayWidget.vala"
				_tmp24_ = _tmp23_;
#line 431 "../src/Widgets/DisplayWidget.vala"
				if (_tmp24_ != active_width) {
#line 431 "../src/Widgets/DisplayWidget.vala"
					_tmp21_ = TRUE;
#line 613 "DisplayWidget.c"
				} else {
					DisplayMonitorMode* _tmp25_;
					gint _tmp26_;
					gint _tmp27_;
#line 431 "../src/Widgets/DisplayWidget.vala"
					_tmp25_ = mode;
#line 431 "../src/Widgets/DisplayWidget.vala"
					_tmp26_ = display_monitor_mode_get_height (_tmp25_);
#line 431 "../src/Widgets/DisplayWidget.vala"
					_tmp27_ = _tmp26_;
#line 431 "../src/Widgets/DisplayWidget.vala"
					_tmp21_ = _tmp27_ != active_height;
#line 626 "DisplayWidget.c"
				}
#line 431 "../src/Widgets/DisplayWidget.vala"
				if (_tmp21_) {
#line 432 "../src/Widgets/DisplayWidget.vala"
					_g_object_unref0 (mode);
#line 432 "../src/Widgets/DisplayWidget.vala"
					continue;
#line 634 "DisplayWidget.c"
				}
#line 435 "../src/Widgets/DisplayWidget.vala"
				_tmp28_ = mode;
#line 435 "../src/Widgets/DisplayWidget.vala"
				_tmp29_ = display_monitor_mode_get_frequency (_tmp28_);
#line 435 "../src/Widgets/DisplayWidget.vala"
				_tmp30_ = _tmp29_;
#line 435 "../src/Widgets/DisplayWidget.vala"
				_tmp31_ = frequencies;
#line 435 "../src/Widgets/DisplayWidget.vala"
				_tmp31__length1 = frequencies_length1;
#line 435 "../src/Widgets/DisplayWidget.vala"
				if (_vala_double_array_contains (_tmp31_, _tmp31__length1, _tmp30_)) {
#line 436 "../src/Widgets/DisplayWidget.vala"
					_g_object_unref0 (mode);
#line 436 "../src/Widgets/DisplayWidget.vala"
					continue;
#line 652 "DisplayWidget.c"
				}
#line 439 "../src/Widgets/DisplayWidget.vala"
				freq_already_added = FALSE;
#line 440 "../src/Widgets/DisplayWidget.vala"
				_tmp32_ = frequencies;
#line 440 "../src/Widgets/DisplayWidget.vala"
				_tmp32__length1 = frequencies_length1;
#line 660 "DisplayWidget.c"
				{
					gdouble* freq_collection = NULL;
					gint freq_collection_length1 = 0;
					gint _freq_collection_size_ = 0;
					gint freq_it = 0;
#line 440 "../src/Widgets/DisplayWidget.vala"
					freq_collection = _tmp32_;
#line 440 "../src/Widgets/DisplayWidget.vala"
					freq_collection_length1 = _tmp32__length1;
#line 440 "../src/Widgets/DisplayWidget.vala"
					for (freq_it = 0; freq_it < freq_collection_length1; freq_it = freq_it + 1) {
#line 672 "DisplayWidget.c"
						gdouble freq = 0.0;
#line 440 "../src/Widgets/DisplayWidget.vala"
						freq = freq_collection[freq_it];
#line 676 "DisplayWidget.c"
						{
							DisplayMonitorMode* _tmp33_;
							gdouble _tmp34_;
							gdouble _tmp35_;
#line 441 "../src/Widgets/DisplayWidget.vala"
							_tmp33_ = mode;
#line 441 "../src/Widgets/DisplayWidget.vala"
							_tmp34_ = display_monitor_mode_get_frequency (_tmp33_);
#line 441 "../src/Widgets/DisplayWidget.vala"
							_tmp35_ = _tmp34_;
#line 441 "../src/Widgets/DisplayWidget.vala"
							if (fabs (_tmp35_ - freq) < ((gdouble) 1)) {
#line 442 "../src/Widgets/DisplayWidget.vala"
								freq_already_added = TRUE;
#line 443 "../src/Widgets/DisplayWidget.vala"
								break;
#line 693 "DisplayWidget.c"
							}
						}
					}
				}
#line 447 "../src/Widgets/DisplayWidget.vala"
				if (freq_already_added) {
#line 448 "../src/Widgets/DisplayWidget.vala"
					_g_object_unref0 (mode);
#line 448 "../src/Widgets/DisplayWidget.vala"
					continue;
#line 704 "DisplayWidget.c"
				}
#line 451 "../src/Widgets/DisplayWidget.vala"
				_tmp36_ = mode;
#line 451 "../src/Widgets/DisplayWidget.vala"
				_tmp37_ = display_monitor_mode_get_frequency (_tmp36_);
#line 451 "../src/Widgets/DisplayWidget.vala"
				_tmp38_ = _tmp37_;
#line 451 "../src/Widgets/DisplayWidget.vala"
				_vala_array_add3 (&frequencies, &frequencies_length1, &_frequencies_size_, _tmp38_);
#line 453 "../src/Widgets/DisplayWidget.vala"
				_tmp39_ = mode;
#line 453 "../src/Widgets/DisplayWidget.vala"
				_tmp40_ = display_monitor_mode_get_frequency (_tmp39_);
#line 453 "../src/Widgets/DisplayWidget.vala"
				_tmp41_ = _tmp40_;
#line 453 "../src/Widgets/DisplayWidget.vala"
				_tmp42_ = g_strdup_printf (_ ("%g Hz"), (gdouble) roundf ((gfloat) _tmp41_));
#line 453 "../src/Widgets/DisplayWidget.vala"
				freq_name = _tmp42_;
#line 454 "../src/Widgets/DisplayWidget.vala"
				_tmp43_ = self->priv->refresh_list_store;
#line 454 "../src/Widgets/DisplayWidget.vala"
				gtk_list_store_append (_tmp43_, &_tmp44_);
#line 454 "../src/Widgets/DisplayWidget.vala"
				iter = _tmp44_;
#line 455 "../src/Widgets/DisplayWidget.vala"
				_tmp45_ = self->priv->refresh_list_store;
#line 455 "../src/Widgets/DisplayWidget.vala"
				_tmp46_ = iter;
#line 455 "../src/Widgets/DisplayWidget.vala"
				_tmp47_ = freq_name;
#line 455 "../src/Widgets/DisplayWidget.vala"
				_tmp48_ = mode;
#line 455 "../src/Widgets/DisplayWidget.vala"
				gtk_list_store_set (_tmp45_, &_tmp46_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME, _tmp47_, DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_VALUE, _tmp48_, -1);
#line 456 "../src/Widgets/DisplayWidget.vala"
				_tmp49_ = added;
#line 456 "../src/Widgets/DisplayWidget.vala"
				added = _tmp49_ + 1;
#line 457 "../src/Widgets/DisplayWidget.vala"
				_tmp50_ = mode;
#line 457 "../src/Widgets/DisplayWidget.vala"
				_tmp51_ = display_monitor_mode_get_is_current (_tmp50_);
#line 457 "../src/Widgets/DisplayWidget.vala"
				_tmp52_ = _tmp51_;
#line 457 "../src/Widgets/DisplayWidget.vala"
				if (_tmp52_) {
#line 752 "DisplayWidget.c"
					GtkComboBox* _tmp53_;
					GtkTreeIter _tmp54_;
#line 458 "../src/Widgets/DisplayWidget.vala"
					_tmp53_ = self->priv->refresh_combobox;
#line 458 "../src/Widgets/DisplayWidget.vala"
					_tmp54_ = iter;
#line 458 "../src/Widgets/DisplayWidget.vala"
					gtk_combo_box_set_active_iter (_tmp53_, &_tmp54_);
#line 459 "../src/Widgets/DisplayWidget.vala"
					refresh_set = TRUE;
#line 763 "DisplayWidget.c"
				}
#line 430 "../src/Widgets/DisplayWidget.vala"
				_g_free0 (freq_name);
#line 430 "../src/Widgets/DisplayWidget.vala"
				_g_object_unref0 (mode);
#line 769 "DisplayWidget.c"
			}
#line 430 "../src/Widgets/DisplayWidget.vala"
			_g_object_unref0 (_mode_list);
#line 773 "DisplayWidget.c"
		}
#line 463 "../src/Widgets/DisplayWidget.vala"
		if (!refresh_set) {
#line 777 "DisplayWidget.c"
			GtkComboBox* _tmp55_;
#line 464 "../src/Widgets/DisplayWidget.vala"
			_tmp55_ = self->priv->refresh_combobox;
#line 464 "../src/Widgets/DisplayWidget.vala"
			gtk_combo_box_set_active (_tmp55_, 0);
#line 783 "DisplayWidget.c"
		}
#line 417 "../src/Widgets/DisplayWidget.vala"
		frequencies = (g_free (frequencies), NULL);
#line 787 "DisplayWidget.c"
	}
#line 468 "../src/Widgets/DisplayWidget.vala"
	_tmp56_ = self->priv->refresh_combobox;
#line 468 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp56_, added > 1);
#line 793 "DisplayWidget.c"
}

static void
display_display_widget_on_monitor_modes_changed (DisplayDisplayWidget* self)
{
#line 471 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (self != NULL);
#line 472 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_set_active_resolution_from_current_mode (self);
#line 803 "DisplayWidget.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 475 "../src/Widgets/DisplayWidget.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 475 "../src/Widgets/DisplayWidget.vala"
	return _data4_;
#line 813 "DisplayWidget.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 475 "../src/Widgets/DisplayWidget.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 823 "DisplayWidget.c"
		DisplayDisplayWidget* self;
#line 475 "../src/Widgets/DisplayWidget.vala"
		self = _data4_->self;
#line 475 "../src/Widgets/DisplayWidget.vala"
		_g_object_unref0 (self);
#line 475 "../src/Widgets/DisplayWidget.vala"
		g_slice_free (Block4Data, _data4_);
#line 831 "DisplayWidget.c"
	}
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 477 "../src/Widgets/DisplayWidget.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 477 "../src/Widgets/DisplayWidget.vala"
	return _data5_;
#line 842 "DisplayWidget.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 477 "../src/Widgets/DisplayWidget.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 852 "DisplayWidget.c"
		DisplayDisplayWidget* self;
#line 477 "../src/Widgets/DisplayWidget.vala"
		self = _data5_->_data4_->self;
#line 477 "../src/Widgets/DisplayWidget.vala"
		_g_object_unref0 (_data5_->mode);
#line 477 "../src/Widgets/DisplayWidget.vala"
		block4_data_unref (_data5_->_data4_);
#line 477 "../src/Widgets/DisplayWidget.vala"
		_data5_->_data4_ = NULL;
#line 477 "../src/Widgets/DisplayWidget.vala"
		g_slice_free (Block5Data, _data5_);
#line 864 "DisplayWidget.c"
	}
}

static gboolean
____lambda7_ (Block5Data* _data5_,
              GtkTreeModel* model,
              GtkTreePath* path,
              GtkTreeIter* iter)
{
	Block4Data* _data4_;
	DisplayDisplayWidget* self;
	gint width = 0;
	gint height = 0;
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	DisplayMonitorMode* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 482 "../src/Widgets/DisplayWidget.vala"
	_data4_ = _data5_->_data4_;
#line 482 "../src/Widgets/DisplayWidget.vala"
	self = _data4_->self;
#line 482 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 482 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 482 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 484 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->resolution_tree_store;
#line 484 "../src/Widgets/DisplayWidget.vala"
	_tmp1_ = *iter;
#line 484 "../src/Widgets/DisplayWidget.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH, &_tmp2_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT, &_tmp3_, -1);
#line 484 "../src/Widgets/DisplayWidget.vala"
	width = _tmp2_;
#line 484 "../src/Widgets/DisplayWidget.vala"
	height = _tmp3_;
#line 488 "../src/Widgets/DisplayWidget.vala"
	_tmp5_ = _data5_->mode;
#line 488 "../src/Widgets/DisplayWidget.vala"
	_tmp6_ = display_monitor_mode_get_width (_tmp5_);
#line 488 "../src/Widgets/DisplayWidget.vala"
	_tmp7_ = _tmp6_;
#line 488 "../src/Widgets/DisplayWidget.vala"
	if (_tmp7_ == width) {
#line 915 "DisplayWidget.c"
		DisplayMonitorMode* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 488 "../src/Widgets/DisplayWidget.vala"
		_tmp8_ = _data5_->mode;
#line 488 "../src/Widgets/DisplayWidget.vala"
		_tmp9_ = display_monitor_mode_get_height (_tmp8_);
#line 488 "../src/Widgets/DisplayWidget.vala"
		_tmp10_ = _tmp9_;
#line 488 "../src/Widgets/DisplayWidget.vala"
		_tmp4_ = _tmp10_ == height;
#line 927 "DisplayWidget.c"
	} else {
#line 488 "../src/Widgets/DisplayWidget.vala"
		_tmp4_ = FALSE;
#line 931 "DisplayWidget.c"
	}
#line 488 "../src/Widgets/DisplayWidget.vala"
	if (_tmp4_) {
#line 935 "DisplayWidget.c"
		GtkComboBox* _tmp11_;
		GtkTreeIter _tmp12_;
#line 489 "../src/Widgets/DisplayWidget.vala"
		_tmp11_ = self->priv->resolution_combobox;
#line 489 "../src/Widgets/DisplayWidget.vala"
		_tmp12_ = *iter;
#line 489 "../src/Widgets/DisplayWidget.vala"
		gtk_combo_box_set_active_iter (_tmp11_, &_tmp12_);
#line 490 "../src/Widgets/DisplayWidget.vala"
		_data4_->_result_ = TRUE;
#line 491 "../src/Widgets/DisplayWidget.vala"
		result = TRUE;
#line 491 "../src/Widgets/DisplayWidget.vala"
		return result;
#line 950 "DisplayWidget.c"
	}
#line 494 "../src/Widgets/DisplayWidget.vala"
	result = FALSE;
#line 494 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 956 "DisplayWidget.c"
}

static gboolean
_____lambda7__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                           GtkTreePath* path,
                                           GtkTreeIter* iter,
                                           gpointer self)
{
	gboolean result;
	result = ____lambda7_ (self, model, path, iter);
#line 482 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 969 "DisplayWidget.c"
}

static gboolean
display_display_widget_set_active_resolution_from_current_mode (DisplayDisplayWidget* self)
{
	Block4Data* _data4_;
	gboolean result;
#line 475 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 475 "../src/Widgets/DisplayWidget.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 475 "../src/Widgets/DisplayWidget.vala"
	_data4_->_ref_count_ = 1;
#line 475 "../src/Widgets/DisplayWidget.vala"
	_data4_->self = g_object_ref (self);
#line 476 "../src/Widgets/DisplayWidget.vala"
	_data4_->_result_ = FALSE;
#line 987 "DisplayWidget.c"
	{
		GeeLinkedList* _mode_list = NULL;
		DisplayVirtualMonitor* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _mode_index = 0;
#line 477 "../src/Widgets/DisplayWidget.vala"
		_tmp0_ = self->priv->_virtual_monitor;
#line 477 "../src/Widgets/DisplayWidget.vala"
		_tmp1_ = display_virtual_monitor_get_available_modes (_tmp0_);
#line 477 "../src/Widgets/DisplayWidget.vala"
		_mode_list = _tmp1_;
#line 477 "../src/Widgets/DisplayWidget.vala"
		_tmp2_ = _mode_list;
#line 477 "../src/Widgets/DisplayWidget.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 477 "../src/Widgets/DisplayWidget.vala"
		_tmp4_ = _tmp3_;
#line 477 "../src/Widgets/DisplayWidget.vala"
		_mode_size = _tmp4_;
#line 477 "../src/Widgets/DisplayWidget.vala"
		_mode_index = -1;
#line 477 "../src/Widgets/DisplayWidget.vala"
		while (TRUE) {
#line 1015 "DisplayWidget.c"
			Block5Data* _data5_;
			gint _tmp5_;
			gint _tmp6_;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			DisplayMonitorMode* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
			GtkTreeStore* _tmp12_;
#line 477 "../src/Widgets/DisplayWidget.vala"
			_data5_ = g_slice_new0 (Block5Data);
#line 477 "../src/Widgets/DisplayWidget.vala"
			_data5_->_ref_count_ = 1;
#line 477 "../src/Widgets/DisplayWidget.vala"
			_data5_->_data4_ = block4_data_ref (_data4_);
#line 477 "../src/Widgets/DisplayWidget.vala"
			_mode_index = _mode_index + 1;
#line 477 "../src/Widgets/DisplayWidget.vala"
			_tmp5_ = _mode_index;
#line 477 "../src/Widgets/DisplayWidget.vala"
			_tmp6_ = _mode_size;
#line 477 "../src/Widgets/DisplayWidget.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 477 "../src/Widgets/DisplayWidget.vala"
				block5_data_unref (_data5_);
#line 477 "../src/Widgets/DisplayWidget.vala"
				_data5_ = NULL;
#line 477 "../src/Widgets/DisplayWidget.vala"
				break;
#line 1045 "DisplayWidget.c"
			}
#line 477 "../src/Widgets/DisplayWidget.vala"
			_tmp7_ = _mode_list;
#line 477 "../src/Widgets/DisplayWidget.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _mode_index);
#line 477 "../src/Widgets/DisplayWidget.vala"
			_data5_->mode = (DisplayMonitorMode*) _tmp8_;
#line 478 "../src/Widgets/DisplayWidget.vala"
			_tmp9_ = _data5_->mode;
#line 478 "../src/Widgets/DisplayWidget.vala"
			_tmp10_ = display_monitor_mode_get_is_current (_tmp9_);
#line 478 "../src/Widgets/DisplayWidget.vala"
			_tmp11_ = _tmp10_;
#line 478 "../src/Widgets/DisplayWidget.vala"
			if (!_tmp11_) {
#line 479 "../src/Widgets/DisplayWidget.vala"
				block5_data_unref (_data5_);
#line 479 "../src/Widgets/DisplayWidget.vala"
				_data5_ = NULL;
#line 479 "../src/Widgets/DisplayWidget.vala"
				continue;
#line 1067 "DisplayWidget.c"
			}
#line 482 "../src/Widgets/DisplayWidget.vala"
			_tmp12_ = self->priv->resolution_tree_store;
#line 482 "../src/Widgets/DisplayWidget.vala"
			gtk_tree_model_foreach ((GtkTreeModel*) _tmp12_, _____lambda7__gtk_tree_model_foreach_func, _data5_);
#line 477 "../src/Widgets/DisplayWidget.vala"
			block5_data_unref (_data5_);
#line 477 "../src/Widgets/DisplayWidget.vala"
			_data5_ = NULL;
#line 1077 "DisplayWidget.c"
		}
#line 477 "../src/Widgets/DisplayWidget.vala"
		_g_object_unref0 (_mode_list);
#line 1081 "DisplayWidget.c"
	}
#line 498 "../src/Widgets/DisplayWidget.vala"
	result = _data4_->_result_;
#line 498 "../src/Widgets/DisplayWidget.vala"
	block4_data_unref (_data4_);
#line 498 "../src/Widgets/DisplayWidget.vala"
	_data4_ = NULL;
#line 498 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1091 "DisplayWidget.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 501 "../src/Widgets/DisplayWidget.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 501 "../src/Widgets/DisplayWidget.vala"
	return _data6_;
#line 1101 "DisplayWidget.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 501 "../src/Widgets/DisplayWidget.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 1111 "DisplayWidget.c"
		DisplayDisplayWidget* self;
#line 501 "../src/Widgets/DisplayWidget.vala"
		self = _data6_->self;
#line 501 "../src/Widgets/DisplayWidget.vala"
		_g_object_unref0 (self);
#line 501 "../src/Widgets/DisplayWidget.vala"
		g_slice_free (Block6Data, _data6_);
#line 1119 "DisplayWidget.c"
	}
}

static gboolean
__lambda8_ (Block6Data* _data6_,
            GtkTreeModel* model,
            GtkTreePath* path,
            GtkTreeIter* iter)
{
	DisplayDisplayWidget* self;
	GValue val = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GValue _tmp2_ = {0};
	DisplayTransform iter_transform = 0;
	GValue _tmp3_;
	gboolean result;
#line 503 "../src/Widgets/DisplayWidget.vala"
	self = _data6_->self;
#line 503 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 503 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 503 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 505 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->rotation_list_store;
#line 505 "../src/Widgets/DisplayWidget.vala"
	_tmp1_ = *iter;
#line 505 "../src/Widgets/DisplayWidget.vala"
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp0_, &_tmp1_, (gint) DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE, &_tmp2_);
#line 505 "../src/Widgets/DisplayWidget.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 505 "../src/Widgets/DisplayWidget.vala"
	val = _tmp2_;
#line 507 "../src/Widgets/DisplayWidget.vala"
	_tmp3_ = val;
#line 507 "../src/Widgets/DisplayWidget.vala"
	iter_transform = (DisplayTransform) g_value_get_int (&_tmp3_);
#line 508 "../src/Widgets/DisplayWidget.vala"
	if (iter_transform == _data6_->transform) {
#line 1161 "DisplayWidget.c"
		GtkComboBox* _tmp4_;
		GtkTreeIter _tmp5_;
#line 509 "../src/Widgets/DisplayWidget.vala"
		_tmp4_ = self->priv->rotation_combobox;
#line 509 "../src/Widgets/DisplayWidget.vala"
		_tmp5_ = *iter;
#line 509 "../src/Widgets/DisplayWidget.vala"
		gtk_combo_box_set_active_iter (_tmp4_, &_tmp5_);
#line 510 "../src/Widgets/DisplayWidget.vala"
		result = TRUE;
#line 510 "../src/Widgets/DisplayWidget.vala"
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 510 "../src/Widgets/DisplayWidget.vala"
		return result;
#line 1176 "DisplayWidget.c"
	}
#line 513 "../src/Widgets/DisplayWidget.vala"
	result = FALSE;
#line 513 "../src/Widgets/DisplayWidget.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 513 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1184 "DisplayWidget.c"
}

static gboolean
___lambda8__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                         GtkTreePath* path,
                                         GtkTreeIter* iter,
                                         gpointer self)
{
	gboolean result;
	result = __lambda8_ (self, model, path, iter);
#line 503 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1197 "DisplayWidget.c"
}

static void
display_display_widget_on_vm_transform_changed (DisplayDisplayWidget* self)
{
	Block6Data* _data6_;
	DisplayVirtualMonitor* _tmp0_;
	DisplayTransform _tmp1_;
	DisplayTransform _tmp2_;
	GtkListStore* _tmp3_;
#line 501 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (self != NULL);
#line 501 "../src/Widgets/DisplayWidget.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 501 "../src/Widgets/DisplayWidget.vala"
	_data6_->_ref_count_ = 1;
#line 501 "../src/Widgets/DisplayWidget.vala"
	_data6_->self = g_object_ref (self);
#line 502 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->_virtual_monitor;
#line 502 "../src/Widgets/DisplayWidget.vala"
	_tmp1_ = display_virtual_monitor_get_transform (_tmp0_);
#line 502 "../src/Widgets/DisplayWidget.vala"
	_tmp2_ = _tmp1_;
#line 502 "../src/Widgets/DisplayWidget.vala"
	_data6_->transform = _tmp2_;
#line 503 "../src/Widgets/DisplayWidget.vala"
	_tmp3_ = self->priv->rotation_list_store;
#line 503 "../src/Widgets/DisplayWidget.vala"
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp3_, ___lambda8__gtk_tree_model_foreach_func, _data6_);
#line 501 "../src/Widgets/DisplayWidget.vala"
	block6_data_unref (_data6_);
#line 501 "../src/Widgets/DisplayWidget.vala"
	_data6_ = NULL;
#line 1232 "DisplayWidget.c"
}

static gboolean
display_display_widget_real_button_press_event (GtkWidget* base,
                                                GdkEventButton* event)
{
	DisplayDisplayWidget * self;
	gboolean _tmp0_;
	gboolean result;
#line 517 "../src/Widgets/DisplayWidget.vala"
	self = (DisplayDisplayWidget*) base;
#line 517 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 518 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->_only_display;
#line 518 "../src/Widgets/DisplayWidget.vala"
	if (_tmp0_) {
#line 519 "../src/Widgets/DisplayWidget.vala"
		result = FALSE;
#line 519 "../src/Widgets/DisplayWidget.vala"
		return result;
#line 1254 "DisplayWidget.c"
	}
#line 522 "../src/Widgets/DisplayWidget.vala"
	self->priv->start_x = event->x_root;
#line 523 "../src/Widgets/DisplayWidget.vala"
	self->priv->start_y = event->y_root;
#line 524 "../src/Widgets/DisplayWidget.vala"
	self->priv->holding = TRUE;
#line 525 "../src/Widgets/DisplayWidget.vala"
	result = FALSE;
#line 525 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1266 "DisplayWidget.c"
}

static gboolean
display_display_widget_real_button_release_event (GtkWidget* base,
                                                  GdkEventButton* event)
{
	DisplayDisplayWidget * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
	gint old_delta_x = 0;
	gint _tmp5_;
	gint old_delta_y = 0;
	gint _tmp6_;
	gboolean result;
#line 528 "../src/Widgets/DisplayWidget.vala"
	self = (DisplayDisplayWidget*) base;
#line 528 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 529 "../src/Widgets/DisplayWidget.vala"
	self->priv->holding = FALSE;
#line 530 "../src/Widgets/DisplayWidget.vala"
	_tmp2_ = self->priv->_delta_x;
#line 530 "../src/Widgets/DisplayWidget.vala"
	if (_tmp2_ == 0) {
#line 1292 "DisplayWidget.c"
		gint _tmp3_;
#line 530 "../src/Widgets/DisplayWidget.vala"
		_tmp3_ = self->priv->_delta_y;
#line 530 "../src/Widgets/DisplayWidget.vala"
		_tmp1_ = _tmp3_ == 0;
#line 1298 "DisplayWidget.c"
	} else {
#line 530 "../src/Widgets/DisplayWidget.vala"
		_tmp1_ = FALSE;
#line 1302 "DisplayWidget.c"
	}
#line 530 "../src/Widgets/DisplayWidget.vala"
	if (_tmp1_) {
#line 530 "../src/Widgets/DisplayWidget.vala"
		_tmp0_ = TRUE;
#line 1308 "DisplayWidget.c"
	} else {
		gboolean _tmp4_;
#line 530 "../src/Widgets/DisplayWidget.vala"
		_tmp4_ = self->priv->_only_display;
#line 530 "../src/Widgets/DisplayWidget.vala"
		_tmp0_ = _tmp4_;
#line 1315 "DisplayWidget.c"
	}
#line 530 "../src/Widgets/DisplayWidget.vala"
	if (_tmp0_) {
#line 531 "../src/Widgets/DisplayWidget.vala"
		result = FALSE;
#line 531 "../src/Widgets/DisplayWidget.vala"
		return result;
#line 1323 "DisplayWidget.c"
	}
#line 534 "../src/Widgets/DisplayWidget.vala"
	_tmp5_ = self->priv->_delta_x;
#line 534 "../src/Widgets/DisplayWidget.vala"
	old_delta_x = _tmp5_;
#line 535 "../src/Widgets/DisplayWidget.vala"
	_tmp6_ = self->priv->_delta_y;
#line 535 "../src/Widgets/DisplayWidget.vala"
	old_delta_y = _tmp6_;
#line 536 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_set_delta_x (self, 0);
#line 537 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_set_delta_y (self, 0);
#line 538 "../src/Widgets/DisplayWidget.vala"
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_END_GRAB_SIGNAL], 0, old_delta_x, old_delta_y);
#line 539 "../src/Widgets/DisplayWidget.vala"
	result = FALSE;
#line 539 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1343 "DisplayWidget.c"
}

static gboolean
display_display_widget_real_motion_notify_event (GtkWidget* base,
                                                 GdkEventMotion* event)
{
	DisplayDisplayWidget * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 542 "../src/Widgets/DisplayWidget.vala"
	self = (DisplayDisplayWidget*) base;
#line 542 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 543 "../src/Widgets/DisplayWidget.vala"
	if (self->priv->holding) {
#line 1359 "DisplayWidget.c"
		gboolean _tmp1_;
#line 543 "../src/Widgets/DisplayWidget.vala"
		_tmp1_ = self->priv->_only_display;
#line 543 "../src/Widgets/DisplayWidget.vala"
		_tmp0_ = !_tmp1_;
#line 1365 "DisplayWidget.c"
	} else {
#line 543 "../src/Widgets/DisplayWidget.vala"
		_tmp0_ = FALSE;
#line 1369 "DisplayWidget.c"
	}
#line 543 "../src/Widgets/DisplayWidget.vala"
	if (_tmp0_) {
#line 544 "../src/Widgets/DisplayWidget.vala"
		g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_MOVE_DISPLAY_SIGNAL], 0, event->x_root - self->priv->start_x, event->y_root - self->priv->start_y);
#line 1375 "DisplayWidget.c"
	}
#line 547 "../src/Widgets/DisplayWidget.vala"
	result = FALSE;
#line 547 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1381 "DisplayWidget.c"
}

void
display_display_widget_set_primary (DisplayDisplayWidget* self,
                                    gboolean is_primary)
{
	GtkSwitch* _tmp8_;
#line 550 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (self != NULL);
#line 551 "../src/Widgets/DisplayWidget.vala"
	if (is_primary) {
#line 1393 "DisplayWidget.c"
		GtkButton* _tmp0_;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
		GtkButton* _tmp3_;
#line 552 "../src/Widgets/DisplayWidget.vala"
		_tmp0_ = self->priv->_primary_image;
#line 552 "../src/Widgets/DisplayWidget.vala"
		_tmp1_ = gtk_button_get_image (_tmp0_);
#line 552 "../src/Widgets/DisplayWidget.vala"
		_tmp2_ = _tmp1_;
#line 552 "../src/Widgets/DisplayWidget.vala"
		g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_image_get_type (), GtkImage), "icon-name", "starred-symbolic", NULL);
#line 553 "../src/Widgets/DisplayWidget.vala"
		_tmp3_ = self->priv->_primary_image;
#line 553 "../src/Widgets/DisplayWidget.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _ ("Is the primary display"));
#line 1410 "DisplayWidget.c"
	} else {
		GtkButton* _tmp4_;
		GtkWidget* _tmp5_;
		GtkWidget* _tmp6_;
		GtkButton* _tmp7_;
#line 555 "../src/Widgets/DisplayWidget.vala"
		_tmp4_ = self->priv->_primary_image;
#line 555 "../src/Widgets/DisplayWidget.vala"
		_tmp5_ = gtk_button_get_image (_tmp4_);
#line 555 "../src/Widgets/DisplayWidget.vala"
		_tmp6_ = _tmp5_;
#line 555 "../src/Widgets/DisplayWidget.vala"
		g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_image_get_type (), GtkImage), "icon-name", "non-starred-symbolic", NULL);
#line 556 "../src/Widgets/DisplayWidget.vala"
		_tmp7_ = self->priv->_primary_image;
#line 556 "../src/Widgets/DisplayWidget.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, _ ("Set as primary display"));
#line 1428 "DisplayWidget.c"
	}
#line 559 "../src/Widgets/DisplayWidget.vala"
	_tmp8_ = self->priv->use_switch;
#line 559 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, !is_primary);
#line 1434 "DisplayWidget.c"
}

static void
display_display_widget_real_get_preferred_width (GtkWidget* base,
                                                 gint* minimum_width,
                                                 gint* natural_width)
{
	DisplayDisplayWidget * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	gdouble _tmp0_;
#line 562 "../src/Widgets/DisplayWidget.vala"
	self = (DisplayDisplayWidget*) base;
#line 563 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->_window_ratio;
#line 563 "../src/Widgets/DisplayWidget.vala"
	_vala_minimum_width = (gint) (self->priv->real_width * _tmp0_);
#line 564 "../src/Widgets/DisplayWidget.vala"
	_vala_natural_width = _vala_minimum_width;
#line 562 "../src/Widgets/DisplayWidget.vala"
	if (minimum_width) {
#line 562 "../src/Widgets/DisplayWidget.vala"
		*minimum_width = _vala_minimum_width;
#line 1458 "DisplayWidget.c"
	}
#line 562 "../src/Widgets/DisplayWidget.vala"
	if (natural_width) {
#line 562 "../src/Widgets/DisplayWidget.vala"
		*natural_width = _vala_natural_width;
#line 1464 "DisplayWidget.c"
	}
}

static void
display_display_widget_real_get_preferred_height (GtkWidget* base,
                                                  gint* minimum_height,
                                                  gint* natural_height)
{
	DisplayDisplayWidget * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	gdouble _tmp0_;
#line 567 "../src/Widgets/DisplayWidget.vala"
	self = (DisplayDisplayWidget*) base;
#line 568 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->_window_ratio;
#line 568 "../src/Widgets/DisplayWidget.vala"
	_vala_minimum_height = (gint) (self->priv->real_height * _tmp0_);
#line 569 "../src/Widgets/DisplayWidget.vala"
	_vala_natural_height = _vala_minimum_height;
#line 567 "../src/Widgets/DisplayWidget.vala"
	if (minimum_height) {
#line 567 "../src/Widgets/DisplayWidget.vala"
		*minimum_height = _vala_minimum_height;
#line 1489 "DisplayWidget.c"
	}
#line 567 "../src/Widgets/DisplayWidget.vala"
	if (natural_height) {
#line 567 "../src/Widgets/DisplayWidget.vala"
		*natural_height = _vala_natural_height;
#line 1495 "DisplayWidget.c"
	}
}

void
display_display_widget_get_geometry (DisplayDisplayWidget* self,
                                     gint* x,
                                     gint* y,
                                     gint* width,
                                     gint* height)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	gint _vala_width = 0;
	gint _vala_height = 0;
	DisplayVirtualMonitor* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	DisplayVirtualMonitor* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 572 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (self != NULL);
#line 573 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->_virtual_monitor;
#line 573 "../src/Widgets/DisplayWidget.vala"
	_tmp1_ = display_virtual_monitor_get_x (_tmp0_);
#line 573 "../src/Widgets/DisplayWidget.vala"
	_tmp2_ = _tmp1_;
#line 573 "../src/Widgets/DisplayWidget.vala"
	_vala_x = _tmp2_;
#line 574 "../src/Widgets/DisplayWidget.vala"
	_tmp3_ = self->priv->_virtual_monitor;
#line 574 "../src/Widgets/DisplayWidget.vala"
	_tmp4_ = display_virtual_monitor_get_y (_tmp3_);
#line 574 "../src/Widgets/DisplayWidget.vala"
	_tmp5_ = _tmp4_;
#line 574 "../src/Widgets/DisplayWidget.vala"
	_vala_y = _tmp5_;
#line 575 "../src/Widgets/DisplayWidget.vala"
	_vala_width = self->priv->real_width;
#line 576 "../src/Widgets/DisplayWidget.vala"
	_vala_height = self->priv->real_height;
#line 572 "../src/Widgets/DisplayWidget.vala"
	if (x) {
#line 572 "../src/Widgets/DisplayWidget.vala"
		*x = _vala_x;
#line 1542 "DisplayWidget.c"
	}
#line 572 "../src/Widgets/DisplayWidget.vala"
	if (y) {
#line 572 "../src/Widgets/DisplayWidget.vala"
		*y = _vala_y;
#line 1548 "DisplayWidget.c"
	}
#line 572 "../src/Widgets/DisplayWidget.vala"
	if (width) {
#line 572 "../src/Widgets/DisplayWidget.vala"
		*width = _vala_width;
#line 1554 "DisplayWidget.c"
	}
#line 572 "../src/Widgets/DisplayWidget.vala"
	if (height) {
#line 572 "../src/Widgets/DisplayWidget.vala"
		*height = _vala_height;
#line 1560 "DisplayWidget.c"
	}
}

void
display_display_widget_set_geometry (DisplayDisplayWidget* self,
                                     gint x,
                                     gint y,
                                     gint width,
                                     gint height)
{
	DisplayVirtualMonitor* _tmp0_;
	DisplayVirtualMonitor* _tmp1_;
#line 579 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (self != NULL);
#line 580 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->_virtual_monitor;
#line 580 "../src/Widgets/DisplayWidget.vala"
	display_virtual_monitor_set_x (_tmp0_, x);
#line 581 "../src/Widgets/DisplayWidget.vala"
	_tmp1_ = self->priv->_virtual_monitor;
#line 581 "../src/Widgets/DisplayWidget.vala"
	display_virtual_monitor_set_y (_tmp1_, y);
#line 582 "../src/Widgets/DisplayWidget.vala"
	self->priv->real_width = width;
#line 583 "../src/Widgets/DisplayWidget.vala"
	self->priv->real_height = height;
#line 1587 "DisplayWidget.c"
}

gboolean
display_display_widget_equals (DisplayDisplayWidget* self,
                               DisplayDisplayWidget* sibling)
{
	DisplayVirtualMonitor* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	DisplayVirtualMonitor* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	gboolean result;
#line 586 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 586 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (sibling != NULL, FALSE);
#line 587 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->_virtual_monitor;
#line 587 "../src/Widgets/DisplayWidget.vala"
	_tmp1_ = display_virtual_monitor_get_id (_tmp0_);
#line 587 "../src/Widgets/DisplayWidget.vala"
	_tmp2_ = _tmp1_;
#line 587 "../src/Widgets/DisplayWidget.vala"
	_tmp3_ = _tmp2_;
#line 587 "../src/Widgets/DisplayWidget.vala"
	_tmp4_ = sibling->priv->_virtual_monitor;
#line 587 "../src/Widgets/DisplayWidget.vala"
	_tmp5_ = display_virtual_monitor_get_id (_tmp4_);
#line 587 "../src/Widgets/DisplayWidget.vala"
	_tmp6_ = _tmp5_;
#line 587 "../src/Widgets/DisplayWidget.vala"
	_tmp7_ = _tmp6_;
#line 587 "../src/Widgets/DisplayWidget.vala"
	_tmp8_ = g_strcmp0 (_tmp3_, _tmp7_) == 0;
#line 587 "../src/Widgets/DisplayWidget.vala"
	_g_free0 (_tmp7_);
#line 587 "../src/Widgets/DisplayWidget.vala"
	_g_free0 (_tmp3_);
#line 587 "../src/Widgets/DisplayWidget.vala"
	result = _tmp8_;
#line 587 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1634 "DisplayWidget.c"
}

DisplayVirtualMonitor*
display_display_widget_get_virtual_monitor (DisplayDisplayWidget* self)
{
	DisplayVirtualMonitor* result;
	DisplayVirtualMonitor* _tmp0_;
#line 37 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->_virtual_monitor;
#line 37 "../src/Widgets/DisplayWidget.vala"
	result = _tmp0_;
#line 37 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1650 "DisplayWidget.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 37 "../src/Widgets/DisplayWidget.vala"
	return self ? g_object_ref (self) : NULL;
#line 1658 "DisplayWidget.c"
}

static void
display_display_widget_set_virtual_monitor (DisplayDisplayWidget* self,
                                            DisplayVirtualMonitor* value)
{
	DisplayVirtualMonitor* old_value;
#line 37 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Widgets/DisplayWidget.vala"
	old_value = display_display_widget_get_virtual_monitor (self);
#line 37 "../src/Widgets/DisplayWidget.vala"
	if (old_value != value) {
#line 1672 "DisplayWidget.c"
		DisplayVirtualMonitor* _tmp0_;
#line 37 "../src/Widgets/DisplayWidget.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 37 "../src/Widgets/DisplayWidget.vala"
		_g_object_unref0 (self->priv->_virtual_monitor);
#line 37 "../src/Widgets/DisplayWidget.vala"
		self->priv->_virtual_monitor = _tmp0_;
#line 37 "../src/Widgets/DisplayWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_VIRTUAL_MONITOR_PROPERTY]);
#line 1682 "DisplayWidget.c"
	}
}

gdouble
display_display_widget_get_window_ratio (DisplayDisplayWidget* self)
{
	gdouble result;
#line 39 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 39 "../src/Widgets/DisplayWidget.vala"
	result = self->priv->_window_ratio;
#line 39 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1696 "DisplayWidget.c"
}

static void
display_display_widget_set_window_ratio (DisplayDisplayWidget* self,
                                         gdouble value)
{
	gdouble old_value;
#line 39 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Widgets/DisplayWidget.vala"
	old_value = display_display_widget_get_window_ratio (self);
#line 39 "../src/Widgets/DisplayWidget.vala"
	if (old_value != value) {
#line 39 "../src/Widgets/DisplayWidget.vala"
		self->priv->_window_ratio = value;
#line 39 "../src/Widgets/DisplayWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_WINDOW_RATIO_PROPERTY]);
#line 1714 "DisplayWidget.c"
	}
}

gint
display_display_widget_get_delta_x (DisplayDisplayWidget* self)
{
	gint result;
#line 40 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "../src/Widgets/DisplayWidget.vala"
	result = self->priv->_delta_x;
#line 40 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1728 "DisplayWidget.c"
}

void
display_display_widget_set_delta_x (DisplayDisplayWidget* self,
                                    gint value)
{
	gint old_value;
#line 40 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/Widgets/DisplayWidget.vala"
	old_value = display_display_widget_get_delta_x (self);
#line 40 "../src/Widgets/DisplayWidget.vala"
	if (old_value != value) {
#line 40 "../src/Widgets/DisplayWidget.vala"
		self->priv->_delta_x = value;
#line 40 "../src/Widgets/DisplayWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY]);
#line 1746 "DisplayWidget.c"
	}
}

gint
display_display_widget_get_delta_y (DisplayDisplayWidget* self)
{
	gint result;
#line 41 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 41 "../src/Widgets/DisplayWidget.vala"
	result = self->priv->_delta_y;
#line 41 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1760 "DisplayWidget.c"
}

void
display_display_widget_set_delta_y (DisplayDisplayWidget* self,
                                    gint value)
{
	gint old_value;
#line 41 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Widgets/DisplayWidget.vala"
	old_value = display_display_widget_get_delta_y (self);
#line 41 "../src/Widgets/DisplayWidget.vala"
	if (old_value != value) {
#line 41 "../src/Widgets/DisplayWidget.vala"
		self->priv->_delta_y = value;
#line 41 "../src/Widgets/DisplayWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY]);
#line 1778 "DisplayWidget.c"
	}
}

gboolean
display_display_widget_get_only_display (DisplayDisplayWidget* self)
{
	gboolean result;
#line 42 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../src/Widgets/DisplayWidget.vala"
	result = self->priv->_only_display;
#line 42 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1792 "DisplayWidget.c"
}

void
display_display_widget_set_only_display (DisplayDisplayWidget* self,
                                         gboolean value)
{
	gboolean old_value;
#line 42 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Widgets/DisplayWidget.vala"
	old_value = display_display_widget_get_only_display (self);
#line 42 "../src/Widgets/DisplayWidget.vala"
	if (old_value != value) {
#line 42 "../src/Widgets/DisplayWidget.vala"
		self->priv->_only_display = value;
#line 42 "../src/Widgets/DisplayWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY]);
#line 1810 "DisplayWidget.c"
	}
}

DisplayDisplayWindow*
display_display_widget_get_display_window (DisplayDisplayWidget* self)
{
	DisplayDisplayWindow* result;
	DisplayDisplayWindow* _tmp0_;
#line 48 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->_display_window;
#line 48 "../src/Widgets/DisplayWidget.vala"
	result = _tmp0_;
#line 48 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1827 "DisplayWidget.c"
}

static void
display_display_widget_set_display_window (DisplayDisplayWidget* self,
                                           DisplayDisplayWindow* value)
{
	DisplayDisplayWindow* old_value;
#line 48 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/Widgets/DisplayWidget.vala"
	old_value = display_display_widget_get_display_window (self);
#line 48 "../src/Widgets/DisplayWidget.vala"
	if (old_value != value) {
#line 1841 "DisplayWidget.c"
		DisplayDisplayWindow* _tmp0_;
#line 48 "../src/Widgets/DisplayWidget.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 48 "../src/Widgets/DisplayWidget.vala"
		_g_object_unref0 (self->priv->_display_window);
#line 48 "../src/Widgets/DisplayWidget.vala"
		self->priv->_display_window = _tmp0_;
#line 48 "../src/Widgets/DisplayWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_DISPLAY_WINDOW_PROPERTY]);
#line 1851 "DisplayWidget.c"
	}
}

GtkButton*
display_display_widget_get_primary_image (DisplayDisplayWidget* self)
{
	GtkButton* result;
	GtkButton* _tmp0_;
#line 49 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->_primary_image;
#line 49 "../src/Widgets/DisplayWidget.vala"
	result = _tmp0_;
#line 49 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1868 "DisplayWidget.c"
}

static void
display_display_widget_set_primary_image (DisplayDisplayWidget* self,
                                          GtkButton* value)
{
	GtkButton* old_value;
#line 49 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/Widgets/DisplayWidget.vala"
	old_value = display_display_widget_get_primary_image (self);
#line 49 "../src/Widgets/DisplayWidget.vala"
	if (old_value != value) {
#line 1882 "DisplayWidget.c"
		GtkButton* _tmp0_;
#line 49 "../src/Widgets/DisplayWidget.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 49 "../src/Widgets/DisplayWidget.vala"
		_g_object_unref0 (self->priv->_primary_image);
#line 49 "../src/Widgets/DisplayWidget.vala"
		self->priv->_primary_image = _tmp0_;
#line 49 "../src/Widgets/DisplayWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY]);
#line 1892 "DisplayWidget.c"
	}
}

GtkMenuButton*
display_display_widget_get_toggle_settings (DisplayDisplayWidget* self)
{
	GtkMenuButton* result;
	GtkMenuButton* _tmp0_;
#line 50 "../src/Widgets/DisplayWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->_toggle_settings;
#line 50 "../src/Widgets/DisplayWidget.vala"
	result = _tmp0_;
#line 50 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 1909 "DisplayWidget.c"
}

static void
display_display_widget_set_toggle_settings (DisplayDisplayWidget* self,
                                            GtkMenuButton* value)
{
	GtkMenuButton* old_value;
#line 50 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/Widgets/DisplayWidget.vala"
	old_value = display_display_widget_get_toggle_settings (self);
#line 50 "../src/Widgets/DisplayWidget.vala"
	if (old_value != value) {
#line 1923 "DisplayWidget.c"
		GtkMenuButton* _tmp0_;
#line 50 "../src/Widgets/DisplayWidget.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 50 "../src/Widgets/DisplayWidget.vala"
		_g_object_unref0 (self->priv->_toggle_settings);
#line 50 "../src/Widgets/DisplayWidget.vala"
		self->priv->_toggle_settings = _tmp0_;
#line 50 "../src/Widgets/DisplayWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY]);
#line 1933 "DisplayWidget.c"
	}
}

static void
g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__DOUBLE_DOUBLE) (gpointer data1, gdouble arg_1, gdouble arg_2, gpointer data2);
	register GMarshalFunc_VOID__DOUBLE_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (n_param_values == 3);
#line 29 "../src/Widgets/DisplayWidget.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "../src/Widgets/DisplayWidget.vala"
		data1 = closure->data;
#line 29 "../src/Widgets/DisplayWidget.vala"
		data2 = param_values->data[0].v_pointer;
#line 1959 "DisplayWidget.c"
	} else {
#line 29 "../src/Widgets/DisplayWidget.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "../src/Widgets/DisplayWidget.vala"
		data2 = closure->data;
#line 1965 "DisplayWidget.c"
	}
#line 29 "../src/Widgets/DisplayWidget.vala"
	callback = (GMarshalFunc_VOID__DOUBLE_DOUBLE) (marshal_data ? marshal_data : cc->callback);
#line 29 "../src/Widgets/DisplayWidget.vala"
	callback (data1, g_value_get_double (param_values + 1), g_value_get_double (param_values + 2), data2);
#line 1971 "DisplayWidget.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "../src/Widgets/DisplayWidget.vala"
	g_return_if_fail (n_param_values == 3);
#line 29 "../src/Widgets/DisplayWidget.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "../src/Widgets/DisplayWidget.vala"
		data1 = closure->data;
#line 29 "../src/Widgets/DisplayWidget.vala"
		data2 = param_values->data[0].v_pointer;
#line 1996 "DisplayWidget.c"
	} else {
#line 29 "../src/Widgets/DisplayWidget.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "../src/Widgets/DisplayWidget.vala"
		data2 = closure->data;
#line 2002 "DisplayWidget.c"
	}
#line 29 "../src/Widgets/DisplayWidget.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 29 "../src/Widgets/DisplayWidget.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 2008 "DisplayWidget.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 89 "../src/Widgets/DisplayWidget.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 89 "../src/Widgets/DisplayWidget.vala"
	return _data7_;
#line 2018 "DisplayWidget.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 89 "../src/Widgets/DisplayWidget.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 2028 "DisplayWidget.c"
		DisplayDisplayWidget* self;
#line 89 "../src/Widgets/DisplayWidget.vala"
		self = _data7_->self;
#line 89 "../src/Widgets/DisplayWidget.vala"
		_g_object_unref0 (_data7_->label);
#line 89 "../src/Widgets/DisplayWidget.vala"
		_g_free0 (_data7_->virtual_monitor_name);
#line 89 "../src/Widgets/DisplayWidget.vala"
		_g_object_unref0 (self);
#line 89 "../src/Widgets/DisplayWidget.vala"
		g_slice_free (Block7Data, _data7_);
#line 2040 "DisplayWidget.c"
	}
}

static void
_display_display_widget___lambda9_ (DisplayDisplayWidget* self)
{
#line 106 "../src/Widgets/DisplayWidget.vala"
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_SET_AS_PRIMARY_SIGNAL], 0);
#line 2049 "DisplayWidget.c"
}

static void
__display_display_widget___lambda9__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 106 "../src/Widgets/DisplayWidget.vala"
	_display_display_widget___lambda9_ ((DisplayDisplayWidget*) self);
#line 2058 "DisplayWidget.c"
}

static gint
_display_monitor_mode_resolution_compare_func_gcompare_data_func (gconstpointer a,
                                                                  gconstpointer b,
                                                                  gpointer self)
{
	gint result;
	result = display_monitor_mode_resolution_compare_func ((DisplayMonitorMode*) a, (DisplayMonitorMode*) b);
#line 174 "../src/Widgets/DisplayWidget.vala"
	return result;
#line 2070 "DisplayWidget.c"
}

static void
_vala_array_add4 (DisplayResolution* * array,
                  gint* length,
                  gint* size,
                  const DisplayResolution* value)
{
#line 188 "../src/Widgets/DisplayWidget.vala"
	if ((*length) == (*size)) {
#line 188 "../src/Widgets/DisplayWidget.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 188 "../src/Widgets/DisplayWidget.vala"
		*array = g_renew (DisplayResolution, *array, *size);
#line 2085 "DisplayWidget.c"
	}
#line 188 "../src/Widgets/DisplayWidget.vala"
	(*array)[(*length)++] = *value;
#line 2089 "DisplayWidget.c"
}

static void
_vala_array_add5 (DisplayResolution* * array,
                  gint* length,
                  gint* size,
                  const DisplayResolution* value)
{
#line 200 "../src/Widgets/DisplayWidget.vala"
	if ((*length) == (*size)) {
#line 200 "../src/Widgets/DisplayWidget.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 200 "../src/Widgets/DisplayWidget.vala"
		*array = g_renew (DisplayResolution, *array, *size);
#line 2104 "DisplayWidget.c"
	}
#line 200 "../src/Widgets/DisplayWidget.vala"
	(*array)[(*length)++] = *value;
#line 2108 "DisplayWidget.c"
}

static void
_vala_array_add6 (DisplayResolution* * array,
                  gint* length,
                  gint* size,
                  const DisplayResolution* value)
{
#line 202 "../src/Widgets/DisplayWidget.vala"
	if ((*length) == (*size)) {
#line 202 "../src/Widgets/DisplayWidget.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 202 "../src/Widgets/DisplayWidget.vala"
		*array = g_renew (DisplayResolution, *array, *size);
#line 2123 "DisplayWidget.c"
	}
#line 202 "../src/Widgets/DisplayWidget.vala"
	(*array)[(*length)++] = *value;
#line 2127 "DisplayWidget.c"
}

static void
_display_display_widget___lambda10_ (DisplayDisplayWidget* self)
{
	DisplayDisplayWindow* _tmp0_;
#line 283 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->_display_window;
#line 283 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
#line 2138 "DisplayWidget.c"
}

static void
__display_display_widget___lambda10__gtk_widget_destroy (GtkWidget* _sender,
                                                         gpointer self)
{
#line 283 "../src/Widgets/DisplayWidget.vala"
	_display_display_widget___lambda10_ ((DisplayDisplayWidget*) self);
#line 2147 "DisplayWidget.c"
}

static void
_display_display_widget___lambda11_ (DisplayDisplayWidget* self)
{
	GtkComboBox* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkComboBox* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GtkComboBox* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GtkSwitch* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
#line 290 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->rotation_combobox;
#line 290 "../src/Widgets/DisplayWidget.vala"
	_tmp1_ = gtk_combo_box_get_active (_tmp0_);
#line 290 "../src/Widgets/DisplayWidget.vala"
	_tmp2_ = _tmp1_;
#line 290 "../src/Widgets/DisplayWidget.vala"
	if (_tmp2_ == -1) {
#line 2173 "DisplayWidget.c"
		GtkComboBox* _tmp3_;
#line 290 "../src/Widgets/DisplayWidget.vala"
		_tmp3_ = self->priv->rotation_combobox;
#line 290 "../src/Widgets/DisplayWidget.vala"
		gtk_combo_box_set_active (_tmp3_, 0);
#line 2179 "DisplayWidget.c"
	}
#line 291 "../src/Widgets/DisplayWidget.vala"
	_tmp4_ = self->priv->resolution_combobox;
#line 291 "../src/Widgets/DisplayWidget.vala"
	_tmp5_ = gtk_combo_box_get_active (_tmp4_);
#line 291 "../src/Widgets/DisplayWidget.vala"
	_tmp6_ = _tmp5_;
#line 291 "../src/Widgets/DisplayWidget.vala"
	if (_tmp6_ == -1) {
#line 2189 "DisplayWidget.c"
		GtkComboBox* _tmp7_;
#line 291 "../src/Widgets/DisplayWidget.vala"
		_tmp7_ = self->priv->resolution_combobox;
#line 291 "../src/Widgets/DisplayWidget.vala"
		gtk_combo_box_set_active (_tmp7_, 0);
#line 2195 "DisplayWidget.c"
	}
#line 292 "../src/Widgets/DisplayWidget.vala"
	_tmp8_ = self->priv->refresh_combobox;
#line 292 "../src/Widgets/DisplayWidget.vala"
	_tmp9_ = gtk_combo_box_get_active (_tmp8_);
#line 292 "../src/Widgets/DisplayWidget.vala"
	_tmp10_ = _tmp9_;
#line 292 "../src/Widgets/DisplayWidget.vala"
	if (_tmp10_ == -1) {
#line 2205 "DisplayWidget.c"
		GtkComboBox* _tmp11_;
#line 292 "../src/Widgets/DisplayWidget.vala"
		_tmp11_ = self->priv->refresh_combobox;
#line 292 "../src/Widgets/DisplayWidget.vala"
		gtk_combo_box_set_active (_tmp11_, 0);
#line 2211 "DisplayWidget.c"
	}
#line 294 "../src/Widgets/DisplayWidget.vala"
	_tmp12_ = self->priv->use_switch;
#line 294 "../src/Widgets/DisplayWidget.vala"
	_tmp13_ = gtk_switch_get_active (_tmp12_);
#line 294 "../src/Widgets/DisplayWidget.vala"
	_tmp14_ = _tmp13_;
#line 294 "../src/Widgets/DisplayWidget.vala"
	if (_tmp14_) {
#line 2221 "DisplayWidget.c"
		GtkStyleContext* _tmp15_;
#line 295 "../src/Widgets/DisplayWidget.vala"
		_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 295 "../src/Widgets/DisplayWidget.vala"
		gtk_style_context_remove_class (_tmp15_, "disabled");
#line 2227 "DisplayWidget.c"
	} else {
		GtkStyleContext* _tmp16_;
#line 297 "../src/Widgets/DisplayWidget.vala"
		_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 297 "../src/Widgets/DisplayWidget.vala"
		gtk_style_context_add_class (_tmp16_, "disabled");
#line 2234 "DisplayWidget.c"
	}
#line 300 "../src/Widgets/DisplayWidget.vala"
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
#line 301 "../src/Widgets/DisplayWidget.vala"
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_ACTIVE_CHANGED_SIGNAL], 0);
#line 2240 "DisplayWidget.c"
}

static void
__display_display_widget___lambda11__g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 289 "../src/Widgets/DisplayWidget.vala"
	_display_display_widget___lambda11_ ((DisplayDisplayWidget*) self);
#line 2250 "DisplayWidget.c"
}

static void
_display_display_widget___lambda12_ (DisplayDisplayWidget* self)
{
	gint active_width = 0;
	gint active_height = 0;
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	DisplayVirtualMonitor* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	DisplayVirtualMonitor* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	DisplayMonitorMode* new_mode = NULL;
	DisplayVirtualMonitor* _tmp13_;
	DisplayMonitorMode* _tmp14_;
	DisplayMonitorMode* _tmp15_;
	DisplayVirtualMonitor* _tmp16_;
	DisplayMonitorMode* _tmp17_;
	GtkComboBox* _tmp18_;
#line 311 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->resolution_combobox;
#line 311 "../src/Widgets/DisplayWidget.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 311 "../src/Widgets/DisplayWidget.vala"
	iter = _tmp1_;
#line 311 "../src/Widgets/DisplayWidget.vala"
	if (_tmp2_) {
#line 2283 "DisplayWidget.c"
		GtkTreeStore* _tmp3_;
		GtkTreeIter _tmp4_;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
#line 312 "../src/Widgets/DisplayWidget.vala"
		_tmp3_ = self->priv->resolution_tree_store;
#line 312 "../src/Widgets/DisplayWidget.vala"
		_tmp4_ = iter;
#line 312 "../src/Widgets/DisplayWidget.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH, &_tmp5_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT, &_tmp6_, -1);
#line 312 "../src/Widgets/DisplayWidget.vala"
		active_width = _tmp5_;
#line 312 "../src/Widgets/DisplayWidget.vala"
		active_height = _tmp6_;
#line 2298 "DisplayWidget.c"
	} else {
#line 317 "../src/Widgets/DisplayWidget.vala"
		return;
#line 2302 "DisplayWidget.c"
	}
#line 320 "../src/Widgets/DisplayWidget.vala"
	_tmp7_ = self->priv->_virtual_monitor;
#line 320 "../src/Widgets/DisplayWidget.vala"
	_tmp8_ = display_virtual_monitor_get_x (_tmp7_);
#line 320 "../src/Widgets/DisplayWidget.vala"
	_tmp9_ = _tmp8_;
#line 320 "../src/Widgets/DisplayWidget.vala"
	_tmp10_ = self->priv->_virtual_monitor;
#line 320 "../src/Widgets/DisplayWidget.vala"
	_tmp11_ = display_virtual_monitor_get_y (_tmp10_);
#line 320 "../src/Widgets/DisplayWidget.vala"
	_tmp12_ = _tmp11_;
#line 320 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_set_geometry (self, _tmp9_, _tmp12_, active_width, active_height);
#line 321 "../src/Widgets/DisplayWidget.vala"
	_tmp13_ = self->priv->_virtual_monitor;
#line 321 "../src/Widgets/DisplayWidget.vala"
	_tmp14_ = display_virtual_monitor_get_mode_for_resolution (_tmp13_, active_width, active_height);
#line 321 "../src/Widgets/DisplayWidget.vala"
	new_mode = _tmp14_;
#line 322 "../src/Widgets/DisplayWidget.vala"
	_tmp15_ = new_mode;
#line 322 "../src/Widgets/DisplayWidget.vala"
	if (_tmp15_ == NULL) {
#line 323 "../src/Widgets/DisplayWidget.vala"
		_g_object_unref0 (new_mode);
#line 323 "../src/Widgets/DisplayWidget.vala"
		return;
#line 2332 "DisplayWidget.c"
	}
#line 326 "../src/Widgets/DisplayWidget.vala"
	_tmp16_ = self->priv->_virtual_monitor;
#line 326 "../src/Widgets/DisplayWidget.vala"
	_tmp17_ = new_mode;
#line 326 "../src/Widgets/DisplayWidget.vala"
	display_virtual_monitor_set_current_mode (_tmp16_, _tmp17_);
#line 327 "../src/Widgets/DisplayWidget.vala"
	_tmp18_ = self->priv->rotation_combobox;
#line 327 "../src/Widgets/DisplayWidget.vala"
	gtk_combo_box_set_active (_tmp18_, 0);
#line 328 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_populate_refresh_rates (self);
#line 329 "../src/Widgets/DisplayWidget.vala"
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
#line 330 "../src/Widgets/DisplayWidget.vala"
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL], 0);
#line 308 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (new_mode);
#line 2352 "DisplayWidget.c"
}

static void
__display_display_widget___lambda12__gtk_combo_box_changed (GtkComboBox* _sender,
                                                            gpointer self)
{
#line 308 "../src/Widgets/DisplayWidget.vala"
	_display_display_widget___lambda12_ ((DisplayDisplayWidget*) self);
#line 2361 "DisplayWidget.c"
}

static void
_display_display_widget___lambda13_ (Block7Data* _data7_)
{
	DisplayDisplayWidget* self;
	GValue val = {0};
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
	GValue _tmp4_ = {0};
	DisplayTransform transform = 0;
	GValue _tmp5_;
	DisplayVirtualMonitor* _tmp6_;
#line 333 "../src/Widgets/DisplayWidget.vala"
	self = _data7_->self;
#line 336 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->rotation_combobox;
#line 336 "../src/Widgets/DisplayWidget.vala"
	gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 336 "../src/Widgets/DisplayWidget.vala"
	iter = _tmp1_;
#line 337 "../src/Widgets/DisplayWidget.vala"
	_tmp2_ = self->priv->rotation_list_store;
#line 337 "../src/Widgets/DisplayWidget.vala"
	_tmp3_ = iter;
#line 337 "../src/Widgets/DisplayWidget.vala"
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp2_, &_tmp3_, (gint) DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE, &_tmp4_);
#line 337 "../src/Widgets/DisplayWidget.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 337 "../src/Widgets/DisplayWidget.vala"
	val = _tmp4_;
#line 339 "../src/Widgets/DisplayWidget.vala"
	_tmp5_ = val;
#line 339 "../src/Widgets/DisplayWidget.vala"
	transform = (DisplayTransform) g_value_get_int (&_tmp5_);
#line 340 "../src/Widgets/DisplayWidget.vala"
	_tmp6_ = self->priv->_virtual_monitor;
#line 340 "../src/Widgets/DisplayWidget.vala"
	display_virtual_monitor_set_transform (_tmp6_, transform);
#line 342 "../src/Widgets/DisplayWidget.vala"
	switch (transform) {
#line 342 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_TRANSFORM_NORMAL:
#line 2408 "DisplayWidget.c"
		{
			DisplayVirtualMonitor* _tmp7_;
			gint _tmp8_ = 0;
			gint _tmp9_ = 0;
			GtkLabel* _tmp10_;
			GtkLabel* _tmp11_;
			const gchar* _tmp12_;
#line 344 "../src/Widgets/DisplayWidget.vala"
			_tmp7_ = self->priv->_virtual_monitor;
#line 344 "../src/Widgets/DisplayWidget.vala"
			display_virtual_monitor_get_current_mode_size (_tmp7_, &_tmp8_, &_tmp9_);
#line 344 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_width = _tmp8_;
#line 344 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_height = _tmp9_;
#line 345 "../src/Widgets/DisplayWidget.vala"
			_tmp10_ = _data7_->label;
#line 345 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_angle (_tmp10_, (gdouble) 0);
#line 346 "../src/Widgets/DisplayWidget.vala"
			_tmp11_ = _data7_->label;
#line 346 "../src/Widgets/DisplayWidget.vala"
			_tmp12_ = _data7_->virtual_monitor_name;
#line 346 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_label (_tmp11_, _tmp12_);
#line 347 "../src/Widgets/DisplayWidget.vala"
			break;
#line 2436 "DisplayWidget.c"
		}
#line 342 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_TRANSFORM_ROTATION_90:
#line 2440 "DisplayWidget.c"
		{
			DisplayVirtualMonitor* _tmp13_;
			gint _tmp14_ = 0;
			gint _tmp15_ = 0;
			GtkLabel* _tmp16_;
			GtkLabel* _tmp17_;
			const gchar* _tmp18_;
#line 349 "../src/Widgets/DisplayWidget.vala"
			_tmp13_ = self->priv->_virtual_monitor;
#line 349 "../src/Widgets/DisplayWidget.vala"
			display_virtual_monitor_get_current_mode_size (_tmp13_, &_tmp14_, &_tmp15_);
#line 349 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_height = _tmp14_;
#line 349 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_width = _tmp15_;
#line 350 "../src/Widgets/DisplayWidget.vala"
			_tmp16_ = _data7_->label;
#line 350 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_angle (_tmp16_, (gdouble) 270);
#line 351 "../src/Widgets/DisplayWidget.vala"
			_tmp17_ = _data7_->label;
#line 351 "../src/Widgets/DisplayWidget.vala"
			_tmp18_ = _data7_->virtual_monitor_name;
#line 351 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_label (_tmp17_, _tmp18_);
#line 352 "../src/Widgets/DisplayWidget.vala"
			break;
#line 2468 "DisplayWidget.c"
		}
#line 342 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_TRANSFORM_ROTATION_180:
#line 2472 "DisplayWidget.c"
		{
			DisplayVirtualMonitor* _tmp19_;
			gint _tmp20_ = 0;
			gint _tmp21_ = 0;
			GtkLabel* _tmp22_;
			GtkLabel* _tmp23_;
			const gchar* _tmp24_;
#line 354 "../src/Widgets/DisplayWidget.vala"
			_tmp19_ = self->priv->_virtual_monitor;
#line 354 "../src/Widgets/DisplayWidget.vala"
			display_virtual_monitor_get_current_mode_size (_tmp19_, &_tmp20_, &_tmp21_);
#line 354 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_width = _tmp20_;
#line 354 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_height = _tmp21_;
#line 355 "../src/Widgets/DisplayWidget.vala"
			_tmp22_ = _data7_->label;
#line 355 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_angle (_tmp22_, (gdouble) 180);
#line 356 "../src/Widgets/DisplayWidget.vala"
			_tmp23_ = _data7_->label;
#line 356 "../src/Widgets/DisplayWidget.vala"
			_tmp24_ = _data7_->virtual_monitor_name;
#line 356 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_label (_tmp23_, _tmp24_);
#line 357 "../src/Widgets/DisplayWidget.vala"
			break;
#line 2500 "DisplayWidget.c"
		}
#line 342 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_TRANSFORM_ROTATION_270:
#line 2504 "DisplayWidget.c"
		{
			DisplayVirtualMonitor* _tmp25_;
			gint _tmp26_ = 0;
			gint _tmp27_ = 0;
			GtkLabel* _tmp28_;
			GtkLabel* _tmp29_;
			const gchar* _tmp30_;
#line 359 "../src/Widgets/DisplayWidget.vala"
			_tmp25_ = self->priv->_virtual_monitor;
#line 359 "../src/Widgets/DisplayWidget.vala"
			display_virtual_monitor_get_current_mode_size (_tmp25_, &_tmp26_, &_tmp27_);
#line 359 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_height = _tmp26_;
#line 359 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_width = _tmp27_;
#line 360 "../src/Widgets/DisplayWidget.vala"
			_tmp28_ = _data7_->label;
#line 360 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_angle (_tmp28_, (gdouble) 90);
#line 361 "../src/Widgets/DisplayWidget.vala"
			_tmp29_ = _data7_->label;
#line 361 "../src/Widgets/DisplayWidget.vala"
			_tmp30_ = _data7_->virtual_monitor_name;
#line 361 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_label (_tmp29_, _tmp30_);
#line 362 "../src/Widgets/DisplayWidget.vala"
			break;
#line 2532 "DisplayWidget.c"
		}
#line 342 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_TRANSFORM_FLIPPED:
#line 2536 "DisplayWidget.c"
		{
			DisplayVirtualMonitor* _tmp31_;
			gint _tmp32_ = 0;
			gint _tmp33_ = 0;
			GtkLabel* _tmp34_;
			GtkLabel* _tmp35_;
			const gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
#line 364 "../src/Widgets/DisplayWidget.vala"
			_tmp31_ = self->priv->_virtual_monitor;
#line 364 "../src/Widgets/DisplayWidget.vala"
			display_virtual_monitor_get_current_mode_size (_tmp31_, &_tmp32_, &_tmp33_);
#line 364 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_width = _tmp32_;
#line 364 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_height = _tmp33_;
#line 365 "../src/Widgets/DisplayWidget.vala"
			_tmp34_ = _data7_->label;
#line 365 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_angle (_tmp34_, (gdouble) 0);
#line 366 "../src/Widgets/DisplayWidget.vala"
			_tmp35_ = _data7_->label;
#line 366 "../src/Widgets/DisplayWidget.vala"
			_tmp36_ = _data7_->virtual_monitor_name;
#line 366 "../src/Widgets/DisplayWidget.vala"
			_tmp37_ = g_utf8_strreverse (_tmp36_, (gssize) -1);
#line 366 "../src/Widgets/DisplayWidget.vala"
			_tmp38_ = _tmp37_;
#line 366 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_label (_tmp35_, _tmp38_);
#line 366 "../src/Widgets/DisplayWidget.vala"
			_g_free0 (_tmp38_);
#line 367 "../src/Widgets/DisplayWidget.vala"
			break;
#line 2572 "DisplayWidget.c"
		}
#line 342 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_TRANSFORM_FLIPPED_ROTATION_90:
#line 2576 "DisplayWidget.c"
		{
			DisplayVirtualMonitor* _tmp39_;
			gint _tmp40_ = 0;
			gint _tmp41_ = 0;
			GtkLabel* _tmp42_;
			GtkLabel* _tmp43_;
			const gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
#line 369 "../src/Widgets/DisplayWidget.vala"
			_tmp39_ = self->priv->_virtual_monitor;
#line 369 "../src/Widgets/DisplayWidget.vala"
			display_virtual_monitor_get_current_mode_size (_tmp39_, &_tmp40_, &_tmp41_);
#line 369 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_height = _tmp40_;
#line 369 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_width = _tmp41_;
#line 370 "../src/Widgets/DisplayWidget.vala"
			_tmp42_ = _data7_->label;
#line 370 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_angle (_tmp42_, (gdouble) 270);
#line 371 "../src/Widgets/DisplayWidget.vala"
			_tmp43_ = _data7_->label;
#line 371 "../src/Widgets/DisplayWidget.vala"
			_tmp44_ = _data7_->virtual_monitor_name;
#line 371 "../src/Widgets/DisplayWidget.vala"
			_tmp45_ = g_utf8_strreverse (_tmp44_, (gssize) -1);
#line 371 "../src/Widgets/DisplayWidget.vala"
			_tmp46_ = _tmp45_;
#line 371 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_label (_tmp43_, _tmp46_);
#line 371 "../src/Widgets/DisplayWidget.vala"
			_g_free0 (_tmp46_);
#line 372 "../src/Widgets/DisplayWidget.vala"
			break;
#line 2612 "DisplayWidget.c"
		}
#line 342 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_TRANSFORM_FLIPPED_ROTATION_180:
#line 2616 "DisplayWidget.c"
		{
			DisplayVirtualMonitor* _tmp47_;
			gint _tmp48_ = 0;
			gint _tmp49_ = 0;
			GtkLabel* _tmp50_;
			GtkLabel* _tmp51_;
			const gchar* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
#line 374 "../src/Widgets/DisplayWidget.vala"
			_tmp47_ = self->priv->_virtual_monitor;
#line 374 "../src/Widgets/DisplayWidget.vala"
			display_virtual_monitor_get_current_mode_size (_tmp47_, &_tmp48_, &_tmp49_);
#line 374 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_width = _tmp48_;
#line 374 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_height = _tmp49_;
#line 375 "../src/Widgets/DisplayWidget.vala"
			_tmp50_ = _data7_->label;
#line 375 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_angle (_tmp50_, (gdouble) 180);
#line 376 "../src/Widgets/DisplayWidget.vala"
			_tmp51_ = _data7_->label;
#line 376 "../src/Widgets/DisplayWidget.vala"
			_tmp52_ = _data7_->virtual_monitor_name;
#line 376 "../src/Widgets/DisplayWidget.vala"
			_tmp53_ = g_utf8_strreverse (_tmp52_, (gssize) -1);
#line 376 "../src/Widgets/DisplayWidget.vala"
			_tmp54_ = _tmp53_;
#line 376 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_label (_tmp51_, _tmp54_);
#line 376 "../src/Widgets/DisplayWidget.vala"
			_g_free0 (_tmp54_);
#line 377 "../src/Widgets/DisplayWidget.vala"
			break;
#line 2652 "DisplayWidget.c"
		}
#line 342 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_TRANSFORM_FLIPPED_ROTATION_270:
#line 2656 "DisplayWidget.c"
		{
			DisplayVirtualMonitor* _tmp55_;
			gint _tmp56_ = 0;
			gint _tmp57_ = 0;
			GtkLabel* _tmp58_;
			GtkLabel* _tmp59_;
			const gchar* _tmp60_;
			gchar* _tmp61_;
			gchar* _tmp62_;
#line 379 "../src/Widgets/DisplayWidget.vala"
			_tmp55_ = self->priv->_virtual_monitor;
#line 379 "../src/Widgets/DisplayWidget.vala"
			display_virtual_monitor_get_current_mode_size (_tmp55_, &_tmp56_, &_tmp57_);
#line 379 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_height = _tmp56_;
#line 379 "../src/Widgets/DisplayWidget.vala"
			self->priv->real_width = _tmp57_;
#line 380 "../src/Widgets/DisplayWidget.vala"
			_tmp58_ = _data7_->label;
#line 380 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_angle (_tmp58_, (gdouble) 90);
#line 381 "../src/Widgets/DisplayWidget.vala"
			_tmp59_ = _data7_->label;
#line 381 "../src/Widgets/DisplayWidget.vala"
			_tmp60_ = _data7_->virtual_monitor_name;
#line 381 "../src/Widgets/DisplayWidget.vala"
			_tmp61_ = g_utf8_strreverse (_tmp60_, (gssize) -1);
#line 381 "../src/Widgets/DisplayWidget.vala"
			_tmp62_ = _tmp61_;
#line 381 "../src/Widgets/DisplayWidget.vala"
			gtk_label_set_label (_tmp59_, _tmp62_);
#line 381 "../src/Widgets/DisplayWidget.vala"
			_g_free0 (_tmp62_);
#line 382 "../src/Widgets/DisplayWidget.vala"
			break;
#line 2692 "DisplayWidget.c"
		}
		default:
#line 342 "../src/Widgets/DisplayWidget.vala"
		break;
#line 2697 "DisplayWidget.c"
	}
#line 385 "../src/Widgets/DisplayWidget.vala"
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
#line 386 "../src/Widgets/DisplayWidget.vala"
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL], 0);
#line 333 "../src/Widgets/DisplayWidget.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 2705 "DisplayWidget.c"
}

static void
__display_display_widget___lambda13__gtk_combo_box_changed (GtkComboBox* _sender,
                                                            gpointer self)
{
#line 333 "../src/Widgets/DisplayWidget.vala"
	_display_display_widget___lambda13_ (self);
#line 2714 "DisplayWidget.c"
}

static void
_display_display_widget___lambda14_ (DisplayDisplayWidget* self)
{
	GValue val = {0};
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
#line 392 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = self->priv->refresh_combobox;
#line 392 "../src/Widgets/DisplayWidget.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 392 "../src/Widgets/DisplayWidget.vala"
	iter = _tmp1_;
#line 392 "../src/Widgets/DisplayWidget.vala"
	if (_tmp2_) {
#line 2733 "DisplayWidget.c"
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		GValue _tmp5_ = {0};
		DisplayMonitorMode* new_mode = NULL;
		GValue _tmp6_;
		DisplayMonitorMode* _tmp7_;
		DisplayVirtualMonitor* _tmp8_;
		DisplayMonitorMode* _tmp9_;
		GtkComboBox* _tmp10_;
#line 393 "../src/Widgets/DisplayWidget.vala"
		_tmp3_ = self->priv->refresh_list_store;
#line 393 "../src/Widgets/DisplayWidget.vala"
		_tmp4_ = iter;
#line 393 "../src/Widgets/DisplayWidget.vala"
		gtk_tree_model_get_value ((GtkTreeModel*) _tmp3_, &_tmp4_, (gint) DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_VALUE, &_tmp5_);
#line 393 "../src/Widgets/DisplayWidget.vala"
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 393 "../src/Widgets/DisplayWidget.vala"
		val = _tmp5_;
#line 394 "../src/Widgets/DisplayWidget.vala"
		_tmp6_ = val;
#line 394 "../src/Widgets/DisplayWidget.vala"
		_tmp7_ = _g_object_ref0 (g_value_get_object (&_tmp6_));
#line 394 "../src/Widgets/DisplayWidget.vala"
		new_mode = _tmp7_;
#line 395 "../src/Widgets/DisplayWidget.vala"
		_tmp8_ = self->priv->_virtual_monitor;
#line 395 "../src/Widgets/DisplayWidget.vala"
		_tmp9_ = new_mode;
#line 395 "../src/Widgets/DisplayWidget.vala"
		display_virtual_monitor_set_current_mode (_tmp8_, _tmp9_);
#line 396 "../src/Widgets/DisplayWidget.vala"
		_tmp10_ = self->priv->rotation_combobox;
#line 396 "../src/Widgets/DisplayWidget.vala"
		gtk_combo_box_set_active (_tmp10_, 0);
#line 397 "../src/Widgets/DisplayWidget.vala"
		g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
#line 398 "../src/Widgets/DisplayWidget.vala"
		g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL], 0);
#line 392 "../src/Widgets/DisplayWidget.vala"
		_g_object_unref0 (new_mode);
#line 2775 "DisplayWidget.c"
	}
#line 389 "../src/Widgets/DisplayWidget.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 2779 "DisplayWidget.c"
}

static void
__display_display_widget___lambda14__gtk_combo_box_changed (GtkComboBox* _sender,
                                                            gpointer self)
{
#line 389 "../src/Widgets/DisplayWidget.vala"
	_display_display_widget___lambda14_ ((DisplayDisplayWidget*) self);
#line 2788 "DisplayWidget.c"
}

static void
_display_display_widget_on_monitor_modes_changed_display_virtual_monitor_modes_changed (DisplayVirtualMonitor* _sender,
                                                                                        gpointer self)
{
#line 405 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_on_monitor_modes_changed ((DisplayDisplayWidget*) self);
#line 2797 "DisplayWidget.c"
}

static void
_display_display_widget_on_vm_transform_changed_g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self)
{
#line 406 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_on_vm_transform_changed ((DisplayDisplayWidget*) self);
#line 2807 "DisplayWidget.c"
}

static GObject *
display_display_widget_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayDisplayWidget * self;
	Block7Data* _data7_;
	GdkEventMask _tmp0_;
	GdkEventMask _tmp1_;
	GdkEventMask _tmp2_;
	GdkEventMask _tmp3_;
	GdkEventMask _tmp4_;
	GdkEventMask _tmp5_;
	DisplayVirtualMonitor* _tmp6_;
	GtkWidget* _tmp7_;
	DisplayDisplayWindow* _tmp8_ = NULL;
	DisplayDisplayWindow* _tmp9_;
	DisplayVirtualMonitor* _tmp10_;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	GtkButton* _tmp13_ = NULL;
	GtkButton* _tmp14_;
	GtkButton* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkButton* _tmp17_;
	DisplayVirtualMonitor* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	GtkLabel* _tmp22_ = NULL;
	GtkLabel* use_label = NULL;
	GtkLabel* _tmp23_ = NULL;
	GtkSwitch* _tmp24_ = NULL;
	DisplayVirtualMonitor* _tmp25_;
	GtkSwitch* _tmp26_;
	GtkLabel* resolution_label = NULL;
	GtkLabel* _tmp27_ = NULL;
	GtkTreeStore* _tmp28_;
	GtkTreeStore* _tmp29_;
	GtkComboBox* _tmp30_;
	GtkCellRendererText* text_renderer = NULL;
	GtkCellRendererText* _tmp31_;
	GtkComboBox* _tmp32_;
	GtkCellRendererText* _tmp33_;
	GtkComboBox* _tmp34_;
	GtkCellRendererText* _tmp35_;
	GtkLabel* rotation_label = NULL;
	GtkLabel* _tmp36_ = NULL;
	GtkListStore* _tmp37_;
	GtkListStore* _tmp38_;
	GtkComboBox* _tmp39_;
	GtkCellRendererText* _tmp40_;
	GtkComboBox* _tmp41_;
	GtkCellRendererText* _tmp42_;
	GtkComboBox* _tmp43_;
	GtkCellRendererText* _tmp44_;
	GtkLabel* refresh_label = NULL;
	GtkLabel* _tmp45_ = NULL;
	GtkListStore* _tmp46_;
	GtkListStore* _tmp47_;
	GtkComboBox* _tmp48_;
	GtkCellRendererText* _tmp49_;
	GtkComboBox* _tmp50_;
	GtkCellRendererText* _tmp51_;
	GtkComboBox* _tmp52_;
	GtkCellRendererText* _tmp53_;
	DisplayResolution* resolutions = NULL;
	DisplayResolution* _tmp62_;
	gint resolutions_length1;
	gint _resolutions_size_;
	DisplayResolution* recommended_resolutions = NULL;
	DisplayResolution* _tmp63_;
	gint recommended_resolutions_length1;
	gint _recommended_resolutions_size_;
	DisplayResolution* other_resolutions = NULL;
	DisplayResolution* _tmp64_;
	gint other_resolutions_length1;
	gint _other_resolutions_size_;
	gint max_width = 0;
	gint max_height = 0;
	guint usable_resolutions = 0U;
	gint current_width = 0;
	gint current_height = 0;
	DisplayVirtualMonitor* _tmp65_;
	gint _tmp66_ = 0;
	gint _tmp67_ = 0;
	GeeTreeSet* resolution_set = NULL;
	GeeTreeSet* _tmp68_;
	gint native_ratio = 0;
	DisplayResolution* _tmp102_;
	gint _tmp102__length1;
	DisplayResolution* _tmp114_;
	gint _tmp114__length1;
	DisplayResolution* _tmp125_;
	gint _tmp125__length1;
	GtkComboBox* _tmp143_;
	GtkGrid* popover_grid = NULL;
	GtkGrid* _tmp144_ = NULL;
	GtkGrid* _tmp145_;
	GtkLabel* _tmp146_;
	GtkGrid* _tmp147_;
	GtkSwitch* _tmp148_;
	GtkGrid* _tmp149_;
	GtkLabel* _tmp150_;
	GtkGrid* _tmp151_;
	GtkComboBox* _tmp152_;
	GtkGrid* _tmp153_;
	GtkLabel* _tmp154_;
	GtkGrid* _tmp155_;
	GtkComboBox* _tmp156_;
	GtkGrid* _tmp157_;
	GtkLabel* _tmp158_;
	GtkGrid* _tmp159_;
	GtkComboBox* _tmp160_;
	GtkGrid* _tmp161_;
	GtkPopover* popover = NULL;
	GtkMenuButton* _tmp162_;
	GtkPopover* _tmp163_ = NULL;
	GtkPopover* _tmp164_;
	GtkGrid* _tmp165_;
	GtkImage* _tmp166_;
	GtkPopover* _tmp167_;
	GtkPopover* _tmp168_;
	gchar* _tmp169_;
	GtkMenuButton* _tmp170_ = NULL;
	GtkMenuButton* _tmp171_;
	GtkMenuButton* _tmp172_;
	GtkStyleContext* _tmp173_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp174_;
	GtkGrid* _tmp175_;
	GtkButton* _tmp176_;
	GtkGrid* _tmp177_;
	GtkMenuButton* _tmp178_;
	GtkGrid* _tmp179_;
	GtkLabel* _tmp180_;
	DisplayVirtualMonitor* _tmp181_;
	gboolean _tmp182_;
	gboolean _tmp183_;
	GtkGrid* _tmp184_;
	GtkSwitch* _tmp185_;
	GtkComboBox* _tmp186_;
	GtkSwitch* _tmp187_;
	GtkComboBox* _tmp188_;
	GtkSwitch* _tmp189_;
	GtkComboBox* _tmp190_;
	GtkSwitch* _tmp191_;
	DisplayVirtualMonitor* _tmp192_;
	gboolean _tmp193_;
	gboolean _tmp194_;
	GtkComboBox* _tmp196_;
	GtkComboBox* _tmp197_;
	GtkComboBox* _tmp198_;
	GtkComboBox* _tmp199_;
	DisplayVirtualMonitor* _tmp200_;
	DisplayTransform _tmp201_;
	DisplayTransform _tmp202_;
	DisplayVirtualMonitor* _tmp203_;
	DisplayVirtualMonitor* _tmp204_;
#line 89 "../src/Widgets/DisplayWidget.vala"
	parent_class = G_OBJECT_CLASS (display_display_widget_parent_class);
#line 89 "../src/Widgets/DisplayWidget.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 89 "../src/Widgets/DisplayWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget);
#line 89 "../src/Widgets/DisplayWidget.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 89 "../src/Widgets/DisplayWidget.vala"
	_data7_->_ref_count_ = 1;
#line 89 "../src/Widgets/DisplayWidget.vala"
	_data7_->self = g_object_ref (self);
#line 90 "../src/Widgets/DisplayWidget.vala"
	_tmp0_ = gtk_widget_get_events ((GtkWidget*) self);
#line 90 "../src/Widgets/DisplayWidget.vala"
	_tmp1_ = _tmp0_;
#line 90 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_events ((GtkWidget*) self, _tmp1_ | GDK_BUTTON_PRESS_MASK);
#line 91 "../src/Widgets/DisplayWidget.vala"
	_tmp2_ = gtk_widget_get_events ((GtkWidget*) self);
#line 91 "../src/Widgets/DisplayWidget.vala"
	_tmp3_ = _tmp2_;
#line 91 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_events ((GtkWidget*) self, _tmp3_ | GDK_BUTTON_RELEASE_MASK);
#line 92 "../src/Widgets/DisplayWidget.vala"
	_tmp4_ = gtk_widget_get_events ((GtkWidget*) self);
#line 92 "../src/Widgets/DisplayWidget.vala"
	_tmp5_ = _tmp4_;
#line 92 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_events ((GtkWidget*) self, _tmp5_ | GDK_POINTER_MOTION_MASK);
#line 94 "../src/Widgets/DisplayWidget.vala"
	_tmp6_ = self->priv->_virtual_monitor;
#line 94 "../src/Widgets/DisplayWidget.vala"
	_tmp7_ = _g_object_ref0 ((GtkWidget*) self);
#line 94 "../src/Widgets/DisplayWidget.vala"
	_tmp8_ = display_display_window_new (_tmp6_);
#line 94 "../src/Widgets/DisplayWidget.vala"
	gtk_window_set_attached_to ((GtkWindow*) _tmp8_, _tmp7_);
#line 94 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (_tmp7_);
#line 94 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp8_);
#line 94 "../src/Widgets/DisplayWidget.vala"
	_tmp9_ = _tmp8_;
#line 94 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_set_display_window (self, _tmp9_);
#line 94 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (_tmp9_);
#line 98 "../src/Widgets/DisplayWidget.vala"
	_tmp10_ = self->priv->_virtual_monitor;
#line 98 "../src/Widgets/DisplayWidget.vala"
	display_virtual_monitor_get_current_mode_size (_tmp10_, &_tmp11_, &_tmp12_);
#line 98 "../src/Widgets/DisplayWidget.vala"
	self->priv->real_width = _tmp11_;
#line 98 "../src/Widgets/DisplayWidget.vala"
	self->priv->real_height = _tmp12_;
#line 100 "../src/Widgets/DisplayWidget.vala"
	_tmp13_ = (GtkButton*) gtk_button_new_from_icon_name ("non-starred-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 100 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp13_, GTK_ALIGN_START);
#line 100 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp13_, GTK_ALIGN_START);
#line 100 "../src/Widgets/DisplayWidget.vala"
	g_object_set ((GtkWidget*) _tmp13_, "margin", 6, NULL);
#line 100 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp13_);
#line 100 "../src/Widgets/DisplayWidget.vala"
	_tmp14_ = _tmp13_;
#line 100 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_set_primary_image (self, _tmp14_);
#line 100 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (_tmp14_);
#line 105 "../src/Widgets/DisplayWidget.vala"
	_tmp15_ = self->priv->_primary_image;
#line 105 "../src/Widgets/DisplayWidget.vala"
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
#line 105 "../src/Widgets/DisplayWidget.vala"
	gtk_style_context_add_class (_tmp16_, GTK_STYLE_CLASS_FLAT);
#line 106 "../src/Widgets/DisplayWidget.vala"
	_tmp17_ = self->priv->_primary_image;
#line 106 "../src/Widgets/DisplayWidget.vala"
	g_signal_connect_object (_tmp17_, "clicked", (GCallback) __display_display_widget___lambda9__gtk_button_clicked, self, 0);
#line 108 "../src/Widgets/DisplayWidget.vala"
	_tmp18_ = self->priv->_virtual_monitor;
#line 108 "../src/Widgets/DisplayWidget.vala"
	_tmp19_ = display_virtual_monitor_get_display_name (_tmp18_);
#line 108 "../src/Widgets/DisplayWidget.vala"
	_tmp20_ = g_strdup (_tmp19_);
#line 108 "../src/Widgets/DisplayWidget.vala"
	_data7_->virtual_monitor_name = _tmp20_;
#line 109 "../src/Widgets/DisplayWidget.vala"
	_tmp21_ = _data7_->virtual_monitor_name;
#line 109 "../src/Widgets/DisplayWidget.vala"
	_tmp22_ = (GtkLabel*) gtk_label_new (_tmp21_);
#line 109 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp22_, GTK_ALIGN_CENTER);
#line 109 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp22_, GTK_ALIGN_CENTER);
#line 109 "../src/Widgets/DisplayWidget.vala"
	g_object_set ((GtkWidget*) _tmp22_, "expand", TRUE, NULL);
#line 109 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp22_);
#line 109 "../src/Widgets/DisplayWidget.vala"
	_data7_->label = _tmp22_;
#line 115 "../src/Widgets/DisplayWidget.vala"
	_tmp23_ = (GtkLabel*) gtk_label_new (_ ("Use this display:"));
#line 115 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp23_, GTK_ALIGN_END);
#line 115 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp23_);
#line 115 "../src/Widgets/DisplayWidget.vala"
	use_label = _tmp23_;
#line 119 "../src/Widgets/DisplayWidget.vala"
	_tmp24_ = (GtkSwitch*) gtk_switch_new ();
#line 119 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp24_, GTK_ALIGN_START);
#line 119 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp24_);
#line 119 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->use_switch);
#line 119 "../src/Widgets/DisplayWidget.vala"
	self->priv->use_switch = _tmp24_;
#line 123 "../src/Widgets/DisplayWidget.vala"
	_tmp25_ = self->priv->_virtual_monitor;
#line 123 "../src/Widgets/DisplayWidget.vala"
	_tmp26_ = self->priv->use_switch;
#line 123 "../src/Widgets/DisplayWidget.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp25_, "is-active", (GObject*) _tmp26_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 125 "../src/Widgets/DisplayWidget.vala"
	_tmp27_ = (GtkLabel*) gtk_label_new (_ ("Resolution:"));
#line 125 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp27_, GTK_ALIGN_END);
#line 125 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp27_);
#line 125 "../src/Widgets/DisplayWidget.vala"
	resolution_label = _tmp27_;
#line 129 "../src/Widgets/DisplayWidget.vala"
	_tmp28_ = gtk_tree_store_new ((gint) DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_TOTAL, G_TYPE_STRING, G_TYPE_INT, G_TYPE_INT);
#line 129 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->resolution_tree_store);
#line 129 "../src/Widgets/DisplayWidget.vala"
	self->priv->resolution_tree_store = _tmp28_;
#line 130 "../src/Widgets/DisplayWidget.vala"
	_tmp29_ = self->priv->resolution_tree_store;
#line 130 "../src/Widgets/DisplayWidget.vala"
	_tmp30_ = (GtkComboBox*) gtk_combo_box_new_with_model ((GtkTreeModel*) _tmp29_);
#line 130 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp30_);
#line 130 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->resolution_combobox);
#line 130 "../src/Widgets/DisplayWidget.vala"
	self->priv->resolution_combobox = _tmp30_;
#line 132 "../src/Widgets/DisplayWidget.vala"
	_tmp31_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 132 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp31_);
#line 132 "../src/Widgets/DisplayWidget.vala"
	text_renderer = _tmp31_;
#line 133 "../src/Widgets/DisplayWidget.vala"
	_tmp32_ = self->priv->resolution_combobox;
#line 133 "../src/Widgets/DisplayWidget.vala"
	_tmp33_ = text_renderer;
#line 133 "../src/Widgets/DisplayWidget.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp32_, (GtkCellRenderer*) _tmp33_, TRUE);
#line 134 "../src/Widgets/DisplayWidget.vala"
	_tmp34_ = self->priv->resolution_combobox;
#line 134 "../src/Widgets/DisplayWidget.vala"
	_tmp35_ = text_renderer;
#line 134 "../src/Widgets/DisplayWidget.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp34_, (GtkCellRenderer*) _tmp35_, "text", (gint) DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME);
#line 136 "../src/Widgets/DisplayWidget.vala"
	_tmp36_ = (GtkLabel*) gtk_label_new (_ ("Screen Rotation:"));
#line 136 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp36_, GTK_ALIGN_END);
#line 136 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp36_);
#line 136 "../src/Widgets/DisplayWidget.vala"
	rotation_label = _tmp36_;
#line 140 "../src/Widgets/DisplayWidget.vala"
	_tmp37_ = gtk_list_store_new ((gint) DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_TOTAL, G_TYPE_STRING, G_TYPE_INT, -1);
#line 140 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->rotation_list_store);
#line 140 "../src/Widgets/DisplayWidget.vala"
	self->priv->rotation_list_store = _tmp37_;
#line 141 "../src/Widgets/DisplayWidget.vala"
	_tmp38_ = self->priv->rotation_list_store;
#line 141 "../src/Widgets/DisplayWidget.vala"
	_tmp39_ = (GtkComboBox*) gtk_combo_box_new_with_model ((GtkTreeModel*) _tmp38_);
#line 141 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp39_);
#line 141 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->rotation_combobox);
#line 141 "../src/Widgets/DisplayWidget.vala"
	self->priv->rotation_combobox = _tmp39_;
#line 143 "../src/Widgets/DisplayWidget.vala"
	_tmp40_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 143 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp40_);
#line 143 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (text_renderer);
#line 143 "../src/Widgets/DisplayWidget.vala"
	text_renderer = _tmp40_;
#line 144 "../src/Widgets/DisplayWidget.vala"
	_tmp41_ = self->priv->rotation_combobox;
#line 144 "../src/Widgets/DisplayWidget.vala"
	_tmp42_ = text_renderer;
#line 144 "../src/Widgets/DisplayWidget.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp41_, (GtkCellRenderer*) _tmp42_, TRUE);
#line 145 "../src/Widgets/DisplayWidget.vala"
	_tmp43_ = self->priv->rotation_combobox;
#line 145 "../src/Widgets/DisplayWidget.vala"
	_tmp44_ = text_renderer;
#line 145 "../src/Widgets/DisplayWidget.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp43_, (GtkCellRenderer*) _tmp44_, "text", (gint) DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME);
#line 147 "../src/Widgets/DisplayWidget.vala"
	_tmp45_ = (GtkLabel*) gtk_label_new (_ ("Refresh Rate:"));
#line 147 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp45_, GTK_ALIGN_END);
#line 147 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp45_);
#line 147 "../src/Widgets/DisplayWidget.vala"
	refresh_label = _tmp45_;
#line 151 "../src/Widgets/DisplayWidget.vala"
	_tmp46_ = gtk_list_store_new ((gint) DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_TOTAL, G_TYPE_STRING, DISPLAY_TYPE_MONITOR_MODE, -1);
#line 151 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->refresh_list_store);
#line 151 "../src/Widgets/DisplayWidget.vala"
	self->priv->refresh_list_store = _tmp46_;
#line 152 "../src/Widgets/DisplayWidget.vala"
	_tmp47_ = self->priv->refresh_list_store;
#line 152 "../src/Widgets/DisplayWidget.vala"
	_tmp48_ = (GtkComboBox*) gtk_combo_box_new_with_model ((GtkTreeModel*) _tmp47_);
#line 152 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp48_);
#line 152 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->refresh_combobox);
#line 152 "../src/Widgets/DisplayWidget.vala"
	self->priv->refresh_combobox = _tmp48_;
#line 154 "../src/Widgets/DisplayWidget.vala"
	_tmp49_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 154 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp49_);
#line 154 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (text_renderer);
#line 154 "../src/Widgets/DisplayWidget.vala"
	text_renderer = _tmp49_;
#line 155 "../src/Widgets/DisplayWidget.vala"
	_tmp50_ = self->priv->refresh_combobox;
#line 155 "../src/Widgets/DisplayWidget.vala"
	_tmp51_ = text_renderer;
#line 155 "../src/Widgets/DisplayWidget.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp50_, (GtkCellRenderer*) _tmp51_, TRUE);
#line 156 "../src/Widgets/DisplayWidget.vala"
	_tmp52_ = self->priv->refresh_combobox;
#line 156 "../src/Widgets/DisplayWidget.vala"
	_tmp53_ = text_renderer;
#line 156 "../src/Widgets/DisplayWidget.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp52_, (GtkCellRenderer*) _tmp53_, "text", (gint) DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_NAME);
#line 3229 "DisplayWidget.c"
	{
		gint i = 0;
#line 158 "../src/Widgets/DisplayWidget.vala"
		i = 0;
#line 3234 "DisplayWidget.c"
		{
			gboolean _tmp54_ = FALSE;
#line 158 "../src/Widgets/DisplayWidget.vala"
			_tmp54_ = TRUE;
#line 158 "../src/Widgets/DisplayWidget.vala"
			while (TRUE) {
#line 3241 "DisplayWidget.c"
				GtkTreeIter iter = {0};
				GtkListStore* _tmp56_;
				GtkTreeIter _tmp57_ = {0};
				GtkListStore* _tmp58_;
				GtkTreeIter _tmp59_;
				gchar* _tmp60_;
				gchar* _tmp61_;
#line 158 "../src/Widgets/DisplayWidget.vala"
				if (!_tmp54_) {
#line 3251 "DisplayWidget.c"
					gint _tmp55_;
#line 158 "../src/Widgets/DisplayWidget.vala"
					_tmp55_ = i;
#line 158 "../src/Widgets/DisplayWidget.vala"
					i = _tmp55_ + 1;
#line 3257 "DisplayWidget.c"
				}
#line 158 "../src/Widgets/DisplayWidget.vala"
				_tmp54_ = FALSE;
#line 158 "../src/Widgets/DisplayWidget.vala"
				if (!(i <= ((gint) DISPLAY_TRANSFORM_FLIPPED_ROTATION_270))) {
#line 158 "../src/Widgets/DisplayWidget.vala"
					break;
#line 3265 "DisplayWidget.c"
				}
#line 160 "../src/Widgets/DisplayWidget.vala"
				_tmp56_ = self->priv->rotation_list_store;
#line 160 "../src/Widgets/DisplayWidget.vala"
				gtk_list_store_append (_tmp56_, &_tmp57_);
#line 160 "../src/Widgets/DisplayWidget.vala"
				iter = _tmp57_;
#line 161 "../src/Widgets/DisplayWidget.vala"
				_tmp58_ = self->priv->rotation_list_store;
#line 161 "../src/Widgets/DisplayWidget.vala"
				_tmp59_ = iter;
#line 161 "../src/Widgets/DisplayWidget.vala"
				_tmp60_ = display_transform_to_string ((DisplayTransform) i);
#line 161 "../src/Widgets/DisplayWidget.vala"
				_tmp61_ = _tmp60_;
#line 161 "../src/Widgets/DisplayWidget.vala"
				gtk_list_store_set (_tmp58_, &_tmp59_, DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME, _tmp61_, DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE, i, -1);
#line 161 "../src/Widgets/DisplayWidget.vala"
				_g_free0 (_tmp61_);
#line 3285 "DisplayWidget.c"
			}
		}
	}
#line 166 "../src/Widgets/DisplayWidget.vala"
	_tmp62_ = g_new0 (DisplayResolution, 0);
#line 166 "../src/Widgets/DisplayWidget.vala"
	resolutions = _tmp62_;
#line 166 "../src/Widgets/DisplayWidget.vala"
	resolutions_length1 = 0;
#line 166 "../src/Widgets/DisplayWidget.vala"
	_resolutions_size_ = resolutions_length1;
#line 167 "../src/Widgets/DisplayWidget.vala"
	_tmp63_ = g_new0 (DisplayResolution, 0);
#line 167 "../src/Widgets/DisplayWidget.vala"
	recommended_resolutions = _tmp63_;
#line 167 "../src/Widgets/DisplayWidget.vala"
	recommended_resolutions_length1 = 0;
#line 167 "../src/Widgets/DisplayWidget.vala"
	_recommended_resolutions_size_ = recommended_resolutions_length1;
#line 168 "../src/Widgets/DisplayWidget.vala"
	_tmp64_ = g_new0 (DisplayResolution, 0);
#line 168 "../src/Widgets/DisplayWidget.vala"
	other_resolutions = _tmp64_;
#line 168 "../src/Widgets/DisplayWidget.vala"
	other_resolutions_length1 = 0;
#line 168 "../src/Widgets/DisplayWidget.vala"
	_other_resolutions_size_ = other_resolutions_length1;
#line 169 "../src/Widgets/DisplayWidget.vala"
	max_width = -1;
#line 170 "../src/Widgets/DisplayWidget.vala"
	max_height = -1;
#line 171 "../src/Widgets/DisplayWidget.vala"
	usable_resolutions = (guint) 0;
#line 173 "../src/Widgets/DisplayWidget.vala"
	_tmp65_ = self->priv->_virtual_monitor;
#line 173 "../src/Widgets/DisplayWidget.vala"
	display_virtual_monitor_get_current_mode_size (_tmp65_, &_tmp66_, &_tmp67_);
#line 173 "../src/Widgets/DisplayWidget.vala"
	current_width = _tmp66_;
#line 173 "../src/Widgets/DisplayWidget.vala"
	current_height = _tmp67_;
#line 174 "../src/Widgets/DisplayWidget.vala"
	_tmp68_ = gee_tree_set_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _display_monitor_mode_resolution_compare_func_gcompare_data_func, NULL, NULL);
#line 174 "../src/Widgets/DisplayWidget.vala"
	resolution_set = _tmp68_;
#line 3331 "DisplayWidget.c"
	{
		GeeLinkedList* _mode_list = NULL;
		DisplayVirtualMonitor* _tmp69_;
		GeeLinkedList* _tmp70_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp71_;
		gint _tmp72_;
		gint _tmp73_;
		gint _mode_index = 0;
#line 175 "../src/Widgets/DisplayWidget.vala"
		_tmp69_ = self->priv->_virtual_monitor;
#line 175 "../src/Widgets/DisplayWidget.vala"
		_tmp70_ = display_virtual_monitor_get_available_modes (_tmp69_);
#line 175 "../src/Widgets/DisplayWidget.vala"
		_mode_list = _tmp70_;
#line 175 "../src/Widgets/DisplayWidget.vala"
		_tmp71_ = _mode_list;
#line 175 "../src/Widgets/DisplayWidget.vala"
		_tmp72_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp71_);
#line 175 "../src/Widgets/DisplayWidget.vala"
		_tmp73_ = _tmp72_;
#line 175 "../src/Widgets/DisplayWidget.vala"
		_mode_size = _tmp73_;
#line 175 "../src/Widgets/DisplayWidget.vala"
		_mode_index = -1;
#line 175 "../src/Widgets/DisplayWidget.vala"
		while (TRUE) {
#line 3359 "DisplayWidget.c"
			gint _tmp74_;
			gint _tmp75_;
			DisplayMonitorMode* mode = NULL;
			GeeLinkedList* _tmp76_;
			gpointer _tmp77_;
			GeeTreeSet* _tmp78_;
			DisplayMonitorMode* _tmp79_;
#line 175 "../src/Widgets/DisplayWidget.vala"
			_mode_index = _mode_index + 1;
#line 175 "../src/Widgets/DisplayWidget.vala"
			_tmp74_ = _mode_index;
#line 175 "../src/Widgets/DisplayWidget.vala"
			_tmp75_ = _mode_size;
#line 175 "../src/Widgets/DisplayWidget.vala"
			if (!(_tmp74_ < _tmp75_)) {
#line 175 "../src/Widgets/DisplayWidget.vala"
				break;
#line 3377 "DisplayWidget.c"
			}
#line 175 "../src/Widgets/DisplayWidget.vala"
			_tmp76_ = _mode_list;
#line 175 "../src/Widgets/DisplayWidget.vala"
			_tmp77_ = gee_abstract_list_get ((GeeAbstractList*) _tmp76_, _mode_index);
#line 175 "../src/Widgets/DisplayWidget.vala"
			mode = (DisplayMonitorMode*) _tmp77_;
#line 176 "../src/Widgets/DisplayWidget.vala"
			_tmp78_ = resolution_set;
#line 176 "../src/Widgets/DisplayWidget.vala"
			_tmp79_ = mode;
#line 176 "../src/Widgets/DisplayWidget.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp78_, _tmp79_);
#line 175 "../src/Widgets/DisplayWidget.vala"
			_g_object_unref0 (mode);
#line 3393 "DisplayWidget.c"
		}
#line 175 "../src/Widgets/DisplayWidget.vala"
		_g_object_unref0 (_mode_list);
#line 3397 "DisplayWidget.c"
	}
	{
		GeeIterator* _mode_it = NULL;
		GeeTreeSet* _tmp80_;
		GeeIterator* _tmp81_;
#line 179 "../src/Widgets/DisplayWidget.vala"
		_tmp80_ = resolution_set;
#line 179 "../src/Widgets/DisplayWidget.vala"
		_tmp81_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp80_);
#line 179 "../src/Widgets/DisplayWidget.vala"
		_mode_it = _tmp81_;
#line 179 "../src/Widgets/DisplayWidget.vala"
		while (TRUE) {
#line 3411 "DisplayWidget.c"
			GeeIterator* _tmp82_;
			DisplayMonitorMode* mode = NULL;
			GeeIterator* _tmp83_;
			gpointer _tmp84_;
			gint mode_width = 0;
			DisplayMonitorMode* _tmp85_;
			gint _tmp86_;
			gint _tmp87_;
			gint mode_height = 0;
			DisplayMonitorMode* _tmp88_;
			gint _tmp89_;
			gint _tmp90_;
			DisplayMonitorMode* _tmp91_;
			gboolean _tmp92_;
			gboolean _tmp93_;
			DisplayResolution res = {0};
			DisplayMonitorMode* _tmp94_;
			gboolean _tmp95_;
			gboolean _tmp96_;
			DisplayMonitorMode* _tmp97_;
			gboolean _tmp98_;
			gboolean _tmp99_;
			DisplayResolution _tmp100_ = {0};
			DisplayResolution _tmp101_;
#line 179 "../src/Widgets/DisplayWidget.vala"
			_tmp82_ = _mode_it;
#line 179 "../src/Widgets/DisplayWidget.vala"
			if (!gee_iterator_next (_tmp82_)) {
#line 179 "../src/Widgets/DisplayWidget.vala"
				break;
#line 3442 "DisplayWidget.c"
			}
#line 179 "../src/Widgets/DisplayWidget.vala"
			_tmp83_ = _mode_it;
#line 179 "../src/Widgets/DisplayWidget.vala"
			_tmp84_ = gee_iterator_get (_tmp83_);
#line 179 "../src/Widgets/DisplayWidget.vala"
			mode = (DisplayMonitorMode*) _tmp84_;
#line 180 "../src/Widgets/DisplayWidget.vala"
			_tmp85_ = mode;
#line 180 "../src/Widgets/DisplayWidget.vala"
			_tmp86_ = display_monitor_mode_get_width (_tmp85_);
#line 180 "../src/Widgets/DisplayWidget.vala"
			_tmp87_ = _tmp86_;
#line 180 "../src/Widgets/DisplayWidget.vala"
			mode_width = _tmp87_;
#line 181 "../src/Widgets/DisplayWidget.vala"
			_tmp88_ = mode;
#line 181 "../src/Widgets/DisplayWidget.vala"
			_tmp89_ = display_monitor_mode_get_height (_tmp88_);
#line 181 "../src/Widgets/DisplayWidget.vala"
			_tmp90_ = _tmp89_;
#line 181 "../src/Widgets/DisplayWidget.vala"
			mode_height = _tmp90_;
#line 182 "../src/Widgets/DisplayWidget.vala"
			_tmp91_ = mode;
#line 182 "../src/Widgets/DisplayWidget.vala"
			_tmp92_ = display_monitor_mode_get_is_preferred (_tmp91_);
#line 182 "../src/Widgets/DisplayWidget.vala"
			_tmp93_ = _tmp92_;
#line 182 "../src/Widgets/DisplayWidget.vala"
			if (_tmp93_) {
#line 183 "../src/Widgets/DisplayWidget.vala"
				max_width = MAX (max_width, mode_width);
#line 184 "../src/Widgets/DisplayWidget.vala"
				max_height = MAX (max_height, mode_height);
#line 3478 "DisplayWidget.c"
			}
#line 187 "../src/Widgets/DisplayWidget.vala"
			_tmp94_ = mode;
#line 187 "../src/Widgets/DisplayWidget.vala"
			_tmp95_ = display_monitor_mode_get_is_preferred (_tmp94_);
#line 187 "../src/Widgets/DisplayWidget.vala"
			_tmp96_ = _tmp95_;
#line 187 "../src/Widgets/DisplayWidget.vala"
			_tmp97_ = mode;
#line 187 "../src/Widgets/DisplayWidget.vala"
			_tmp98_ = display_monitor_mode_get_is_current (_tmp97_);
#line 187 "../src/Widgets/DisplayWidget.vala"
			_tmp99_ = _tmp98_;
#line 187 "../src/Widgets/DisplayWidget.vala"
			_tmp100_.width = mode_width;
#line 187 "../src/Widgets/DisplayWidget.vala"
			_tmp100_.height = mode_height;
#line 187 "../src/Widgets/DisplayWidget.vala"
			_tmp100_.aspect = (mode_width * 10) / mode_height;
#line 187 "../src/Widgets/DisplayWidget.vala"
			_tmp100_.is_preferred = _tmp96_;
#line 187 "../src/Widgets/DisplayWidget.vala"
			_tmp100_.is_current = _tmp99_;
#line 187 "../src/Widgets/DisplayWidget.vala"
			res = _tmp100_;
#line 188 "../src/Widgets/DisplayWidget.vala"
			_tmp101_ = res;
#line 188 "../src/Widgets/DisplayWidget.vala"
			_vala_array_add4 (&resolutions, &resolutions_length1, &_resolutions_size_, &_tmp101_);
#line 179 "../src/Widgets/DisplayWidget.vala"
			_g_object_unref0 (mode);
#line 3510 "DisplayWidget.c"
		}
#line 179 "../src/Widgets/DisplayWidget.vala"
		_g_object_unref0 (_mode_it);
#line 3514 "DisplayWidget.c"
	}
#line 191 "../src/Widgets/DisplayWidget.vala"
	native_ratio = (max_width * 10) / max_height;
#line 193 "../src/Widgets/DisplayWidget.vala"
	_tmp102_ = resolutions;
#line 193 "../src/Widgets/DisplayWidget.vala"
	_tmp102__length1 = resolutions_length1;
#line 3522 "DisplayWidget.c"
	{
		DisplayResolution* resolution_collection = NULL;
		gint resolution_collection_length1 = 0;
		gint _resolution_collection_size_ = 0;
		gint resolution_it = 0;
#line 193 "../src/Widgets/DisplayWidget.vala"
		resolution_collection = _tmp102_;
#line 193 "../src/Widgets/DisplayWidget.vala"
		resolution_collection_length1 = _tmp102__length1;
#line 193 "../src/Widgets/DisplayWidget.vala"
		for (resolution_it = 0; resolution_it < resolution_collection_length1; resolution_it = resolution_it + 1) {
#line 3534 "DisplayWidget.c"
			DisplayResolution resolution = {0};
#line 193 "../src/Widgets/DisplayWidget.vala"
			resolution = resolution_collection[resolution_it];
#line 3538 "DisplayWidget.c"
			{
				gboolean _tmp103_ = FALSE;
				DisplayResolution _tmp104_;
				gboolean _tmp106_ = FALSE;
				gboolean _tmp107_ = FALSE;
				DisplayResolution _tmp108_;
				guint _tmp113_;
#line 195 "../src/Widgets/DisplayWidget.vala"
				_tmp104_ = resolution;
#line 195 "../src/Widgets/DisplayWidget.vala"
				if (_tmp104_.width < 1024) {
#line 195 "../src/Widgets/DisplayWidget.vala"
					_tmp103_ = TRUE;
#line 3552 "DisplayWidget.c"
				} else {
					DisplayResolution _tmp105_;
#line 195 "../src/Widgets/DisplayWidget.vala"
					_tmp105_ = resolution;
#line 195 "../src/Widgets/DisplayWidget.vala"
					_tmp103_ = _tmp105_.height < 768;
#line 3559 "DisplayWidget.c"
				}
#line 195 "../src/Widgets/DisplayWidget.vala"
				if (_tmp103_) {
#line 196 "../src/Widgets/DisplayWidget.vala"
					continue;
#line 3565 "DisplayWidget.c"
				}
#line 199 "../src/Widgets/DisplayWidget.vala"
				_tmp108_ = resolution;
#line 199 "../src/Widgets/DisplayWidget.vala"
				if (_tmp108_.is_preferred) {
#line 199 "../src/Widgets/DisplayWidget.vala"
					_tmp107_ = TRUE;
#line 3573 "DisplayWidget.c"
				} else {
					DisplayResolution _tmp109_;
#line 199 "../src/Widgets/DisplayWidget.vala"
					_tmp109_ = resolution;
#line 199 "../src/Widgets/DisplayWidget.vala"
					_tmp107_ = _tmp109_.is_current;
#line 3580 "DisplayWidget.c"
				}
#line 199 "../src/Widgets/DisplayWidget.vala"
				if (_tmp107_) {
#line 199 "../src/Widgets/DisplayWidget.vala"
					_tmp106_ = TRUE;
#line 3586 "DisplayWidget.c"
				} else {
					DisplayResolution _tmp110_;
#line 199 "../src/Widgets/DisplayWidget.vala"
					_tmp110_ = resolution;
#line 199 "../src/Widgets/DisplayWidget.vala"
					_tmp106_ = _tmp110_.aspect == native_ratio;
#line 3593 "DisplayWidget.c"
				}
#line 199 "../src/Widgets/DisplayWidget.vala"
				if (_tmp106_) {
#line 3597 "DisplayWidget.c"
					DisplayResolution _tmp111_;
#line 200 "../src/Widgets/DisplayWidget.vala"
					_tmp111_ = resolution;
#line 200 "../src/Widgets/DisplayWidget.vala"
					_vala_array_add5 (&recommended_resolutions, &recommended_resolutions_length1, &_recommended_resolutions_size_, &_tmp111_);
#line 3603 "DisplayWidget.c"
				} else {
					DisplayResolution _tmp112_;
#line 202 "../src/Widgets/DisplayWidget.vala"
					_tmp112_ = resolution;
#line 202 "../src/Widgets/DisplayWidget.vala"
					_vala_array_add6 (&other_resolutions, &other_resolutions_length1, &_other_resolutions_size_, &_tmp112_);
#line 3610 "DisplayWidget.c"
				}
#line 205 "../src/Widgets/DisplayWidget.vala"
				_tmp113_ = usable_resolutions;
#line 205 "../src/Widgets/DisplayWidget.vala"
				usable_resolutions = _tmp113_ + 1;
#line 3616 "DisplayWidget.c"
			}
		}
	}
#line 208 "../src/Widgets/DisplayWidget.vala"
	_tmp114_ = recommended_resolutions;
#line 208 "../src/Widgets/DisplayWidget.vala"
	_tmp114__length1 = recommended_resolutions_length1;
#line 3624 "DisplayWidget.c"
	{
		DisplayResolution* resolution_collection = NULL;
		gint resolution_collection_length1 = 0;
		gint _resolution_collection_size_ = 0;
		gint resolution_it = 0;
#line 208 "../src/Widgets/DisplayWidget.vala"
		resolution_collection = _tmp114_;
#line 208 "../src/Widgets/DisplayWidget.vala"
		resolution_collection_length1 = _tmp114__length1;
#line 208 "../src/Widgets/DisplayWidget.vala"
		for (resolution_it = 0; resolution_it < resolution_collection_length1; resolution_it = resolution_it + 1) {
#line 3636 "DisplayWidget.c"
			DisplayResolution resolution = {0};
#line 208 "../src/Widgets/DisplayWidget.vala"
			resolution = resolution_collection[resolution_it];
#line 3640 "DisplayWidget.c"
			{
				GtkTreeIter iter = {0};
				GtkTreeStore* _tmp115_;
				GtkTreeIter _tmp116_ = {0};
				GtkTreeStore* _tmp117_;
				GtkTreeIter _tmp118_;
				DisplayResolution _tmp119_;
				DisplayResolution _tmp120_;
				gchar* _tmp121_;
				gchar* _tmp122_;
				DisplayResolution _tmp123_;
				DisplayResolution _tmp124_;
#line 210 "../src/Widgets/DisplayWidget.vala"
				_tmp115_ = self->priv->resolution_tree_store;
#line 210 "../src/Widgets/DisplayWidget.vala"
				gtk_tree_store_append (_tmp115_, &_tmp116_, NULL);
#line 210 "../src/Widgets/DisplayWidget.vala"
				iter = _tmp116_;
#line 211 "../src/Widgets/DisplayWidget.vala"
				_tmp117_ = self->priv->resolution_tree_store;
#line 211 "../src/Widgets/DisplayWidget.vala"
				_tmp118_ = iter;
#line 211 "../src/Widgets/DisplayWidget.vala"
				_tmp119_ = resolution;
#line 211 "../src/Widgets/DisplayWidget.vala"
				_tmp120_ = resolution;
#line 211 "../src/Widgets/DisplayWidget.vala"
				_tmp121_ = display_monitor_mode_get_resolution_string (_tmp119_.width, _tmp120_.height, FALSE);
#line 211 "../src/Widgets/DisplayWidget.vala"
				_tmp122_ = _tmp121_;
#line 211 "../src/Widgets/DisplayWidget.vala"
				_tmp123_ = resolution;
#line 211 "../src/Widgets/DisplayWidget.vala"
				_tmp124_ = resolution;
#line 211 "../src/Widgets/DisplayWidget.vala"
				gtk_tree_store_set (_tmp117_, &_tmp118_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME, _tmp122_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH, _tmp123_.width, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT, _tmp124_.height, -1);
#line 211 "../src/Widgets/DisplayWidget.vala"
				_g_free0 (_tmp122_);
#line 3679 "DisplayWidget.c"
			}
		}
	}
#line 218 "../src/Widgets/DisplayWidget.vala"
	_tmp125_ = other_resolutions;
#line 218 "../src/Widgets/DisplayWidget.vala"
	_tmp125__length1 = other_resolutions_length1;
#line 218 "../src/Widgets/DisplayWidget.vala"
	if (_tmp125__length1 > 0) {
#line 3689 "DisplayWidget.c"
		GtkTreeIter iter = {0};
		GtkTreeIter parent_iter = {0};
		GtkTreeStore* _tmp126_;
		GtkTreeIter _tmp127_ = {0};
		GtkTreeStore* _tmp128_;
		GtkTreeIter _tmp129_;
		DisplayResolution* _tmp130_;
		gint _tmp130__length1;
#line 221 "../src/Widgets/DisplayWidget.vala"
		_tmp126_ = self->priv->resolution_tree_store;
#line 221 "../src/Widgets/DisplayWidget.vala"
		gtk_tree_store_append (_tmp126_, &_tmp127_, NULL);
#line 221 "../src/Widgets/DisplayWidget.vala"
		parent_iter = _tmp127_;
#line 222 "../src/Widgets/DisplayWidget.vala"
		_tmp128_ = self->priv->resolution_tree_store;
#line 222 "../src/Widgets/DisplayWidget.vala"
		_tmp129_ = parent_iter;
#line 222 "../src/Widgets/DisplayWidget.vala"
		gtk_tree_store_set (_tmp128_, &_tmp129_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME, _ ("Other…"), DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH, -1, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT, -1, -1);
#line 227 "../src/Widgets/DisplayWidget.vala"
		_tmp130_ = other_resolutions;
#line 227 "../src/Widgets/DisplayWidget.vala"
		_tmp130__length1 = other_resolutions_length1;
#line 3714 "DisplayWidget.c"
		{
			DisplayResolution* resolution_collection = NULL;
			gint resolution_collection_length1 = 0;
			gint _resolution_collection_size_ = 0;
			gint resolution_it = 0;
#line 227 "../src/Widgets/DisplayWidget.vala"
			resolution_collection = _tmp130_;
#line 227 "../src/Widgets/DisplayWidget.vala"
			resolution_collection_length1 = _tmp130__length1;
#line 227 "../src/Widgets/DisplayWidget.vala"
			for (resolution_it = 0; resolution_it < resolution_collection_length1; resolution_it = resolution_it + 1) {
#line 3726 "DisplayWidget.c"
				DisplayResolution resolution = {0};
#line 227 "../src/Widgets/DisplayWidget.vala"
				resolution = resolution_collection[resolution_it];
#line 3730 "DisplayWidget.c"
				{
					GtkTreeStore* _tmp131_;
					GtkTreeIter _tmp132_;
					GtkTreeIter _tmp133_ = {0};
					GtkTreeStore* _tmp134_;
					GtkTreeIter _tmp135_;
					DisplayResolution _tmp136_;
					DisplayResolution _tmp137_;
					gchar* _tmp138_;
					gchar* _tmp139_;
					DisplayResolution _tmp140_;
					DisplayResolution _tmp141_;
#line 228 "../src/Widgets/DisplayWidget.vala"
					_tmp131_ = self->priv->resolution_tree_store;
#line 228 "../src/Widgets/DisplayWidget.vala"
					_tmp132_ = parent_iter;
#line 228 "../src/Widgets/DisplayWidget.vala"
					gtk_tree_store_append (_tmp131_, &_tmp133_, &_tmp132_);
#line 228 "../src/Widgets/DisplayWidget.vala"
					iter = _tmp133_;
#line 229 "../src/Widgets/DisplayWidget.vala"
					_tmp134_ = self->priv->resolution_tree_store;
#line 229 "../src/Widgets/DisplayWidget.vala"
					_tmp135_ = iter;
#line 229 "../src/Widgets/DisplayWidget.vala"
					_tmp136_ = resolution;
#line 229 "../src/Widgets/DisplayWidget.vala"
					_tmp137_ = resolution;
#line 229 "../src/Widgets/DisplayWidget.vala"
					_tmp138_ = display_monitor_mode_get_resolution_string (_tmp136_.width, _tmp137_.height, TRUE);
#line 229 "../src/Widgets/DisplayWidget.vala"
					_tmp139_ = _tmp138_;
#line 229 "../src/Widgets/DisplayWidget.vala"
					_tmp140_ = resolution;
#line 229 "../src/Widgets/DisplayWidget.vala"
					_tmp141_ = resolution;
#line 229 "../src/Widgets/DisplayWidget.vala"
					gtk_tree_store_set (_tmp134_, &_tmp135_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME, _tmp139_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH, _tmp140_.width, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT, _tmp141_.height, -1);
#line 229 "../src/Widgets/DisplayWidget.vala"
					_g_free0 (_tmp139_);
#line 3771 "DisplayWidget.c"
				}
			}
		}
	}
#line 237 "../src/Widgets/DisplayWidget.vala"
	if (!display_display_widget_set_active_resolution_from_current_mode (self)) {
#line 3778 "DisplayWidget.c"
		GtkComboBox* _tmp142_;
#line 238 "../src/Widgets/DisplayWidget.vala"
		_tmp142_ = self->priv->resolution_combobox;
#line 238 "../src/Widgets/DisplayWidget.vala"
		gtk_combo_box_set_active (_tmp142_, 0);
#line 3784 "DisplayWidget.c"
	}
#line 241 "../src/Widgets/DisplayWidget.vala"
	_tmp143_ = self->priv->resolution_combobox;
#line 241 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp143_, usable_resolutions > ((guint) 1));
#line 243 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_populate_refresh_rates (self);
#line 245 "../src/Widgets/DisplayWidget.vala"
	_tmp144_ = (GtkGrid*) gtk_grid_new ();
#line 245 "../src/Widgets/DisplayWidget.vala"
	gtk_grid_set_column_spacing (_tmp144_, 12);
#line 245 "../src/Widgets/DisplayWidget.vala"
	gtk_grid_set_row_spacing (_tmp144_, 6);
#line 245 "../src/Widgets/DisplayWidget.vala"
	g_object_set ((GtkWidget*) _tmp144_, "margin", 12, NULL);
#line 245 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp144_);
#line 245 "../src/Widgets/DisplayWidget.vala"
	popover_grid = _tmp144_;
#line 250 "../src/Widgets/DisplayWidget.vala"
	_tmp145_ = popover_grid;
#line 250 "../src/Widgets/DisplayWidget.vala"
	_tmp146_ = use_label;
#line 250 "../src/Widgets/DisplayWidget.vala"
	gtk_grid_attach (_tmp145_, (GtkWidget*) _tmp146_, 0, 0, 1, 1);
#line 251 "../src/Widgets/DisplayWidget.vala"
	_tmp147_ = popover_grid;
#line 251 "../src/Widgets/DisplayWidget.vala"
	_tmp148_ = self->priv->use_switch;
#line 251 "../src/Widgets/DisplayWidget.vala"
	gtk_grid_attach (_tmp147_, (GtkWidget*) _tmp148_, 1, 0, 1, 1);
#line 252 "../src/Widgets/DisplayWidget.vala"
	_tmp149_ = popover_grid;
#line 252 "../src/Widgets/DisplayWidget.vala"
	_tmp150_ = resolution_label;
#line 252 "../src/Widgets/DisplayWidget.vala"
	gtk_grid_attach (_tmp149_, (GtkWidget*) _tmp150_, 0, 1, 1, 1);
#line 253 "../src/Widgets/DisplayWidget.vala"
	_tmp151_ = popover_grid;
#line 253 "../src/Widgets/DisplayWidget.vala"
	_tmp152_ = self->priv->resolution_combobox;
#line 253 "../src/Widgets/DisplayWidget.vala"
	gtk_grid_attach (_tmp151_, (GtkWidget*) _tmp152_, 1, 1, 1, 1);
#line 254 "../src/Widgets/DisplayWidget.vala"
	_tmp153_ = popover_grid;
#line 254 "../src/Widgets/DisplayWidget.vala"
	_tmp154_ = rotation_label;
#line 254 "../src/Widgets/DisplayWidget.vala"
	gtk_grid_attach (_tmp153_, (GtkWidget*) _tmp154_, 0, 2, 1, 1);
#line 255 "../src/Widgets/DisplayWidget.vala"
	_tmp155_ = popover_grid;
#line 255 "../src/Widgets/DisplayWidget.vala"
	_tmp156_ = self->priv->rotation_combobox;
#line 255 "../src/Widgets/DisplayWidget.vala"
	gtk_grid_attach (_tmp155_, (GtkWidget*) _tmp156_, 1, 2, 1, 1);
#line 256 "../src/Widgets/DisplayWidget.vala"
	_tmp157_ = popover_grid;
#line 256 "../src/Widgets/DisplayWidget.vala"
	_tmp158_ = refresh_label;
#line 256 "../src/Widgets/DisplayWidget.vala"
	gtk_grid_attach (_tmp157_, (GtkWidget*) _tmp158_, 0, 3, 1, 1);
#line 257 "../src/Widgets/DisplayWidget.vala"
	_tmp159_ = popover_grid;
#line 257 "../src/Widgets/DisplayWidget.vala"
	_tmp160_ = self->priv->refresh_combobox;
#line 257 "../src/Widgets/DisplayWidget.vala"
	gtk_grid_attach (_tmp159_, (GtkWidget*) _tmp160_, 1, 3, 1, 1);
#line 258 "../src/Widgets/DisplayWidget.vala"
	_tmp161_ = popover_grid;
#line 258 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp161_);
#line 260 "../src/Widgets/DisplayWidget.vala"
	_tmp162_ = self->priv->_toggle_settings;
#line 260 "../src/Widgets/DisplayWidget.vala"
	_tmp163_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) _tmp162_);
#line 260 "../src/Widgets/DisplayWidget.vala"
	gtk_popover_set_position (_tmp163_, GTK_POS_BOTTOM);
#line 260 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp163_);
#line 260 "../src/Widgets/DisplayWidget.vala"
	popover = _tmp163_;
#line 263 "../src/Widgets/DisplayWidget.vala"
	_tmp164_ = popover;
#line 263 "../src/Widgets/DisplayWidget.vala"
	_tmp165_ = popover_grid;
#line 263 "../src/Widgets/DisplayWidget.vala"
	gtk_container_add ((GtkContainer*) _tmp164_, (GtkWidget*) _tmp165_);
#line 265 "../src/Widgets/DisplayWidget.vala"
	_tmp166_ = (GtkImage*) gtk_image_new_from_icon_name ("open-menu-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 265 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp166_);
#line 265 "../src/Widgets/DisplayWidget.vala"
	_tmp167_ = popover;
#line 265 "../src/Widgets/DisplayWidget.vala"
	_tmp168_ = _g_object_ref0 (_tmp167_);
#line 265 "../src/Widgets/DisplayWidget.vala"
	_tmp169_ = g_strdup (_ ("Configure display"));
#line 265 "../src/Widgets/DisplayWidget.vala"
	_tmp170_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 265 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp170_, GTK_ALIGN_END);
#line 265 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp170_, GTK_ALIGN_START);
#line 265 "../src/Widgets/DisplayWidget.vala"
	gtk_button_set_image ((GtkButton*) _tmp170_, (GtkWidget*) _tmp166_);
#line 265 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (_tmp166_);
#line 265 "../src/Widgets/DisplayWidget.vala"
	g_object_set ((GtkWidget*) _tmp170_, "margin", 6, NULL);
#line 265 "../src/Widgets/DisplayWidget.vala"
	gtk_menu_button_set_popover (_tmp170_, _tmp168_);
#line 265 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (_tmp168_);
#line 265 "../src/Widgets/DisplayWidget.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp170_, _tmp169_);
#line 265 "../src/Widgets/DisplayWidget.vala"
	_g_free0 (_tmp169_);
#line 265 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp170_);
#line 265 "../src/Widgets/DisplayWidget.vala"
	_tmp171_ = _tmp170_;
#line 265 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_set_toggle_settings (self, _tmp171_);
#line 265 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (_tmp171_);
#line 273 "../src/Widgets/DisplayWidget.vala"
	_tmp172_ = self->priv->_toggle_settings;
#line 273 "../src/Widgets/DisplayWidget.vala"
	_tmp173_ = gtk_widget_get_style_context ((GtkWidget*) _tmp172_);
#line 273 "../src/Widgets/DisplayWidget.vala"
	gtk_style_context_add_class (_tmp173_, GTK_STYLE_CLASS_FLAT);
#line 275 "../src/Widgets/DisplayWidget.vala"
	_tmp174_ = (GtkGrid*) gtk_grid_new ();
#line 275 "../src/Widgets/DisplayWidget.vala"
	g_object_ref_sink (_tmp174_);
#line 275 "../src/Widgets/DisplayWidget.vala"
	grid = _tmp174_;
#line 276 "../src/Widgets/DisplayWidget.vala"
	_tmp175_ = grid;
#line 276 "../src/Widgets/DisplayWidget.vala"
	_tmp176_ = self->priv->_primary_image;
#line 276 "../src/Widgets/DisplayWidget.vala"
	gtk_grid_attach (_tmp175_, (GtkWidget*) _tmp176_, 0, 0, 1, 1);
#line 277 "../src/Widgets/DisplayWidget.vala"
	_tmp177_ = grid;
#line 277 "../src/Widgets/DisplayWidget.vala"
	_tmp178_ = self->priv->_toggle_settings;
#line 277 "../src/Widgets/DisplayWidget.vala"
	gtk_grid_attach (_tmp177_, (GtkWidget*) _tmp178_, 2, 0, 1, 1);
#line 278 "../src/Widgets/DisplayWidget.vala"
	_tmp179_ = grid;
#line 278 "../src/Widgets/DisplayWidget.vala"
	_tmp180_ = _data7_->label;
#line 278 "../src/Widgets/DisplayWidget.vala"
	gtk_grid_attach (_tmp179_, (GtkWidget*) _tmp180_, 0, 0, 3, 2);
#line 280 "../src/Widgets/DisplayWidget.vala"
	_tmp181_ = self->priv->_virtual_monitor;
#line 280 "../src/Widgets/DisplayWidget.vala"
	_tmp182_ = display_virtual_monitor_get_primary (_tmp181_);
#line 280 "../src/Widgets/DisplayWidget.vala"
	_tmp183_ = _tmp182_;
#line 280 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_set_primary (self, _tmp183_);
#line 281 "../src/Widgets/DisplayWidget.vala"
	_tmp184_ = grid;
#line 281 "../src/Widgets/DisplayWidget.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp184_);
#line 283 "../src/Widgets/DisplayWidget.vala"
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) __display_display_widget___lambda10__gtk_widget_destroy, self, 0);
#line 285 "../src/Widgets/DisplayWidget.vala"
	_tmp185_ = self->priv->use_switch;
#line 285 "../src/Widgets/DisplayWidget.vala"
	_tmp186_ = self->priv->resolution_combobox;
#line 285 "../src/Widgets/DisplayWidget.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp185_, "active", (GObject*) _tmp186_, "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 286 "../src/Widgets/DisplayWidget.vala"
	_tmp187_ = self->priv->use_switch;
#line 286 "../src/Widgets/DisplayWidget.vala"
	_tmp188_ = self->priv->rotation_combobox;
#line 286 "../src/Widgets/DisplayWidget.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp187_, "active", (GObject*) _tmp188_, "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 287 "../src/Widgets/DisplayWidget.vala"
	_tmp189_ = self->priv->use_switch;
#line 287 "../src/Widgets/DisplayWidget.vala"
	_tmp190_ = self->priv->refresh_combobox;
#line 287 "../src/Widgets/DisplayWidget.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp189_, "active", (GObject*) _tmp190_, "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 289 "../src/Widgets/DisplayWidget.vala"
	_tmp191_ = self->priv->use_switch;
#line 289 "../src/Widgets/DisplayWidget.vala"
	g_signal_connect_object ((GObject*) _tmp191_, "notify::active", (GCallback) __display_display_widget___lambda11__g_object_notify, self, 0);
#line 304 "../src/Widgets/DisplayWidget.vala"
	_tmp192_ = self->priv->_virtual_monitor;
#line 304 "../src/Widgets/DisplayWidget.vala"
	_tmp193_ = display_virtual_monitor_get_is_active (_tmp192_);
#line 304 "../src/Widgets/DisplayWidget.vala"
	_tmp194_ = _tmp193_;
#line 304 "../src/Widgets/DisplayWidget.vala"
	if (!_tmp194_) {
#line 3984 "DisplayWidget.c"
		GtkStyleContext* _tmp195_;
#line 305 "../src/Widgets/DisplayWidget.vala"
		_tmp195_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 305 "../src/Widgets/DisplayWidget.vala"
		gtk_style_context_add_class (_tmp195_, "disabled");
#line 3990 "DisplayWidget.c"
	}
#line 308 "../src/Widgets/DisplayWidget.vala"
	_tmp196_ = self->priv->resolution_combobox;
#line 308 "../src/Widgets/DisplayWidget.vala"
	g_signal_connect_object (_tmp196_, "changed", (GCallback) __display_display_widget___lambda12__gtk_combo_box_changed, self, 0);
#line 333 "../src/Widgets/DisplayWidget.vala"
	_tmp197_ = self->priv->rotation_combobox;
#line 333 "../src/Widgets/DisplayWidget.vala"
	g_signal_connect_data (_tmp197_, "changed", (GCallback) __display_display_widget___lambda13__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 389 "../src/Widgets/DisplayWidget.vala"
	_tmp198_ = self->priv->refresh_combobox;
#line 389 "../src/Widgets/DisplayWidget.vala"
	g_signal_connect_object (_tmp198_, "changed", (GCallback) __display_display_widget___lambda14__gtk_combo_box_changed, self, 0);
#line 402 "../src/Widgets/DisplayWidget.vala"
	_tmp199_ = self->priv->rotation_combobox;
#line 402 "../src/Widgets/DisplayWidget.vala"
	_tmp200_ = self->priv->_virtual_monitor;
#line 402 "../src/Widgets/DisplayWidget.vala"
	_tmp201_ = display_virtual_monitor_get_transform (_tmp200_);
#line 402 "../src/Widgets/DisplayWidget.vala"
	_tmp202_ = _tmp201_;
#line 402 "../src/Widgets/DisplayWidget.vala"
	gtk_combo_box_set_active (_tmp199_, (gint) _tmp202_);
#line 403 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_on_vm_transform_changed (self);
#line 405 "../src/Widgets/DisplayWidget.vala"
	_tmp203_ = self->priv->_virtual_monitor;
#line 405 "../src/Widgets/DisplayWidget.vala"
	g_signal_connect_object (_tmp203_, "modes-changed", (GCallback) _display_display_widget_on_monitor_modes_changed_display_virtual_monitor_modes_changed, self, 0);
#line 406 "../src/Widgets/DisplayWidget.vala"
	_tmp204_ = self->priv->_virtual_monitor;
#line 406 "../src/Widgets/DisplayWidget.vala"
	g_signal_connect_object ((GObject*) _tmp204_, "notify::transform", (GCallback) _display_display_widget_on_vm_transform_changed_g_object_notify, self, 0);
#line 408 "../src/Widgets/DisplayWidget.vala"
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
#line 409 "../src/Widgets/DisplayWidget.vala"
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL], 0);
#line 89 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (grid);
#line 89 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (popover);
#line 89 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (popover_grid);
#line 89 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (resolution_set);
#line 89 "../src/Widgets/DisplayWidget.vala"
	other_resolutions = (g_free (other_resolutions), NULL);
#line 89 "../src/Widgets/DisplayWidget.vala"
	recommended_resolutions = (g_free (recommended_resolutions), NULL);
#line 89 "../src/Widgets/DisplayWidget.vala"
	resolutions = (g_free (resolutions), NULL);
#line 89 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (refresh_label);
#line 89 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (rotation_label);
#line 89 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (text_renderer);
#line 89 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (resolution_label);
#line 89 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (use_label);
#line 89 "../src/Widgets/DisplayWidget.vala"
	block7_data_unref (_data7_);
#line 89 "../src/Widgets/DisplayWidget.vala"
	_data7_ = NULL;
#line 89 "../src/Widgets/DisplayWidget.vala"
	return obj;
#line 4058 "DisplayWidget.c"
}

static void
display_display_widget_class_init (DisplayDisplayWidgetClass * klass,
                                   gpointer klass_data)
{
#line 29 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Widgets/DisplayWidget.vala"
	g_type_class_adjust_private_offset (klass, &DisplayDisplayWidget_private_offset);
#line 29 "../src/Widgets/DisplayWidget.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) display_display_widget_real_button_press_event;
#line 29 "../src/Widgets/DisplayWidget.vala"
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) display_display_widget_real_button_release_event;
#line 29 "../src/Widgets/DisplayWidget.vala"
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*) (GtkWidget*, GdkEventMotion*)) display_display_widget_real_motion_notify_event;
#line 29 "../src/Widgets/DisplayWidget.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) display_display_widget_real_get_preferred_width;
#line 29 "../src/Widgets/DisplayWidget.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) display_display_widget_real_get_preferred_height;
#line 29 "../src/Widgets/DisplayWidget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_display_display_widget_get_property;
#line 29 "../src/Widgets/DisplayWidget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_display_display_widget_set_property;
#line 29 "../src/Widgets/DisplayWidget.vala"
	G_OBJECT_CLASS (klass)->constructor = display_display_widget_constructor;
#line 29 "../src/Widgets/DisplayWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = display_display_widget_finalize;
#line 29 "../src/Widgets/DisplayWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_VIRTUAL_MONITOR_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_VIRTUAL_MONITOR_PROPERTY] = g_param_spec_object ("virtual-monitor", "virtual-monitor", "virtual-monitor", DISPLAY_TYPE_VIRTUAL_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 29 "../src/Widgets/DisplayWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_WINDOW_RATIO_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_WINDOW_RATIO_PROPERTY] = g_param_spec_double ("window-ratio", "window-ratio", "window-ratio", -G_MAXDOUBLE, G_MAXDOUBLE, 1.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/Widgets/DisplayWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY] = g_param_spec_int ("delta-x", "delta-x", "delta-x", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/Widgets/DisplayWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY] = g_param_spec_int ("delta-y", "delta-y", "delta-y", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/Widgets/DisplayWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY] = g_param_spec_boolean ("only-display", "only-display", "only-display", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/Widgets/DisplayWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_DISPLAY_WINDOW_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_DISPLAY_WINDOW_PROPERTY] = g_param_spec_object ("display-window", "display-window", "display-window", DISPLAY_TYPE_DISPLAY_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/Widgets/DisplayWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY] = g_param_spec_object ("primary-image", "primary-image", "primary-image", gtk_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/Widgets/DisplayWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY] = g_param_spec_object ("toggle-settings", "toggle-settings", "toggle-settings", gtk_menu_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_SET_AS_PRIMARY_SIGNAL] = g_signal_new ("set-as-primary", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_MOVE_DISPLAY_SIGNAL] = g_signal_new ("move-display", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE, G_TYPE_NONE, 2, G_TYPE_DOUBLE, G_TYPE_DOUBLE);
#line 29 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_END_GRAB_SIGNAL] = g_signal_new ("end-grab", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 29 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL] = g_signal_new ("check-position", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL] = g_signal_new ("configuration-changed", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../src/Widgets/DisplayWidget.vala"
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_ACTIVE_CHANGED_SIGNAL] = g_signal_new ("active-changed", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4115 "DisplayWidget.c"
}

static void
display_display_widget_instance_init (DisplayDisplayWidget * self,
                                      gpointer klass)
{
#line 29 "../src/Widgets/DisplayWidget.vala"
	self->priv = display_display_widget_get_instance_private (self);
#line 39 "../src/Widgets/DisplayWidget.vala"
	self->priv->_window_ratio = 1.0;
#line 40 "../src/Widgets/DisplayWidget.vala"
	self->priv->_delta_x = 0;
#line 41 "../src/Widgets/DisplayWidget.vala"
	self->priv->_delta_y = 0;
#line 42 "../src/Widgets/DisplayWidget.vala"
	self->priv->_only_display = FALSE;
#line 44 "../src/Widgets/DisplayWidget.vala"
	self->priv->start_x = (gdouble) 0;
#line 45 "../src/Widgets/DisplayWidget.vala"
	self->priv->start_y = (gdouble) 0;
#line 46 "../src/Widgets/DisplayWidget.vala"
	self->priv->holding = FALSE;
#line 63 "../src/Widgets/DisplayWidget.vala"
	self->priv->real_width = 0;
#line 64 "../src/Widgets/DisplayWidget.vala"
	self->priv->real_height = 0;
#line 4142 "DisplayWidget.c"
}

static void
display_display_widget_finalize (GObject * obj)
{
	DisplayDisplayWidget * self;
#line 29 "../src/Widgets/DisplayWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget);
#line 37 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->_virtual_monitor);
#line 48 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->_display_window);
#line 49 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->_primary_image);
#line 50 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->_toggle_settings);
#line 52 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->use_switch);
#line 54 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->resolution_combobox);
#line 55 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->resolution_tree_store);
#line 57 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->rotation_combobox);
#line 58 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->rotation_list_store);
#line 60 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->refresh_combobox);
#line 61 "../src/Widgets/DisplayWidget.vala"
	_g_object_unref0 (self->priv->refresh_list_store);
#line 29 "../src/Widgets/DisplayWidget.vala"
	G_OBJECT_CLASS (display_display_widget_parent_class)->finalize (obj);
#line 4175 "DisplayWidget.c"
}

static GType
display_display_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayDisplayWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_display_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayDisplayWidget), 0, (GInstanceInitFunc) display_display_widget_instance_init, NULL };
	GType display_display_widget_type_id;
	display_display_widget_type_id = g_type_register_static (gtk_event_box_get_type (), "DisplayDisplayWidget", &g_define_type_info, 0);
	DisplayDisplayWidget_private_offset = g_type_add_instance_private (display_display_widget_type_id, sizeof (DisplayDisplayWidgetPrivate));
	return display_display_widget_type_id;
}

GType
display_display_widget_get_type (void)
{
	static volatile gsize display_display_widget_type_id__once = 0;
	if (g_once_init_enter (&display_display_widget_type_id__once)) {
		GType display_display_widget_type_id;
		display_display_widget_type_id = display_display_widget_get_type_once ();
		g_once_init_leave (&display_display_widget_type_id__once, display_display_widget_type_id);
	}
	return display_display_widget_type_id__once;
}

static void
_vala_display_display_widget_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	DisplayDisplayWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget);
#line 29 "../src/Widgets/DisplayWidget.vala"
	switch (property_id) {
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_VIRTUAL_MONITOR_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		g_value_set_object (value, display_display_widget_get_virtual_monitor (self));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_WINDOW_RATIO_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		g_value_set_double (value, display_display_widget_get_window_ratio (self));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		g_value_set_int (value, display_display_widget_get_delta_x (self));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		g_value_set_int (value, display_display_widget_get_delta_y (self));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		g_value_set_boolean (value, display_display_widget_get_only_display (self));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_DISPLAY_WINDOW_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		g_value_set_object (value, display_display_widget_get_display_window (self));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		g_value_set_object (value, display_display_widget_get_primary_image (self));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		g_value_set_object (value, display_display_widget_get_toggle_settings (self));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 4258 "DisplayWidget.c"
		default:
#line 29 "../src/Widgets/DisplayWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 4264 "DisplayWidget.c"
	}
}

static void
_vala_display_display_widget_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	DisplayDisplayWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget);
#line 29 "../src/Widgets/DisplayWidget.vala"
	switch (property_id) {
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_VIRTUAL_MONITOR_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		display_display_widget_set_virtual_monitor (self, g_value_get_object (value));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_WINDOW_RATIO_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		display_display_widget_set_window_ratio (self, g_value_get_double (value));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		display_display_widget_set_delta_x (self, g_value_get_int (value));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		display_display_widget_set_delta_y (self, g_value_get_int (value));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		display_display_widget_set_only_display (self, g_value_get_boolean (value));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_DISPLAY_WINDOW_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		display_display_widget_set_display_window (self, g_value_get_object (value));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		display_display_widget_set_primary_image (self, g_value_get_object (value));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 29 "../src/Widgets/DisplayWidget.vala"
		case DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY:
#line 29 "../src/Widgets/DisplayWidget.vala"
		display_display_widget_set_toggle_settings (self, g_value_get_object (value));
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 4326 "DisplayWidget.c"
		default:
#line 29 "../src/Widgets/DisplayWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Widgets/DisplayWidget.vala"
		break;
#line 4332 "DisplayWidget.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

